/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#ifndef MTK_FUNCNO_PIN_SETUP_H
#define MTK_FUNCNO_PIN_SETUP_H

UINT32 _gu4SysPinmuxInit[][2] = 
{
    // Audio
    {PIN_ALIN, PINMUX_FUNCTION2},//ARC out
    {PIN_TCON0, PINMUX_FUNCTION0},//X_AUDIO_MUTE1.GPIO:80
	{PIN_TCON6, PINMUX_FUNCTION0},//X_AUDIO_MUTE2.GPIO:86
	{PIN_TCON5, PINMUX_FUNCTION0},//X_AUDIO_RST.GPIO:85
	{PIN_TCON1, PINMUX_FUNCTION0},//X_AUDIO_MUTE3.GPIO:81
	{PIN_TCON11,PINMUX_FUNCTION0},//X_AUDIO_MON.GPIO_IN:91
	{PIN_TCON8,PINMUX_FUNCTION0},//X_AUDIO_MON1.GPIO_IN:88
	{PIN_TCON12,PINMUX_FUNCTION0},//HP_DET.GPIO_IN:92
#ifndef CC_MT5565_TURNKEY
	{PIN_TCON3,PINMUX_FUNCTION0},//DAMP_DET.GPIO_IN:83
#else
    {PIN_TCON3,PINMUX_FUNCTION4}, //Viper-E turnkey
#endif 
    {PIN_ASPDIFO0, PINMUX_FUNCTION1},//spdf out
	{PIN_AOMCLK,PINMUX_FUNCTION1},
	{PIN_AOSDATA0, PINMUX_FUNCTION1},
    {PIN_AOSDATA1, PINMUX_FUNCTION1},
	{PIN_AOBCK, PINMUX_FUNCTION1},
    {PIN_AOLRCK, PINMUX_FUNCTION1},         
	
	//CI
	{PIN_TCON9, PINMUX_FUNCTION0},//gpio89     
	{PIN_TCON10, PINMUX_FUNCTION0},//gpio90 in   
	{PIN_GPIO5, PINMUX_FUNCTION5},//gpio62  CI OCP

    //Demod 
	//TS
    {PIN_CIGPIO15, PINMUX_FUNCTION2},
	{PIN_CIGPIO16, PINMUX_FUNCTION2},	
	{PIN_CIGPIO17, PINMUX_FUNCTION2},
	{PIN_CIGPIO18, PINMUX_FUNCTION2},
	//RST
	{PIN_GPIO1, PINMUX_FUNCTION0},//RESET PIN 58
	
	//eep
	{PIN_GPIO11, PINMUX_FUNCTION1},//eep wp gpio68
	
	//led
	{PIN_OPCTRL2, PINMUX_FUNCTION0},//power led gpio202
	//{PIN_HDMI_1_SCL, PINMUX_FUNCTION2},//stby led GPIO212
	//{PIN_HDMI_1_HPD, PINMUX_FUNCTION2},//amber led GPIO213
	
	//led driver
#ifdef CC_SOEM_BOARD
	{PIN_OPWM1, PINMUX_FUNCTION1},//TODO
#else
	{PIN_OPWM1, PINMUX_FUNCTION0},//Demo board is for audio use
#endif
	{PIN_OPWM2, PINMUX_FUNCTION1},
	{PIN_OPWM3, PINMUX_FUNCTION3},
	{PIN_OPWM5, PINMUX_FUNCTION0},//BL err.gpio in gpio78
	
	//LVDS
	{PIN_GPIO2, PINMUX_FUNCTION0},//PANEL B INT.gpio in gpio59
	{PIN_GPIO7, PINMUX_FUNCTION5},//PANEL power gpio 64
	{PIN_GPIO8, PINMUX_FUNCTION5},//PANELBL gpio 65
    
	{PIN_OPWRSB,PINMUX_FUNCTION0},
    
	{PIN_ADIN4,PINMUX_FUNCTION0},
	{PIN_ADIN5,PINMUX_FUNCTION0},
	
	{PIN_GPIO10,PINMUX_FUNCTION1},//DC Mon gpio67
	//KEYPAD
	{PIN_VGA_SCL,PINMUX_FUNCTION0},//KEY PAD POWER gpio205
	{PIN_ADIN3,PINMUX_FUNCTION0},//KEY PAD other key
	
	//USB
	{PIN_OPWM0, PINMUX_FUNCTION0},//usb ocp gpio73
	{PIN_TCON2, PINMUX_FUNCTION0},//hub reset.gpio82
	{PIN_GPIO6, PINMUX_FUNCTION5},//USB ENABLE gpio63
    
	//hotel
	//{PIN_HDMI_1_SDA, PINMUX_FUNCTION2},//IR PASS THROUGH EN gpio 213
	{PIN_OPWM4, PINMUX_FUNCTION0},//hotel vol- gpio 77
	{PIN_OPWM6, PINMUX_FUNCTION0},//hotel vol+ gpio79
	
	
    {PIN_AIN1_L, PINMUX_FUNCTION0},
    {PIN_AIN2_L, PINMUX_FUNCTION0},
    {PIN_AIN3_L, PINMUX_FUNCTION0},
    {PIN_AIN4_L, PINMUX_FUNCTION0},
    //{PIN_AIN5_L, PINMUX_FUNCTION0},
    //{PIN_AIN6_L, PINMUX_FUNCTION0},
	
	{PIN_AL0,	PINMUX_FUNCTION0 },//GPIO 129
	{PIN_AR0,	PINMUX_FUNCTION0 },//GPIO 130
	{PIN_AL1,	PINMUX_FUNCTION0 },//GPIO 131
	{PIN_AL2,	PINMUX_FUNCTION0 },//GPIO 132
	{PIN_AR1,	PINMUX_FUNCTION0 },//GPIO 133
	{PIN_AR2,	PINMUX_FUNCTION0 },//GPIO 134




    {PIN_OSDA0, 1},
 //   {PIN_OSDA1, 1},
    {PIN_OSDA2, 0},

    // UART 0
//    {PIN_U0TX, 0},
//    {PIN_U0RX, 0},
    
    // Demod ATD
    {PIN_IF_AGC, 1},
    {PIN_RF_AGC, 1},


    // Internal CI
   // {PIN_GPIO1, PINMUX_FUNCTION1 },//GPIO 58
    {PIN_GPIO3, PINMUX_FUNCTION1 },//GPIO 60
    {PIN_CIGPIO10,    PINMUX_FUNCTION1 },//GPIO 10
    {PIN_CIGPIO11,    PINMUX_FUNCTION1 },//GPIO 11
    {PIN_CIGPIO12,    PINMUX_FUNCTION1 },//GPIO 12
    {PIN_CIGPIO13,    PINMUX_FUNCTION1 },//GPIO 13
    {PIN_CIGPIO14,    PINMUX_FUNCTION1 },//GPIO 14
    {PIN_CIGPIO36,    PINMUX_FUNCTION1 },//GPIO 36
    {PIN_CIGPIO37,    PINMUX_FUNCTION1 },//GPIO 37
    {PIN_CIGPIO38,    PINMUX_FUNCTION1 },//GPIO 38
    {PIN_CIGPIO39,    PINMUX_FUNCTION1 },//GPIO 39

    // HDMI
    {PIN_HDMI_CEC, 1},

#if 0
    {PIN_LDM_CS,    PINMUX_FUNCTION1 },//GPIO 112
    {PIN_LDM_DO,    PINMUX_FUNCTION1 },//GPIO 113
    {PIN_LDM_DI,    PINMUX_FUNCTION1 },//GPIO 114
    {PIN_LDM_CLK,   PINMUX_FUNCTION1 },//GPIO 115
    {PIN_LDM_VSYNC, PINMUX_FUNCTION1 },//GPIO 116   
#endif 

    {PIN_LAST_PINMUX, 0}//always put last!

};


#endif /* MTK_FUNCNO_PIN_SETUP_H */

