/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#ifndef MTK_FUNCNO_PIN_SETUP_H
#define MTK_FUNCNO_PIN_SETUP_H

UINT32 _gu4SysPinmuxInit[][2] = 
{
    // Audio
    {PIN_ALIN, PINMUX_FUNCTION2},
    {PIN_ASPDIFO0, PINMUX_FUNCTION1},
    //{PIN_ASPDIF1, PINMUX_FUNCTION1},
    {PIN_AOMCLK, PINMUX_FUNCTION1},
    //{PIN_AOBCK, PINMUX_FUNCTION1},
    //{PIN_AOLRCK, PINMUX_FUNCTION1},         
    {PIN_AOSDATA0, PINMUX_FUNCTION1},
    {PIN_AOSDATA1, PINMUX_FUNCTION1},
    //{PIN_AOSDATA2, PINMUX_FUNCTION1},
    //{PIN_AOSDATA3, PINMUX_FUNCTION1},
    //{PIN_AOSDATA4, PINMUX_FUNCTION1},
    //{PIN_AIN0_L, PINMUX_FUNCTION0},
    {PIN_AIN1_L, PINMUX_FUNCTION0},
    {PIN_AIN2_L, PINMUX_FUNCTION0},
    {PIN_AIN3_L, PINMUX_FUNCTION0},
    {PIN_AIN4_L, PINMUX_FUNCTION0},
    //{PIN_AIN5_L, PINMUX_FUNCTION0},
    //{PIN_AIN6_L, PINMUX_FUNCTION0},
	
	{PIN_AL0,	PINMUX_FUNCTION0 },//GPIO 129
	{PIN_AR0,	PINMUX_FUNCTION0 },//GPIO 130
	{PIN_AL1,	PINMUX_FUNCTION0 },//GPIO 131
	{PIN_AL2,	PINMUX_FUNCTION0 },//GPIO 132
	{PIN_AR1,	PINMUX_FUNCTION0 },//GPIO 133
	{PIN_AR2,	PINMUX_FUNCTION0 },//GPIO 134
#ifdef CC_MT5565_TURNKEY    
    {PIN_TCON3, PINMUX_FUNCTION4},    //Turnkey Viper-E use TCON3 as SPDIF out, ASPIDFO0 only for ARC
#endif

#if 0
    // Ethernet
    {PIN_TCON0, 2},         // ETMDC
    {PIN_TCON1, 2},         // ETMDIO
    {PIN_TCON2, 2},         // ETRXDV
    {PIN_TCON3, 2},         // ETRXD0
    {PIN_TCON4, 2},         // ETRXD1
    {PIN_TCON5, 2},         // ETRXD2
    {PIN_TCON6, 2},         // ETRXD3
    {PIN_TCON7, 2},         // ETRXCLK
    {PIN_TCON8, 2},         // ETTXCLK
    {PIN_TCON9, 2},         // ETTXD0
    {PIN_TCON10, 2},        // ETTXD1
    {PIN_TCON11, 2},        // ETTXD2
    {PIN_TCON12, 2},        // ETTXD3
    {PIN_GPIO45, 3},        // ETTXEN
    {PIN_GPIO46, 3},        // ETCOL
    {PIN_GPIO49, 2},        // ETPHYCLK
#endif

    {PIN_OSDA0, 1},
 //   {PIN_OSDA1, 1},
    {PIN_OSDA2, 0},

    // UART 0
    {PIN_U0TX, 0},
    {PIN_U0RX, 0},
    
    // Demod ATD
    {PIN_IF_AGC, 1},
    {PIN_RF_AGC, 1},
    //{PIN_DEMOD_TSCLK, 1},
    //{PIN_DEMOD_TSVAL, 1},
    //{PIN_DEMOD_TSSYNC, 1},
    //{PIN_DEMOD_TSDATA0, 1},
    //{PIN_DEMOD_TSDATA1, 1},
    //{PIN_DEMOD_TSDATA2, 1},
    //{PIN_DEMOD_TSDATA3, 1},
    //{PIN_DEMOD_TSDATA4, 1},
    //{PIN_DEMOD_TSDATA5, 1},
    //{PIN_DEMOD_TSDATA6, 1},
    //{PIN_DEMOD_TSDATA7, 1},

    // Internal CI
    {PIN_GPIO1, PINMUX_FUNCTION1 },//GPIO 58
    {PIN_GPIO3, PINMUX_FUNCTION1 },//GPIO 60
    {PIN_CIGPIO10,    PINMUX_FUNCTION1 },//GPIO 10
    {PIN_CIGPIO11,    PINMUX_FUNCTION1 },//GPIO 11
    {PIN_CIGPIO12,    PINMUX_FUNCTION1 },//GPIO 12
    {PIN_CIGPIO13,    PINMUX_FUNCTION1 },//GPIO 13
    {PIN_CIGPIO14,    PINMUX_FUNCTION1 },//GPIO 14
    {PIN_CIGPIO36,    PINMUX_FUNCTION1 },//GPIO 36
    {PIN_CIGPIO37,    PINMUX_FUNCTION1 },//GPIO 37
    {PIN_CIGPIO38,    PINMUX_FUNCTION1 },//GPIO 38
    {PIN_CIGPIO39,    PINMUX_FUNCTION1 },//GPIO 39


    // PWM
    {PIN_OPWM0, 2},
    //{PIN_OPWM1, 2},
    {PIN_OPWM2, 2},

    // VGA
    {PIN_VGA_SCL, 2},
    {PIN_VGA_SDA, 2},

    // PDWNC
    //{PIN_OPCTRL5, 1}, // Scanning PWM1


    // HDMI
    {PIN_HDMI_CEC, 1},

    /*
    {PIN_HDMI_0_SDA, 1},
    {PIN_HDMI_0_SCL, 1},
    {PIN_HDMI_1_SDA, 1},
    {PIN_HDMI_1_SCL, 1},
    {PIN_HDMI_2_SDA, 1},
    {PIN_HDMI_2_SCL, 1},
    {PIN_HDMI_3_SDA, 1},
    {PIN_HDMI_3_SCL, 1},*/

    // LDM (Local Dimming SPI)
#if 0
    {PIN_LDM_CS,    PINMUX_FUNCTION1 },//GPIO 112
    {PIN_LDM_DO,    PINMUX_FUNCTION1 },//GPIO 113
    {PIN_LDM_DI,    PINMUX_FUNCTION1 },//GPIO 114
    {PIN_LDM_CLK,   PINMUX_FUNCTION1 },//GPIO 115
    {PIN_LDM_VSYNC, PINMUX_FUNCTION1 },//GPIO 116   
#endif 

#ifdef CC_ENABLE_HDMI_JTAG
    //{PIN_JTCK, PINMUX_FUNCTION1 },
    {PIN_HDMI_1_SCL, PINMUX_FUNCTION2 },
    {PIN_HDMI_1_SDA, PINMUX_FUNCTION2 },
    {PIN_HDMI_2_SCL, PINMUX_FUNCTION2 },
    {PIN_HDMI_2_SDA, PINMUX_FUNCTION2 },
    {PIN_HDMI_2_HPD, PINMUX_FUNCTION2 },
#else // deticated JTAG
    //{PIN_JTCK, PINMUX_FUNCTION0 },
    /*
    {PIN_HDMI_1_SCL, PINMUX_FUNCTION1 },
    {PIN_HDMI_1_SDA, PINMUX_FUNCTION1 },
    {PIN_HDMI_2_SCL, PINMUX_FUNCTION1 },
    {PIN_HDMI_2_SDA, PINMUX_FUNCTION1 },
    {PIN_HDMI_2_HPD, PINMUX_FUNCTION1 },*/
#endif

    {PIN_LAST_PINMUX, 0}//always put last!

};


#endif /* MTK_FUNCNO_PIN_SETUP_H */

