/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 * Copyright (c) 2005, MediaTek Inc.
 * All rights reserved.
 *
 * Unauthorized use, practice, perform, copy, distribution, reproduction,
 * or disclosure of this information in whole or in part is prohibited.
 *---------------------------------------------------------------------------
 *
 * $Author: dtvbm11 $
 * $Date: 2016/06/23 $
 * $RCSfile: adac_cust.c,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

/** @file adac_cust.c
 *  Brief of file amp_cust.c.
 *  Details of file amp_cust.c (optional).
 */

#define AUD_EXTERN_FILE

//---------------------------------------------------------------------------
// Include files
//---------------------------------------------------------------------------

#include "x_lint.h"
LINT_EXT_HEADER_BEGIN

#include "amp_cust.h"
#include "sif_if.h"  // for i2c
#include "aud_if.h"
//#include "aud_debug.h"
#include "drvcust_if.h"
//#include "aud_cfg.h"

LINT_EXT_HEADER_END

//---------------------------------------------------------------------------
// Configurations
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Constant definitions
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Type definitions
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Macro definitions
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Imported variables
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Imported functions
//---------------------------------------------------------------------------
extern INT32 GPIO_Output(INT32 i4GpioNum, INT32 *pfgSet);
extern INT32 GPIO_SetOut(INT32 i4GpioNum, INT32 i4Val);
extern INT32 GPIO_GetIn(INT32 i4GpioNum);

//---------------------------------------------------------------------------
// Static function forward declarations
//---------------------------------------------------------------------------

static void  _Cust_Init(void);
static void  _Cust_Mute(BOOL fgEnable);
static void _Cust_DacFmtCfg(DATA_FORMAT_T eFormat, MCLK_FREQUENCY_T eMclk);
static void _Cust_SetDacGain(UINT8 u1HpId, INT16 i2Gain);
static void  _Cust_RegWrite(UINT8 u1Addr, UINT8 u1Data);
static UINT8 _Cust_RegRead(UINT8 u1Addr);

//---------------------------------------------------------------------------
// Static variables
//---------------------------------------------------------------------------
static AMP_FUNCTBL_T _rAmpFunTbl = 
{
	_Cust_Init,					//pfnInit
	_Cust_Mute,					//pfnMute 
	_Cust_DacFmtCfg,  			//pfnSetDacInFmt;
	_Cust_SetDacGain,           //pfnSetDacGain;
	_Cust_RegWrite, 			//pfnWrite;
	_Cust_RegRead				//pfnRead;
};

static AMP_T _rAmpCust = 
{
	"Cust AMP",			// szName[32];
	256,				// i2MaxGain
	-256,				// i2MaxGain
	1,					// u1DacNum
	&_rAmpFunTbl		// rCodecFuncTbl
};

//---------------------------------------------------------------------------
// Static functions
//---------------------------------------------------------------------------

static void _Cust_RegWrite(UINT8 u1Addr, UINT8 u1Data)
{

    /* ---  sample code
    UINT32 u4WriteCount = 0; 

    u4WriteCount = SIF_X_Write(AUD_AMP_BUS_ID, SIF_CLK_DIV, CUST_ADDR, 1 ,u1Addr, &u1Data, 1);
    LOG( 9,"I2C write (address,data) = (0x %x,0x %x)\n",u1Addr, u1Data);

    if (u4WriteCount > 0)
    {
    }	
    else
    {
        LOG(5, "AMP WRITE FAIL\n");
    }	
    */
}

static UINT8 _Cust_RegRead(UINT8 u1Addr) 
{
    /* --- sample code
    
    UINT32 u4ReadCount = 0;
    UINT8 u1Data;

    u4ReadCount = SIF_X_Read(AUD_AMP_BUS_ID, SIF_CLK_DIV, CUST_ADDR, 1 , u1Addr, &u1Data, 1);

    LOG( 9,"I2C read (address,data) = (0x%x, 0x%x)\n",u1Addr, u1Data);

    if (u4ReadCount > 0)
    {
    	return u1Data;
    }	
    else
    {
        LOG(5, "AMP READ FAIL\n");
    	return 0;
    }	
    */
    return 0;
}

static void _Cust_Init(void)
{
    //Do amp init here
    
    /* --- sample code
    AOUT_CFG_T*		prAudOutFmt;
    UINT32 u4reset,u4polarity;
	UINT32 AmpEnable,AmpEnablepolarity;

    // Make sure I2c is init
    SIF_Init(); 

    DRVCUST_OptQuery(eAudioAmpEnableGpioNum, &AmpEnable);	//sam 100714
    DRVCUST_OptQuery(eAudioAmpGpioPolarity, &AmpEnablepolarity);
    if (AmpEnable != 0xffffffff)
    {        
        GPIO_Output((INT32)AmpEnable,(INT32 *)&AmpEnablepolarity); 
    }

    DRVCUST_OptQuery(eAudioDigiAMPResetGpio, &u4reset);
    DRVCUST_OptQuery(eAudioDigiAMPResetGpioPolarity, &u4polarity);
    if (u4reset != 0xffffffff)
    {        
        GPIO_Output((INT32)u4reset,(INT32 *)&u4polarity);     
        u4polarity = !u4polarity;
        GPIO_Output((INT32)u4reset,(INT32 *)&u4polarity); 
    }
    
    // Format config
    UNUSED(DRVCUST_OptQuery(eAudioOutFmtTable, (UINT32 *)(void *)&prAudOutFmt));
    _Cust_DacFmtCfg(prAudOutFmt->eFormat, (MCLK_FREQUENCY_T)DRVCUST_OptGet(eAudioDacMclk));
    */
}

static void _Cust_Mute(BOOL fgEnable)
{
    /* --- sample code
    if (fgEnable)  //Mute
    {
        // Do mute here 
    }
    else  //Unmute
    {      
        // Do unmute here
	} 
	*/   
}

static void _Cust_SetDacGain(UINT8 u1HpId, INT16 i2Gain)
{
    // set amp gain here    
}

static void _Cust_DacFmtCfg(DATA_FORMAT_T eFormat, MCLK_FREQUENCY_T eMclk)
{
    /* --- sample code    
    switch (eFormat)
    {
        case FORMAT_LJ:
        	// LJ setting
        	break;
        case FORMAT_I2S:
        	// I2S setting
        	break;
        case FORMAT_RJ:
        	// RJ setting
        	break;
        default:
        	// default setting
        	break;
    }
    */
}

AMP_T* _AMP_GetAmpCustFunTbl(void)
{
	return &_rAmpCust;
}
