/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 *
 * $Author: dtvbm11 $
 * $Date: 2016/06/23 $
 * $RCSfile: $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

/** @file gcpu_iram.h
 *  gcpu driver - instruction ram uCode inclusion
 */

static const unsigned long GCPU_IRAMP_TRAPPING[] = {
0x82362027,     // fix AES CTR command when the length is not multiples of 16 bytes
0x8cfc202b,     // support the bypass function and TS Scramble schemes 1
0x8c95208b,     // support the bypass function and TS Scramble schemes 2
0x8cb2209c,     // support the bypass function and TS Scramble schemes 3
0x8cd420a8,     // support the bypass function and TS Scramble schemes 4
0x82000202,     // bypass AES security check, this trapping should always in array last item index
};

static const unsigned long GCPU_IRAMP_CODE[] = {
0x001c8bd2, 0x001d8965, 0x001ed9a4, 0x0010cb64, 0x000fa957,
0x001ed9e5, 0x001c0a54, 0x000909fa, 0x001d8955, 0x001c8be8,
0x000909fa, 0x001ee975, 0x001de946, 0x00128b35, 0x001ee914,
0x001ee927, 0x001bc147, 0x000809fa, 0x000c0957, 0x0008825d,
0x001b8975, 0x001b8dd4, 0x001ac167, 0x000fa947, 0x000909fa,
0x001ee974, 0x001ee915, 0x001de946, 0x00128b35, 0x001ee927,
0x001bc147, 0x000809fa, 0x0008824d, 0x000c0115, 0x001b8975,
0x001b8dd4, 0x001ac167, 0x000fa975, 0x000909fa, 0x001b94bd,
0x0018a9dd, 0x0019a9dd, 0x00090b62, 0x001d88b7, 0x0010a917,
0x00082926, 0x001a8115, 0x0008296d, 0x001a8135, 0x0008296d,
0x001d89c7, 0x001a8095, 0x00082914, 0x001a80b5, 0x0008296a,
0x00092926, 0x0021c8b5, 0x000c0956, 0x001bad7c, 0x00234945,
0x00198975, 0x001b89c7, 0x00092917, 0x001db9d6, 0x00092917,
0x001d8b56, 0x001aad5c, 0x000f2907, 0x001bad45, 0x001dc844,
0x00088999, 0x0019aad5, 0x00188ad5, 0x001a88a4, 0x000fa91a,
0x001dc864, 0x001d89c7, 0x00088999, 0x00092907, 0x001dc804,
0x001d89c7, 0x00088999, 0x001d8957, 0x0019aad5, 0x00188ad5,
0x001a88b5, 0x0008290f, 0x00118d15, 0x001a8b55, 0x000f2921,
0x001dc864, 0x0019aad5, 0x00188ad5, 0x001a88b5, 0x000fa935,
0x001dc804, 0x0012e105, 0x001d89c7, 0x0008855b, 0x001c935e,
0x00088847, 0x001dc865, 0x0019aad5, 0x00188ad5, 0x001a88b5,
0x000fa93e, 0x001dc805, 0x0012e104, 0x001d89c7, 0x0008854a,
0x001b8357, 0x00118d15, 0x000f2926, 0x00118d15, 0x000fa906,
0x000905a8, 0x00218965, 0x001a8895, 0x000fa926, 0x001ec815,
0x001c8b5c, 0x001ec815, 0x001c8b5c, 0x001ec815, 0x001c8b5c,
0x001ec815, 0x001c8b5c, 0x0012e105, 0x001dc804, 0x001d89c7,
0x0008855b, 0x001da9d5, 0x001c8b5e, 0x00088847, 0x001dc805,
0x0012e104, 0x001d89c7, 0x0008854a, 0x00092926, 0x00199515,
0x0011a55e, 0x001aa5de, 0x001b89d4, 0x001de95a, 0x001ee80d,
0x0012e8ad, 0x001ee875, 0x002388b5, 0x0011b956, 0x000829c2,
0x0019b916, 0x001b8576, 0x0012e936, 0x001b8959, 0x000805e7,
0x000905f5, 0x001ee875, 0x001b8955, 0x000f29f1, 0x001ee8f5,
0x00198975, 0x00188975, 0x001c8a58, 0x0009058c, 0x002388b9,
0x0019b915, 0x0012e956, 0x000905e9, 0x0019b11b, 0x0018b11b,
0x00218967, 0x001a8115, 0x000829e5, 0x001a8135, 0x000829e5,
0x00090583, 0x00198297, 0x0017b11b, 0x00090583
};

#define GCPU_IRAMP_LEN   0x2CC

// built on  2012/04/19 13:52
