/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 *
 * $Author: dtvbm11 $
 * $Date: 2016/06/23 $
 * $RCSfile: ir_reg.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/


/** @file ir_reg.h
 *  ir_reg.h The IRRX/IRTX register definitions.
 */


#ifndef IR_REGS_H
#define IR_REGS_H


//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------

#include "x_typedef.h"


//-----------------------------------------------------------------------------
// Constant definitions
//-----------------------------------------------------------------------------

// IRRX misc registers
#define REG_RW_IRCLK_SEL    0x0004      // IR Receiver Clock Selection Register
    #define IRRX_CLK_3MHZ_DIV_1    0   // IRRX clock set in 27MHZ
    #define IRRX_CLK_3MHZ_DIV_2    1   // IRRX clock set in 27MHZ/2
    #define IRRX_CLK_3MHZ_DIV_4    2   // IRRX clock set in 27MHZ/4
    #define IRRX_CLK_3MHZ_DIV_8    3   // IRRX clock set in 27MHZ/8
    #define IRRX_CLK_3MHZ_DIV_16   4   // IRRX clock set in 27MHZ/16
    #define IRRX_CLK_3MHZ_DIV_32   5   // IRRX clock set in 27MHZ/32
    #define IRRX_CLK_3MHZ_DIV_64   6   // IRRX clock set in 27MHZ/64
    #define IRRX_CLK_3MHZ_DIV_128  7   // IRRX clock set in 27MHZ/128
    #define IRRX_CLK_3MHZ_DIV_256  8   // IRRX clock set in 27MHZ/256
    #define IRRX_CLK_3MHZ_DIV_511  9   // IRRX clock set in 27MHZ/511


// IRRX read/write configuration registers
#define IRRX_CLEAR_BUSY_REG     0x0218
    #define IRRX_CLR_BSY_IR     0x01

#endif /* IR_REGS_H */

