/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 *
 * $Author: dtvbm11 $
 * $Date: 2016/06/23 $
 * $RCSfile: color_param.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/


#ifndef _COLOR_PARAM_H_
#define _COLOR_PARAM_H_

#include "general.h"
////////////////////////////////////////////////////////////////////////////////
UINT8 DEFAULT_SCE_TBL[960] = 
{
    #include "default.cv"

};

UINT8 BASE_SCE_TBL[960] = 
{
    #include "default.cv"

};

UINT8 MIN_SCE_TBL[960] = 
{
    #include "flat.cv"

};

////////////////////////////////////////////////////////////////////////////////
UINT8 GAMMA_256[][257] =
{
	#include "Gamma_100.tbl"
};

////////////////////////////////////////////////////////////////////////////////
UINT8 OD_Table[41*41]=
{
#ifdef __MODEL_slt__
	#include "fb_17x17_linear.tbl"
#else
	#include "fb_17x17_linear.tbl"
#endif
};

UINT8 FB_Table[17*17]=
{
#ifdef __MODEL_slt__
	#include "fb_17x17_linear.tbl"
#else
	#include "fb_17x17_linear.tbl"
#endif
};

UINT8 PCID_Table[17*17]=
{
#ifdef __MODEL_slt__
	#include "fb_17x17_linear.tbl"
#else
	#include "fb_17x17_linear.tbl"
#endif
};

/////////////////////////////////////////////////////
//Zero-D part
UINT16 OPCLuminanceTable[][33][33] = // content x pwm
{
	#include "ZeroD_32_BOE_Champ.tbl"    //Panel id = 1
    #include "ZeroD_32_BOE_Champ.tbl"    //Panel id = 2  PANEL_BOE32W--
    #include "ZeroD_32_LGD_Champ.tbl"    //Panel id = 3  PANEL_LGD32W--
    #include "ZeroD_32_BOE_Champ.tbl"    //Panel id = 4
    #include "ZeroD_32_SDC_Champ.tbl"    //Panel id = 5  PANEL_SDC32W--
    #include "ZeroD_32_BOE_Champ.tbl"    //Panel id = 6
    #include "ZeroD_32_AUO_Champ.tbl"    //Panel id = 7  PANEL_AUO32F--
    #include "ZeroD_32_AUO_Champ.tbl"    //Panel id = 8
    #include "ZeroD_40_SDC_Champ.tbl"    //Panel id = 9   PANEL_SDC40_FY15_L7--
    #include "ZeroD_40_SDC_Champ.tbl"    //Panel id = 10  PANEL_SDC40_FY15_L8
    
    #include "ZeroD_40_SDC_Champ.tbl"    //Panel id = 11  PANEL_SDC40_FY14_1
    #include "ZeroD_40_SDC_Champ.tbl"    //Panel id = 12  PANEL_SDC40_FY14_2
    #include "ZeroD_40_SDC_Champ.tbl"    //Panel id = 13  PANEL_SDP40_FY14
    #include "ZeroD_40_SDC_Champ.tbl"    //Panel id = 14  PANEL_SDC40--
    #include "ZeroD_40_SDC_Champ.tbl"    //Panel id = 15
    #include "ZeroD_48_SDC_Champ.tbl"    //Panel id = 16  PANEL_SDC48_FY15_KR--
    #include "ZeroD_48_SDC_Champ.tbl"    //Panel id = 17  PANEL_SDC48_FY15_CH
    #include "ZeroD_48_SDC_Champ.tbl"    //Panel id = 18  PANEL_SDC48_FY14_KR
    #include "ZeroD_48_SDC_Champ.tbl"    //Panel id = 19  PANEL_SDC48_FY14_CH
    #include "ZeroD_48_SDC_Champ.tbl"    //Panel id = 20
};
#endif // #ifndef _COLOR_PARAM_H_
