/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
  * $RCSfile: modelIndex_cust.c,v $
  * $Revision: #1 $
  * $Date: 2016/06/23 $
  * $Author: dtvbm11 $
  * Description:
  *
  *---------------------------------------------------------------------------*/
#ifdef CC_ENABLE_MTK_MODEL_INDEX
#include "general.h"
#include "feature.h"
#include "panel.h"
#include "../modelIndex.h"

extern unsigned int modelindex_id; //parse in kernel, export symbol

//===================FHD================================
MAIN_MODELINDEX_DATA_T DEFAULT_MODEL_TBL[]=
{
#ifdef DEMO_BOARD	
    {// 0
        PANEL_CMO_19_A1_P2,    		 // u4PanelId
        0xA0,            			 		 // u4TunerId
        FBM_MEM_CFG_MT5880_DDR3x2, // u4FbmId
        (0), 											 // 0: no mirror/no flip, 1: mirror/no flip, 2: no mirror/flip, 3: mirror/flip
        "VIPER",									 // s_MODEL_NAME
        "VIPER_DEV",   						 // s_MODEL_STATUS
        (oVIA),										 // iOSD_Information
        1, 												 // u4AQId
        0, 												 // u4PQId
        0, 												 // u4EdidId
        0, 												 //i3D_Model_Information
        FALSE,                     // u1HDMIInverse
        "User"										 // Customer external_data
    },
    {// 1
        PANEL_AUO_32_XW1,    		 	 // u4PanelId
        0xA0,            			 		 // u4TunerId
        FBM_MEM_CFG_MT5880_DDR3x2, // u4FbmId
        (0), 											 // 0: no mirror/no flip, 1: mirror/no flip, 2: no mirror/flip, 3: mirror/flip
        "VIPER",									 // s_MODEL_NAME
        "VIPER_DEV",   						 // s_MODEL_STATUS
        (oVIA),										 // iOSD_Information
        1, 												 // u4AQId
        0, 												 // u4PQId
        0, 												 // u4EdidId
        0, 												 //i3D_Model_Information
        FALSE,                     // u1HDMIInverse
        "User"										 // Customer external_data
    },    
#else	
/***********************************************************************************/
/*                        Customization part                                       */
/***********************************************************************************/
    {// 0
        PANEL_CMO_19_A1_P2,    		 // u4PanelId
        0xA0,            			 		 // u4TunerId
        FBM_MEM_CFG_MT5880_DDR3x2, // u4FbmId
        (0), 											 // 0: no mirror/no flip, 1: mirror/no flip, 2: no mirror/flip, 3: mirror/flip
        "5580",									 // s_MODEL_NAME
        "5580_DEV",   						 // s_MODEL_STATUS
        (oVIA),										 // iOSD_Information
        1, 												 // u4AQId
        0, 												 // u4PQId
        0, 												 // u4EdidId
        0, 												 //i3D_Model_Information
        FALSE,                     // u1HDMIInverse
        {"User"}										 // Customer external_data
    },
    {// 1
        PANEL_AUO_32_XW1,    		 	 // u4PanelId
        0xA0,            			 		 // u4TunerId
        FBM_MEM_CFG_MT5880_DDR3x2, // u4FbmId
        (0), 											 // 0: no mirror/no flip, 1: mirror/no flip, 2: no mirror/flip, 3: mirror/flip
        "5580",									 // s_MODEL_NAME
        "5580_DEV",   						 // s_MODEL_STATUS
        (oVIA),										 // iOSD_Information
        1, 												 // u4AQId
        0, 												 // u4PQId
        0, 												 // u4EdidId
        0, 												 //i3D_Model_Information
        FALSE,                     // u1HDMIInverse
        {"User"}										 // Customer external_data
    },  
#endif    
};

UINT16 GetModelIndexTableSize(void)
{
    return sizeof(MAIN_MODELINDEX_DATA_T);
}

void * GetModelIndexTable(UINT8 index)
{
    return (void*)&DEFAULT_MODEL_TBL[index];
}

UINT8 GetModelIndexCount(void)
{
    return sizeof(DEFAULT_MODEL_TBL) / sizeof(MAIN_MODELINDEX_DATA_T);
}

#if !defined(CC_UBOOT) && !defined(CC_MTK_LOADER) && !defined(CC_MTK_PRELOADER)
UINT8 GetModelIndexID(void)
{
    return  (UINT8) modelindex_id;
}
#endif

UINT32 GetModelIndexPanelId(UINT32 index)
{
    return DEFAULT_MODEL_TBL[index].u4PanelId;
}

UINT32 GetModelIndexTunerId(UINT32 index)
{
    return DEFAULT_MODEL_TBL[index].u4TunerId;
}

UINT32 GetModelIndexFbmId(UINT32 index)
{
    return DEFAULT_MODEL_TBL[index].u4FbmId;
}

UINT32 GetModelIndexMirrorFlipOpt(UINT32 index)
{
    return DEFAULT_MODEL_TBL[index].u4MirrorFlipOpt;
}

UINT32 GetModelIndexAQId(UINT32 index)
{
    return DEFAULT_MODEL_TBL[index].u4AQId;
}

UINT32 GetModelIndexPQId(UINT32 index)
{
    return DEFAULT_MODEL_TBL[index].u4PQId;
}

UINT32 GetModelIndexEdidId(UINT32 index)
{
    return DEFAULT_MODEL_TBL[index].u4EdidId;
}

UINT32 GetModelIndex3DModelInformation(UINT32 index)
{
    return DEFAULT_MODEL_TBL[index].i3D_Model_Information;
}

BOOL GetModelIndexHDMIInversePort(UINT32 index)
{
    return DEFAULT_MODEL_TBL[index].u1HDMIInverse;
}

BOOL GetModelIndexFBMType(UINT32 index)
{
    return (DEFAULT_MODEL_TBL[index].u4FbmId == FBM_MEM_CFG_MT5880_DDR3x2) ? TRUE : FALSE;
}
/*----------------------------------------------------------------------------
   Description : This function returns model name with current model index
   Parameter1 : None
   Return    : model name in mode index table
 ---------------------------------------------------------------------------*/
     
CHAR* GetModelName(VOID)
{
    MAIN_MODELINDEX_DATA_T* pt_this = (MAIN_MODELINDEX_DATA_T*)GetModelIndexTable(GetModelIndexFromEEPROM());

    return pt_this->s_MODEL_NAME;
}

CHAR* GetModelStatus(VOID)
{
    MAIN_MODELINDEX_DATA_T* pt_this = (MAIN_MODELINDEX_DATA_T*)GetModelIndexTable(GetModelIndexFromEEPROM());

    return pt_this->s_MODEL_STATUS;
}

UINT32 GetModelIndexOSDFormal( VOID)
{
    MAIN_MODELINDEX_DATA_T* pt_this = (MAIN_MODELINDEX_DATA_T*)GetModelIndexTable(GetModelIndexFromEEPROM());

    return (UINT32)pt_this->iOSD_Information;
}
#endif // CC_ENABLE_MTK_MODEL_INDEX
