/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
#ifndef SONY_AUD_H
#define SONY_AUD_H

#include "aud_if.h"

//-----------------------------------------------------------------------------
// Audio input SW
//-----------------------------------------------------------------------------
static const AUD_INPUT_SW_GPIO_T _arSonyInputSwGpio =
{
    UNUSED_GPIO,                    
    UNUSED_GPIO,                
    UNUSED_GPIO,
    UNUSED_GPIO
};

//AdcMuxSel = 6 is for microphone in BGA 
static const AUD_INPUT_MUX_SEL_T _arSonyAudInputMux[] = 
{   // Input ID                 AdcMuxSel,  SwGpio1,    SwGpio2,    SwGpio3,    SwGpio4
    // Input ID             AdcMuxSel,    SwGpio1,    SwGpio2,    SwGpio3,    SwGpio4
    {AUD_INPUT_ID_COMP_VID_0,    3,      SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_COMP_VID_1,    4,      SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_COMP_VID_2,    NO_USED,      SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_COMP_VID_3, NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_S_VID_0,          6,      SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_S_VID_1,       NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_S_VID_2,       NO_USED,    SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_YPBPR_0,          5,  SW_NO_USED,SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_YPBPR_1,          NO_USED,             SW_NO_USED, SW_NO_USED,SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_YPBPR_2,     NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_VGA_0,             2,             SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_VGA_1,       NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_0,           NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_1,     NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_2,     NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_3,     NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_HDMI_4,     NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_0,             NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_1,           NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_2,      NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_3,      NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_DVI_4,      NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_SCART_0,         0,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_SCART_1,         1,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_SCART_2,         NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_SCART_3,         NO_USED,  SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_AUXIN_0,      2,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED},
    {AUD_INPUT_ID_AUXIN_1,      NO_USED,   SW_NO_USED, SW_NO_USED, SW_NO_USED, SW_NO_USED}
};


static const AUD_INPUT_MUX_SEL_TABLE_T _rSonyAudInputMuxTable = 
{
    (sizeof(_arSonyAudInputMux)/sizeof(AUD_INPUT_MUX_SEL_T)),
    _arSonyAudInputMux   
};

static const INT16 _ai2SonyAudAvInputSrcVol[AUD_INPUT_ID_MAX] =
{   
    VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB,
    VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB
};

static const AUD_POST_SM_T _arSonySoundModeCase[AUD_SOUND_MODE_NUM][AUD_STREAM_FROM_NUM] = 
{
    {//AUD_SOUND_MODE_DYNAMIC
    AUD_SM_CASE0,//AUD_STREAM_FROM_OTHERS
    AUD_SM_CASE3,//AUD_STREAM_FROM_DIGITAL_TUNER
    AUD_SM_CASE2,//AUD_STREAM_FROM_ANALOG_TUNER
    AUD_SM_CASE0,//AUD_STREAM_FROM_SPDIF
    AUD_SM_CASE0,//AUD_STREAM_FROM_LINE_IN
    AUD_SM_CASE1,//AUD_STREAM_FROM_HDMI
    AUD_SM_CASE1,//AUD_STREAM_FROM_MEMORY
    AUD_SM_CASE1,//AUD_STREAM_FROM_BUF_AGT
    AUD_SM_CASE0,//AUD_STREAM_FROM_FEEDER
    AUD_SM_CASE1//AUD_STREAM_FROM_MULTI_MEDIA
    //AUD_SM_CASE0//AUD_STREAM_FROM_LINE_IN_2
    },
    {//AUD_SOUND_MODE_STANDARD
    AUD_SM_CASE4,//AUD_STREAM_FROM_OTHERS
    AUD_SM_CASE7,//AUD_STREAM_FROM_DIGITAL_TUNER
    AUD_SM_CASE6,//AUD_STREAM_FROM_ANALOG_TUNER
    AUD_SM_CASE4,//AUD_STREAM_FROM_SPDIF
    AUD_SM_CASE4,//AUD_STREAM_FROM_LINE_IN
    AUD_SM_CASE5,//AUD_STREAM_FROM_HDMI
    AUD_SM_CASE5,//AUD_STREAM_FROM_MEMORY
    AUD_SM_CASE5,//AUD_STREAM_FROM_BUF_AGT
    AUD_SM_CASE4,//AUD_STREAM_FROM_FEEDER
    AUD_SM_CASE5//AUD_STREAM_FROM_MULTI_MEDIA
    //AUD_SM_CASE4//AUD_STREAM_FROM_LINE_IN_2
    },
    {//AUD_SOUND_MODE_CLEAR_VOICE
    AUD_SM_CASE8,//AUD_STREAM_FROM_OTHERS
    AUD_SM_CASE11,//AUD_STREAM_FROM_DIGITAL_TUNER
    AUD_SM_CASE10,//AUD_STREAM_FROM_ANALOG_TUNER
    AUD_SM_CASE8,//AUD_STREAM_FROM_SPDIF
    AUD_SM_CASE8,//AUD_STREAM_FROM_LINE_IN
    AUD_SM_CASE9,//AUD_STREAM_FROM_HDMI
    AUD_SM_CASE9,//AUD_STREAM_FROM_MEMORY
    AUD_SM_CASE9,//AUD_STREAM_FROM_BUF_AGT
    AUD_SM_CASE8,//AUD_STREAM_FROM_FEEDER
    AUD_SM_CASE9//AUD_STREAM_FROM_MULTI_MEDIA
    //AUD_SM_CASE8//AUD_STREAM_FROM_LINE_IN_2
    },
    {//AUD_SOUND_MODE_CUST
    AUD_SM_CASE12,//AUD_STREAM_FROM_OTHERS
    AUD_SM_CASE15,//AUD_STREAM_FROM_DIGITAL_TUNER
    AUD_SM_CASE14,//AUD_STREAM_FROM_ANALOG_TUNER
    AUD_SM_CASE12,//AUD_STREAM_FROM_SPDIF
    AUD_SM_CASE12,//AUD_STREAM_FROM_LINE_IN
    AUD_SM_CASE13,//AUD_STREAM_FROM_HDMI
    AUD_SM_CASE13,//AUD_STREAM_FROM_MEMORY
    AUD_SM_CASE13,//AUD_STREAM_FROM_BUF_AGT
    AUD_SM_CASE12,//AUD_STREAM_FROM_FEEDER
    AUD_SM_CASE13//AUD_STREAM_FROM_MULTI_MEDIA
    //AUD_SM_CASE12//AUD_STREAM_FROM_LINE_IN_2
    }
};

//-----------------------------------------------------------------------------
// IEC Configuration
//-----------------------------------------------------------------------------
static const UINT8 _au1SonyAudIecCopyright[SPDIF_REG_TYPE_NUM][AUD_STREAM_FROM_NUM] = 
{
    // default
    {
        IEC_COPY_NEVER,                     // DVI
        IEC_COPY_FREELY,            // DIGITAL_TUNER
        IEC_COPY_FREELY,                    // ANALOG_TUNER
        IEC_COPY_FREELY,                    // SPDIF
        IEC_COPY_FREELY,                    // LINE_IN
        IEC_COPY_NEVER,                     // HDMI
        IEC_COPY_FREELY,                    // MEMORY
        IEC_COPY_FREELY,                    // BUF_AGT
        IEC_COPY_FREELY,                    // FEEDER
        IEC_COPY_FREELY,                    // MULTI_MEDIA
        //IEC_COPY_FREELY,                    // LINE_IN_2
    },
    // custom 0
    {
        IEC_COPY_NEVER,                     // DVI
        IEC_COPY_FREELY,            // DIGITAL_TUNER
        IEC_COPY_FREELY,                    // ANALOG_TUNER
        IEC_COPY_FREELY,                    // SPDIF
        IEC_COPY_FREELY,                    // LINE_IN
        IEC_COPY_NEVER,                     // HDMI
        IEC_COPY_FREELY,                    // MEMORY
        IEC_COPY_FREELY,                    // BUF_AGT
        IEC_COPY_FREELY,                    // FEEDER
        IEC_COPY_FREELY,                    // MULTI_MEDIA
        //IEC_COPY_FREELY,                    // LINE_IN_2
    },
    // CI plus
    {
        IEC_COPY_NEVER,                     // DVI
        IEC_COPY_FREELY,            // DIGITAL_TUNER
        IEC_COPY_FREELY,                    // ANALOG_TUNER
        IEC_COPY_FREELY,                    // SPDIF
        IEC_COPY_FREELY,                    // LINE_IN
        IEC_COPY_NEVER,                     // HDMI
        IEC_COPY_FREELY,                    // MEMORY
        IEC_COPY_FREELY,                    // BUF_AGT
        IEC_COPY_FREELY,                    // FEEDER
        IEC_COPY_FREELY,                    // MULTI_MEDIA
        //IEC_COPY_FREELY,                    // LINE_IN_2
    }
};


//-----------------------------------------------------------------------------
// Internal DAC channel config
//-----------------------------------------------------------------------------
static const AOUT_CFG_T _arSonyAudOutFmtTable =
{
    FORMAT_I2S,              // format of alignment
    DAC_24_BIT,             // number of bits per sample
    LRCK_CYC_32,            // cycles per sample
    MCLK_256FS,             // DAC sampling frequence
    TRUE,                  // Invert audio output for OP phase
    FALSE                  // Invert L/R audio output
};

// Define the usage of audio I2S data
static const AUD_DIGITAL_DATA_T _afgSonyAudDigitalDataUsage =
{
    TRUE,   //MCLK,BCK,LRCK
    TRUE,   //AOSDATA0
    FALSE,   //AOSDATA1
    FALSE,   //AOSDATA2
    FALSE,   //AOSDATA3
    FALSE   //AOSDATA4
};

//-----------------------------------------------------------------------------
// Internal DAC channel config
//-----------------------------------------------------------------------------
static const AUD_INTER_DAC_CFG_T _arSonyInterDacUsage = 
{
    AUD_CHL_AUX,               ///AR0, AL0 for SCART
    AUD_CHL_DOWNMIX,           ///AR1, AL1 for HP & Line out
    AUD_CHL_BYPASS,
    AUD_CHL_AUX
};

static const AUD_ADAC_USAGE_T _arSonyAdacUsage = 
{
    AUD_ADAC_NULL,
    AUD_ADAC_NULL,
    AUD_ADAC_NULL,
    AUD_ADAC_NULL,
    AUD_CODEC_MT5398,
    AUD_CODEC_NULL,
    AUD_AMP_NULL,
    AUD_AMP_NULL
};

static const AUD_AOUT_PAD_CFG_T _arSonyAoutPadTable =
{
    AUD_CH_FRONT_LEFT,  //AOSDATA0 ==> Speaker
    AUD_CH_BYPASS_LEFT, //AOSDATA1 ==> SCART2
    AUD_CH_FRONT_LEFT,  //NA
    AUD_CH_FRONT_LEFT,  //NA
    AUD_CH_FRONT_LEFT,  //NA
    AUD_CH_FRONT_LEFT,  //NA
};

#ifdef AUDIO_AVC_TARGET_LEV
static const INT16 _ai2SonyAudAvcTarget[AUD_STREAM_FROM_NUM] =
{
    -24,        // OTHERS
    -24,        // DIGITAL_TUNER
    -24,        // ANALOG_TUNER
    -24,        // SPDIF
    -24,        // LINE_IN
    -24,        // HDMI
    -24,        // MEMORY
    -24,        // BUF_AGT
    -24,        // FEEDER
    -24,        // MM
};
#endif

#ifdef AUDIO_AVC_GAIN_UP
static const INT16 _ai2SonyAudAvcGainUp[AUD_STREAM_FROM_NUM] =
{
    0,        // OTHERS
    0,        // DIGITAL_TUNER
    0,        // ANALOG_TUNER
    0,        // SPDIF
    0,        // LINE_IN
    0,        // HDMI
    0,        // MEMORY
    0,        // BUF_AGT
    0,        // FEEDER
    0,        // MM
};
#endif


static const UINT32 _au4Sony_VolumeTable[100 + 1] =
{

//  1~9
    0x0000000, 0x0000018, 0x0000047, 0x0000083,0x00000D2, 0x0000128, 0x000018C, 0x00001FA,
    0x0000274, 0x00002F5,

//10~14,2db,-41db~-33db
    0x0000385, 0x000040F, 0x00004B1, 0x0000558, 0x00005FF,

//15~26,1db,-31db~-20db
    0x00006BA, 0x0000770, 0x000083B, 0x00008F9,
    0x00009C7, 0x0000AAB, 0x0000B45, 0x0000BEC, 0x0000C9B, 0x0000D56, 0x0000E1B, 0x0000F75,

//27~45,0.5db,-19db~-10db    //chris 20100806 setting 34 step to 0x1BD8
    0x000102F, 0x0001125, 0x0001260,
    0x0001376, 0x0001510, 0x0001651, 0x000177D, 0x00018DF, 0x0001A45, 0x0001B7D, 0x0001CCC,
    0x0001E25, 0x0001F95, 0x00020DD, 0x000223A, 0x000236B, 0x00024AD, 0x00025F3, 0x000274C,

//46~67,0.25db,-9.5db~-4.25
    0x00028AB, 0x0002A1B, 0x0002B93,
    0x0002D1D, 0x0002EB0, 0x0003055, 0x0003207, 0x00033CB, 0x000359B, 0x0003781, 0x0003971,
    0x0003B76, 0x0003D8D, 0x0003FB2, 0x0004193, 0x0004379, 0x0004577, 0x0004775, 0x0004994,
    0x0004BB1, 0x0004DF0, 0x000502B,

//68~100,0.125dB,-4db~0db
    0x000528E, 0x00054EE, 0x00057F3, 0x0005B1F, 0x0005EC9,
    0x00062C8, 0x00066D8, 0x0006B15, 0x0006F7A, 0x000740F, 0x00078D8, 0x0007DD4, 0x00083c0,
    0x00089F4, 0x00091AA, 0x0009905, 0x000A12A, 0x000A9BD, 0x000B2C4, 0x000BC46, 0x000C641,
    0x000D0C4, 0x000DFBF, 0x000EFA9, 0x0010394, 0x00113E9, 0x00121ED, 0x0013B58, 0x00157F7,
 	0x001772D, 0x0019209, 0x001BE43, 0x0020000,
};

//-----------------------------------------------------------------------------
// Audio adjustable volume
//-----------------------------------------------------------------------------

#define VOL_SHM_0_DB        (0x20000)
#define VOL_SHM_NEG_1_DB    (0x1C852)
#define VOL_SHM_NEG_2_DB    (0x196B2)
#define VOL_SHM_NEG_6_DB    (0x20000/2)
#define VOL_SHM_NEG_12_DB   (0x20000/4)

#ifndef AUDIO_INPUT_SRC_VOL_DEFAULT
static const INT16 _aai2SonyAudInputSrcVol[AUD_DEC_NUM][AUD_STREAM_FROM_NUM] =
{
    //Others   DTV           ATV           SPDIF     LINE_IN   HDMI      MEMORY
    {VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB},
    {VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB}
};
#endif

//-----------------------------------------------------------------------------
// Channel volume extra gain
//-----------------------------------------------------------------------------
#ifdef AUDIO_CHL_VOL_EXTRA_GAIN
// Note: data may saturate if extra gain is larger than 0dB
static const INT8 _aai1SonyAudChVolExtraGain[AUD_DEC_NUM][AUD_CH_NUM] =
{
    //AUD_DEC_MAIN
      //L      R         SL        SR        Center    Subwoofer BypassL   BypassR   DownmixL  DownmixR
    {VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB, VOL_0_DB},
    //AUD_DEX_AUX
      //L      R
    {VOL_0_DB, VOL_0_DB}
};
#endif

//-----------------------------------------------------------------------------
// Flash AQ
//-----------------------------------------------------------------------------
/* For adding new items:
    1. Add a Data Description item
    2. XXXXXX Modify Default data table(size and content) XXXXXX. No need to 
do this now.
    3. Add Size definition in "aud_if.h"
    4. Add global array and parser code in "aud_dsp_cfg.c"
    5. _AudCmdFlashAQListAll, and if need test add CLI command in "aud_cmd.c."
*/
static const AUD_AQ_DSCRPT_T _arSonyAudNvmDscrpt[] =
{
#ifdef CC_SONY_2K14_FLASH_AQ
/// For 2K13 FlashAQ "MTK Function Field" sheet
	///Common Part = 621
	{AQ_TYPE_VERSION,		"Ver",			8},
	{AQ_TYPE_SRC_VOLUME,	"Src Vol",		7},
	{AQ_TYPE_VOL_TABLE, 	"Vol Tab",		303},
	{AQ_TYPE_LO_VOL_TABLE,	"LO Tab",		303},
	{AQ_TYPE_HP_VOL_TABLE,	"HP Vol",		303},
	///AQ Part = 2006
	{AQ_TYPE_PEQ_TABLE, 		  "Peq_T",		  540},
	{AQ_TYPE_PEQ_WALL,			  "Peq_W",		  540},
	{AQ_TYPE_BASS_TREBLE_TABLE,   "Bass/Tre_T", 	24},
	{AQ_TYPE_BASS_TREBLE_WALL,	  "Bass/Tre_W", 	24},
	{AQ_TYPE_BASS_TREBLE_CUTOFF,  "Bass/Tre_C", 	24},
	{AQ_TYPE_VBASS_TABLE,		  "VBass_T",		84},
	{AQ_TYPE_VBASS_WALL,		  "VBass_W",		84},
	{AQ_TYPE_SPKHEIGHT_TABLE,	  "SpkHght_T",		12},
	{AQ_TYPE_SPKHEIGHT_WALL,	  "SpkHght_W",		12},
	{AQ_TYPE_LOUDNESS_TABLE,		"Loudness_T", 	164},	///Change
	{AQ_TYPE_LOUDNESS_WALL,		"Loudness_W", 	164},	///Change
	{AQ_TYPE_MVS_TABLE, 		  "VSurr_T",		105},
	{AQ_TYPE_MVS_WALL,			  "VSurr_W",		105},
	{AQ_TYPE_MTKDRC_TABLE,		"MtkDrc_T",		132},	///Change
	{AQ_TYPE_MTKDRC_WALL,		"MtkDrc_W",		132},	///Change
	{AQ_TYPE_AVC,			"AVC",			5}, 	///Change
	{AQ_TYPE_LIMITER,		"Limiter",		12},	///Change
	{AQ_TYPE_BASS_MANAGEMENT_TABLE,"BassMana_T",	96},
	{AQ_TYPE_BASS_MANAGEMENT_WALL, "BassMana_W",	96},
	{AQ_TYPE_CH_VOLUME, 	"Ch Vol G", 	60},
	{AQ_TYPE_FIR_TABLE, 		  "FIR_T",			768}, 
	{AQ_TYPE_FIR_WALL,			  "FIR_W",			768},	///Comm+AQ part = 4347
#else
/// For 2K13 FlashAQ "MTK Function Field" sheet
	///Common Part = 621
	{AQ_TYPE_VERSION,		"Ver",			8},
	{AQ_TYPE_SRC_VOLUME,	"Src Vol",		7},
	{AQ_TYPE_VOL_TABLE, 	"Vol Tab",		303},
	{AQ_TYPE_HP_VOL_TABLE,	"HP Vol",		303},
	///AQ Part = 2006
	{AQ_TYPE_PEQ,			"Peq",			720},
	{AQ_TYPE_BASS_TREBLE,	"Bass/Tre", 	32},
	{AQ_TYPE_VBASS, 		"VBass",		112},
	{AQ_TYPE_SPKHEIGHT, 	"SpkHght",		16},
	{AQ_TYPE_LOUDNESS,		"Loudness", 	25},	///Change
	{AQ_TYPE_MVS,			"VSurr",		105},
	{AQ_TYPE_MTKDRC,		"MtkDrc",		33},	///Change
	{AQ_TYPE_AVC,			"AVC",			5}, 	///Change
	{AQ_TYPE_LIMITER,		"Limiter",		12},	///Change
	{AQ_TYPE_BASS_MANAGEMENT,"BassMana",	128},
	{AQ_TYPE_CH_VOLUME, 	"Ch Vol G", 	50},
	{AQ_TYPE_FIR,			"FIR",			768},	///Comm+AQ part = 2627
#endif
};
static const UINT8 u1SonyAudAQDscrptSize = sizeof(_arSonyAudNvmDscrpt)/sizeof(AUD_AQ_DSCRPT_T);

#if 1 ///def CC_SONY_2K13_FLASH_AQ
/// For 2K13 FlashAQ "AMP Function Field" sheet
static const AUD_AQ_DSCRPT_T _arSonyAmpNvmDscrpt[] =
{
    ///AMP Function Field
    ///Amp AQ Part = 54
    {AQ_TYPE_LEVEL,         "Level",        48},
    {AQ_TYPE_POST,          "PostScl",      6},
};
static const UINT8 u1ISonyAmpAQDscrptSize = sizeof(_arSonyAmpNvmDscrpt)/sizeof(AUD_AQ_DSCRPT_T);
#endif

static const AUD_MTS_FAC_T _arSonyMtsFactory =
{
    50,                                // numers of check
    //****** stereo detection  **********************//
    35,                                // numers of pilot
    155,                               // higher threshold of pilot detection
    51, /*for FXC 100%->15% spec 112,*/// lower threshold of pilot detection
    //****** SAP detection  *************************//
    30,                                // numers of SAP
    144,                               // higher threshold of SAP detection
    106,                               // lower threshold of SAP detection
    //****** high deviation mode  *******************//
    FALSE,                             // enable/disable of high deviation mode
    //****** carrier shift mode  ********************//
    TRUE,                             // enable/disable of carrier shift mode
    //****** FM saturation mute mode  ***************//
    FALSE,                             // enable/disable of saturation mute mode
    69,                                // higher threshold of saturation mute
    16,                                // lower threshold of saturation mute
    //****** FM carrier mute mode  ******************//
    FALSE,                             // enable/disable of FM carrier mute mode
    180,                               // higher threshold of FM carrier mute
    120,                                // lower threshold of FM carrier mute
    //****** prescale  ******************************//
    20,                                //mono and stereo prescale
    25,                                //SAP prescale
    //****** pilot offset calibration mode  *********//
    FALSE,                             // enable/disable of pilot calibration mode
    //****** SAP noise mute  ************************//
    10,                               //  (higher threshold - lower threshold )of SAP noise mute
    12                                 // lower threshold of SAP noise mute
};

static const AUD_A2_FAC_T _arSonyA2Factory =
{
    //******  detection  ****************************//
    10,                                // numers of check
    10,                                // numers of double check
    1,                                 // mono weight
    1,                                 // stereo weight
    1,                                 // dual weight
    //****** high deviation mode  *******************//
    FALSE,                             // enable/disable of high deviation mode
    //****** carrier shift mode  ********************//
    FALSE,                             // enable/disable of carrier shift mode
    //****** FM carrier mute mode  ******************//
    FALSE,                             // enable/disable of FM carrier mute mode
    34,                                // higher threshold of FM carrier mute
    32,                                // lower threshold of FM carrier mute
    //****** prescale  ******************************//
    21,                                //A2 prescale
    //****** FM saturation mute mode  ***************//
    FALSE,                             // enable/disable of saturation mute mode
    //****** non-EU mode  ***************************//
    FALSE,                               // enable/disable of non-EU mode
    //****** stereo/dual detection threshold  *******************//
    128,                             // mono 2 stereo threshold for EU model
    64,                             // stereo 2 mono threshold for EU model
    112,                             // mono 2 stereo threshold for Korea model
    80,                             // stereo 2 mono threshold for Korea model
    656,                             // mono 2 stereo threshold for EU model
    896                             // stereo 2 mono threshold for EU model
};

static const AUD_PAL_FAC_T _arSonyPalFactory =
{
    //******  detection  ****************************//
    6,                                 // correction threshold
    63,                                // total sync loop
    8,                                 // error threshold
    1056,                                // parity error threshold
    512,                               // every number frames
    //****** high deviation mode  *******************//
    TRUE,                              // enable/disable of high deviation mode
    //****** AM mute mode  ******************//
    FALSE,                             // enable/disable of AM mute mode
    53,                                // higher threshold of AM mute
    37,                                // lower threshold of AM mute
    //****** carrier shift mode  ********************//
    FALSE,                             // enable/disable of carrier shift mode
    //****** FM carrier mute mode  ******************//
    FALSE,                             // enable/disable of FM carrier mute mode
    59,                                // higher threshold of FM carrier mute     
    42,                                // lower threshold of FM carrier mute
#ifdef CC_AUD_SX1_FEATURE    
    150,                                // higher threshold of FM carrier mute(HDEV mode)     
    124,                                // lower threshold of FM carrier mute(HDEV mode)     
#endif    
    //****** prescale  ******************************//
    21,                                //PAL prescale
    25,                                //AM prescale
    19,                                //NICAM prescale
    //****** FM saturation mute mode  ***************//
    FALSE,                             // enable/disable of saturation mute mode
    //****** non-EU mode  ***************************//
    FALSE,                       // enable/disable of non-EU mode
     //****** not to boost NICAM I ? ********************//
    FALSE                              // False :to boost nicam I by 4dB, True: not to boost NICAM I for 4dB
};

#endif /* SONY_AUD_H */

