/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*************************************************************************
 *
 * Filename:
 * ---------
 *   $Workfile: drv_upscaler.h $
 *
 * Project:
 * --------
 *
 *
 * Description:
 * ------------
 *
 *
 * Author:
 * -------
 *
 *
 * Last changed:
 * -------------
 * $Author: dtvbm11 $
 *
 * $Modtime: 04/05/28 9:33a $
 *
 * $Revision: #1 $
*************************************************************************/

#ifndef _DRV_UPSCALER_H_
#define _DRV_UPSCALER_H_

#include "hw_scpip_pq.h"

enum SCPQ_COEF_TYPE
{
	COEFTYP_HOR_Y=0,
	COEFTYP_HOR_C,
	COEFTYP_VER_Y,
	COEFTYP_VER_C,
	COEFTYP_MAX
};

enum SCPQ_INPUTBIT_NUM
{
	SCIN_422=0,
	SCIN_444,
	COEFMODE_MAX
};

enum PSCPQ_COEF_TYPE
{
	PSC_COEFTYP_HOR_Y=0,
	PSC_COEFTYP_HOR_C,
	PSC_COEFTYP_MAX
};
#define SCPQ_PHASE_NUM 129
#define SCPQ_COEF_LEN 3
#define SCPQ_COEF_TBLSIZE (SCPQ_COEF_LEN*SCPQ_PHASE_NUM)
#define SCPQ_COEFF_TYPENUM 4
#define SCPQ_COEF_TOTAL_SIEZ (SCPQ_COEFF_TYPENUM*SCPQ_COEF_TBLSIZE)


void vDrvSCPQInit(void);
void vDrvSCPQSramCoeffOnOff(UINT8 bOnOff);
UINT8 bDrvSCPQCoeffValidate(UINT8 bType, UINT32 dwCoeffTblR[SCPQ_COEF_TBLSIZE], UINT32 dwCoeffTblW[SCPQ_COEF_TBLSIZE]);
void vDrvSCPQSetSramCoeff(UINT8 bType, UINT32 dwCoeff[SCPQ_COEF_TBLSIZE]);
UINT8 vDrvSCPQSetVCoeff(UINT8 bPath);
UINT8 vDrvSCPQSetHCoeff(UINT8 bPath);
void vDrvDeRingInit(void);
void vDrvDeRingOnOff(UINT8 bPath, UINT8 bOnOff);
void vDrvDeRingHOnOff(UINT8 bOnOff);
void vDrvDeRingVOnOff(UINT8 bOnOff);   
void vDrvSCPQCoeffRead(UINT8 bType, UINT32 dwResult[SCPQ_COEF_TBLSIZE]);
void vDrvSCPQTapAdapInit(void);
void vDrvSCPQTapAdapOnOff(UINT8 bOnOff);
// Post Upscaler
#if defined(CC_MT5398)
void vDrvUsPeiInit(void);
void vDrvUsPeiOnOff(UINT8 bOnOff);
UINT8 bDrvPSCPQCoeffValidate(UINT8 bType, UINT32 dwCoeffTblR[SCPQ_COEF_TBLSIZE], UINT32 dwCoeffTblW[SCPQ_COEF_TBLSIZE]);
void vDrvPSCPQSetSramCoeff(UINT8 bType, UINT32 dwCoeff[SCPQ_COEF_TBLSIZE]);
void vDrvPSCPQCoeffRead(UINT8 bType, UINT32 dwResult[SCPQ_COEF_TBLSIZE]);
void vDrvPostDeRingInit(void);
void vDrvPostDeRingOnOff(UINT8 bPath, UINT8 bOnOff);
#endif
#endif

