/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/**
 * @file LVDS HW register map
 *
 * @author dragon_chen@mtk.com.tw
 */

#ifndef _HW_LVDS_H_
#define _HW_LVDS_H_

// *********************************************************************
// LVDS Register
// *********************************************************************

#ifdef CC_UP8032_ATV
#define IO_VIRT 0
#endif
#if defined (CC_MT5880)
#define IO_ANA_LVDS (IO_VIRT + 0x62100)
#else
#define IO_ANA_LVDS (IO_VIRT + 0x60000)
#endif

    
#define REG_LVDS_TX_CFG0 (IO_ANA_LVDS+0x00)
    #define RG_LVDSB_TVO Fld(4, 28, AC_MSKB3) //31:28
    #define RG_LVDSB_TVCM Fld(4, 24, AC_MSKB3) //27:24
    #define RG_LVDSB_NSRC Fld(3, 20, AC_MSKB2) //22:20
    #define RG_LVDSB_PSRC Fld(3, 17, AC_MSKB2) //19:17
    #define RG_LVDSB_EN Fld(1, 16, AC_MSKB2) //16
    #define RG_LVDSB_BIAS_ODD_PWD Fld(1, 15, AC_MSKB1) //15
    #define RG_LVDSB_BIAS_EVEN_PWD Fld(1, 14, AC_MSKB1) //14
#if defined (CC_MT5880)
    #define RG_LVDSB_EXT_EN_D11 Fld(14, 0, AC_MSKW10) //13:0
    #define RG_LVDSB_EXT_EN_D11_E0 Fld(1, 7, AC_MSKW10) //7
#else
    #define RG_LVDSB_EXT_EN_D11 Fld(12, 0, AC_MSKW10) //11:0
#endif    
#define REG_LVDS_TX_CFG1 (IO_ANA_LVDS+0x04)
    #define RG_LVDSB_TVO_PRE Fld(3, 28, AC_MSKB3) //30:28
    #define RG_LVDSB_BIAS_SEL Fld(2, 24, AC_MSKB3) //25:24
    #define RG_LVDSB_PAD_TST_SEL Fld(1, 16, AC_MSKB2) //16
#if defined (CC_MT5880)
    #define RG_LVDSB_DRV_PWD Fld(14, 0, AC_MSKW10) //13:0
#else
    #define RG_LVDSB_DRV_PWD Fld(12, 0, AC_MSKW10) //11:0
#endif    
#define REG_LVDS_TX_CFG2 (IO_ANA_LVDS+0x08)
#if defined (CC_MT5880)
    #define RG_LVDSB_PRE_PWD Fld(14, 16, AC_MSKW32) //29:16
     #define RG_LVDSB_CLK_IQ_SEL Fld(14, 0, AC_MSKW10) //13:0
#else     
    #define RG_LVDSB_PRE_PWD Fld(12, 16, AC_MSKW32) //27:16
     #define RG_LVDSB_CLK_IQ_SEL Fld(12, 0, AC_MSKW10) //11:0
#endif     
#define REG_LVDS_TX_CFG3 (IO_ANA_LVDS+0x0c)
    #define RG_LVDSB_SEL_CKTST Fld(1, 0, AC_MSKB0) //0
#define REG_LVDS_TX_CFG4 (IO_ANA_LVDS+0x10)
    #define RG_LVDSB_SEL_MERGE Fld(1, 16, AC_MSKB2) //16
    #define RG_LVDSB_CKDIGFF_INV_D11 Fld(1, 0, AC_MSKB0) //0
#define REG_LVDS_TX_CFG5 (IO_ANA_LVDS+0x14)
    #define RG_LVDSB_REV_O Fld(16, 16, AC_FULLW32) //31:16
    #define RG_LVDSB_REV_E Fld(16, 0, AC_FULLW10) //15:0
#define REG_LVDS_TX_CFG6 (IO_ANA_LVDS+0x18)
    #define RG_LVDSB_ATST_ODD_EN_D11 Fld(1, 23, AC_MSKB2) //23
    #define RG_LVDSB_ABIST_LB_ODD_SEL_D11 Fld(2, 18, AC_MSKB2) //19:18
    #define RG_LVDSB_ABIST_LB_DIV_ODD_D11 Fld(2, 16, AC_MSKB2) //17:16
    #define RG_LVDSB_ABIST_LB_ODD_EN_D11 Fld(1, 14, AC_MSKB1) //14
    #define RG_LVDSB_ABIST_ODD_EN_D11 Fld(1, 12, AC_MSKB1) //12
    #define RG_LVDSB_BIST_ODD_EN_D11 Fld(1, 11, AC_MSKB1) //11
    #define RG_LVDSB_BIST_TOGGLE_ODD_D11 Fld(1, 10, AC_MSKB1) //10
    #define RG_LVDSB_INSKEWTST_ODD_EN_D11 Fld(1, 9, AC_MSKB1) //9
    #define RG_LVDSB_ABIST_VL_ODD_SEL_D11 Fld(2, 4, AC_MSKB0) //5:4
    #define RG_LVDSB_SERABIST_ODD_SEL_D11 Fld(3, 0, AC_MSKB0) //2:0
#define REG_LVDS_TX_CFG7 (IO_ANA_LVDS+0x1c)
    #define RG_LVDSB_ATST_EVEN_EN_D11 Fld(1, 23, AC_MSKB2) //23
    #define RG_LVDSB_ABIST_LB_EVEN_SEL_D11 Fld(2, 18, AC_MSKB2) //19:18
    #define RG_LVDSB_ABIST_LB_DIV_EVEN_D11 Fld(2, 16, AC_MSKB2) //17:16
    #define RG_LVDSB_ABIST_LB_EVEN_EN_D11 Fld(1, 14, AC_MSKB1) //14
    #define RG_LVDSB_ABIST_EVEN_EN_D11 Fld(1, 12, AC_MSKB1) //12
    #define RG_LVDSB_BIST_EVEN_EN_D11 Fld(1, 11, AC_MSKB1) //11
    #define RG_LVDSB_BIST_TOGGLE_EVEN_D11 Fld(1, 10, AC_MSKB1) //10
    #define RG_LVDSB_INSKEWTST_EVEN_EN_D11 Fld(1, 9, AC_MSKB1) //9
    #define RG_LVDSB_ABIST_VL_EVEN_SEL_D11 Fld(2, 4, AC_MSKB0) //5:4
    #define RG_LVDSB_SERABIST_EVEN_SEL_D11 Fld(3, 0, AC_MSKB0) //2:0
#define REG_LVDS_TX_CFG8 (IO_ANA_LVDS+0x20)
    #define RG_LVDSDB_ENEDGE_SEL_D11 Fld(1, 18, AC_MSKB2) //18
    #define RG_LVDSB_RESYNC_CLK_IQ_SEL_D11 Fld(1, 17, AC_MSKB2) //17
    #define RG_LVDSB_LDO_PWD_D11 Fld(1, 16, AC_MSKB2) //16
    #define RG_LVDSB_R_TERM_D11 Fld(2, 14, AC_MSKB1) //15:14
#if defined (CC_MT5880)
    #define RG_LVDSB_IMP_TEST_EN Fld(14, 0, AC_MSKW10) //13:0
#else
    #define RG_LVDSB_IMP_TEST_EN Fld(12, 0, AC_MSKW10) //11:0
#endif
#if defined (CC_MT5880)
#define RGS_LVDS_TX_CFG0 (IO_ANA_LVDS+0x24)    
#define RGS_ABIST_ODD_21EDG_D11 Fld(1, 31, AC_MSKB3) //31    
#define RGS_ABIST_ODD_21LEV_D11 Fld(1, 30, AC_MSKB3) //30    
#define RGS_ABIST_ODD_51EDG_D11 Fld(1, 29, AC_MSKB3) //29    
#define RGS_ABIST_ODD_51LEV_D11 Fld(1, 28, AC_MSKB3) //28    
#define RGS_ABIST_EVEN_21EDG_D11 Fld(1, 27, AC_MSKB3) //27    
#define RGS_ABIST_EVEN_21LEV_D11 Fld(1, 26, AC_MSKB3) //26
#define RGS_ABIST_EVEN_51EDG_D11 Fld(1, 25, AC_MSKB3) //25    
#define RGS_ABIST_EVEN_51LEV_D11 Fld(1, 24, AC_MSKB3) //24
#else
#define REG_LVDS_TX_CFG9 (IO_ANA_LVDS+0x24)
    #define RG_LVDSA_TVO Fld(4, 28, AC_MSKB3) //31:28
    #define RG_LVDSA_TVCM Fld(4, 24, AC_MSKB3) //27:24
    #define RG_LVDSA_NSRC Fld(3, 20, AC_MSKB2) //22:20
    #define RG_LVDSA_PSRC Fld(3, 17, AC_MSKB2) //19:17
    #define RG_LVDSA_EN Fld(1, 16, AC_MSKB2) //16
    #define RG_LVDSA_BIAS_ODD_PWD Fld(1, 15, AC_MSKB1) //15
    #define RG_LVDSA_BIAS_EVEN_PWD Fld(1, 14, AC_MSKB1) //14
    #define RG_LVDSA_EXT_EN_D11 Fld(12, 0, AC_MSKW10) //11:0
    #define RG_LVDSA_EXT_EN_D11_E0 Fld(1, 6, AC_MSKW10) //6
 #endif   
#define REG_LVDS_TX_CFG10 (IO_ANA_LVDS+0x28)
    #define RG_LVDSA_TVO_PRE Fld(3, 28, AC_MSKB3) //30:28
    #define RG_LVDSA_BIAS_SEL Fld(4, 24, AC_MSKB3) //27:24
    #define RG_LVDSA_NSRC_PRE Fld(3, 20, AC_MSKB2) //22:20
    #define RG_LVDSA_PSRC_PRE Fld(3, 17, AC_MSKB2) //19:17
    #define RG_LVDSA_PAD_TST_SEL Fld(1, 16, AC_MSKB2) //16
    #define RG_LVDSA_VDC_ABIST_SEL Fld(1, 14, AC_MSKB1) //14
    #define RG_LVDSA_DRV_PWD Fld(12, 0, AC_MSKW10) //11:0
#define REG_LVDS_TX_CFG11 (IO_ANA_LVDS+0x2c)
    #define RG_LVDSA_PRE_PWD Fld(12, 16, AC_MSKW32) //27:16
    #define RG_LVDSA_CLK_IQ_SEL Fld(12, 0, AC_MSKW10) //11:0
        #define RG_LVDSA_CLK_IQ_SEL_E3 Fld(1, 11, AC_MSKB1) //21
        #define RG_LVDSA_CLK_IQ_SEL_O3 Fld(1, 5, AC_MSKB0) //15
#define REG_LVDS_TX_CFG12 (IO_ANA_LVDS+0x30)
    #define RG_LVDSA_LVDS_SEL Fld(12, 16, AC_MSKW32) //27:16
    #define RG_LVDSA_HSN_MODE_EVEN_EN_D11 Fld(1, 7, AC_MSKB0) //7
    #define RG_LVDSA_HSP_MODE_EVEN_EN_D11 Fld(1, 6, AC_MSKB0) //6
    #define RG_LVDSA_HSN_MODE_ODD_EN_D11 Fld(1, 5, AC_MSKB0) //5
    #define RG_LVDSA_HSP_MODE_ODD_EN_D11 Fld(1, 4, AC_MSKB0) //4
    #define RG_LVDSA_IMP_REF_MPX_EN_D11 Fld(1, 1, AC_MSKB0) //1
    #define RG_LVDSA_SEL_CKTST Fld(1, 0, AC_MSKB0) //0
#define REG_LVDS_TX_CFG13 (IO_ANA_LVDS+0x34)
    #define RG_LVDSA_SEL_MERGE Fld(1, 16, AC_MSKB2) //16
    #define RG_LVDSA_CKDIGFF_INV_D11 Fld(1, 0, AC_MSKB0) //0
#define REG_LVDS_TX_CFG14 (IO_ANA_LVDS+0x38)
    #define RG_LVDSA_REV_O Fld(16, 16, AC_FULLW32) //31:16
    #define RG_LVDSA_REV_E Fld(16, 0, AC_FULLW10) //15:0
#define REG_LVDS_TX_CFG15 (IO_ANA_LVDS+0x3c)
    #define RG_LVDSA_ATST_ODD_EN_D11 Fld(1, 23, AC_MSKB2) //23
    #define RG_LVDSA_CKINTST_ODD_EN_D11 Fld(1, 22, AC_MSKB2) //22
    #define RG_LVDSA_TBUF_ODD_EN_D11 Fld(1, 21, AC_MSKB2) //21
    #define RG_LVDSA_ABIST_VL_ODD_EN_D11 Fld(1, 20, AC_MSKB2) //20
    #define RG_LVDSA_ABIST_LB_ODD_SEL_D11 Fld(2, 18, AC_MSKB2) //19:18
    #define RG_LVDSA_ABIST_LB_DIV_ODD_D11 Fld(2, 16, AC_MSKB2) //17:16
    #define RG_LVDSA_ABIST_VL_DIV2_ODD_D11 Fld(1, 15, AC_MSKB1) //15
    #define RG_LVDSA_ABIST_LB_ODD_EN_D11 Fld(1, 14, AC_MSKB1) //14
    #define RG_LVDSA_ABIST_ODD_EN_D11 Fld(1, 12, AC_MSKB1) //12
    #define RG_LVDSA_BIST_ODD_EN_D11 Fld(1, 11, AC_MSKB1) //11
    #define RG_LVDSA_BIST_TOGGLE_ODD_D11 Fld(1, 10, AC_MSKB1) //10
    #define RG_LVDSA_INSKEWTST_ODD_EN_D11 Fld(1, 9, AC_MSKB1) //9
    #define RG_LVDSA_ABIST_VL_ODD_SEL_D11 Fld(5, 3, AC_MSKB0) //7:3
    #define RG_LVDSA_SERABIST_ODD_SEL_D11 Fld(3, 0, AC_MSKB0) //2:0
#define REG_LVDS_TX_CFG16 (IO_ANA_LVDS+0x40)
    #define RG_LVDSA_ATST_EVEN_EN_D11 Fld(1, 23, AC_MSKB2) //23
    #define RG_LVDSA_CKINTST_EVEN_EN_D11 Fld(1, 22, AC_MSKB2) //22
    #define RG_LVDSA_TBUF_EVEN_EN_D11 Fld(1, 21, AC_MSKB2) //21
    #define RG_LVDSA_ABIST_VL_EVEN_EN_D11 Fld(1, 20, AC_MSKB2) //20
    #define RG_LVDSA_ABIST_LB_EVEN_SEL_D11 Fld(2, 18, AC_MSKB2) //19:18
    #define RG_LVDSA_ABIST_LB_DIV_EVEN_D11 Fld(2, 16, AC_MSKB2) //17:16
    #define RG_LVDSA_ABIST_VL_DIV2_EVEN_D11 Fld(1, 15, AC_MSKB1) //15
    #define RG_LVDSA_ABIST_LB_EVEN_EN_D11 Fld(1, 14, AC_MSKB1) //14
    #define RG_LVDSA_ABIST_EVEN_EN_D11 Fld(1, 12, AC_MSKB1) //12
    #define RG_LVDSA_BIST_EVEN_EN_D11 Fld(1, 11, AC_MSKB1) //11
    #define RG_LVDSA_BIST_TOGGLE_EVEN_D11 Fld(1, 10, AC_MSKB1) //10
    #define RG_LVDSA_INSKEWTST_EVEN_EN_D11 Fld(1, 9, AC_MSKB1) //9
    #define RG_LVDSA_ABIST_VL_EVEN_SEL_D11 Fld(5, 3, AC_MSKB0) //7:3
    #define RG_LVDSA_SERABIST_EVEN_SEL_D11 Fld(3, 0, AC_MSKB0) //2:0
#define REG_LVDS_TX_CFG17 (IO_ANA_LVDS+0x44)
    #define RG_LVDSA_ENEDGE_SEL_D11 Fld(1, 26, AC_MSKB3) //26
    #define RG_LVDSA_RESYNC_CLK_IQ_SEL_D11 Fld(1, 25, AC_MSKB3) //25
    #define RG_LVDSA_RESYNC_LVDS_SEL_D11 Fld(1, 24, AC_MSKB3) //24
    #define RG_LVDSA_VSW_CALIB_SEL_D11 Fld(1, 23, AC_MSKB2) //23
    #define RG_LVDSA_IMP_COMP_EN_D11 Fld(1, 22, AC_MSKB2) //22
    #define RG_LVDSA_VSW_CALIB_ODD_D11 Fld(1, 21, AC_MSKB2) //21
    #define RG_LVDSA_VSW_CALIB_EVEN_D11 Fld(1, 20, AC_MSKB2) //20
    #define RG_LVDSA_LDO_ODD_PWD_D11 Fld(1, 19, AC_MSKB2) //19
    #define RG_LVDSA_LDO_BIAS_ODD_PWD_D11 Fld(1, 18, AC_MSKB2) //18
    #define RG_LVDSA_LDO_EVEN_PWD_D11 Fld(1, 17, AC_MSKB2) //17
    #define RG_LVDSA_LDO_BIAS_EVEN_PWD_D11 Fld(1, 16, AC_MSKB2) //16
#define REG_LVDS_TX_CFG18 (IO_ANA_LVDS+0x48)
    #define RG_VB1_REV Fld(32, 0, AC_FULLDW) //31:0
    #ifdef CC_MT5398
#define RGS_LVDS_TX_CFG0 (IO_ANA_LVDS+0x4c)
    #define RGS_LVDSA_ABIST_ODD_21EDG_D11 Fld(1, 31, AC_MSKB3) //31
    #define RGS_LVDSA_ABIST_ODD_21LEV_D11 Fld(1, 30, AC_MSKB3) //30
    #define RGS_LVDSA_ABIST_ODD_51EDG_D11 Fld(1, 29, AC_MSKB3) //29
    #define RGS_LVDSA_ABIST_ODD_51LEV_D11 Fld(1, 28, AC_MSKB3) //28
    #define RGS_LVDSA_ABIST_EVEN_21EDG_D11 Fld(1, 27, AC_MSKB3) //27
    #define RGS_LVDSA_ABIST_EVEN_21LEV_D11 Fld(1, 26, AC_MSKB3) //26
    #define RGS_LVDSA_ABIST_EVEN_51EDG_D11 Fld(1, 25, AC_MSKB3) //25
    #define RGS_LVDSA_ABIST_EVEN_51LEV_D11 Fld(1, 24, AC_MSKB3) //24
    #define RGS_LVDSB_ABIST_ODD_21EDG_D11 Fld(1, 23, AC_MSKB2) //23
    #define RGS_LVDSB_ABIST_ODD_21LEV_D11 Fld(1, 22, AC_MSKB2) //22
    #define RGS_LVDSB_ABIST_ODD_51EDG_D11 Fld(1, 21, AC_MSKB2) //21
    #define RGS_LVDSB_ABIST_ODD_51LEV_D11 Fld(1, 20, AC_MSKB2) //20
    #define RGS_LVDSB_ABIST_EVEN_21EDG_D11 Fld(1, 19, AC_MSKB2) //19
    #define RGS_LVDSB_ABIST_EVEN_21LEV_D11 Fld(1, 18, AC_MSKB2) //18
    #define RGS_LVDSB_ABIST_EVEN_51EDG_D11 Fld(1, 17, AC_MSKB2) //17
    #define RGS_LVDSB_ABIST_EVEN_51LEV_D11 Fld(1, 16, AC_MSKB2) //16
    #endif
#endif
