#ifndef _HW_PLLGP_H_
#define _HW_PLLGP_H_

#include <x_hal_5381.h>

#define IO_VPLL_BASE (IO_VIRT + 0x62000)
#define IO_PLLGP_BASE (IO_VIRT + 0x60000)


#define REG_VOPLL_CFG0 (IO_VPLL_BASE + 0x000)
    #define RG_VPLL_BG_CKEN Fld(1,31,AC_MSKB3)//[31:31]
    #define RG_VPLL_XTAL_DIV Fld(1,30,AC_MSKB3)//[30:30]
    #define RG_VPLL_BG_TRIM Fld(4,26,AC_MSKB3)//[29:26]
    #define RG_VPLL_BG_RASEL Fld(2,24,AC_MSKB3)//[25:24]
    #define RG_VPLL_BG_RBSEL Fld(2,22,AC_MSKB2)//[23:22]
    #define RG_VPLL_BG_PWD Fld(1,21,AC_MSKB2)//[21:21]
    #define RG_VPLL_BG_VB1_COMP_PWD Fld(1,20,AC_MSKB2)//[20:20]
    #define RG_VPLL_BG_VB1_PRE_PWD Fld(1,19,AC_MSKB2)//[19:19]
    #define RG_VPLL_BG_VB1_TX_PWD Fld(1,18,AC_MSKB2)//[18:18]
    #define RG_VPLL_BG_LVDS_PWD Fld(1,17,AC_MSKB2)//[17:17]
    #define RG_VPLL_BIAS_BYP Fld(1,16,AC_MSKB2)//[16:16]
    #define RG_VPLL_PWD Fld(1,15,AC_MSKB1)//[15:15]
    #define RG_VPLL_FBKDIV Fld(7,8,AC_MSKB1)//[14:8]
    #define RG_VPLL_PREDIV Fld(2,6,AC_MSKB0)//[7:6]
    #define RG_VPLL_FBKSEL Fld(2,4,AC_MSKB0)//[5:4]
    #define RG_VPLL_POSDIV Fld(2,2,AC_MSKB0)//[3:2]
    #define RG_VPLL_REFSEL Fld(2,0,AC_MSKB0)//[1:0]
#define REG_VOPLL_CFG1 (IO_VPLL_BASE + 0x004)
    #define RG_VPLL_LVDSEN Fld(1,31,AC_MSKB3)//[31:31]
    #define RG_VPLL_VB1EN Fld(1,30,AC_MSKB3)//[30:30]
    #define RG_VPLL_MLVDSEN Fld(1,29,AC_MSKB3)//[29:29]
    #define RG_VPLL_EPIEN Fld(1,28,AC_MSKB3)//[28:28]
    #define RG_VPLL_IDPEN Fld(1,27,AC_MSKB3)//[27:27]
      #define VPLL_POST_SEL Fld(5, 27, AC_MSKB3) //[31:27]      check
        #define VPLL_POST_LVDSEN  (1<<4)//              check
        #define VPLL_POST_VB1EN   (1<<3)//              check
        #define VPLL_POST_MINIEN  (1<<2)//              check
        #define VPLL_POST_EPIEN   (1<<1)//                  check    
    #define RG_VPLL_LVDSCHL_EN Fld(1,26,AC_MSKB3)//[26:26]
    #define RG_VPLL_LVDS_DPIX_DIV2 Fld(1,20,AC_MSKB2)//[20:20]
    #define RG_VPLL_TXCLK_DIV Fld(2,18,AC_MSKB2)//[19:18]
    #define RG_VPLL_TXCLK_DIV2 Fld(2,16,AC_MSKB2)//[17:16]
    #define RG_VPLL_AUTOK_CTRL Fld(2,14,AC_MSKB1)//[15:14]
    #define RG_VPLL_BAND Fld(6,8,AC_MSKB1)//[13:8]
    #define RG_VPLL_AUTOK_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define RG_VPLL_AUTOK_LOAD Fld(1,6,AC_MSKB0)//[6:6]
    #define RG_VPLL_VODEN Fld(1,5,AC_MSKB0)//[5:5]
    #define RG_VPLL_DLY_DATA Fld(4,0,AC_MSKB0)//[3:0]
#define REG_VOPLL_CFG2 (IO_VPLL_BASE + 0x008)
    #define RG_VPLL_DLY_CLKA Fld(4,28,AC_MSKB3)//[31:28]
    #define RG_VPLL_DLY_CLKB Fld(4,24,AC_MSKB3)//[27:24]
    #define RG_VPLL_BIC Fld(3,21,AC_MSKB2)//[23:21]
    #define RG_VPLL_BC Fld(2,19,AC_MSKB2)//[20:19]
    #define RG_VPLL_DIVEN Fld(3,16,AC_MSKB2)//[18:16]
    #define RG_VPLL_BIR Fld(4,12,AC_MSKB1)//[15:12]
    #define RG_VPLL_BP Fld(4,8,AC_MSKB1)//[11:8]
    #define RG_VPLL_BR Fld(3,5,AC_MSKB0)//[7:5]
    #define RG_VPLL_MONEN Fld(1,4,AC_MSKB0)//[4:4]
    #define RG_VPLL_MONENCKEN Fld(1,3,AC_MSKB0)//[3:3]
    #define RG_VPLL_FPEN Fld(1,2,AC_MSKB0)//[2:2]
    #define RG_VPLL_FMEN Fld(1,1,AC_MSKB0)//[1:1]
    #define RG_VPLL_TST_CKENB Fld(1,0,AC_MSKB0)//[0:0]
#define REG_VOPLL_CFG3 (IO_VPLL_BASE + 0x00C)
    #define RG_VPLL_TST_SEL Fld(3,29,AC_MSKB3)//[31:29]
    #define RG_VPLL_CHL_SEL Fld(2,27,AC_MSKB3)//[28:27]
    #define RG_VPLL_XTAL_MONEN Fld(1,26,AC_MSKB3)//[26:26]
    #define RG_VPLL_BG_MONEN Fld(1,25,AC_MSKB3)//[25:25]
    #define RG_VPLL_REF_MONEN Fld(1,24,AC_MSKB3)//[24:24]
    #define RG_VPLL_RESERVE Fld(8,16,AC_FULLB2)//[23:16]
    #define RG_VPLL_RESERVE_bit7 Fld(1, 23, AC_MSKB2) 
    #define RG_PPLL_PWD Fld(1,15,AC_MSKB1)//[15:15]
    #define RG_PPLL_FBKDIV Fld(7,8,AC_MSKB1)//[14:8]
    #define RG_PPLL_PREDIV Fld(2,6,AC_MSKB0)//[7:6]
    #define RG_PPLL_FBKSEL Fld(2,4,AC_MSKB0)//[5:4]
    #define RG_PPLL_POSDIV Fld(2,2,AC_MSKB0)//[3:2]
    #define RG_PPLL_POSDIV2 Fld(2,0,AC_MSKB0)//[1:0]
#define REG_VOPLL_CFG4 (IO_VPLL_BASE + 0x010)
    #define RG_PPLL_REFSEL Fld(2,30,AC_MSKB3)//[31:30]
           #define PPLL_REFSEL_IDP 0
           #define PPLL_REFSEL_DDDS 1
           #define PPLL_REFSEL_VPLL 2    
    #define RG_PPLL_DIVEN Fld(3,27,AC_MSKB3)//[29:27]
    #define RG_PPLL_BP Fld(1,26,AC_MSKB3)//[26:26]
    #define RG_PPLL_BR Fld(1,25,AC_MSKB3)//[25:25]
    #define RG_PPLL_LF Fld(1,24,AC_MSKB3)//[24:24]
    #define RG_PPLL_VODEN Fld(1,23,AC_MSKB2)//[23:23]
    #define RG_PPLL_MONEN Fld(1,22,AC_MSKB2)//[22:22]
    #define RG_PPLL_MONCKEN Fld(1,21,AC_MSKB2)//[21:21]
    #define RG_PPLL_FMEN Fld(1,20,AC_MSKB2)//[20:20]
    #define RG_PPLL_TSTEN Fld(1,19,AC_MSKB2)//[19:19]
    #define RG_PPLL_TST_DIV2 Fld(1,18,AC_MSKB2)//[18:18]
    #define RG_PPLL_RESERVE Fld(2,16,AC_MSKB2)//[17:16]
#define RGS_VOPLL_CFG0 (IO_VPLL_BASE + 0x014)
    #define RGS_VPLL_CAL_CPLT Fld(1,31,AC_MSKB3)//[31:31]
    #define RGS_VPLL_CAL_FAIL Fld(1,30,AC_MSKB3)//[30:30]
    #define RGS_VPLL_CAL_STATE Fld(6,24,AC_MSKB3)//[29:24]

//Page TABLE
#define REG_PLL_GROUP_CFG0 (IO_PLLGP_BASE + 0x900)
    #define FLD_RG_VGAPLL_PWD Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_VGAPLL_VODEN Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_VGAPLL_HF Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_VGAPLL_LF Fld(1,28,AC_MSKB3)//[28:28]
    #define FLD_RG_VGAPLL_V11EN Fld(1,27,AC_MSKB3)//[27:27]
    #define FLD_RG_VGAPLL_PREDIV Fld(2,25,AC_MSKB3)//[26:25]
    #define FLD_RG_VGAPLL_POSDIV Fld(2,23,AC_MSKW32)//[24:23]
    #define FLD_RG_VGAPLL_FBSEL Fld(2,21,AC_MSKB2)//[22:21]
    #define FLD_RG_VGAPLL_BP Fld(1,20,AC_MSKB2)//[20:20]
    #define FLD_RG_VGAPLL_BR Fld(1,19,AC_MSKB2)//[19:19]
    #define FLD_RG_VGAPLL_DIVEN Fld(3,16,AC_MSKB2)//[18:16]
    #define FLD_RG_VGAPLL_FPEN Fld(1,15,AC_MSKB1)//[15:15]
    #define FLD_RG_VGAPLL_MONCKEN Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_VGAPLL_FBDIV Fld(7,7,AC_MSKW10)//[13:7]
    #define FLD_RG_VGAPLL_MONEN Fld(1,6,AC_MSKB0)//[6:6]
    #define FLD_RG_VGAPLL_FMEN Fld(1,5,AC_MSKB0)//[5:5]
    #define FLD_RG_VGAPLL_BS Fld(2,3,AC_MSKB0)//[4:3]
    #define FLD_RG_VGAPLL_DET_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define FLD_RG_VGAPLL_RESERVE Fld(2,0,AC_MSKB0)//[1:0]
#define REG_PLL_GROUP_CFG1 (IO_PLLGP_BASE + 0x904)
    #define FLD_RG_TAPLL_PWD Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_TAPLL_VODEN Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_TAPLL_LF Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_TAPLL_V11EN Fld(1,28,AC_MSKB3)//[28:28]
    #define FLD_RG_TAPLL_PREDIV Fld(2,26,AC_MSKB3)//[27:26]
    #define FLD_RG_TAPLL_POSDIV Fld(2,24,AC_MSKB3)//[25:24]
    #define FLD_RG_TAPLL_FBDIV2 Fld(1,23,AC_MSKB2)//[23:23]
    #define FLD_RG_TAPLL_FBDIV Fld(7,16,AC_MSKB2)//[22:16]
    #define FLD_RG_TAPLL_BP Fld(1,15,AC_MSKB1)//[15:15]
    #define FLD_RG_TAPLL_BR Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_TAPLL_DIVEN Fld(6,8,AC_MSKB1)//[13:8]
    #define FLD_RG_TAPLL_FPEN Fld(1,7,AC_MSKB0)//[7:7]
    #define FLD_RG_TAPLL_MONCKEN Fld(1,6,AC_MSKB0)//[6:6]
    #define FLD_RG_TAPLL_MONEN Fld(1,5,AC_MSKB0)//[5:5]
    #define FLD_RG_TAPLL_FMEN Fld(1,4,AC_MSKB0)//[4:4]
    #define FLD_RG_TAPLL_RESERVE Fld(4,0,AC_MSKB0)//[3:0]
#define REG_PLL_GROUP_CFG2 (IO_PLLGP_BASE + 0x908)
    #define FLD_RG_SYSPLL_PWD Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_SYSPLL_VODEN Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_SYSPLL_LF Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_SYSPLL_V11EN Fld(1,28,AC_MSKB3)//[28:28]
    #define FLD_RG_SYSPLL_PREDIV Fld(2,26,AC_MSKB3)//[27:26]
    #define FLD_RG_SYSPLL_POSDIV Fld(2,24,AC_MSKB3)//[25:24]
    #define FLD_RG_SYSPLL_FBDIV2 Fld(1,23,AC_MSKB2)//[23:23]
    #define FLD_RG_SYSPLL_FBDIV Fld(7,16,AC_MSKB2)//[22:16]
    #define FLD_RG_SYSPLL_BP Fld(1,15,AC_MSKB1)//[15:15]
    #define FLD_RG_SYSPLL_BR Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_SYSPLL_DIVEN Fld(6,8,AC_MSKB1)//[13:8]
    #define FLD_RG_SYSPLL_FPEN Fld(1,7,AC_MSKB0)//[7:7]
    #define FLD_RG_SYSPLL_MONCKEN Fld(1,6,AC_MSKB0)//[6:6]
    #define FLD_RG_SYSPLL_MONEN Fld(1,5,AC_MSKB0)//[5:5]
    #define FLD_RG_SYSPLL_FMEN Fld(1,4,AC_MSKB0)//[4:4]
    #define FLD_RG_SYSPLL_DET_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define FLD_RG_SYSPLL_RESERVE Fld(3,0,AC_MSKB0)//[2:0]
#define REG_PLL_GROUP_CFG3 (IO_PLLGP_BASE + 0x90C)
    #define FLD_RG_HADDS2_PWD Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_HADDS2_VODEN Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_HADDS2_HF Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_HADDS2_LF Fld(1,28,AC_MSKB3)//[28:28]
    #define FLD_RG_HADDS2_V11EN Fld(1,27,AC_MSKB3)//[27:27]
    #define FLD_RG_HADDS2_PREDIV Fld(2,25,AC_MSKB3)//[26:25]
    #define FLD_RG_HADDS2_POSDIV Fld(2,23,AC_MSKW32)//[24:23]
    #define FLD_RG_HADDS2_FBSEL Fld(2,21,AC_MSKB2)//[22:21]
    #define FLD_RG_HADDS2_BP Fld(1,20,AC_MSKB2)//[20:20]
    #define FLD_RG_HADDS2_BR Fld(1,19,AC_MSKB2)//[19:19]
    #define FLD_RG_HADDS2_DIVEN Fld(3,16,AC_MSKB2)//[18:16]
    #define FLD_RG_HADDS2_FPEN Fld(1,15,AC_MSKB1)//[15:15]
    #define FLD_RG_HADDS2_MONCKEN Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_HADDS2_FIFO_START_MAN Fld(1,13,AC_MSKB1)//[13:13]
    #define FLD_RG_HADDS2_DDS_RSTB Fld(1,12,AC_MSKB1)//[12:12]
    #define FLD_RG_HADDS2_DDS_MONEN Fld(1,11,AC_MSKB1)//[11:11]
    #define FLD_RG_HADDS2_MONEN Fld(1,4,AC_MSKB0)//[4:4]
    #define FLD_RG_HADDS2_FMEN Fld(1,3,AC_MSKB0)//[3:3]
    #define FLD_RG_HADDS2_DDS_PWDB Fld(1,2,AC_MSKB0)//[2:2]
    #define FLD_RG_HADDS2_NCPO_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define FLD_RG_HADDS2_DDS_HF_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_PLL_GROUP_CFG4 (IO_PLLGP_BASE + 0x910)
    #define FLD_RG_HADDS2_DDS_DMY Fld(16,16,AC_FULLW32)//[31:16]
    #define FLD_RG_HADDS2_DDSEN Fld(1,15,AC_MSKB1)//[15:15]
    #define FLD_RG_HADDS2_CKREF_SEL Fld(3,12,AC_MSKB1)//[14:12]
    #define FLD_RG_HADDS2_ACCEN Fld(1,11,AC_MSKB1)//[11:11]
    #define FLD_RG_HADDS2_CKCTRL Fld(2,9,AC_MSKB1)//[10:9]
    #define FLD_RG_HADDS2_CK_98M_RSTB Fld(1,8,AC_MSKB1)//[8:8]
    #define FLD_RG_HADDS2_DET_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define FLD_RG_HADDS2_CK_294M_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define FLD_RG_HADDS2_RESERVE Fld(6,0,AC_MSKB0)//[5:0]
#define REG_PLL_GROUP_CFG5 (IO_PLLGP_BASE + 0x914)
    #define FLD_RG_HADDS3_PWD Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_HADDS3_VODEN Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_HADDS3_HF Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_HADDS3_LF Fld(1,28,AC_MSKB3)//[28:28]
    #define FLD_RG_HADDS3_V11EN Fld(1,27,AC_MSKB3)//[27:27]
    #define FLD_RG_HADDS3_PREDIV Fld(2,25,AC_MSKB3)//[26:25]
    #define FLD_RG_HADDS3_POSDIV Fld(2,23,AC_MSKW32)//[24:23]
    #define FLD_RG_HADDS3_FBSEL Fld(2,21,AC_MSKB2)//[22:21]
    #define FLD_RG_HADDS3_BP Fld(1,20,AC_MSKB2)//[20:20]
    #define FLD_RG_HADDS3_BR Fld(1,19,AC_MSKB2)//[19:19]
    #define FLD_RG_HADDS3_DIVEN Fld(3,16,AC_MSKB2)//[18:16]
    #define FLD_RG_HADDS3_FPEN Fld(1,15,AC_MSKB1)//[15:15]
    #define FLD_RG_HADDS3_MONCKEN Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_HADDS3_FIFO_START_MAN Fld(1,13,AC_MSKB1)//[13:13]
    #define FLD_RG_HADDS3_DDS_RSTB Fld(1,12,AC_MSKB1)//[12:12]
    #define FLD_RG_HADDS3_NCPO_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define FLD_RG_HADDS3_MONEN Fld(1,4,AC_MSKB0)//[4:4]
    #define FLD_RG_HADDS3_FMEN Fld(1,3,AC_MSKB0)//[3:3]
    #define FLD_RG_HADDS3_DDS_PWDB Fld(1,2,AC_MSKB0)//[2:2]
    #define FLD_RG_HADDS3_DDS_MONEN Fld(1,1,AC_MSKB0)//[1:1]
    #define FLD_RG_HADDS3_DDS_HF_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_PLL_GROUP_CFG6 (IO_PLLGP_BASE + 0x918)
    #define FLD_RG_HADDS3_DDS_DMY Fld(16,16,AC_FULLW32)//[31:16]
    #define FLD_RG_HADDS3_DDSEN Fld(1,15,AC_MSKB1)//[15:15]
    #define FLD_RG_HADDS3_CKREF_SEL Fld(3,12,AC_MSKB1)//[14:12]
    #define FLD_RG_HADDS3_ACCEN Fld(1,11,AC_MSKB1)//[11:11]
    #define FLD_RG_HADDS3_CKCTRL Fld(2,9,AC_MSKB1)//[10:9]
    #define FLD_RG_HADDS3_CK_98M_RSTB Fld(1,8,AC_MSKB1)//[8:8]
    #define FLD_RG_HADDS3_DET_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define FLD_RG_HADDS3_CK_294M_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define FLD_RG_HADDS3_RESERVE Fld(6,0,AC_MSKB0)//[5:0]
#define REG_PLL_GROUP_CFG7 (IO_PLLGP_BASE + 0x91C)
    #define FLD_RG_G3DPLL_PWD Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_G3DPLL_VODEN Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_G3DPLL_LF Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_G3DPLL_V11EN Fld(1,28,AC_MSKB3)//[28:28]
    #define FLD_RG_G3DPLL_PREDIV Fld(2,26,AC_MSKB3)//[27:26]
    #define FLD_RG_G3DPLL_POSDIV Fld(2,24,AC_MSKB3)//[25:24]
    #define FLD_RG_G3DPLL_FBDIV2 Fld(1,23,AC_MSKB2)//[23:23]
    #define FLD_RG_G3DPLL_FBDIV Fld(7,16,AC_MSKB2)//[22:16]
    #define FLD_RG_G3DPLL_BP Fld(1,15,AC_MSKB1)//[15:15]
    #define FLD_RG_G3DPLL_BR Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_G3DPLL_DIVEN Fld(6,8,AC_MSKB1)//[13:8]
    #define FLD_RG_G3DPLL_FPEN Fld(1,7,AC_MSKB0)//[7:7]
    #define FLD_RG_G3DPLL_MONCKEN Fld(1,6,AC_MSKB0)//[6:6]
    #define FLD_RG_G3DPLL_MONEN Fld(1,5,AC_MSKB0)//[5:5]
    #define FLD_RG_G3DPLL_FMEN Fld(1,4,AC_MSKB0)//[4:4]
    #define FLD_RG_G3DPLL_RESERVE Fld(4,0,AC_MSKB0)//[3:0]
#define REG_PLL_GROUP_CFG8 (IO_PLLGP_BASE + 0x920)
    #define FLD_RG_VGAPLL_SDDS_PD_PDB Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_VGAPLL_SDDS_PD_EN Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_VGATL_BIAS_PWD Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_XDDS_PWDB Fld(1,28,AC_MSKB3)//[28:28]
    #define FLD_RG_XDDS_CKSEL Fld(2,26,AC_MSKB3)//[27:26]
    #define FLD_RG_XDDS_PI_C Fld(3,23,AC_MSKW32)//[25:23]
    #define FLD_RG_XDDS_HF Fld(1,22,AC_MSKB2)//[22:22]
    #define FLD_RG_VGAPLL_CKO_SEL Fld(2,20,AC_MSKB2)//[21:20]
    #define FLD_RG_VGAPLL_R_EN Fld(1,19,AC_MSKB2)//[19:19]
    #define FLD_RG_VGAPLL_G_EN Fld(1,18,AC_MSKB2)//[18:18]
    #define FLD_RG_VGAPLL_B_EN Fld(1,17,AC_MSKB2)//[17:17]
    #define FLD_RG_VGAPLL_RTB_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define FLD_RG_VGAPLL_ENTL Fld(7,9,AC_MSKB1)//[15:9]
    #define FLD_RG_VGAPLL_INTH_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define FLD_RG_VGAPLL_EXTH_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define FLD_RG_VGAPLL_SDDS_FBKSEL Fld(2,5,AC_MSKB0)//[6:5]
    #define FLD_RG_VGATL_TSELA Fld(4,1,AC_MSKB0)//[4:1]
    #define FLD_RG_VGATL_PCLKD2_EN Fld(1,0,AC_MSKB0)//[0:0]
#define REG_PLL_GROUP_CFG9 (IO_PLLGP_BASE + 0x924)
    #define FLD_RG_INTP_TOP_PHSEL_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_VGATL_TSELB Fld(4,27,AC_MSKB3)//[30:27]
    #define FLD_RG_VGAPLL_SDDS_HPOR Fld(1,26,AC_MSKB3)//[26:26]
    #define FLD_RG_VGAPLL_SDDS_HSEL Fld(2,24,AC_MSKB3)//[25:24]
    #define FLD_RG_VGAPLL_SDDS_PDSEL Fld(1,23,AC_MSKB2)//[23:23]
    #define FLD_RG_SDDS_PSEL_EN Fld(1,22,AC_MSKB2)//[22:22]
    #define FLD_RG_HRESYNC_POSEL Fld(1,21,AC_MSKB2)//[21:21]
    #define FLD_RG_VGAPLL_X27IN_EN Fld(1,20,AC_MSKB2)//[20:20]
    #define FLD_RG_XDDS_MONEN Fld(1,19,AC_MSKB2)//[19:19]
    #define FLD_RG_VGATL_RESERVE Fld(3,16,AC_MSKB2)//[18:16]
    #define FLD_RG_DDDS1_PWDB Fld(1,15,AC_MSKB1)//[15:15]
    #define FLD_RG_DDDS1_MONEN Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_DDDS1_CKSEL Fld(2,12,AC_MSKB1)//[13:12]
    #define FLD_RG_DDDS1_PRE_DIV2 Fld(1,11,AC_MSKB1)//[11:11]
    #define FLD_RG_DDDS1_HF Fld(1,10,AC_MSKB1)//[10:10]
    #define FLD_RG_DDDS1_PI_C Fld(3,7,AC_MSKW10)//[9:7]
    #define FLD_RG_DDDS1_CKTX_PWDB Fld(1,6,AC_MSKB0)//[6:6]
    #define FLD_RG_DDDS2_PWDB Fld(1,5,AC_MSKB0)//[5:5]
    #define FLD_RG_DDDS2_MONEN Fld(1,4,AC_MSKB0)//[4:4]
    #define FLD_RG_DDDS2_CKSEL Fld(2,2,AC_MSKB0)//[3:2]
    #define FLD_RG_DDDS2_PRE_DIV2 Fld(1,1,AC_MSKB0)//[1:1]
    #define FLD_RG_DDDS2_HF Fld(1,0,AC_MSKB0)//[0:0]
#define REG_PLL_GROUP_CFG10 (IO_PLLGP_BASE + 0x928)
    #define FLD_RG_DDDS2_PI_C Fld(3,29,AC_MSKB3)//[31:29]
    #define FLD_RG_DMSS_PWDB Fld(1,28,AC_MSKB3)//[28:28]
    #define FLD_RG_DMSS_MONEN Fld(1,27,AC_MSKB3)//[27:27]
    #define FLD_RG_DMSS_CKSEL Fld(2,25,AC_MSKB3)//[26:25]
    #define FLD_RG_DMSS_PRE_DIV2 Fld(1,24,AC_MSKB3)//[24:24]
    #define FLD_RG_DMSS_HF Fld(1,23,AC_MSKB2)//[23:23]
    #define FLD_RG_DMSS_PI_C Fld(3,20,AC_MSKB2)//[22:20]
    #define FLD_RG_DMSS_CKTX_PWDB Fld(1,19,AC_MSKB2)//[19:19]
    #define FLD_RG_HADDS1_PWDB Fld(1,18,AC_MSKB2)//[18:18]
    #define FLD_RG_HADDS1_MONEN Fld(1,17,AC_MSKB2)//[17:17]
    #define FLD_RG_HADDS1_VSP_EN Fld(1,16,AC_MSKB2)//[16:16]
    #define FLD_RG_HADDS1_CKSEL Fld(2,14,AC_MSKB1)//[15:14]
    #define FLD_RG_HADDS1_PRE_DIV2 Fld(1,13,AC_MSKB1)//[13:13]
    #define FLD_RG_HADDS1_HF Fld(1,12,AC_MSKB1)//[12:12]
    #define FLD_RG_HADDS1_PI_C Fld(3,9,AC_MSKB1)//[11:9]
    #define FLD_RG_HADDS1_BIAS_PWD Fld(1,8,AC_MSKB1)//[8:8]
    #define FLD_RG_DDS_RESERVE Fld(8,0,AC_FULLB0)//[7:0]
#define REG_PLL_GROUP_CFG11 (IO_PLLGP_BASE + 0x92C)
    #define FLD_RG_PLLGP_BIAS_PWD Fld(1,31,AC_MSKB3)//[31:31]
    #define FLD_RG_PLLGP_BIAS_RST Fld(1,30,AC_MSKB3)//[30:30]
    #define FLD_RG_PLLGP_XTAL_MONEN Fld(1,29,AC_MSKB3)//[29:29]
    #define FLD_RG_PLLGP_XTAL_PWD Fld(1,28,AC_MSKB3)//[28:28]
    #define FLD_RG_PLLGP_TSTSEL Fld(6,22,AC_MSKW32)//[27:22]
    #define FLD_RG_PLLGP_TSTEN Fld(1,21,AC_MSKB2)//[21:21]
    #define FLD_RG_VGACK_DIV Fld(2,19,AC_MSKB2)//[20:19]
    #define FLD_RG_VGACK_RSTB Fld(1,18,AC_MSKB2)//[18:18]
    #define FLD_RG_TL_27M_SEL Fld(1,17,AC_MSKB2)//[17:17]
    #define FLD_RG_HADDS1_27M_SEL Fld(1,16,AC_MSKB2)//[16:16]
    #define FLD_RG_HADDS2_27M_SEL Fld(1,15,AC_MSKB1)//[15:15]
    #define FLD_RG_HADDS3_27M_SEL Fld(1,14,AC_MSKB1)//[14:14]
    #define FLD_RG_PLLGP_TSTCK_FMEN Fld(1,13,AC_MSKB1)//[13:13]
    #define FLD_RG_PLLGP_TSTCKENB Fld(1,12,AC_MSKB1)//[12:12]
    #define FLD_RG_PLLGP_TSTCKAMP Fld(2,10,AC_MSKB1)//[11:10]
    #define FLD_RG_HADDS_TSTSEL Fld(4,6,AC_MSKW10)//[9:6]
    #define FLD_RG_HADDS_TSTEN Fld(1,5,AC_MSKB0)//[5:5]
    #define FLD_RG_HADDS_TSTCKENB Fld(1,4,AC_MSKB0)//[4:4]
    #define FLD_RG_HADDS_TSTCK_FMEN Fld(1,3,AC_MSKB0)//[3:3]
#define REG_PLL_GROUP_CFG12 (IO_PLLGP_BASE + 0x930)
    #define FLD_RG_HADDS3_TSTSEL Fld(4,28,AC_MSKB3)//[31:28]
    #define FLD_RG_HADDS3_TSTEN Fld(1,27,AC_MSKB3)//[27:27]
    #define FLD_RG_HADDS3_TSTCKENB Fld(1,26,AC_MSKB3)//[26:26]
    #define FLD_RG_HADDS3_TSTCK_FMEN Fld(1,25,AC_MSKB3)//[25:25]
    #define FLD_RG_XTAL_SEL Fld(1,24,AC_MSKB3)//[24:24]
    #define FLD_RG_PLLGP_TOP_RESERVE Fld(11,13,AC_MSKW21)//[23:13]

#endif /* _HW_PLLGP_H_ */
