/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/ng upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/

#ifndef CONFIG_DEFAULT_H
#define CONFIG_DEFAULT_H

/*This is generated by Sony/Salvia_common_pcb_drv_cust.h*/
#ifndef SALVIA_COMMON_PCB_DRV_CUST_H
#define SALVIA_COMMON_PCB_DRV_CUST_H 1

//----------------------------------------------------------------------------
// Initial dram settings
//----------------------------------------------------------------------------
#define DEFAULT_DRAM_TYPE                   DDR_III_x1
#define DEFAULT_DDR_CLOCK                   (1404000000)//(1296000000)

#define DDR3_CMD_DRIVING			0x88
#define DDR3_CS_DRIVING 			0x88


#ifdef CC_FORCE_DRAM256M
#define TOTAL_MEM_SIZE                      (256 * 1024 * 1024)
#else
#define TOTAL_MEM_SIZE                      (512 * 1024 * 1024)
#endif

#ifndef FBM_MEM_CFG_SIZE
#ifdef CC_FORCE_DRAM256M
#define FBM_MEM_CFG_SIZE                    (FBM_MEM_CFG_MT5880_DDR3x1)
#else
#define FBM_MEM_CFG_SIZE                    (FBM_MEM_CFG_MT5880_DDR3x2)
#endif
#endif /* FBM_MEM_CFG_SIZE */


#define DRVCUST_EEPROM_DATA_MEM_OFFSET ((UINT32)0x2F00000)  

#ifdef CC_TRUSTZONE_SUPPORT
#define TRUSTZONE_CODE_BASE                 (0x5000)
#if defined(CC_SVP_SUPPORT)
#define TRUSTZONE_MEM_SIZE                  (16 * 1024 * 1024)
#else
#define TRUSTZONE_MEM_SIZE                  (2 * 1024 * 1024)
#endif
#else
#define TRUSTZONE_MEM_SIZE                  (0)
#endif

//----------------------------------------------------------------------------
// Default Panel setting
//----------------------------------------------------------------------------
#ifndef DEFAULT_PANEL_SELECT
#define DEFAULT_PANEL_SELECT                (PANEL_DEFAULT)
#endif
#define BACKLIGHT_GPIO                      (GPIO(65))
#define BACKLIGHT_ON_VAL                    (1)
#define PANELPOWER_GPIO                     (GPIO(64))
#define PANELPOWER_ON_VAL                   (1)

// disable spread spectrum for vga output
#define SPREAD_SPECTRUM_PERMILLAGE          (0)

// pwm backlight adjustment setting
#define PANEL_BACKLIGHT_PWM_PORT            (2)

#define PDWNC_POLARITY                      (0)

#define SYS_RESET_TIMER             (IS_XTAL_27MHZ()? 0x2932E0 :0x249F00) //100ms

#ifndef DRV_LOGO_ENABLE
#define DRV_LOGO_ENABLE                         (1)
#endif
#define DRV_LOGO_H_FILE                         "Sony/sony_DrvLogo.h"
#define LOADER_MUSIC_H_FILE                     "Sony/sony_DrvLogoMusic.h"
#define DRV_LOGO_EARLY_RETURN_COUNTER          (0x6)

//----------------------------------------------------------------------------
// Audio Customization
//----------------------------------------------------------------------------
//audio
//-----------------------------------------------------------------------------
// AUDIO_Amp_Gpio_Num:         AMP mute
// AUDIO_Amp1_Gpio_Num:       Assist AMP mute (PAA/PAD)
// AUDIO_CUST_HP_GPIO_CTRL:    HP mute (HP/LINEOUT share HW port)
// AUDIO_CUST_SPEC_GPIO_CTRL:  SCART mute (EU)
// AUDIO_CUST_SPEC2_GPIO_CTRL: Hotel Bath SPK mute (PAD) 
//-----------------------------------------------------------------------------
#define AUDIO_INCLUDE_FILE                  "Sony/salvia_aud.h"

#define AUDIO_Amp_Gpio_Num                  80//PIN_TCON0
#define AUDIO_AMP_GPIO_POLARITY             AUD_AMP_GPIO_HIGH_ENALBE //High:Unmute Low:Mute

#define AUDIO_CUST_HP_GPIO_CTRL             86//PIN_TCON6 
#define AUDIO_CUST_HP_POLARITY              AUD_GPIO_HIGH_ENALBE    //High:Unmute Low:Mute

#define AUDIO_HP_PLUG_IN_GPIO               GPIO(92)//PIN_TCON12
#define AUDIO_HP_PLUG_IN_POLARITY           AUD_GPIO_HIGH_ENALBE   //Hihg: Plug in

#define AUDIO_DIGITAL_AMP_RESET_GPIO            85//PIN_TCON5 
#define AUDIO_DIGITAL_AMP_RESET_GPIO_POLARITY   AUD_GPIO_HIGH_ENALBE   //AMP RST High: Normal Low:Mute


#define AUDIO_SPK_TYPE_LARGE                (FALSE)
#define AUDIO_SUBWOOFER_ON                  (TRUE)
#define AUDIO_DOWNMIX_WITH_BALANCE          (FALSE)

#define AUDIO_OUT_PAD_DRV_CUR               (6)

#define AUDIO_INPUT_SW_GPIO_SEL             (&_arSonyInputSwGpio)
#define AUDIO_AOUT_PAD_CFG                  (&_arSonyAoutPadTable)
#define AUDIO_INPUT_MUX_SEL_TABLE           (&_rSonyAudInputMuxTable)
#define AUDIO_ADAC_USAGE                    (&_arSonyAdacUsage)
#define AUDIO_INTER_DAC_USAGE               (&_arSonyInterDacUsage)
#define AUDIO_INTER_DAC_USAGE_ES2           (&_arSonyInterDacUsage)
#define AUDIO_Digital_Data_TABLE            (&_afgSonyAudDigitalDataUsage)
#define AUDIO_INPUT_SRC_VOL                 (&_aai2SonyAudInputSrcVol)
#define AUDIO_AV_INPUT_SRC_VOL              (&_ai2SonyAudAvInputSrcVol) 
#define AUDIO_VOL_TABLE                     (&_au4Sony_VolumeTable) 
#define AUDIO_CHANNEL_VOL_TABLE             (&_au4Sony_VolumeTable)
#define AUDIO_HEADPHONE_VOL_TABLE           (&_au4Sony_VolumeTable)
#define AUDIO_CHL_VOL_EXTRA_GAIN            (&_aai1SonyAudChVolExtraGain)
#define AUDIO_OUT_FMT_TABLE                 (&_arSonyAudOutFmtTable)
#define AUDIO_POWER_ON_MUSIC_VOL            (20)
#define AUDIO_IEC_COPYRIGHT                 (&_au1SonyAudIecCopyright)
#define AUD_CHL_SOUND_MODE_CFG              (&_arSonySoundModeCase)
#define AUDIO_AVC_TARGET_LEV                (&_ai2SonyAudAvcTarget)
#define AUDIO_AVC_GAIN_UP                   (&_ai2SonyAudAvcGainUp)

#ifdef CC_AUD_USE_FLASH_AQ
#ifdef CC_SONY_2K14_FLASH_AQ
#define AUDIO_FLASH_AQ_DATA_DSCRPT          (&_arSonyAudNvmDscrpt)
#define AUDIO_FLASH_AQ_DATA_DSCRPT_SIZE     (u1SonyAudAQDscrptSize)
#else ///def CC_SONY_2K15_FLASH_AQ
#define AUDIO_FLASH_AQ_DATA_DSCRPT          (&_arSonyAudSysNvmDscrpt)
#define AUDIO_FLASH_AQ_DATA_DSCRPT_SIZE     (u1SonyAudSysAQDscrptSize)
#define AUDIO_FLASH_AQ_DATA_DSCRPT1         (&_arSonyAudTuningNvmDscrpt)
#define AUDIO_FLASH_AQ_DATA_DSCRPT_SIZE1    (u1ISonyAudTuningAQDscrptSize)
#endif
#endif
#define FLASH_AQ_BASE_PARTITION             (16)  
#define AUDIO_BI2S_ENABLE                   (FALSE)
#define AUDIO_MTS_FACTORY_MODE              (&_arSonyMtsFactory)
#define AUDIO_A2_FACTORY_MODE               (&_arSonyA2Factory)
#define AUDIO_PAL_FACTORY_MODE              (&_arSonyPalFactory)
#define AUDIO_SPDIF_ENABLE                  (FALSE)
#define AUDIO_DOWNMIX_CHANNEL_POSITION      (DOWNMIX_CH_BEFORE_AVC) 
#define AUDIO_MTK_VS_CLARITY                (0x200000)
#define AUDIO_MTK_VS_WIDTH                  (0x300000)
#define AUDIO_MTK_VS_XTALK                  (0x022000)
#define AUDIO_MTK_VS_OUTPUTGAIN             (0x043000)
#define AUDIO_MTK_VS_BASSGAIN               (0x060000)
#define AUDIO_LINE_OUT_FIX_VOL              (88)

#define AUDIO_HEAAC_MULTICHL_DDCO           (FALSE)

#define FLAG_EXT_STATUS     (1)

#define DEFAULT_DEMOD_RESET_GPIO            (GPIO(58))
#define DEFAULT_DEMOD_I2C_BUS_ID  1
#define DEFAULT_TUNER_I2C_BUS_ID 1


//----------------------------------------------------------------------------
// EEPROM customization
//----------------------------------------------------------------------------
#define SYSTEM_EEPROM_ADDRESS             (0xA4)
#ifdef REPLACE_EEPROM_WITH_FLASH
#define SYSTEM_EEPROM_SIZE                  (16*1024)
#else
#define SYSTEM_EEPROM_SIZE                  0x4000//(4096)
#endif
#define SYSTEM_EEPROM_WP_GPIO               (68)
#define SYSTEM_EEPROM_WP_ENABLE_POLARITY    (0)
#define SYSTEM_EEPROM_BUS                   (1)

#define EDID_INCLUDE_FILE                "Sony/salvia_edid.h"

//----------------------------------------------------------------------------
// USB Customization
//----------------------------------------------------------------------------
// 1. Loader/Nuclues system, USB port using define (1)=used (0)=not used
#define USB0_PORT_USING_LOADER              (1)
#define USB1_PORT_USING_LOADER              (0)
#define USB2_PORT_USING_LOADER              (0)
#define USB3_PORT_USING_LOADER              (0)

// 2. Linux/Android System USB port using define (1)=used (0)=not used
#define USB0_PORT_USING                     (1)
#define USB1_PORT_USING                     (1)
#define USB2_PORT_USING                     (0)
#define USB3_PORT_USING                     (0)




// 3. USB power switch Vbus GPIO control, if vbus not control by GPIO, mark off it.
#ifndef CC_IS_SIMPLE_IPTV
#define USB0_VBUS_GPIO   (200) //(63)
#define USB0_VBUS_GPIO_POLARITY             (1)
#endif
// 4. USB power switch overcurrent GPIO control, if have not ic to control by GPIO, mark off it.
#ifndef CC_IS_SIMPLE_IPTV
#define USB0_OC_GPIO                        (202) //GPIO(73)
#define USB0_OC_GPIO_POLARITY               (0)
#endif

// 5. Detect USB upgrade time, default is 0, but some device maybe can't detect when upgrade.
// If possible, set it to (300)ms when in customer's module.
#define USB_LOADER_WAIT_TIME                (0)

#ifdef CC_IS_SIMPLE_IPTV
#define USB_HUB_RESET_GPIO (GPIO(82))//PIN_TCON2
#define USB_HUB_RESET_GPIO_POLARITY (0)//L:RESET H:NORMAL
#endif

//----------------------------------------------------------------------------
// WIFI Customization
//----------------------------------------------------------------------------
#define CONFIG_WIFI_PORT_DISABLE 1
#define CONFIG_WIFI_PORT_NUMBER    1//wifi is in usb port 1
#ifdef WIFI_WOWLAN_SUPPORT
#define WAKEUP_ON_WLAN_GPIO OPCTRL(2)
#define WAKEUP_ON_WLAN_POL (1) //high:wakeup
#define WIFI_MODULE_RESET_GPIO    GPIO(87)
#define WIFI_MODULE_RESET_GPIO_POL (1)//High is reset
#define WIFI_MODULE_RESET_DURATION  (2000)//ms
#endif
//----------------------------------------------------------------------------
// Button Customization
//----------------------------------------------------------------------------
#define FLAG_BUTTON_SUPPORT                 (1)
#define BUTTON_INCLUDE_FILE                 "Sony/Salvia_button.h"

#ifndef T8032UP_INCLUDE_FILE
#define T8032UP_INCLUDE_FILE                "Sony/sony_t8032fw.h"
#define T8032UP_OFFSET                      au1T8032FW
#define T8032UP_SIZE                        24576//16384
#endif

//----------------------------------------------------------------------------
// MTK IR only setting
//----------------------------------------------------------------------------
#define IR_INCLUDE_FILE                     "Sony/sirc_ir.h"

#ifndef NPTV_SOURCE_TABLE
#ifdef NEW_BOARD
#define NPTV_SOURCE_TABLE       "Sony/salvia_source_table.c"
#else
#define NPTV_SOURCE_TABLE                   "mtk/source_table.c"
#endif
#endif
//----------------------------------------------------------------------------
// default PIN Setup
//----------------------------------------------------------------------------
#define PINMUX_INCLUDE_FILE                 "Sony/sony_salvia_pin_setup.h"
#define GPIO_INCLUDE_FILE                       "Sony/Salvia_gpio.h"

//----------------------------------------------------------------------------
// default HDMI GPIO control
//----------------------------------------------------------------------------
#define HDMI_GPIO_CONF "Sony/salvia_hdmi_conf.c"

/*
 * default VGA table
*/
#ifndef VGA_INCLUDE_FILE
#define VGA_INCLUDE_FILE                    "Sony/Sony_vga.h"
#endif

//----------------------------------------------------------------------------
// Tcon Customization
//----------------------------------------------------------------------------
// support LVDS and MLVDS both
#define PANEL_DISPLAY_TYPE_ALLOWED_MASK ((1<<PANEL_DISPLAY_TYPE_LVDS) | (1 << PANEL_DISPLAY_TYPE_MLVDS))

#ifndef TCON_CUST_FILE
#define TCON_CUST_FILE                      "mtk/Viper_tcon_cust.c"
#endif
//#define SUPPORT_LOCK_FROM_SRVAD 

//----------------------------------------------------------------------------
// DMX configuration
//----------------------------------------------------------------------------
#define DMX_INCLUDE_FILE                "Sony/salvia_dmx.h"

//----------------------------------------------------------------------------
// SIF configuration
//----------------------------------------------------------------------------
#define SIF_INCLUDE_FILE               "mtk/mtk_sif_cfg.h"

//----------------------------------------------------------------------------
// Loader configuration
//----------------------------------------------------------------------------
#ifdef CC_USE_256MB_NAND
#define MAX_UPGRADE_IMAGE_FILE_SIZE         (256*1024*1024)     /* 256 MB */
#else
#define MAX_UPGRADE_IMAGE_FILE_SIZE         (512*1024*1024)     /* 512 MB */
#endif

#define LOADER_UPGRADE_ONLY_ACON 0

#if defined(LINUX_TURNKEY_SOLUTION) || defined(__KERNEL__)
//----------------------------------------------------------------------------
// Flash Partition configuration
//----------------------------------------------------------------------------
#define NAND_INCLUDE_FILE                   "Sony/sony_flash_layout.h"

#endif //defined(LINUX_TURNKEY_SOLUTION) || defined(__KERNEL__)

/*
 * dynamic backlight parameter
*/

/*
 * OD setting
*/

#define SUPPORT_OD                          (0)

#ifndef CUSTOM_VIDEO_DRV_BODY_FILE
#define CUSTOM_VIDEO_DRV_BODY_FILE              "Sony/video_drv/Salvia_video_drv.c"
#endif

#ifndef CUSTOM_BACKLIGHT_DRV_BODY_FILE
#define CUSTOM_BACKLIGHT_DRV_BODY_FILE          "Sony/video_drv/Salvia_backlight_drv.c"
#endif

#ifndef COLOR_PARAM_INCLUDE_FILE
#define COLOR_PARAM_INCLUDE_FILE                "Sony/PANEL_DEFAULT/color_param.h"
#endif

//----------------------------------------------------------------------------
// D-interface Customization
//----------------------------------------------------------------------------
#ifndef DRV_CUSTOM_CUST_FILE
#define DRV_CUSTOM_CUST_FILE                    "Sony/Soem_linux_d_custom.c"
#endif

#ifndef DRV_CUSTOM_CUST_SPEC_SET
#define DRV_CUSTOM_CUST_SPEC_SET                d_Soem_cust_spec_set
#endif

#ifndef DRV_CUSTOM_CUST_SPEC_GET
#define DRV_CUSTOM_CUST_SPEC_GET                d_Soem_cust_spec_get
#endif

#define PDWNC_EXT_IMPL                          "Sony/Soem_pdwnc.h"

//----------------------------------------------------------------------------
// Flash Panel
//----------------------------------------------------------------------------
#ifdef CC_PANEL_FROM_FLASH
#ifndef LOAD_PANEL_FROM_FLASH_CUSTOM
#define LOAD_PANEL_FROM_FLASH_CUSTOM            CustomPanelLoadTableFromFlash
#define DUMP_PANEL_LIST_FROM_FLASH_CUSTOM       CustomDumpPanelListFromFlash
#define CUSTOM_SHOW_PANEL_INFO_BY_ID(u4Idx)     CustomShowPanelInfoByID(u4Idx)

#define PANEL_VERSION_LENGTH                    16
#endif
#endif  /* CC_PANEL_FROM_FLASH */

#endif
/*============END(Sony/Salvia_common_pcb_drv_cust.h)===========*/

#if 1
#define CC_CONFIG_OSD_CM_SIZE               (4) // 4:argb 8888 ;2:argb 4444
#define CC_CONFIG_OSD_BUF_MODE              (2) // 2:double  buffer ;1:sngle buffer
        
#ifndef CC_CONFIG_OSD_PLANE1_MAX_W
#define CC_CONFIG_OSD_PLANE1_MAX_W          (0)
#endif
#ifndef CC_CONFIG_OSD_PLANE1_MAX_H
#define CC_CONFIG_OSD_PLANE1_MAX_H          (0)
#endif
#define CC_CONFIG_OSD_PLANE1_MEM_SIZE       (((CC_CONFIG_OSD_PLANE1_MAX_W*     \
                                        CC_CONFIG_OSD_PLANE1_MAX_H*        \
                                        CC_CONFIG_OSD_CM_SIZE*             \
                                        CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
        // osd 3d buffer size
#if (defined(CC_CONFIG_OSD_SBS_PLANE1)||defined(CC_CONFIG_OSD_TB_PLANE1))
#define CC_CONFIG_OSD_3D_PLANE1_MEM_SIZE    (CC_CONFIG_OSD_PLANE1_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE1_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE1_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE1_MEM_SIZE   (CC_CONFIG_OSD_PLANE1_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE1_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE2_MAX_W
#define CC_CONFIG_OSD_PLANE2_MAX_W          (960)
#endif
#ifndef CC_CONFIG_OSD_PLANE2_MAX_H
#define CC_CONFIG_OSD_PLANE2_MAX_H          (540)
#endif
#define CC_CONFIG_OSD_PLANE2_MEM_SIZE       (((CC_CONFIG_OSD_PLANE2_MAX_W*     \
                                            CC_CONFIG_OSD_PLANE2_MAX_H*        \
                                            CC_CONFIG_OSD_CM_SIZE*             \
                                            CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
#if (defined(CC_CONFIG_OSD_SBS_PLANE2)||defined(CC_CONFIG_OSD_TB_PLANE2))
#define CC_CONFIG_OSD_3D_PLANE2_MEM_SIZE    (CC_CONFIG_OSD_PLANE2_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE2_MEM_SIZE    (0)
#endif
        
#ifndef CONFIG_OSD_PLANE2_COMPRESSION
        //#define  CONFIG_OSD_PLANE2_COMPRESSION
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE2_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE2_MEM_SIZE   (CC_CONFIG_OSD_PLANE2_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE2_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE3_MAX_W
#define CC_CONFIG_OSD_PLANE3_MAX_W          (1920)
#endif
#ifndef CC_CONFIG_OSD_PLANE3_MAX_H
#define CC_CONFIG_OSD_PLANE3_MAX_H          (1080)
#endif
#define CC_CONFIG_OSD_PLANE3_MEM_SIZE       (((CC_CONFIG_OSD_PLANE3_MAX_W*     \
                                            CC_CONFIG_OSD_PLANE3_MAX_H*        \
                                            CC_CONFIG_OSD_CM_SIZE*             \
                                            CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
#if (defined(CC_CONFIG_OSD_SBS_PLANE3)||defined(CC_CONFIG_OSD_TB_PLANE3))
#define CC_CONFIG_OSD_3D_PLANE3_MEM_SIZE    (CC_CONFIG_OSD_PLANE3_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE3_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifndef CONFIG_OSD_PLANE3_COMPRESSION
        // #define  CONFIG_OSD_PLANE3_COMPRESSION
#endif
        
#ifdef CONFIG_OSD_PLANE3_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE3_MEM_SIZE   (CC_CONFIG_OSD_PLANE3_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE3_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE4_MAX_W
#define CC_CONFIG_OSD_PLANE4_MAX_W          (0)
#endif
#ifndef CC_CONFIG_OSD_PLANE4_MAX_H
#define CC_CONFIG_OSD_PLANE4_MAX_H          (0)
#endif
#define CC_CONFIG_OSD_PLANE4_MEM_SIZE       (((CC_CONFIG_OSD_PLANE4_MAX_W*     \
                                            CC_CONFIG_OSD_PLANE4_MAX_H*        \
                                            CC_CONFIG_OSD_CM_SIZE*             \
                                            CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
#if (defined(CC_CONFIG_OSD_SBS_PLANE4)||defined(CC_CONFIG_OSD_TB_PLANE4))
#define CC_CONFIG_OSD_3D_PLANE4_MEM_SIZE    (CC_CONFIG_OSD_PLANE4_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE4_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE4_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE4_MEM_SIZE   (CC_CONFIG_OSD_PLANE4_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE4_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE5_MAX_W
#define CC_CONFIG_OSD_PLANE5_MAX_W          (100)
#endif
#ifndef CC_CONFIG_OSD_PLANE5_MAX_H
#define CC_CONFIG_OSD_PLANE5_MAX_H          (100)
#endif
        
#define CC_CONFIG_OSD_PLANE5_MEM_SIZE       (((CC_CONFIG_OSD_PLANE5_MAX_W*     \
                                    CC_CONFIG_OSD_PLANE5_MAX_H*        \
                                    CC_CONFIG_OSD_CM_SIZE)+0x1000)&(0xFFFFF000))
        
        // osd 3d buffer size
#if (defined(CC_CONFIG_OSD_SBS_PLANE5)||defined(CC_CONFIG_OSD_TB_PLANE5))
#define CC_CONFIG_OSD_3D_PLANE5_MEM_SIZE    (CC_CONFIG_OSD_PLANE5_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE5_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE5_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE5_MEM_SIZE   (CC_CONFIG_OSD_PLANE5_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE5_MEM_SIZE   (0)
#endif
        
#define CC_CONFIG_OSD_PLANE_BASIC_MEM_SIZE  (CC_CONFIG_OSD_PLANE1_MEM_SIZE+ \
                                        CC_CONFIG_OSD_PLANE2_MEM_SIZE+  \
                                        CC_CONFIG_OSD_PLANE3_MEM_SIZE+  \
                                        CC_CONFIG_OSD_PLANE4_MEM_SIZE+  \
                                        CC_CONFIG_OSD_PLANE5_MEM_SIZE)
        
#define CC_CONFIG_OSD_3D_PLANE_MEM_SIZE     (CC_CONFIG_OSD_3D_PLANE1_MEM_SIZE+  \
                                            CC_CONFIG_OSD_3D_PLANE2_MEM_SIZE+   \
                                            CC_CONFIG_OSD_3D_PLANE3_MEM_SIZE+   \
                                            CC_CONFIG_OSD_3D_PLANE4_MEM_SIZE+   \
                                            CC_CONFIG_OSD_3D_PLANE5_MEM_SIZE)
        
#define CC_CONFIG_OSD_DEC_PLANE_MEM_SIZE    (CC_CONFIG_OSD_DEC_PLANE1_MEM_SIZE+ \
                                            CC_CONFIG_OSD_DEC_PLANE2_MEM_SIZE+  \
                                            CC_CONFIG_OSD_DEC_PLANE3_MEM_SIZE+  \
                                            CC_CONFIG_OSD_DEC_PLANE4_MEM_SIZE+  \
                                            CC_CONFIG_OSD_DEC_PLANE5_MEM_SIZE)
        
#define CC_CONFIG_GFX_TEMP_MEM_SIZE         (CC_CONFIG_OSD_PLANE3_MAX_W*    \
                                            CC_CONFIG_OSD_PLANE3_MAX_H*     \
                                            CC_CONFIG_OSD_CM_SIZE)
        
#define DFB_SUM_MEM_SIZE                    (CC_CONFIG_OSD_PLANE_BASIC_MEM_SIZE+\
                                            CC_CONFIG_OSD_3D_PLANE_MEM_SIZE+    \
                                            CC_CONFIG_OSD_DEC_PLANE_MEM_SIZE+   \
                                            CC_CONFIG_GFX_TEMP_MEM_SIZE)
#endif                                                    


#ifdef CC_GFX_MMU
#define DIRECT_FB_MEM_SIZE                  ((DFB_SUM_MEM_SIZE + 4*1024 + 4*1024*1024)&(0xFFFFF000)) 
#else
#define DIRECT_FB_MEM_SIZE                  (96 * 1024 * 1024)
#endif



#define FB_MEM_SIZE                         (0 * 1024 * 1024)

#define LINUX_KERNEL_MEM_SIZE               ((TOTAL_MEM_SIZE > (FBM_MEM_CFG_SIZE + DIRECT_FB_MEM_SIZE + FB_MEM_SIZE + TRUSTZONE_MEM_SIZE)) ?\
                                            (TOTAL_MEM_SIZE - FBM_MEM_CFG_SIZE - DIRECT_FB_MEM_SIZE - FB_MEM_SIZE - TRUSTZONE_MEM_SIZE) : (54 * 1024 * 1024))

#define DEFAULT_TARGET_COUNTRY              (COUNTRY_PAD)
//----------------------------------------------------------------------------
// Audio Customization
//-----------------------------------------------------------------------------
// AUDIO_Amp_Gpio_Num:         AMP mute
// AUDIO_Amp1_Gpio_Num:       Assist AMP mute (PAA/PAD)
// AUDIO_CUST_HP_GPIO_CTRL:    HP mute (HP/LINEOUT share HW port)
// AUDIO_CUST_SPEC_GPIO_CTRL:  SCART mute (EU)
// AUDIO_CUST_SPEC2_GPIO_CTRL: Hotel Bath SPK mute (PAD) 
//-----------------------------------------------------------------------------
//TCON1 for SCART out/ Bath SPK/ AS SPK mute, AS SPK and Bath SPK don't both exist.
#define AUDIO_Amp1_Gpio_Num                 81//PIN_TCON1 //AS SPK
#define AUDIO_AMP1_GPIO_POLARITY            AUD_AMP_GPIO_HIGH_ENALBE //High:Unmute Low:Mute
#define AUDIO_CUST_SPEC2_GPIO_CTRL          81//PIN_TCON1 //Hotel Bath SPK
#define AUDIO_CUST_SPEC2_POLARITY           AUD_GPIO_HIGH_ENALBE   //Hihg:Unmute Low:Mute

//----------------------------------------------------------------------------
// MT8283 Customization
//----------------------------------------------------------------------------

#ifdef DRV_SUPPORT_EXTMJC
//#define MT8280_RESET_GPIO           (WT6720_GPIO2) //(GPIO(80))
//#define MT8280_RESET_GPIO_POLARITY  (0) //Low reset
//#define MT8283_LVDS_POWER_GPIO           (WT6720_GPIO5) //(GPIO(80))
#define CUSTOM_BootupMode           (GPIO_INIT_COMPANION_CHIP)
#endif

#define USB_UPGRADE_FILE_NAME_PREFIX    ("sony_fw_2015_")

#ifdef CC_IS_SIMPLE_IPTV
#define USB_UPGRADE_FILE_NAME           ("sony_fw_2015_0000_SLPDA.pkg")
#define USB_UPGRADE_FILE_NAME_SUFFIX    ("_SLPDA.pkg")
#else
#ifdef CC_USE_SE1L_BOARD
#define USB_UPGRADE_FILE_NAME           ("sony_fw_2015_0000_SLPD2.pkg")
#define USB_UPGRADE_FILE_NAME_SUFFIX    ("_SLPD2.pkg")
#else
#define USB_UPGRADE_FILE_NAME           ("sony_fw_2015_0000_SLPD1.pkg")
#define USB_UPGRADE_FILE_NAME_SUFFIX    ("_SLPD1.pkg")
#endif
#endif


/*This is generated by Sony/sony_eeprom_layout.h*/
#ifndef EEPROM_LAYOUT_H
#define EEPROM_LAYOUT_H

//----------------------------------------------------------------------------
// HDCP EEPROM customization
//----------------------------------------------------------------------------
/* 
Start Address (Size):
    HDCP:           0x000 (320 Bytes)
    DTV Driver:     0x140 ( 96 Bytes)
    NPTV Driver:    0x1A0 (448 Bytes)
    Custom Driver:  0x360 ( 64 Bytes)
    VGA EDID:       0x3A0 (256 Bytes)
    HDMI EDID:      0x4A0 (272 Bytes)
    MW:             0x5B0 (144 Bytes)
    AP:             0x640 (--- Bytes)
*/
#define DRVCUST_EEPROM_HDMI_HDCP_OFFSET     ((UINT32)0)
#define DRVCUST_EEPROM_HDMI_HDCP_SIZE       ((UINT32)320)

#define DRVCUST_EEPROM_DTV_DRIVER_OFFSET    ((UINT32)(DRVCUST_EEPROM_HDMI_HDCP_OFFSET + DRVCUST_EEPROM_HDMI_HDCP_SIZE))
#define DRVCUST_EEPROM_DTV_DRIVER_SIZE      ((UINT32)96)

#define DRVCUST_EEPROM_NPTV_DRIVER_OFFSET   ((UINT32)(DRVCUST_EEPROM_DTV_DRIVER_OFFSET + DRVCUST_EEPROM_DTV_DRIVER_SIZE))
#define DRVCUST_EEPROM_NPTV_DRIVER_SIZE     ((UINT32)448)

#define DRVCUST_EEPROM_CUSTOM_DRIVER_OFFSET ((UINT32)(DRVCUST_EEPROM_NPTV_DRIVER_OFFSET + DRVCUST_EEPROM_NPTV_DRIVER_SIZE))
#define DRVCUST_EEPROM_CUSTOM_DRIVER_SIZE   ((UINT32)64)

#define DRVCUST_EEPROM_VGA_EDID_OFFSET	    ((UINT32)DRVCUST_EEPROM_CUSTOM_DRIVER_OFFSET + DRVCUST_EEPROM_CUSTOM_DRIVER_SIZE)
#define DRVCUST_VGA_EDID_SIZE               ((UINT32)256)
#define DRVCUST_VGA_EDID_STORAGE_SIZE	    ((UINT32)DRVCUST_VGA_EDID_SIZE)

#define DRVCUST_EEPROM_HDMI_EDID_OFFSET     ((UINT32)(DRVCUST_EEPROM_VGA_EDID_OFFSET + DRVCUST_VGA_EDID_STORAGE_SIZE))
#define DRVCUST_HDMI_EDID_SIZE              ((UINT32)256) 
#define DRVCUST_HDMI_EDID_STORAGE_SIZE	    ((UINT32)DRVCUST_HDMI_EDID_SIZE+16) /* 16 for PhyAddr, actually need 4 only */

#define DRVCUST_EEPROM_DRIVER_SIZE          ((UINT32)(DRVCUST_EEPROM_HDMI_EDID_OFFSET + DRVCUST_HDMI_EDID_STORAGE_SIZE))

#define DRVCUST_EEPROM_MW_OFFSET            ((UINT32)(DRVCUST_EEPROM_HDMI_EDID_OFFSET + DRVCUST_HDMI_EDID_STORAGE_SIZE))
#define DRVCUST_EEPROM_MW_SIZE              ((UINT32)144)
#define DRVCUST_EEPROM_MW_DRIVER_SIZE       ((UINT32)DRVCUST_EEPROM_MW_SIZE)

/*
    Notice:
        HDCP2.x is moved to flash (Partition: Miracast HDCP).
        The defiend area here is just for SW compatible and is NOT actually RESERVED in EEPROM.
        But for avoiding un-expected writing or usage, I overlap this area with PQ's WB data.
        Linux: 0x3200, Android: 0xA200
*/
#define DRVCUST_EEPROM_HDCP2X_OFFSET		((UINT32)0x3200)
#define DRVCUST_EEPROM_HDCP2X_SIZE			((UINT32)880)
#define	DRVCUST_EEPROM_HDCP2X_STORAGE_SIZE  ((UINT32)DRVCUST_EEPROM_HDCP2X_SIZE)

#endif /*EEPROM_LAYOUT_H*/
/*============END(Sony/sony_eeprom_layout.h)===========*/
//----------------------------------------------------------------------------
// European CI (Common Interface) customization
//----------------------------------------------------------------------------
#define CI_8295_RESET_GPIO                  (GPIO(15))  // It's GPIO_3 on schematic, but we should use 54. (reference to x_pinmux.h)
#define CI_8295_RESET_POLARITY              (1)
#define CI_EXTERNAL_IC_INT_GPIO             (GPIO(34))  // Set:Interrupt Mode, UnSet:Polling Mode
//#define CI_5V_OC_GPIO                      (MT5135_GPIO(16)) // PAD_IF_AGC of mt5135
#define CI_5V_POWERON_POLARITY              (1)
//#define CI_5V_OC_POLARITY                 (0)
#define CI_5V_POWERON_GPIO                  (GPIO(89))
#define CI_EXTERNAL_IC_DRIVING_CURRENT      (2)         // 2mA
#define CI_SYSTEM_CLOCK                     (72)        // 72 MHz
#define CI_TS_CLOCK                         (108)       // 108 MHz
#define CI_SPI_CLOCK                        (27)        // 72 MHz
#define CI_5V_OC_GPIO    (GPIO(62))
#define CI_5V_OC_POLARITY (0)//0 is fault

//----------------------------------------------------------------------------
// SCART out configuration
//----------------------------------------------------------------------------
#ifndef TVE_INCLUDE_FILE
#define TVE_INCLUDE_FILE                    "mtk/mtk_tve.c"
#endif

#define SCART1_FS_SERVO_ADC             (1)
#define SCART2_FS_SERVO_ADC             (0)



/*
 * default quality table
*/
#ifndef QTYTBL_INCLUDE_FILE
//#define QTYTBL_INCLUDE_FILE               "mtk/QTY_DEFAULT/mtk_QtyTbl.h"
#endif

/*
 * default color parameter
*/
#ifndef COLOR_PARAM_INCLUDE_FILE
//#define COLOR_PARAM_INCLUDE_FILE          "mtk/PANEL_DEFAULT/color_param.h"
#endif

/*
 * dynamic backlight parameter
*/

#ifndef QTYTBL_INCLUDE_FILE
#define QTYTBL_INCLUDE_FILE                 "Sony/QTY_Salvia_PAD/Salvia_QtyTbl.h"
#endif

#else /* CONFIG_DEFAULT_H */
#error "Cannot include multi-config files"
#endif /* CONFIG_DEFAULT_H */

#endif /* C_MODEL_H */
