/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 * Copyright (c) 2004, MediaTek Inc.
 * All rights reserved.
 *
 * Unauthorized use, practice, perform, copy, distribution, reproduction,
 * or disclosure of this information in whole or in part is prohibited.
 *-----------------------------------------------------------------------------
 * $RCSfile: Waff;e_d_custom.c,v $
 * $Revision: #5 $
 * $Date: 2018/03/09 $
 * $Author: daiou.zeng $
 *
 * Description:
 *         This header file contains specific implementation.
 *---------------------------------------------------------------------------*/


//-----------------------------------------------------------------------------
//                    include files
// ----------------------------------------------------------------------------
#include "d_Soem_linux_cust.h"
#include "sv_const.h"
#include "drv_scart.h"
#include "nptv_debug.h"
#include "nptv_drvif.h"
#include "drv_tvd.h"
#include "pe_if.h"
#include "vdp_if.h"
#include "vdec_if.h"
#include "x_drv_cli.h"
#include "x_pdwnc.h"
//#ifdef CC_AUD_SETUP_MELODY 
#include "aud_if.h"
//#endif
#include "panel.h"
#include "dmx_if.h"
#include "tuner_interface_if.h"
#include "nand_if.h"
#include <linux/uaccess.h>
//#include "CustomCtrl.h"
#ifdef LOAD_PANEL_FROM_FLASH_CUSTOM
#include "panel_cust.h"
#endif
#ifndef CC_UBOOT
#include "CustomCtrl.h"
#else
#ifdef TARGET_SPEC_DRV_CUST_CUSTOMIZED_HDR_FILE
#include TARGET_SPEC_DRV_CUST_CUSTOMIZED_HDR_FILE
#endif
#endif
#include "x_gpio.h"
#include "x_os.h"
#define MT5396_PORTING 0// 1
#ifdef CC_Factory2K12
#include "u_drv_cust.h"
#include "ATV/priv_drv/sony_drv_inc/rgb_if.h"
#include "ATV/priv_drv/sony_drv_inc/sig_bstr_if.h"
#include "ATV/priv_drv/sony_drv_inc/temp_setup_if.h"
#include "ATV/priv_drv/sony_drv_inc/a_bl_ctrl.h"
#include "ATV/priv_drv/sony_drv_inc/utility_if.h"
#include "ATV/priv_drv/sony_drv_inc/htl_clk_if.h"
#include "ATV/priv_drv/sony_drv_inc/htl_vol_if.h"
#include "ATV/priv_drv/sony_drv_inc/htl_si_if.h"
#include "ATV/priv_drv/sony_drv_inc/sony_tuner_if.h"
#include "ATV/priv_drv/sony_drv_inc/wb_pbm.h"
#include "ATV/priv_drv/sony_drv_inc/pq_gamma_if.h"
#include "ATV/priv_drv/sony_priv_inc/pq_gamma.h"
#ifndef CC_MTK_LOADER    
#if 1//def STELLAR_LED_SPEC
extern void vSonyLedModeChg(UINT16 u2LedMode);
extern void vUpdateLedFixPattern(UINT8 u1Fixpattern);
extern void vUpdateRecStatus(UINT8 u1Rec);
#endif
#endif
#if defined(CC_PDWNC_SUPPORT_WOL) || defined(WIFI_WOWLAN_SUPPORT)
extern void vWoNET_Exit(void);
extern void vWoNET_Setup_BG(void);
#endif
//extern void vDrvSetDIDataMode(UINT8 u1VdpId,UINT8 u1Onoff); //no need on salvia

#if  defined(SYS_DVBS_SUPPORT) && defined(CC_Factory2K12)//api for dvbs factory
//extern  void TunerDVBSFac_SetLnbVol(UINT8 u1Vol);
extern void TunerDVBSFac_SetLnbVol(UINT8 TunerID, UINT8 u1Vol);
//extern void TunerDVBSFac_GetLnbVol(UINT8 *pu1Vol);
extern void TunerDVBSFac_GetLnbVol(UINT8 TunerID, UINT8 *pu1Vol);
//extern void TunerDVBSFac_GetLnbShortStatus(UINT8 *pbshort);
extern void TunerDVBSFac_GetLnbShortStatus(UINT8 TunerID, UINT8 *pbshort);
//extern void TunerDVBSFac_Set22K(UINT8 u1On);
extern void TunerDVBSFac_Set22K(UINT8 TunerID, UINT8 u1On);
//extern void TunerDVBSFac_GetLnb22KStatus(UINT8 *pb22kOn);
extern void TunerDVBSFac_GetLnb22KStatus(UINT8 TunerID, UINT8 *pb22kOn);
//extern void TunerDVBSFac_SetDemodClock(UINT8 u1ClockOn);
extern void TunerDVBSFac_SetDemodClock(UINT8 TunerID, UINT8 u1ClockOn);
//extern BOOL TunerDVBSFac_GetDemodMountStatus(void);
extern BOOL TunerDVBSFac_GetDemodMountStatus(UINT8 TunerID);
//extern BOOL TunerDVBSFac_GetLNBMountStatus(void);
extern BOOL TunerDVBSFac_GetLNBMountStatus(UINT8 TunerID);
#endif
extern void SelfDiagRequirePanelIDRead(void);
extern void SelfDiagReleasePanelIDRead(void);
#if 0//def CC_Factory2K12
extern BOOL Tuner_IsSignalLoss(VOID); 
#endif

#ifdef CC_Factory2K12_Debug
extern INT32 c_sprintf (CHAR*        ps_str,
                        const CHAR*  ps_format,
                        ...);
extern CHAR fact_dbg_buf[128];  
extern void fact_show_msg(void);
#define Factory2K12Debug(x)	(x); fact_show_msg();
#else
#define Factory2K12Debug(x) 
#endif 
#ifdef ENABLE_USB2UART_FUNC
extern void SerTransparent(void);
#endif
#ifdef CUST_SOEM_DRV //lcct_2H
static UINT32 u4_WB_EDID_Write_return = 0;
static Gamma_RGB_t Current_Gamma_RGB = GAMMA_R;
static Luma_Lvl_t Current_Luma_Lvl = LUMA_LVL_0;
static BOOL fgGammaRefreshFirstcall=TRUE;
static WBS_NVM_ENV_T Current_Wbs_Nvm_Env = {0};
static WB_PBM_PQP_LUT_PRESET_T Current_Pqp_Lut_setting = {0};
#endif

#endif
UINT32 au4Country = 0;

// -------------------------------------------------------------------------
// Defines
// -------------------------------------------------------------------------
#define SIF_ERROR_RETURN            0
#define BUS_ID                      0 //panel i2c bus id
#define TCON_NVM_SLVADDR            0xAA
#define CLK_DIV                     0x100
#define ADDR_LENGTH                 2
#define PIN_LOW                     0
#define PIN_HIGH                    1
#define FLASH_LIGHT_IPREF           32
//---------------------------------------------------------------------------
// Constant definitions
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// Type definitions
//---------------------------------------------------------------------------
#define ENABLE_SOEM_PQ 1
#define ENABLE_SOEM_HDMI 1
//---------------------------------------------------------------------------
// Macro definitions
//---------------------------------------------------------------------------
#define SIZE_CHK(size, target_size)                                   \
          do {                                              \
            if (size != sizeof(target_size)) { \
                LOG(2, "Invalid parameter\n");\
                return RMR_INV_ARG; }     \
          } while (0)

#define PARAM_CHK(ptr, type, limit)  \
          do {                                              \
            if ((ptr == NULL) || ((*(type *)(ptr)) >= limit))\
            {\
                    LOG(2, "Invalid parameter\n");\
                    return RMR_INV_ARG;\
            } } while (0)

//---------------------------------------------------------------------------
// Static variables
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Global variables
//---------------------------------------------------------------------------
extern UINT32 _u4gModelType;
CHAR szTagStr[DRV_CUSTOM_TAG_TYPE_MAX][20]
={
	"load",
	"firm", 
	"pqda", 
	"pnel", 
	"aqda",
	"ueep",
	"uimg",
	"nvrm",
	"edid",
	"upbt",
	"mhl"
  };
        
extern INT32 const YCBCR2RGBOS[3][15];
//extern INT32 COLOR_TRANSFORM_ADJ[15];

//---------------------------------------------------------------------------
// Internal functions
//---------------------------------------------------------------------------
extern void vGetTagVersion(CHAR* ucTagName, CHAR * szVerStr);
extern UINT32 IRRX_ReadSvadc(UINT32 u4Channel);
#ifdef CC_Support_Sil9285
extern UINT8  vSiI9287HDCPKSVread(UINT8*); 
#endif
extern UINT32 IS_SupportRM(VOID);
#if ENABLE_SOEM_PQ
extern void DRVCUST_DBC_DEBUG_MODE(UINT8 bDBC_MAGIC, UINT8 bBrightLevel);
extern UINT16 bDrvGetTVDADCDGain(void);
extern void DRVCUST_TeleText_FLAG(UINT8 bMode);
extern void DRVCUST_MHEG_FLAG(UINT8 bMode);
extern void DRVCUST_GINGA_FLAG(UINT8 bMode);
extern BOOL _bDemoMode;
extern BOOL _bTorchLightOnOff;

#endif
#if ENABLE_SOEM_HDMI
#define SIF_HDCPWithSerialNum		340
#define SIF_HDMIEDID_SIZE 			256
#if defined(CC_SOEM_BOARD)
extern UINT8 SifEDIDRead(UINT8 u1EDID_ID, UINT16 u2Count, UINT8 u1Dev, UINT8 u1Addr, UINT8 * pbData);
#endif
static UINT8 SifHDCPWrite(UINT16 u2_offset, UINT8 *pBuf, UINT16 u2_length)  // jiewen.hdcp
{
	INT32 fgSet;

	fgSet = EEPHDCP_Write(0, (UINT32)pBuf, SIF_HDCPWithSerialNum);
	if (fgSet)
	{
		Printf("EEPHDCP_Write fail.\n");
		return 1;
	}

  
	Printf("write successfully !\n");
	return 0;
}

static UINT8 SifHDCPRead(UINT16 u2_offset, UINT8 *pBuf, UINT16 u2_length)  // jiewen.hdcp
{
	INT32 fgSet;
	
	fgSet = EEPHDCP_Read(u2_offset, (UINT32)pBuf, u2_length);
	if (fgSet)
	{
		Printf("read fail.\n");
		return 1;
	}
	return 0;
}

#endif

#if 0//STELLAR_MODEL==STELLAR_CND
extern void RC232_SetLNA(UINT8 SetVal);
#endif

extern void vStartLedBlink(UINT32 u4LedState);
extern void vStopLedBlink(UINT32 u4LedState);

BOOL gbScartOut = TRUE;
UINT8 buf_HDCP2x[880];
UINT16 hdcp2x_received = 0;

//---------------------------------------------------------------------------
// Global functions
//---------------------------------------------------------------------------
#define NAND_PAGE_SIZE 	4096
#define KEY_HDR_OFFSET	1
#define TVID_KEY_OFFSET	2
#define KEY_DEBUG 		0
#ifndef CC_MTK_LOADER
INT32 ui4GetKeyHeader(INT8 i1_key_hdr, UINT8* pui1_buffer)
{
	INT32 i4_ret = -1, i4_PartID = 0;//, i4_position;
	UINT64 u8Offset = 0;

	UINT8* pui1Buf;

#if KEY_DEBUG
	UINT8 i, j;
#endif

	if(i1_key_hdr >= DRV_CUSTOM_HDR_END)
	{
		Printf("@@@@@@the key header %d is bigger than DRV_CUSTOM_HDR_END\n",i1_key_hdr);
		return i4_ret;
	}
	pui1Buf = x_mem_alloc(DRV_CUSTOM_HDR_END * KEY_HDR_SIZE);
	if(pui1Buf == NULL)
	{
		Printf("@@@@@@ alloc mem fail\n");
		return i4_ret;
	}
	u8Offset = NAND_PAGE_SIZE * KEY_HDR_OFFSET;// + i1_key_hdr*64;
	i4_PartID = (INT32)DRVCUST_OptGet(eHDCPNANDPartId);
	if(i4_PartID > 1)
	{
		u8Offset |= (((UINT64)(UINT32)i4_PartID) << 32);
		Printf("@@@@@@header= %d offset= %llu\n",i1_key_hdr,u8Offset);
		i4_ret = NANDPART_Read(u8Offset, (UINT32)pui1Buf, DRV_CUSTOM_HDR_END * KEY_HDR_SIZE);
		if(i4_ret < 0)
		{
			Printf("@@@@@@ nand read fail\n");
			x_mem_free(pui1Buf);
			return i4_ret;
		}
	}

	x_memcpy(pui1_buffer, (const VOID*)(pui1Buf + i1_key_hdr*KEY_HDR_SIZE), KEY_HDR_SIZE);
	
	x_mem_free(pui1Buf);

#if KEY_DEBUG
	for(i = 0; i < KEY_HDR_SIZE; i +=8)
	{
		Printf("0x%x: ",i);
		for(j=0; j < 8; j++)
		{
			if(j%8 == 7){
				Printf("0x%x\n", *(pui1_buffer + i +j));
			}else{
				Printf("0x%x\t", *(pui1_buffer + i +j));
			}
		}
	}
#endif
	return i4_ret;
}
INT32 ui4SetKeyHeader(INT8 i1_key_hdr,UINT8* pui1_buffer, size_t z_size)
{
	INT32 i4_ret = -1, i4_PartID = 0;//, i4_position;
	UINT64 u8Offset = 0;

	UINT8* pui1Buf;

	if(i1_key_hdr >= DRV_CUSTOM_HDR_END)
	{
		Printf("@@@@@@the key header %d is bigger than DRV_CUSTOM_HDR_END\n",i1_key_hdr);
		return i4_ret;
	}
	if(z_size != KEY_HDR_SIZE)
	{
		Printf("@@@@@@the key header Size is not corrent\n",i1_key_hdr);
		return i4_ret;
	}
	//create buffer for all key
	pui1Buf = x_mem_alloc(DRV_CUSTOM_HDR_END * KEY_HDR_SIZE);
	if(pui1Buf == NULL)
	{
		Printf("@@@@@@ alloc mem fail\n");
		return i4_ret;
	}

	//get offset in nand flash: hdcp1.4 part, page 2;
	u8Offset = NAND_PAGE_SIZE * KEY_HDR_OFFSET;//+ i1_key_hdr*64;
	i4_PartID = (INT32)DRVCUST_OptGet(eHDCPNANDPartId);
	if(i4_PartID > 1)
	{
		u8Offset |= (((UINT64)(UINT32)i4_PartID) << 32);
		Printf("@@@@@@header= %d offset= %llu\n",i1_key_hdr,u8Offset);
		i4_ret = NANDPART_Read(u8Offset, (UINT32)pui1Buf, DRV_CUSTOM_HDR_END * KEY_HDR_SIZE);
		if(i4_ret < 0)
		{
			Printf("@@@@@@ nand read fail\n");
			x_mem_free(pui1Buf);
			return i4_ret;
		}
		//set the key to the right offset
		x_memcpy((pui1Buf + i1_key_hdr*KEY_HDR_SIZE), (const VOID*)pui1_buffer, KEY_HDR_SIZE);
		//write all the key back to nand flash
		i4_ret = NANDPART_Write(u8Offset, (UINT32)pui1Buf, DRV_CUSTOM_HDR_END * KEY_HDR_SIZE);
		if(i4_ret < 0)
		{
			x_mem_free(pui1Buf);
			Printf("@@@@@@ nand write fail\n");
			return i4_ret;
		}
	}
	
	x_mem_free(pui1Buf);
	
	return i4_ret;
}

INT32 ui4GetNANDKey(INT8 i1_keyID, UINT8* pui1_buffer, size_t t_size)
{
	INT32 i4_ret = -1, i4_PartID = 0;//, i4_position;
	UINT64 u8Offset = 0;
    
	UINT8* pui1KernBuf=NULL;

#if KEY_DEBUG
	UINT8 i, j;
#endif

	if(i1_keyID >= DRV_CUSTOM_KEY_END)
	{
		Printf("@@@@@@the key header %d is bigger than DRV_CUSTOM_HDR_END\n",i1_keyID);
		return i4_ret;
	}
    if(t_size==0)
	{
	    Printf("@@@@@@invalid get size\n");
		return i4_ret; 
	}
	switch(i1_keyID)
	{
		case DRV_CUSTOM_KEY_TVID:
			u8Offset = TVID_KEY_OFFSET * NAND_PAGE_SIZE;
			break;
		default:
			Printf("[D-Interface] No valid key ID found\n");
			return i4_ret;
	}
    pui1KernBuf=x_mem_alloc_virtual(t_size);
	if(pui1KernBuf==NULL)
	{
	   Printf("Allocate mem fail at L%d\n",__LINE__);
	   return i4_ret;
	}
	i4_PartID = (INT32)DRVCUST_OptGet(eHDCPNANDPartId);
	if(i4_PartID > 1)
	{
		u8Offset |= (((UINT64)(UINT32)i4_PartID) << 32);
		Printf("@@@@@@keyID= %d offset= %llu\n",i1_keyID,u8Offset);
		i4_ret = NANDPART_Read(u8Offset, (UINT32)pui1KernBuf, t_size);
		if(i4_ret < 0)
		{
			Printf("@@@@@@ nand read fail\n");
			x_mem_free(pui1KernBuf);
			return i4_ret;
		}
	}
	
#if KEY_DEBUG
	for(i = 0; i < t_size; i +=8)
	{
		Printf("0x%x: ",i);
		for(j=0; j < 8; j++)
		{
			if(j%8 == 7){
				Printf("0x%x\n", *(pui1KernBuf + i +j));
			}else{
				Printf("0x%x\t", *(pui1KernBuf + i +j));
			}
		}
	}
#endif
    if(copy_to_user(pui1_buffer,pui1KernBuf,t_size))
	{
	   Printf("copy to user fail at L%d\n",__LINE__);
	   i4_ret=-1;
	}
    x_mem_free(pui1KernBuf);
	return i4_ret;
}
INT32 ui4SetNANDKey(INT8 i1_keyID,UINT8* pui1_buffer, size_t z_size)
{
	INT32 i4_ret = -1, i4_PartID = 0;//, i4_position;
	UINT64 u8Offset = 0;

	//UINT8* pui1Buf;
#if KEY_DEBUG
	UINT8 i, j;
	Printf("@@[D-Interface] key %d, size %d\n",i1_keyID,z_size);
#endif

	if(i1_keyID >= DRV_CUSTOM_KEY_END)
	{
		Printf("@@@@@@the key header %d is bigger than DRV_CUSTOM_HDR_END\n",i1_keyID);
		return i4_ret;
	}

	switch(i1_keyID)
	{
		case DRV_CUSTOM_KEY_TVID:
			u8Offset = TVID_KEY_OFFSET * NAND_PAGE_SIZE;
			break;
		default:
			Printf("[D-Interface] No valid key ID found\n");
			return i4_ret;
	}

	i4_PartID = (INT32)DRVCUST_OptGet(eHDCPNANDPartId);
	if(i4_PartID > 1)
	{
		u8Offset |= (((UINT64)(UINT32)i4_PartID) << 32);
		Printf("@@@@@@header= %d offset= %llu\n",i1_keyID,u8Offset);
		//write all the key back to nand flash
		i4_ret = NANDPART_Write(u8Offset, (UINT32)pui1_buffer, z_size);
		if(i4_ret < 0)
		{
			Printf("@@@@@@ nand write fail\n");
			return i4_ret;
		}
	}
#if KEY_DEBUG
	for(i = 0; i < z_size; i +=8)
	{
		Printf("0x%x: ",i);
		for(j=0; j < 8; j++)
		{
			if(j%8 == 7){
				Printf("0x%x\n", *(pui1_buffer + i + j));
			}else{
				Printf("0x%x\t", *(pui1_buffer + i + j));
			}
		}
	}
#endif
	
	return i4_ret;
}

#endif

INT32 d_Soem_cust_spec_set (
    DRV_CUSTOM_CUST_SPEC_TYPE_T    e_cust_spec_type,
    VOID*                          pv_set_info,
    SIZE_T                         z_size,
    BOOL                           b_store
)
{
    INT32 i4_ret = RMR_OK;

	switch (e_cust_spec_type)
    {
		case DRV_CUSTOM_CUST_SPEC_SET_GAMMA_REFRESH:
			if (z_size != sizeof(DRV_CUSTOM_GAMMA_REFRESH_T))
			{
				return (-1);
			}
			if (((DRV_CUSTOM_GAMMA_REFRESH_T *)pv_set_info)->ui1_OnOff)
			{
				DRVCUST_SET_GAMMA();
			}
			break;
		case DRV_CUSTOM_CUST_SPEC_SET_WB_GAMMA_ORIGINAL:
			if (z_size != sizeof(DRV_CUSTOM_GAMMA_WB_TYPE_T))
			{
				return (-1);
			}
			vDrvGammaOnOff(((DRV_CUSTOM_GAMMA_WB_TYPE_T *)pv_set_info)->ui1_gamma_onoff);
			break;
		case DRV_CUSTOM_SPEC_TYPE_DBC_DEBUG:
				if (z_size != sizeof(DRV_CUSTOM_DBC_DEBUG_T))
				{
					return (-1);
				}
			#if ENABLE_SOEM_PQ
			DRVCUST_DBC_DEBUG_MODE(((DRV_CUSTOM_DBC_DEBUG_T *)pv_set_info)->ui1DBC_MAGIC,
				((DRV_CUSTOM_DBC_DEBUG_T *)pv_set_info)->ui1BrightLevel);
      #endif		 
			break;

        case DRV_CUSTOM_CUST_SPEC_TYPE_MMP_MODE:
        {
            SIZE_CHK(z_size, UINT8); 
            PARAM_CHK(pv_set_info, UINT8, NUM_OF_MMP_MODE);
            #if ENABLE_SOEM_PQ
            DRVCUST_USBPHOTO_MODE((*(UINT8 *)pv_set_info));
            #endif           
            break;
        }
         case DRV_CUSTOM_CUST_SPEC_TYPE_MMP_OSD_STATE:
        {
            SIZE_CHK(z_size, UINT8); 
            PARAM_CHK(pv_set_info, UINT8, NUM_OF_MMP_OSD_STATE);
            #if ENABLE_SOEM_PQ 
            DRVCUST_USBOSD_MODE((*(UINT8 *)pv_set_info));
            #endif           
            break;
        }        
        case DRV_CUSTOM_CUST_SPEC_TYPE_MMP_PHOTO_FRAME_MODE:    // add for sony, 0x0: out of  photo frame mode,  0x1: in photo frame mode
        {   
			SIZE_CHK(z_size, UINT8); 
            PARAM_CHK(pv_set_info, UINT8, NUM_OF_MMP_OSD_STATE);
			DRVCUST_SetPhotoFrameMode(( *(UINT8*)pv_set_info));
			break;
        }
		case DRV_CUSTOM_CUST_SPEC_TYPE_MMP_PHOTO_FRAME_DISP_MODE:
		{
			SIZE_CHK(z_size, UINT8); 
            PARAM_CHK(pv_set_info, UINT8, NUM_OF_MMP_OSD_STATE);
			//DRVCUST_SetPhotoDisplayMode((*(UINT8*)pv_set_info));
			break;
		}
        case DRV_CUSTOM_CUST_SPEC_TYPE_OSD_TYPE:
        {
            SIZE_CHK(z_size, UINT8); 
            PARAM_CHK(pv_set_info, UINT8, NUM_OF_OSD_TYPE);
            #if ENABLE_SOEM_PQ 
            DRVCUST_EPG_FLAG((*(UINT8 *)pv_set_info));
            #endif           
            break;
        }     
//#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */  
        case DRV_CUSTOM_CUST_SPEC_TYPE_FM_RADIO_STATE:
        {
            SIZE_CHK(z_size, UINT8); 
            PARAM_CHK(pv_set_info, UINT8, NUM_OF_FM_RADIO_STATE);
            #if ENABLE_SOEM_PQ 
            DRVCUST_FMRADIO_FLAG((*(UINT8 *)pv_set_info));
            #endif
            break;
        } 
//#endif
#ifdef CC_Factory2K12
       case DRV_CUSTOM_CUST_SPEC_TYPE_HDMI_HDCP:
       {
           //for nand flash, write operation must be block based, which means offset must be 0
           //so, read all, modify in RAM, and write all
           MISC_TYPE_HDMI_HDCP_T *param = (MISC_TYPE_HDMI_HDCP_T *)pv_set_info;
           UINT8 buffer[340];

           i4_ret = 0;
           if(param->u2_offset + param->u2_length > 340)
           {
               i4_ret = -1;
           }
           if(i4_ret == 0)
           {
               #if ENABLE_SOEM_HDMI
               if(SifHDCPRead(0, buffer, 340))
               {
                   i4_ret = -1;
               }
               #endif
           }
           if(i4_ret == 0)
           {
               x_memcpy(buffer+param->u2_offset, param->aui1_hdcp_buf, param->u2_length);
               #if ENABLE_SOEM_HDMI
               if(SifHDCPWrite(0, buffer, 340))
               {
                   i4_ret = -1;
               }
               #endif
           }
           
           break;
       }
       case DRV_CUSTOM_CUST_SPEC_TYPE_HDCP2X_RW:
	   {
	       MISC_TYPE_HDCP2x_T *param = (MISC_TYPE_HDCP2x_T *)pv_set_info;
		   UINT16 Off_s = 0;
	       i4_ret = 0;
		   
           if(param->u2_offset + param->u2_length > 885)
           {
               i4_ret = -1;
           }
		   else
		   {
		   		if(param->u2_offset<256)
		   		{
		   			x_memcpy(buf_HDCP2x, &param->aui1_hdcp2x_buf[5], param->u2_length-5);
		   		}else
		   		{
		   			Off_s = param->u2_offset-5;
					x_memcpy(buf_HDCP2x+Off_s, param->aui1_hdcp2x_buf, param->u2_length);
		   		}
		   			
		   		hdcp2x_received += param->u2_length;
				
				if(885 <= hdcp2x_received)
					{
						if(EEPHDCP2x_Write(0,(UINT32)buf_HDCP2x,880))
			            {
			               i4_ret = -1;
			            }
					}
			  
		   }
	   }
	   break;
	   
       case DRV_CUSTOM_CUST_SPEC_SET_INTERNAL_SIG_PTN:
       {
           DRV_CUSTOM_INT_SIG_PTN *sig_ptn_info = NULL;
           UINT8 tag=0;
           UINT8 pattern=0;
           UINT8 path=0;
           UINT16 gamma_r=0;
           UINT16 gamma_g=0;
           UINT16 gamma_b=0;
          
           sig_ptn_info = (DRV_CUSTOM_INT_SIG_PTN*)pv_set_info;
           tag = sig_ptn_info->tag;
           pattern = sig_ptn_info->pattern;
           path = sig_ptn_info->path;
           gamma_r = sig_ptn_info->gamma_r;
           gamma_g = sig_ptn_info->gamma_g;
           gamma_b = sig_ptn_info->gamma_b;          
           
           if (tag == 0)
           {
               vDrvPreprocEnablePattern(0,0); //off the PreProc pattern first before turn on gamma
               vDrvGammaMute(gamma_r,gamma_g,gamma_b);
           }
           else if (tag == 1)
           {
               vDrvGammaUnmute();//off the Gamma pattern first before turn on PreProc
               // purplearrow mark vDrvSetMatrixUnit(); // use YCbCr 601 matrix and bypass all post-process
               vDrvPreprocEnablePattern(path, pattern);
           }
           else if (tag == 2)
           {
               // purplearrow mark vDrvSetMatrixReset(); // reset matrix when exit pattern
               vDrvPreprocEnablePattern(0, 0);
               vDrvGammaUnmute();
           }
           break;
       }
        case DRV_CUSTOM_CUST_SPEC_SET_GAMMA_PAT_GEN:
        {
           Sony_PreSetup(*(BOOL*)pv_set_info);
           Sony_GammaSetPatgen(*(BOOL*)pv_set_info);
           break;
        }
		/*>>> START Cheah: Sony GammaWB callback func 07Sep09 */
        case DRV_CUSTOM_CUST_SPEC_SET_GAMMA_SETUP:
        {
            Sony_GammaSetup(*(UINT16*)pv_set_info);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_GAMMA_SAVE:
        {
            Sony_GammaSave(*(UINT16*)pv_set_info);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_GAMMA_QUIT:
        {
            Sony_GammaQuit(*(UINT16*)pv_set_info);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_GAMMA_EXIT:
        {
            Sony_GammaExit(*(UINT16*)pv_set_info);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_GAMMA_RESET:
        {
            Sony_GammaResetNVM();
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_GAMMA_SAMPLE:
        {
            Sony_GammaSetSample(*(UINT16*)pv_set_info);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_WB_SETUP:
        {
            Sony_WBSetup(*(UINT16*)pv_set_info);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_WB_SAVE:
        {
            Sony_WBSave(*(UINT16*)pv_set_info);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_WB_QUIT:
        {
            Sony_WBQuit(*(UINT16*)pv_set_info);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_WB_EXIT:
        {
            Sony_WBExit(*(UINT16*)pv_set_info);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_WB_RESET:
        {
            Sony_WBResetNVM();
            break;
        }  

        case DRV_CUSTOM_CUST_SPEC_SET_WB_SETLVL:
        {
            Sony_WBSetLvl(*(UINT16*)pv_set_info);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_WB_SETCLR:
        {
            Sony_WBSetColor(*(UINT16*)pv_set_info);
            break;
        }
        
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_WBT_IDX:
        {
            Factory2K12Debug(c_sprintf(fact_dbg_buf,"-- sony_d_custom, set(%x) --\n",0));
            WB_PBM_ColorTempIdxSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_ADJ_METHOD:
        {
            WB_PBM_WBAdjustMethodSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_EASY_SET_LVL:
        {
            WB_PBM_EasySetPatternLevelSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_EASY_SET_EN:
        {
            WB_PBM_EasySetPatternEnableSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_Y_SUM_POS:
        {
            WB_PBM_YSumPosSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_Y_SUM_MEAS:
        {
            WB_PBM_YSumMeasSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_PIXEL_POS:
        {
            WB_PBM_YSumPixelPosSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_PIXEL_MEAS_Y:
        {
            WB_PBM_PixelMeasYSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_PIXEL_MEAS_CB:
        {
            WB_PBM_PixelMeasCBSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_PIXEL_MEAS_CR:
        {
            WB_PBM_PixelMeasCRSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_ON:
        {
            WB_PBM_LutAdjOnSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_WBT_IDX_CHANGE_STS:
        {
            WB_PBM_WBTIdxChangeStsSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INP_EASY_SET_R:
        {
            WB_PBM_InpEasySetRSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INP_EASY_SET_G:
        {
            WB_PBM_InpEasySetGSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INP_EASY_SET_B:
        {
            WB_PBM_InpEasySetBSet(*(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R00:
        {
            WB_PBM_CoefSet(0, 0, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R01:
        {
            WB_PBM_CoefSet(0, 1, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R02:
        {
            WB_PBM_CoefSet(0, 2, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R03:
        {
            WB_PBM_CoefSet(0, 3, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R04:
        {
            WB_PBM_CoefSet(0, 4, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R05:
        {
            WB_PBM_CoefSet(0, 5, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R06:
        {
            WB_PBM_CoefSet(0, 6, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R07:
        {
            WB_PBM_CoefSet(0, 7, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R08:
        {
            WB_PBM_CoefSet(0, 8, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R09:
        {
            WB_PBM_CoefSet(0, 9, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R10:
        {
            WB_PBM_CoefSet(0, 10, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R11:
        {
            WB_PBM_CoefSet(0, 11, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R12:
        {
            WB_PBM_CoefSet(0, 12, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R13:
        {
            WB_PBM_CoefSet(0, 13, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R14:
        {
            WB_PBM_CoefSet(0, 14, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R15:
        {
            WB_PBM_CoefSet(0, 15, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R16:
        {
            WB_PBM_CoefSet(0, 16, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R17:
        {
            WB_PBM_CoefSet(0, 17, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R18:
        {
            WB_PBM_CoefSet(0, 18, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R19:
        {
            WB_PBM_CoefSet(0, 19, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R20:
        {
            WB_PBM_CoefSet(0, 20, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R21:
        {
            WB_PBM_CoefSet(0, 21, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R22:
        {
            WB_PBM_CoefSet(0, 22, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R23:
        {
            WB_PBM_CoefSet(0, 23, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R24:
        {
            WB_PBM_CoefSet(0, 24, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R25:
        {
            WB_PBM_CoefSet(0, 25, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R26:
        {
            WB_PBM_CoefSet(0, 26, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R27:
        {
            WB_PBM_CoefSet(0, 27, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R28:
        {
            WB_PBM_CoefSet(0, 28, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R29:
        {
            WB_PBM_CoefSet(0, 29, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R30:
        {
            WB_PBM_CoefSet(0, 30, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R31:
        {
            WB_PBM_CoefSet(0, 31, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R32:
        {
            WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
            break;
        }
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R33:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R34:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R35:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R36:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R37:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R38:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R39:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R40:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R41:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R42:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R43:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R44:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R45:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R46:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R47:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R48:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R49:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R50:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R51:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R52:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R53:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R54:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R55:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R56:
		{
		   //WB_PBM_CoefSet(0, 32, *(UINT16*)pv_set_info);
		   break;
		}		
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G00:
        {
            WB_PBM_CoefSet(1, 0, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G01:
        {
            WB_PBM_CoefSet(1, 1, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G02:
        {
            WB_PBM_CoefSet(1, 2, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G03:
        {
            WB_PBM_CoefSet(1, 3, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G04:
        {
            WB_PBM_CoefSet(1, 4, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G05:
        {
            WB_PBM_CoefSet(1, 5, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G06:
        {
            WB_PBM_CoefSet(1, 6, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G07:
        {
            WB_PBM_CoefSet(1, 7, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G08:
        {
            WB_PBM_CoefSet(1, 8, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G09:
        {
            WB_PBM_CoefSet(1, 9, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G10:
        {
            WB_PBM_CoefSet(1, 10, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G11:
        {
            WB_PBM_CoefSet(1, 11, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G12:
        {
            WB_PBM_CoefSet(1, 12, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G13:
        {
            WB_PBM_CoefSet(1, 13, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G14:
        {
            WB_PBM_CoefSet(1, 14, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G15:
        {
            WB_PBM_CoefSet(1, 15, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G16:
        {
            WB_PBM_CoefSet(1, 16, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G17:
        {
            WB_PBM_CoefSet(1, 17, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G18:
        {
            WB_PBM_CoefSet(1, 18, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G19:
        {
            WB_PBM_CoefSet(1, 19, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G20:
        {
            WB_PBM_CoefSet(1, 20, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G21:
        {
            WB_PBM_CoefSet(1, 21, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G22:
        {
            WB_PBM_CoefSet(1, 22, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G23:
        {
            WB_PBM_CoefSet(1, 23, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G24:
        {
            WB_PBM_CoefSet(1, 24, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G25:
        {
            WB_PBM_CoefSet(1, 25, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G26:
        {
            WB_PBM_CoefSet(1, 26, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G27:
        {
            WB_PBM_CoefSet(1, 27, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G28:
        {
            WB_PBM_CoefSet(1, 28, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G29:
        {
            WB_PBM_CoefSet(1, 29, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G30:
        {
            WB_PBM_CoefSet(1, 30, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G31:
        {
            WB_PBM_CoefSet(1, 31, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G32:
        {
            WB_PBM_CoefSet(1, 32, *(UINT16*)pv_set_info);
            break;
        }  
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G33:
		{
		   //WB_PBM_CoefSet(1, 33, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G34:
		{
		   //WB_PBM_CoefSet(1, 34, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G35:
		{
		   //WB_PBM_CoefSet(1, 45, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G36:
		{
		   //WB_PBM_CoefSet(1, 36, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G37:
		{
		   //WB_PBM_CoefSet(1, 37, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G38:
		{
		   //WB_PBM_CoefSet(1, 38, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G39:
		{
		   //WB_PBM_CoefSet(1, 39, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G40:
		{
		   //WB_PBM_CoefSet(1, 40, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G41:
		{
		   //WB_PBM_CoefSet(1, 41, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G42:
		{
		   //WB_PBM_CoefSet(1, 42, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G43:
		{
		   //WB_PBM_CoefSet(1, 43, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G44:
		{
		   //WB_PBM_CoefSet(1, 44, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G45:
		{
		   //WB_PBM_CoefSet(1, 45, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G46:
		{
		   //WB_PBM_CoefSet(1, 46, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G47:
		{
		   //WB_PBM_CoefSet(1, 47, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G48:
		{
		   //WB_PBM_CoefSet(1, 48, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G49:
		{
		   //WB_PBM_CoefSet(1, 49, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G50:
		{
		   //WB_PBM_CoefSet(1, 50, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G51:
		{
		   //WB_PBM_CoefSet(1, 51, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G52:
		{
		   //WB_PBM_CoefSet(1, 52, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G53:
		{
		   //WB_PBM_CoefSet(1, 53, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G54:
		{
		   //WB_PBM_CoefSet(1, 54, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G55:
		{
		   //WB_PBM_CoefSet(1, 55, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G56:
		{
		   //WB_PBM_CoefSet(1, 56, *(UINT16*)pv_set_info);
		   break;
		}		
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B00:
        {
            WB_PBM_CoefSet(2, 0, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B01:
        {
            WB_PBM_CoefSet(2, 1, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B02:
        {
            WB_PBM_CoefSet(2, 2, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B03:
        {
            WB_PBM_CoefSet(2, 3, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B04:
        {
            WB_PBM_CoefSet(2, 4, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B05:
        {
            WB_PBM_CoefSet(2, 5, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B06:
        {
            WB_PBM_CoefSet(2, 6, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B07:
        {
            WB_PBM_CoefSet(2, 7, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B08:
        {
            WB_PBM_CoefSet(2, 8, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B09:
        {
            WB_PBM_CoefSet(2, 9, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B10:
        {
            WB_PBM_CoefSet(2, 10, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B11:
        {
            WB_PBM_CoefSet(2, 11, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B12:
        {
            WB_PBM_CoefSet(2, 12, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B13:
        {
            WB_PBM_CoefSet(2, 13, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B14:
        {
            WB_PBM_CoefSet(2, 14, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B15:
        {
            WB_PBM_CoefSet(2, 15, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B16:
        {
            WB_PBM_CoefSet(2, 16, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B17:
        {
            WB_PBM_CoefSet(2, 17, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B18:
        {
            WB_PBM_CoefSet(2, 18, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B19:
        {
            WB_PBM_CoefSet(2, 19, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B20:
        {
            WB_PBM_CoefSet(2, 20, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B21:
        {
            WB_PBM_CoefSet(2, 21, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B22:
        {
            WB_PBM_CoefSet(2, 22, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B23:
        {
            WB_PBM_CoefSet(2, 23, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B24:
        {
            WB_PBM_CoefSet(2, 24, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B25:
        {
            WB_PBM_CoefSet(2, 25, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B26:
        {
            WB_PBM_CoefSet(2, 26, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B27:
        {
            WB_PBM_CoefSet(2, 27, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B28:
        {
            WB_PBM_CoefSet(2, 28, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B29:
        {
            WB_PBM_CoefSet(2, 29, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B30:
        {
            WB_PBM_CoefSet(2, 30, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B31:
        {
            WB_PBM_CoefSet(2, 31, *(UINT16*)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B32:
        {
            WB_PBM_CoefSet(2, 32, *(UINT16*)pv_set_info);
            break;
        }
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B33:
		{
		   //WB_PBM_CoefSet(2, 23, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B34:
		{
		   //WB_PBM_CoefSet(2, 24, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B35:
		{
		   //WB_PBM_CoefSet(2, 25, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B36:
		{
		   //WB_PBM_CoefSet(2, 26, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B37:
		{
		   //WB_PBM_CoefSet(2, 27, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B38:
		{
		   //WB_PBM_CoefSet(2, 28, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B39:
		{
		   //WB_PBM_CoefSet(2, 29, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B40:
		{
		   //WB_PBM_CoefSet(2, 20, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B41:
		{
		   //WB_PBM_CoefSet(2, 21, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B42:
		{
		   //WB_PBM_CoefSet(2, 22, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B43:
		{
		   //WB_PBM_CoefSet(2, 23, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B44:
		{
		   //WB_PBM_CoefSet(2, 24, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B45:
		{
		   //WB_PBM_CoefSet(2, 25, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B46:
		{
		   //WB_PBM_CoefSet(2, 26, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B47:
		{
		   //WB_PBM_CoefSet(2, 27, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B48:
		{
		   //WB_PBM_CoefSet(2, 28, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B49:
		{
		   //WB_PBM_CoefSet(2, 29, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B50:
		{
		   //WB_PBM_CoefSet(2, 20, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B51:
		{
		   //WB_PBM_CoefSet(2, 21, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B52:
		{
		   //WB_PBM_CoefSet(2, 22, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B53:
		{
		   //WB_PBM_CoefSet(2, 23, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B54:
		{
		   //WB_PBM_CoefSet(2, 24, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B55:
		{
		   //WB_PBM_CoefSet(2, 25, *(UINT16*)pv_set_info);
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B56:
		{
		   //WB_PBM_CoefSet(2, 26, *(UINT16*)pv_set_info);
		   break;
		}

		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_00:
        {
           WB_TRACK_GAM0_RGB_SET(0, 0, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_01:
        {
           WB_TRACK_GAM0_RGB_SET(0, 1, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_02:
        {
           WB_TRACK_GAM0_RGB_SET(0, 2, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_03:
        {
           WB_TRACK_GAM0_RGB_SET(0, 3, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_04:
        {
           WB_TRACK_GAM0_RGB_SET(0, 4, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_05:
        {
           WB_TRACK_GAM0_RGB_SET(0, 5, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_06:
        {
           WB_TRACK_GAM0_RGB_SET(0, 6, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_07:
        {
           WB_TRACK_GAM0_RGB_SET(0, 7, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_08:
        {
           WB_TRACK_GAM0_RGB_SET(0, 8, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_09:
        {
           WB_TRACK_GAM0_RGB_SET(0, 9, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_10:
        {
           WB_TRACK_GAM0_RGB_SET(0, 10, *(UINT8*)pv_set_info);
           break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_00:
        {
           WB_TRACK_GAM0_RGB_SET(1, 0, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_01:
        {
           WB_TRACK_GAM0_RGB_SET(1, 1, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_02:
        {
           WB_TRACK_GAM0_RGB_SET(1, 2, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_03:
        {
           WB_TRACK_GAM0_RGB_SET(1, 3, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_04:
        {
           WB_TRACK_GAM0_RGB_SET(1, 4, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_05:
        {
           WB_TRACK_GAM0_RGB_SET(1, 5, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_06:
        {
           WB_TRACK_GAM0_RGB_SET(1, 6, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_07:
        {
           WB_TRACK_GAM0_RGB_SET(1, 7, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_08:
        {
           WB_TRACK_GAM0_RGB_SET(1, 8, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_09:
        {
           WB_TRACK_GAM0_RGB_SET(1, 9, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_10:
        {
           WB_TRACK_GAM0_RGB_SET(1, 10, *(UINT8*)pv_set_info);
           break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_00:
        {
           WB_TRACK_GAM0_RGB_SET(2, 0, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_01:
        {
           WB_TRACK_GAM0_RGB_SET(2, 1, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_02:
        {
           WB_TRACK_GAM0_RGB_SET(2, 2, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_03:
        {
           WB_TRACK_GAM0_RGB_SET(2, 3, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_04:
        {
           WB_TRACK_GAM0_RGB_SET(2, 4, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_05:
        {
           WB_TRACK_GAM0_RGB_SET(2, 5, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_06:
        {
           WB_TRACK_GAM0_RGB_SET(2, 6, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_07:
        {
           WB_TRACK_GAM0_RGB_SET(2, 7, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_08:
        {
           WB_TRACK_GAM0_RGB_SET(2, 8, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_09:
        {
           WB_TRACK_GAM0_RGB_SET(2, 9, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_10:
        {
           WB_TRACK_GAM0_RGB_SET(2, 10, *(UINT8*)pv_set_info);
           break;
        }

		case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_00:
        {
           WB_TRACK_INP_LVL_SET(0, *(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_01:
        {
           WB_TRACK_INP_LVL_SET(1, *(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_02:
        {
           WB_TRACK_INP_LVL_SET(2, *(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_03:
        {
           WB_TRACK_INP_LVL_SET(3, *(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_04:
        {
           WB_TRACK_INP_LVL_SET(4, *(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_05:
        {
           WB_TRACK_INP_LVL_SET(5, *(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_06:
        {
           WB_TRACK_INP_LVL_SET(6, *(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_07:
        {
           WB_TRACK_INP_LVL_SET(7, *(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_08:
        {
           WB_TRACK_INP_LVL_SET(8, *(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_09:
        {
           WB_TRACK_INP_LVL_SET(9, *(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_10:
        {
           WB_TRACK_INP_LVL_SET(10, *(UINT16*)pv_set_info);
           break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_00:
        {
           WB_TRACK_GAM_GAIN_SET(0, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_01:
        {
           WB_TRACK_GAM_GAIN_SET(1, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_02:
        {
           WB_TRACK_GAM_GAIN_SET(2, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_03:
        {
           WB_TRACK_GAM_GAIN_SET(3, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_04:
        {
           WB_TRACK_GAM_GAIN_SET(4, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_05:
        {
           WB_TRACK_GAM_GAIN_SET(5, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_06:
        {
           WB_TRACK_GAM_GAIN_SET(6, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_07:
        {
           WB_TRACK_GAM_GAIN_SET(7, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_08:
        {
           WB_TRACK_GAM_GAIN_SET(8, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_09:
        {
           WB_TRACK_GAM_GAIN_SET(9, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_10:
        {
           WB_TRACK_GAM_GAIN_SET(10, *(UINT8*)pv_set_info);
           break;
        }  

        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_BASE_GAIN_R:
        {
           WB_TRACK_BASE_GAIN_RGB_SET(0, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_BASE_GAIN_G:
        {
           WB_TRACK_BASE_GAIN_RGB_SET(1, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_BASE_GAIN_B:
        {
           WB_TRACK_BASE_GAIN_RGB_SET(2, *(UINT8*)pv_set_info);
           break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R00:
        {
           WB_TRACK_OFST_RGB_SET(0, 0, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R01:
        {
           WB_TRACK_OFST_RGB_SET(0, 1, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R02:
        {
           WB_TRACK_OFST_RGB_SET(0, 2, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R03:
        {
           WB_TRACK_OFST_RGB_SET(0, 3, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R04:
        {
           WB_TRACK_OFST_RGB_SET(0, 4, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R05:
        {
           WB_TRACK_OFST_RGB_SET(0, 5, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R06:
        {
           WB_TRACK_OFST_RGB_SET(0, 6, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R07:
        {
           WB_TRACK_OFST_RGB_SET(0, 7, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R08:
        {
           WB_TRACK_OFST_RGB_SET(0, 8, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R09:
        {
           WB_TRACK_OFST_RGB_SET(0, 9, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R10:
        {
           WB_TRACK_OFST_RGB_SET(0, 10, *(UINT8*)pv_set_info);
           break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G00:
        {
           WB_TRACK_OFST_RGB_SET(1, 0, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G01:
        {
           WB_TRACK_OFST_RGB_SET(1, 1, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G02:
        {
           WB_TRACK_OFST_RGB_SET(1, 2, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G03:
        {
           WB_TRACK_OFST_RGB_SET(1, 3, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G04:
        {
           WB_TRACK_OFST_RGB_SET(1, 4, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G05:
        {
           WB_TRACK_OFST_RGB_SET(1, 5, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G06:
        {
           WB_TRACK_OFST_RGB_SET(1, 6, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G07:
        {
           WB_TRACK_OFST_RGB_SET(1, 7, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G08:
        {
           WB_TRACK_OFST_RGB_SET(1, 8, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G09:
        {
           WB_TRACK_OFST_RGB_SET(1, 9, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G10:
        {
           WB_TRACK_OFST_RGB_SET(1, 10, *(UINT8*)pv_set_info);
           break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B00:
        {
           WB_TRACK_OFST_RGB_SET(2, 0, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B01:
        {
           WB_TRACK_OFST_RGB_SET(2, 1, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B02:
        {
           WB_TRACK_OFST_RGB_SET(2, 2, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B03:
        {
           WB_TRACK_OFST_RGB_SET(2, 3, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B04:
        {
           WB_TRACK_OFST_RGB_SET(2, 4, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B05:
        {
           WB_TRACK_OFST_RGB_SET(2, 5, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B06:
        {
           WB_TRACK_OFST_RGB_SET(2, 6, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B07:
        {
           WB_TRACK_OFST_RGB_SET(2, 7, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B08:
        {
           WB_TRACK_OFST_RGB_SET(2, 8, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B09:
        {
           WB_TRACK_OFST_RGB_SET(2, 9, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B10:
        {
           WB_TRACK_OFST_RGB_SET(2, 10, *(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_GODID:
        {
           DRVCUST_SET_WBADJ_GODID_EEP(*(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_PON_TIME:
        {
           DRVCUST_SET_WBADJ_PON_TIME_EEP(*(UINT8*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_JIG_VER:
        {
           DRVCUST_SET_WBADJ_JIG_VER_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_DS_DATE:
        {
           DRVCUST_SET_WBADJ_DS_DATE_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_ADJ_DATE:
        {
           DRVCUST_SET_WBADJ_ADJ_DATE_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_AGING1:
        {
           DRVCUST_SET_WBADJ_AGING1_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_AGING2:
        {
           DRVCUST_SET_WBADJ_AGING2_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_JIG_INFO1:
        {
           DRVCUST_SET_WBADJ_JJG_INFO1_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_JIG_INFO2:
        {
           DRVCUST_SET_WBADJ_JJG_INFO2_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INFO0:
        {
           DRVCUST_SET_WB_INFO0_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INFO1:
        {
           DRVCUST_SET_WB_INFO1_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INFO2:
        {
           DRVCUST_SET_WB_INFO2_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INFO3:
        {
           DRVCUST_SET_WB_INFO3_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INFO4:
        {
           DRVCUST_SET_WB_INFO4_EEP(*(UINT16*)pv_set_info);
           break;
        }
        case DRV_CUSTMO_CUST_TYPE_MACBETH_PTN:
        {
           DRVCUST_SetMacbethOnOff(((DRV_MACBETH_PTN*)pv_set_info)->bOnoff, ((DRV_MACBETH_PTN*)pv_set_info)->u2Ylvl,
                                    ((DRV_MACBETH_PTN*)pv_set_info)->u2Ulvl, ((DRV_MACBETH_PTN*)pv_set_info)->u2Vlvl);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_EEP_WB_GAM0_RGB:
        {
           if((pv_set_info == NULL) || (z_size != sizeof(DRV_EEP_WB_GAM0_RGB)))
           {
               LOG(2, "Invalid parameter (DRV_EEP_WB_GAM0_RGB)\n");
        	   return RMR_INV_ARG;
           }

           //DRVCUST_SET_WB_GAM(((DRV_EEP_WB_GAM0_RGB*)pv_set_info)->u1Channel,
                                //((DRV_EEP_WB_GAM0_RGB*)pv_set_info)->u1Levle, 
                                //((DRV_EEP_WB_GAM0_RGB*)pv_set_info)->u1Value);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_EEP_INP_LVL_WB:
        {
           if((pv_set_info == NULL) || (z_size != sizeof(DRV_EEP_INP_LVL_WB)))
           {
               LOG(2, "Invalid parameter (DRV_EEP_INP_LVL_WB)\n");
        	   return RMR_INV_ARG;
           }

           //DRVCUST_SET_INP_LVL_WB(((DRV_EEP_INP_LVL_WB*)pv_set_info)->u1Levle,
                                //((DRV_EEP_INP_LVL_WB*)pv_set_info)->u2Value);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_EEP_WB_GAM_GAIN:
        {
           if((pv_set_info == NULL) || (z_size != sizeof(DRV_EEP_WB_GAM_GAIN)))
           {
               LOG(2, "Invalid parameter (DRV_EEP_WB_GAM_GAIN)\n");
        	   return RMR_INV_ARG;
           }

           //DRVCUST_SET_WB_GAM_GAIN(((DRV_EEP_WB_GAM_GAIN*)pv_set_info)->u1Levle,
                                    //((DRV_EEP_WB_GAM_GAIN*)pv_set_info)->u1Value);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_EEP_WB_BASE_GAIN_RGB:
        {
           if((pv_set_info == NULL) || (z_size != sizeof(DRV_EEP_WB_BASE_GAIN_RGB)))
           {
               LOG(2, "Invalid parameter (DRV_EEP_WB_BASE_GAIN_RGB)\n");
        	   return RMR_INV_ARG;
           }

           //DRVCUST_SET_WB_BASE_GAIN(((DRV_EEP_WB_BASE_GAIN_RGB*)pv_set_info)->u1ColorTemp,
                                    //((DRV_EEP_WB_BASE_GAIN_RGB*)pv_set_info)->u1Channel,
                                    //((DRV_EEP_WB_BASE_GAIN_RGB*)pv_set_info)->u1Value);
           break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_EEP_WB_OFST_RGB:
        {
           if((pv_set_info == NULL) || (z_size != sizeof(DRV_EEP_WB_OFST_RGB)))
           {
               LOG(2, "Invalid parameter (DRV_EEP_WB_OFST_RGB)\n");
        	   return RMR_INV_ARG;
           }

           //DRVCUST_SET_WB_OFST(((DRV_EEP_WB_OFST_RGB*)pv_set_info)->u1ColorTemp,
                                //((DRV_EEP_WB_OFST_RGB*)pv_set_info)->u1Channel, 
                                //((DRV_EEP_WB_OFST_RGB*)pv_set_info)->u1Levle, 
                                //((DRV_EEP_WB_OFST_RGB*)pv_set_info)->u1Value);
           break;
        }

    #ifdef CC_MAPLE_CUST_DRV
        //Only for Sakura, Salvia NO need
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_R00:
        {
            DRVCUST_GAMMA_Ofst_ADJ_UI(0, 0, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_R01:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(0, 1, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_R02:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(0, 2, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_R03:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(0, 3, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_R04:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(0, 4, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_R05:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(0, 5, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_R06:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(0, 6, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_R07:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(0, 7, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_R08:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(0, 8, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_R09:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(0, 9, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_R10:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(0, 10, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_G00:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(1, 0, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_G01:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(1, 1, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_G02:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(1, 2, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_G03:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(1, 3, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_G04:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(1, 4, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_G05:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(1, 5, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_G06:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(1, 6, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_G07:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(1, 7, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_G08:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(1, 8, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_G09:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(1, 9, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_G10:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(1, 10, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_B00:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(2, 0, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_B01:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(2, 1, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_B02:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(2, 2, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_B03:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(2, 3, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_B04:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(2, 4, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_B05:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(2, 5, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_B06:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(2, 6, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_B07:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(2, 7, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_B08:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(2, 8, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_B09:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(2, 9, *(UINT8*)pv_set_info);
        	break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_UI_OFST_B10:
        {
        	DRVCUST_GAMMA_Ofst_ADJ_UI(2, 10, *(UINT8*)pv_set_info);
        	break;
        }
    #endif
		case DRV_CUSTOM_CUST_SPEC_TYPE_AGING_LAST_POWER_CONTROL:
		{
			UINT16 ui2_result;
			ui2_result = *((UINT16 *)(pv_set_info));
			AgingLastPowerControlState_Set(ui2_result);
			break;
		}
		
		case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_STOP_MONITOR_ANA:
		{
			BOOL b_result;
			if ((pv_set_info == NULL) || (z_size != sizeof(BOOL)))
			{
				LOG(2, "Invalid parameter (STOP_MONITOR_ANA)\n");
				return RMR_INV_ARG;
			}			
			b_result = *((BOOL *)(pv_set_info));
			if(b_result == TRUE)
			{
				CLI_Parser("nim.dm 1");				
			}
		    else
			{
				CLI_Parser("nim.dm 0");
			
			}			
			break;
		}

	    case DRV_CUSTOM_CUST_SPEC_TYPE_FREE_ALL_DMX_PID:
		{
            CLI_Parser("d.fpinst");             		
			break;
		}

		case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_STOP_MONITOR_DIG:
		{
			BOOL b_result;
			if ((pv_set_info == NULL) || (z_size != sizeof(BOOL)))
			{
				LOG(2, "Invalid parameter (STOP_MONITOR_DIG)\n");
				return RMR_INV_ARG;
			}			
			b_result = *((BOOL *)(pv_set_info));
			if(b_result == TRUE)
			{
				CLI_Parser("nim.dm 1");				
			}
		    else
			{
				CLI_Parser("nim.dm 0");
			
			}			
			break;
		}
		
		case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_DMX_CONNECT:
		{
			//dmx set connect
			break;
		}
		
	    case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_DMX_DISCONNECT:
		{
			//dmx set disconnect
			break;
		}
		
	    case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_SET_PID:
	    {
		   //dmx set pid
		   break;
	    }
		
        case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_ANALOG:
        {
           UINT8        ui1_antenna = 0;
           UINT32       ui4_freq = 0;
           UINT32       ui4_video_sys = 0;
           UINT32       ui4_audio_sys = 0;
           UINT32       ui4_audio_soud = 0;
           UINT8        ui1_lna = 0;
#if 1 // wwj		   
		   UINT32		ui4_begin_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();
		   UINT32		ui4_end_time = 0;
#endif		   
		   
           if ((pv_set_info == NULL) || (z_size != sizeof(DRV_TUNE_ANALOG_T)))
           {
               LOG(2, "Invalid parameter (TUNE_ANALOG)\n");
               return RMR_INV_ARG;
           }           
		   
           ui1_antenna = (((DRV_TUNE_ANALOG_T *)pv_set_info)->ui1_antenna);
           ui4_freq = (((DRV_TUNE_ANALOG_T *)pv_set_info)->ui4_freq);
           ui4_video_sys = (((DRV_TUNE_ANALOG_T *)pv_set_info)->ui4_video_sys);
           ui4_audio_sys = (((DRV_TUNE_ANALOG_T *)pv_set_info)->ui4_audio_sys);
           ui4_audio_soud = (((DRV_TUNE_ANALOG_T *)pv_set_info)->ui4_audio_soud);
           ui1_lna = (((DRV_TUNE_ANALOG_T *)pv_set_info)->ui1_lna);
           
           //tuner          
           CLI_Parser("n.mute.on 0");          
           CLI_Parser("aud.stop 0");	//stop main audio decoder
           x_thread_delay(50);
           CLI_Parser("aud.stop 1");	//stop sub audio decoder
           x_thread_delay(50);
		   /////////////
           CLI_Parser("nim.id 0");         
           if(ui1_antenna == FACTORY_TUNER_ANTENNA_TERR)
           {   
               CLI_Parser("nim.go t_ana");	//switch to analog air 
           }
           else if(ui1_antenna == FACTORY_TUNER_ANTENNA_CABLE)
           {
               CLI_Parser("nim.go c_ana");	//switch to analog cable
           }    
           x_thread_delay(50);
                      //vdp
           CLI_Parser("vdp.e 0");   		// enable vdp main path ?
           CLI_Parser("vdp.s.outr 0 1");    // set vdp ouput region (ucVdpId; X; Y; W; H)  ?	    
           CLI_Parser("vdp.s.i 0 0 0");		// set vdp input region (ucVdpId; ucEsId; ucPort) ?
           CLI_Parser("vdp.s.srcr 0 1");	// set vdp source region (ucVdpId; X; Y; W; H) ?
		   //lna
           CLI_Parser_Arg("sif.xw 0 270 0xd8 1 0x09 3 0xc0 0x85 %d",ui1_lna);	// write lna to tuner register
           x_thread_delay(50); 
           CLI_Parser_Arg("nim.atd s %d",ui4_video_sys);	//set video system
           x_thread_delay(50); 
           CLI_Parser_Arg("nim.atd f %d",ui4_freq);		// set frequency
           x_thread_delay(100); 
           CLI_Parser("n.ms atd1");		// main source select ?
           //Audio	   		   
           CLI_Parser_Arg("aud.atv.sys %d",ui4_audio_sys);  // set current channel's audio system
           x_thread_delay(50); 
		   CLI_Parser_Arg("aud.atv.sm %d",ui4_audio_soud);		// set current channel's audio sound mode	   
           x_thread_delay(50); 
           CLI_Parser("aud.play 1");	// play audio sub decoder
           CLI_Parser("aud.s 0 2 3");	// set audio decoder (main_decoder; stream_from_analog_tuner; stream_type_is_PCM)
           CLI_Parser("aud.play 0");	// play audio main decoder
           CLI_Parser("osd.p.en 2 0");	// disable OSD plane 3
           CLI_Parser("n.mute.all 0 0");  // mute Vdp(ucVdpId; on/off)
           x_thread_delay(50); 	   
           CLI_Parser("n.mute.off 0");   // unmute main Vdp
#if 1 // wwj		   
		   ui4_end_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();

		   LOG(0, "TUNE_ANALOG %d ms ~~ \n", (ui4_end_time - ui4_begin_time));
#endif		   		   
       break;   
       }
       case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_ATSC:
       {
           UINT32   ui4_freq = 0;
           UINT8    ui1_modulation = 0;
           UINT16   ui2_video_pid = 0;
           UINT8    ui1_video_codec = 0;
           UINT16   ui2_audio_pid = 0;
           UINT8    ui1_audio_codec = 0;
           UINT8    ui1_framerate = 0;
           AUD_FMT_T eAudDecFmt = 0;
           ENUM_VDEC_FMT_T    eVideoDecFmt = 0;
#if 1 // wwj		   
		   UINT32		ui4_begin_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();
		   UINT32		ui4_end_time = 0;
#endif			   
           
           if ((pv_set_info == NULL) || (z_size != sizeof(DRV_TUNE_ATSC_T)))
           {
               LOG(2, "Invalid parameter (TUNE_ATSC)\n");
               return RMR_INV_ARG;
           }
           ui4_freq = (((DRV_TUNE_ATSC_T *)pv_set_info)->ui4_freq);
           ui1_modulation = (((DRV_TUNE_ATSC_T *)pv_set_info)->ui1_modulation);
           ui2_video_pid = (((DRV_TUNE_ATSC_T *)pv_set_info)->ui2_video_pid);
           ui1_video_codec = (((DRV_TUNE_ATSC_T *)pv_set_info)->ui1_video_codec);
           ui2_audio_pid = (((DRV_TUNE_ATSC_T *)pv_set_info)->ui2_audio_pid);
           ui1_audio_codec = (((DRV_TUNE_ATSC_T *)pv_set_info)->ui1_audio_codec);
           ui1_framerate = (((DRV_TUNE_ATSC_T *)pv_set_info)->ui1_framerate);
           
           //tuner
           CLI_Parser("n.mute.on 0"); 	// mute Vdp main	
           CLI_Parser("aud.stop 0");	// mute audio main decoder
           x_thread_delay(50); 
           CLI_Parser("aud.stop 1");	// mute audio sub decoder
           x_thread_delay(50); 
		   //
           CLI_Parser("vdec.s 0");		// stop video decoder main path
           x_thread_delay(50);           
           CLI_Parser("d.fp 0");	// free id ???
           x_thread_delay(50);           
           CLI_Parser("vdp.d 0");	// disable Vdp main         
           x_thread_delay(50);
		   
           bApiVideoSetVideoSrc(0,255);		// set video source ???
           x_thread_delay(50);
           CLI_Parser("n.ms dtv1");      // select main source to DTV      
           CLI_Parser("nim.id 1");		 // set tuner type to DTV 
           CLI_Parser("nim.go atsc");	// set tuner scan rule ATSC
           x_thread_delay(50); 
           CLI_Parser_Arg("nim.freq %d",ui4_freq);	//set ATSC's frequency
           x_thread_delay(50); 
           //vdp
           CLI_Parser("vdp.e 0");   	// enable vdp main path ?
           CLI_Parser("vdp.s.outr 0 1");    // set vdp ouput region (ucVdpId; X; Y; W; H)  ?   
           CLI_Parser("vdp.s.i 0 0 0");		// set vdp input region (ucVdpId; ucEsId; ucPort) ?
           CLI_Parser("vdp.s.srcr 0 1");	// set vdp source region (ucVdpId; X; Y; W; H) ?
           //vdec
           switch(ui1_video_codec)
           {
             case FCTRY_VIDEO_CODEC_MPEG2://MPEG2
                eVideoDecFmt = VDEC_FMT_MPV;
                break;
             case FCTRY_VIDEO_CODEC_AVC://AVC
                eVideoDecFmt = VDEC_FMT_H264;
                break;
             case FCTRY_VIDEO_CODEC_AVS://AVS
                eVideoDecFmt = VDEC_FMT_AVS;
                break;
             case FCTRY_VIDEO_CODEC_VC1://VC1
                eVideoDecFmt = VDEC_FMT_WMV;
                break;
             case FCTRY_VIDEO_CODEC_MPEG4VISUAL://MPEG4VISUAL
                eVideoDecFmt = VDEC_FMT_MP4;
                break;
             case FCTRY_VIDEO_CODEC_DIVX://DIVX
                eVideoDecFmt = VDEC_FMT_MP4;
                break;          
             default:
                eVideoDecFmt = VDEC_FMT_MPV;
                break;
           }    
           CLI_Parser_Arg("vdec.p 0 %d",eVideoDecFmt);	// video decoder play (EsId; Format)
           //dmx
           if(eVideoDecFmt == VDEC_FMT_H264)
           {
               CLI_Parser("d.svt 1");		// set DMX video type
           }           
           else if(eVideoDecFmt == VDEC_FMT_AVS)
           {
               CLI_Parser("d.svt 2");		// set DMX video type
           }
           else
           {               
               CLI_Parser("d.svt 0");		// set DMX video type
           }
           CLI_Parser_Arg("d.sp 0 0x%x video",ui2_video_pid);	// set video PID(pid_index; PID; PID_type; device_id )	
       
           //Audio
           switch(ui1_audio_codec)
           {
             case FCTRY_AUDIO_CODEC_LPCM://LPCM
                eAudDecFmt = AUD_FMT_LPCM;
                break;
             case FCTRY_AUDIO_CODEC_AAC://AAC
                eAudDecFmt = AUD_FMT_AAC;
                break;
             case FCTRY_AUDIO_CODEC_AC3://AC3
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_AC3_PLUS://AC3_PLUS
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_HEAAC://HEAAC
                eAudDecFmt = AUD_FMT_HE_AAC;
                break;
             case FCTRY_AUDIO_CODEC_MPEG_AUDIO://MPEG_AUDIO
                eAudDecFmt = AUD_FMT_MPEG;
                break;
             default:
                eAudDecFmt = AUD_FMT_UNKNOWN;
                break;
           }
           
           CLI_Parser_Arg("aud.s 1 1 %d",eAudDecFmt);	// set audio decoder (decoder_id; stream_from; stream type)
           CLI_Parser("aud.play 1");	// play audio sub decoder
           CLI_Parser("aud.s 0 1 3");	// set audio decoder (main_decoder; stream_from_digital-tuner; stream_type_is_PCM)
           CLI_Parser("aud.play 0");	// play audio main decoder
           CLI_Parser_Arg("d.sp 1 0x%x audio 1",ui2_audio_pid); 	// set audio PID(pid_index; PID; PID_type; device_id )
           x_thread_delay(100);
           CLI_Parser("osd.p.en 2 0");		// disable OSD plane 2
           CLI_Parser("n.mute.all 0 0"); 	// mute Vdp(ucVdpId; on/off) 
           CLI_Parser("n.mute.off 0"); 		// unmute main Vdp
#if 1 // wwj		   
		   ui4_end_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();

		   LOG(0, "TUNE_ATSC %d ms ~~ \n", (ui4_end_time - ui4_begin_time));
#endif		   
           break;   
       }
       case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_DTMB:
       {
           UINT32             ui4_freq = 0;
           UINT8              ui1_modulation = 0;
           UINT8              ui1_lna = 0;
           UINT16             ui2_video_pid = 0;
           UINT8              ui1_video_codec = 0;
           UINT16             ui2_audio_pid = 0;
           UINT8              ui1_audio_codec = 0;
           UINT8              ui1_framerate = 0;
           AUD_FMT_T          eAudDecFmt = 0;
           ENUM_VDEC_FMT_T    eVideoDecFmt = 0;
#if 1 // wwj		   
		  UINT32	   ui4_begin_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();
		  UINT32	   ui4_end_time = 0;
#endif	

           
           if ((pv_set_info == NULL) || (z_size != sizeof(DRV_TUNE_DTMB_T)))
           {
               LOG(2, "Invalid parameter (TUNE_DTMB)\n");
               return RMR_INV_ARG;
           }
           
           ui4_freq = (((DRV_TUNE_DTMB_T *)pv_set_info)->ui4_freq);
           ui1_modulation = (((DRV_TUNE_DTMB_T *)pv_set_info)->ui1_modulation);
           ui1_lna = (((DRV_TUNE_DTMB_T *)pv_set_info)->ui1_lna);
           ui2_video_pid = (((DRV_TUNE_DTMB_T *)pv_set_info)->ui2_video_pid);
           ui1_video_codec = (((DRV_TUNE_DTMB_T *)pv_set_info)->ui1_video_codec);
           ui2_audio_pid = (((DRV_TUNE_DTMB_T *)pv_set_info)->ui2_audio_pid);
           ui1_audio_codec = (((DRV_TUNE_DTMB_T *)pv_set_info)->ui1_audio_codec);
           ui1_framerate = (((DRV_TUNE_DTMB_T *)pv_set_info)->ui1_framerate);

		   //free DMX pid and stop VDEC
           CLI_Parser("vdec.s 0");		// stop video decoder main path
           x_thread_delay(50);
		   CLI_Parser("d.fpinst");  // free all DMX PIDs of instance 0
		   
           //tuner
           CLI_Parser("n.mute.on 0"); 	// mute Vdp main path
           CLI_Parser("aud.stop 0");	// stop audio main decoder
           x_thread_delay(50);
           CLI_Parser("aud.stop 1");	// stop audio sub decoder
           x_thread_delay(50);
           CLI_Parser("d.fp 0");	// free id ???
           x_thread_delay(50);
           CLI_Parser("vdp.d 0");    // disable Vdp main     
           x_thread_delay(50);
           bApiVideoSetVideoSrc(0,255);		// set video source ???
           x_thread_delay(50);
           CLI_Parser("n.ms dtv1");		// select main source to DTV 
           CLI_Parser("nim.id 1"); 		// set tuner type to DTV 
           x_thread_delay(100);
           CLI_Parser("nim.go dtmb");    // set tuner scan rule is DTMB 
           CLI_Parser_Arg("sif.xw 0 270 0xd8 1 0x09 3 0xc0 0x85 %d",ui1_lna);	//set lna parameter to tuner register
           CLI_Parser_Arg("nim.freq %d",ui4_freq);	//set DTMB's frequency
           x_thread_delay(100);
           //vdp
           CLI_Parser("vdp.e 0");   	// enable vdp main path ?
           CLI_Parser("vdp.s.outr 0 1");    // set vdp ouput region (ucVdpId; X; Y; W; H)  ?
           CLI_Parser("vdp.s.i 0 0 0");		// set vdp input region (ucVdpId; ucEsId; ucPort) ?
           CLI_Parser("vdp.s.srcr 0 1");	// set vdp source region (ucVdpId; X; Y; W; H) ?
           //vdec
           switch(ui1_video_codec)
           {
             case FCTRY_VIDEO_CODEC_MPEG2://MPEG2
                eVideoDecFmt = VDEC_FMT_MPV;
                break;
             case FCTRY_VIDEO_CODEC_AVC://AVC
                eVideoDecFmt = VDEC_FMT_H264;
                break;
             case FCTRY_VIDEO_CODEC_AVS://AVS
                eVideoDecFmt = VDEC_FMT_AVS;
                break;
             case FCTRY_VIDEO_CODEC_VC1://VC1
                eVideoDecFmt = VDEC_FMT_WMV;
                break;
             case FCTRY_VIDEO_CODEC_MPEG4VISUAL://MPEG4VISUAL
                eVideoDecFmt = VDEC_FMT_MP4;
                break;
             case FCTRY_VIDEO_CODEC_DIVX://DIVX
                eVideoDecFmt = VDEC_FMT_MP4;
                break;          
             default:
                eVideoDecFmt = VDEC_FMT_MPV;
                break;
           }    
           CLI_Parser_Arg("vdec.p 0 %d",eVideoDecFmt);		// video decoder play (EsId; Format)
           //dmx
           if(eVideoDecFmt == VDEC_FMT_H264)
           {
               CLI_Parser("d.svt 1");		// set DMX video type
           }            
           else if(eVideoDecFmt == VDEC_FMT_AVS)
           {
               CLI_Parser("d.svt 2");		// set DMX video type
           }
           else
           {               
               CLI_Parser("d.svt 0");		// set DMX video type
           }
           CLI_Parser_Arg("d.sp 0 0x%x video",ui2_video_pid);	// set video PID(pid_index; PID; PID_type; device_id )
           Printf("444\n");
           //AUDIO
           switch(ui1_audio_codec)
           {
             case FCTRY_AUDIO_CODEC_LPCM://LPCM
                eAudDecFmt = AUD_FMT_LPCM;
                break;
             case FCTRY_AUDIO_CODEC_AAC://AAC
                eAudDecFmt = AUD_FMT_AAC;
                break;
             case FCTRY_AUDIO_CODEC_AC3://AC3
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_AC3_PLUS://AC3_PLUS
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_HEAAC://HEAAC
                eAudDecFmt = AUD_FMT_HE_AAC;
                break;
             case FCTRY_AUDIO_CODEC_MPEG_AUDIO://MPEG_AUDIO
                eAudDecFmt = AUD_FMT_MPEG;
                break;
             default:
                eAudDecFmt = AUD_FMT_UNKNOWN;
                break;
           }
           CLI_Parser_Arg("aud.s 1 1 %d",eAudDecFmt);		// set audio decoder (decoder_id; stream_from; stream type)
           CLI_Parser("aud.play 1");		// play audio sub decoder
           CLI_Parser("aud.s 0 1 3");		// set audio decoder (main_decoder; stream_from_digital-tuner; stream_type_is_PCM)
           CLI_Parser("aud.play 0");		// play audio main decoder
           CLI_Parser_Arg("d.sp 1 0x%x audio 1",ui2_audio_pid);   	// set audio PID(pid_index; PID; PID_type; device_id ) 
           x_thread_delay(100);
           CLI_Parser("n.mute.all 0 0");   	// mute Vdp(ucVdpId; on/off)          
           CLI_Parser("n.mute.off 0");		// unmute main Vdp
#if 1 // wwj		   
		   ui4_end_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();

		   LOG(0, "TUNE_DTMB %d ms ~~ \n", (ui4_end_time - ui4_begin_time));
#endif		   
           break;
       }
       case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_DVBS:
       {    
           UINT8              ui1_tuner_path = 0;
           UINT8              ui1_standard = 0;
           UINT32             ui4_freq = 0;
           UINT32             ui1_symbol_rate = 0;
           UINT16             ui2_video_pid = 0;
           UINT8              ui1_video_codec = 0;
           UINT16             ui2_audio_pid = 0;
           UINT8              ui1_audio_codec = 0;
           UINT8              ui1_framerate = 0;
           AUD_FMT_T          eAudDecFmt = 0;
           ENUM_VDEC_FMT_T    eVideoDecFmt = 0;
#if 1 // wwj		   
		   UINT32		ui4_begin_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();
		   UINT32		ui4_end_time = 0;
#endif		   
           
           if ((pv_set_info == NULL) || (z_size != sizeof(DRV_TUNE_DVBS_T)))
           {
               LOG(2, "Invalid parameter (TUNE_DVBS)\n");
               return RMR_INV_ARG;
           }
           
           ui1_tuner_path = (((DRV_TUNE_DVBS_T *)pv_set_info)->ui1_tuner_path);
           ui1_standard = (((DRV_TUNE_DVBS_T *)pv_set_info)->ui1_standard);
           ui4_freq = (((DRV_TUNE_DVBS_T *)pv_set_info)->ui4_freq);
           ui1_symbol_rate = (((DRV_TUNE_DVBS_T *)pv_set_info)->ui1_symbol_rate);
           ui2_video_pid = (((DRV_TUNE_DVBS_T *)pv_set_info)->ui2_video_pid);
           ui1_video_codec = (((DRV_TUNE_DVBS_T *)pv_set_info)->ui1_video_codec);
           ui2_audio_pid = (((DRV_TUNE_DVBS_T *)pv_set_info)->ui2_audio_pid);
           ui1_audio_codec = (((DRV_TUNE_DVBS_T *)pv_set_info)->ui1_audio_codec);
           ui1_framerate = (((DRV_TUNE_DVBS_T *)pv_set_info)->ui1_framerate);
       
           
           //tuner         
           CLI_Parser("n.mute.on 0"); 	// mute Vdp main path
           CLI_Parser("aud.stop 0");	// stop audio main decoder
           x_thread_delay(50);
           CLI_Parser("aud.stop 1");	// stop audio sub decoder
           x_thread_delay(50);
           CLI_Parser("vdec.s 0");		// stop video decoder main path
           x_thread_delay(50);
           CLI_Parser("d.fp 0");	// free id ???
           x_thread_delay(50);           
           CLI_Parser("vdp.d 0");    // disable Vdp main     
           x_thread_delay(50);
           bApiVideoSetVideoSrc(0,255);		// set video source ???
           x_thread_delay(50);
           CLI_Parser("n.ms dtv1");		// select main source to DTV
           CLI_Parser("nim.id 1");  
           CLI_Parser("nim.go dvbs");   // set tuner scan rule is DVB-S
           CLI_Parser_Arg("nim.sc %d %d 64",ui4_freq,ui1_symbol_rate);
           x_thread_delay(50);
           //vdp
           CLI_Parser("vdp.e 0");   	// enable vdp main path ?
           CLI_Parser("vdp.s.outr 0 1");  	// set vdp ouput region (ucVdpId; X; Y; W; H)  ? 
           CLI_Parser("vdp.s.i 0 0 0");		// set vdp input region (ucVdpId; ucEsId; ucPort) ?
           CLI_Parser("vdp.s.srcr 0 1");	// set vdp source region (ucVdpId; X; Y; W; H) ?
           //vdec
           switch(ui1_video_codec)
           {
             case FCTRY_VIDEO_CODEC_MPEG2://MPEG2
                eVideoDecFmt = VDEC_FMT_MPV;
                break;
             case FCTRY_VIDEO_CODEC_AVC://AVC
                eVideoDecFmt = VDEC_FMT_H264;
                break;
             case FCTRY_VIDEO_CODEC_AVS://AVS
                eVideoDecFmt = VDEC_FMT_AVS;
                break;
             case FCTRY_VIDEO_CODEC_VC1://VC1
                eVideoDecFmt = VDEC_FMT_WMV;
                break;
             case FCTRY_VIDEO_CODEC_MPEG4VISUAL://MPEG4VISUAL
                eVideoDecFmt = VDEC_FMT_MP4;
                break;
             case FCTRY_VIDEO_CODEC_DIVX://DIVX
                eVideoDecFmt = VDEC_FMT_MP4;
                break;          
             default:
                eVideoDecFmt = FCTRY_VIDEO_CODEC_MPEG2;
                break;
           }             
           x_thread_delay(50);
           CLI_Parser_Arg("vdec.p 0 %d",eVideoDecFmt);		// video decoder play (EsId; Format)
           //dmx
           if(eVideoDecFmt == VDEC_FMT_H264)
           {
               CLI_Parser("d.svt 1");		// set DMX video type
           }           
           else if(eVideoDecFmt == VDEC_FMT_AVS)
           {
               CLI_Parser("d.svt 2");		// set DMX video type
           }
           else
           {               
               CLI_Parser("d.svt 0");		// set DMX video type
           }
           CLI_Parser("d.sfe 0x11 0");		// set fe_type ???
           CLI_Parser_Arg("d.sp 0 0x%x video",ui2_video_pid);	// set video PID(pid_index; PID; PID_type; device_id )
       
           //AUDIO
           switch(ui1_audio_codec)
           {
             case FCTRY_AUDIO_CODEC_LPCM://LPCM
                eAudDecFmt = AUD_FMT_LPCM;
                break;
             case FCTRY_AUDIO_CODEC_AAC://AAC
                eAudDecFmt = AUD_FMT_AAC;
                break;
             case FCTRY_AUDIO_CODEC_AC3://AC3
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_AC3_PLUS://AC3_PLUS
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_HEAAC://HEAAC
                eAudDecFmt = AUD_FMT_HE_AAC;
                break;
             case FCTRY_AUDIO_CODEC_MPEG_AUDIO://MPEG_AUDIO
                eAudDecFmt = AUD_FMT_MPEG;
                break;
             default:
                eAudDecFmt = AUD_FMT_UNKNOWN;
                break;
           }
           CLI_Parser_Arg("aud.s 1 1 %d",eAudDecFmt);		// set audio decoder (decoder_id; stream_from; stream type)
           CLI_Parser("aud.play 1");		// play audio sub decoder
           CLI_Parser("aud.s 0 1 3");		// set audio decoder (main_decoder; stream_from_digital-tuner; stream_type_is_PCM)
           CLI_Parser("aud.play 0");		// play audio main decoder
           CLI_Parser_Arg("d.sp 1 0x%x audio 1",ui2_audio_pid);		// set video PID(pid_index; PID; PID_type; device_id )
           x_thread_delay(100);
           CLI_Parser("n.mute.all 0 0");     // mute Vdp(ucVdpId; on/off)      
           CLI_Parser("n.mute.off 0"); 		// unmute main Vdp	
#if 1 // wwj		   
		   ui4_end_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();

		   LOG(0, "TUNE_DVBS %d ms ~~ \n", (ui4_end_time - ui4_begin_time));
#endif		   
           break;
       }
       case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_DVBT:
       {
           UINT8              ui1_tuner_path = 0;
           UINT8              ui1_standard = 0;
           UINT32             ui4_freq = 0;
           UINT8              ui1_bandwith = 0;
           UINT8              ui1_modulation = 0;
           UINT8              ui1_lna = 0;
           UINT16             ui2_video_pid = 0;
           UINT8              ui1_video_codec = 0;
           UINT16             ui2_audio_pid = 0;
           UINT8              ui1_audio_codec = 0;
           UINT8              ui1_framerate = 0;
           UINT8              tuner_type =0;
           AUD_FMT_T          eAudDecFmt = 0;
           ENUM_VDEC_FMT_T    eVideoDecFmt = 0;
#if 1 // wwj		   
		   UINT32		ui4_begin_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();
		   UINT32		ui4_end_time = 0;
#endif		   
           
           if ((pv_set_info == NULL) || (z_size != sizeof(DRV_TUNE_DVBT_T)))
           {
               LOG(2, "Invalid parameter (TUNE_DVBT)\n");
               return RMR_INV_ARG;
           }
           ui1_tuner_path = (((DRV_TUNE_DVBT_T *)pv_set_info)->ui1_tuner_path);
           ui1_standard = (((DRV_TUNE_DVBT_T *)pv_set_info)->ui1_standard);
           ui4_freq = (((DRV_TUNE_DVBT_T *)pv_set_info)->ui4_freq);
           ui1_bandwith = (((DRV_TUNE_DVBT_T *)pv_set_info)->ui1_bandwith);
           ui1_modulation = (((DRV_TUNE_DVBT_T *)pv_set_info)->ui1_modulation);
           ui1_lna = (((DRV_TUNE_DVBT_T *)pv_set_info)->ui1_lna);
           ui2_video_pid = (((DRV_TUNE_DVBT_T *)pv_set_info)->ui2_video_pid);
           ui1_video_codec = (((DRV_TUNE_DVBT_T *)pv_set_info)->ui1_video_codec);
           ui2_audio_pid = (((DRV_TUNE_DVBT_T *)pv_set_info)->ui2_audio_pid);
           ui1_audio_codec = (((DRV_TUNE_DVBT_T *)pv_set_info)->ui1_audio_codec);
           ui1_framerate = (((DRV_TUNE_DVBT_T *)pv_set_info)->ui1_framerate);
           
           //tuner
           CLI_Parser("n.mute.on 0");	// mute Vdp main path
           CLI_Parser("aud.stop 0");  	// stop audio main decoder          
           x_thread_delay(50);
           CLI_Parser("aud.stop 1");	// stop audio sub decoder
           x_thread_delay(50);
           CLI_Parser("vdec.s 0");      // stop video decoder main path  //first should stop vdec,then play will ok
           x_thread_delay(50);
           CLI_Parser("d.fp 0");	// free id ???
           x_thread_delay(50);          
           CLI_Parser("vdp.d 0");    // disable Vdp main 	    
           x_thread_delay(50);
           bApiVideoSetVideoSrc(0,255);		// set video source ???
           x_thread_delay(50);
           CLI_Parser("n.ms dtv1");  	// select main source to DTV
           CLI_Parser("nim.id 1"); 		// switch tuner type to DTV
           x_thread_delay(50);
           CLI_Parser("nim.go dvbt"); 	// set tuner scan rule is DVB-T  
           x_thread_delay(100);
           CLI_Parser_Arg("sif.xw 0 270 0xd8 1 0x09 3 0xc0 0x85 %d",ui1_lna);	//set lna parameter to tuner register
           CLI_Parser_Arg("nim.sbw %d",ui1_bandwith); 	// set tuner bandwith 
           CLI_Parser_Arg("nim.freq %d",ui4_freq);		// set channel frequency
           x_thread_delay(100);
           //vdp
           CLI_Parser("vdp.e 0");   	// enable vdp main path ?
           CLI_Parser("vdp.s.outr 0 1");  	// set vdp ouput region (ucVdpId; X; Y; W; H)  ?  
           CLI_Parser("vdp.s.i 0 0 0");		// set vdp input region (ucVdpId; ucEsId; ucPort) ?
           CLI_Parser("vdp.s.srcr 0 1");	// set vdp source region (ucVdpId; X; Y; W; H) ?
           //vdec
           switch(ui1_video_codec)
           {
             case FCTRY_VIDEO_CODEC_MPEG2://MPEG2
                eVideoDecFmt = VDEC_FMT_MPV;
                break;
             case FCTRY_VIDEO_CODEC_AVC://AVC
                eVideoDecFmt = VDEC_FMT_H264;
                break;
             case FCTRY_VIDEO_CODEC_AVS://AVS
                eVideoDecFmt = VDEC_FMT_AVS;
                break;
             case FCTRY_VIDEO_CODEC_VC1://VC1
                eVideoDecFmt = VDEC_FMT_WMV;
                break;
             case FCTRY_VIDEO_CODEC_MPEG4VISUAL://MPEG4VISUAL
                eVideoDecFmt = VDEC_FMT_MP4;
                break;
             case FCTRY_VIDEO_CODEC_DIVX://DIVX
                eVideoDecFmt = VDEC_FMT_MP4;
                break;          
             default:
                eVideoDecFmt = VDEC_FMT_MPV;
                break;
           }    
           
           CLI_Parser_Arg("vdec.p 0 %d",eVideoDecFmt);		// video decoder play (EsId; Format)
           //dmx
           x_thread_delay(100);
           EEPROM_Read((UINT64)0x6cd,(UINT32)(VOID *)&tuner_type,1);
           if(tuner_type == 0x0a)
           {
               CLI_Parser("d.sfe 0x0 0");		// set fe_type ???
           }
           else
           {
               CLI_Parser("d.sfe 0x11 0");		// set fe_type ???
           }
           if(eVideoDecFmt == VDEC_FMT_H264)
           {
               CLI_Parser("d.svt 1");		// set DMX video type
           }
           else if(eVideoDecFmt == VDEC_FMT_AVS)
           {
               CLI_Parser("d.svt 2");		// set DMX video type
           }
           else
           {   
               CLI_Parser("d.svt 0");		// set DMX video type
           }
           CLI_Parser_Arg("d.sp 0 0x%x video",ui2_video_pid);	// set video PID(pid_index; PID; PID_type; device_id )

           //AUDIO
           switch(ui1_audio_codec)
           {
             case FCTRY_AUDIO_CODEC_LPCM://LPCM
                eAudDecFmt = AUD_FMT_LPCM;
                break;
             case FCTRY_AUDIO_CODEC_AAC://AAC
                eAudDecFmt = AUD_FMT_AAC;
                break;
             case FCTRY_AUDIO_CODEC_AC3://AC3
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_AC3_PLUS://AC3_PLUS
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_HEAAC://HEAAC
                eAudDecFmt = AUD_FMT_HE_AAC;
                break;
             case FCTRY_AUDIO_CODEC_MPEG_AUDIO://MPEG_AUDIO
                eAudDecFmt = AUD_FMT_MPEG;
                break;
             default:
                eAudDecFmt = AUD_FMT_UNKNOWN;
                break;
           }    

           CLI_Parser_Arg("aud.s 1 1 %d",eAudDecFmt);		// set audio decoder (decoder_id; stream_from; stream type)
           CLI_Parser("aud.play 1");		// play audio sub decoder
           CLI_Parser("aud.s 0 1 3");		// set audio decoder (main_decoder; stream_from_digital-tuner; stream_type_is_PCM)
           CLI_Parser("aud.play 0");		// play audio main decoder
           CLI_Parser_Arg("d.sp 1 0x%x audio 1",ui2_audio_pid);		// set audio PID(pid_index; PID; PID_type; device_id )
           x_thread_delay(100);
           CLI_Parser("n.mute.all 0 0");	// mute Vdp(ucVdpId; on/off) 	
           CLI_Parser("n.mute.off 0");		// unmute main Vdp
#if 1 // wwj		   
		   ui4_end_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();

		   LOG(0, "TUNE_DVBT %d ms ~~ \n", (ui4_end_time - ui4_begin_time));
#endif			   
           break;
       }
       case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_ISDBT:
       {
           UINT8              ui1_tuner_path = 0;
           UINT32             ui4_freq = 0;
           UINT16             ui2_video_pid = 0;
           UINT8              ui1_video_codec = 0;
           UINT16             ui2_audio_pid = 0;
           UINT8              ui1_audio_codec = 0;
           UINT8              ui1_framerate;
           AUD_FMT_T          eAudDecFmt = 0;
           ENUM_VDEC_FMT_T    eVideoDecFmt = 0;
#if 1 // wwj		   
		   UINT32		ui4_begin_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();
		   UINT32		ui4_end_time = 0;
#endif			   
           
           if ((pv_set_info == NULL) || (z_size != sizeof(DRV_TUNE_ISDBT_T)))
           {
               LOG(2, "Invalid parameter (TUNE_ISDBT)\n");
               return RMR_INV_ARG;
           }
           
           ui1_tuner_path = (((DRV_TUNE_ISDBT_T *)pv_set_info)->ui1_tuner_path);
           ui4_freq = (((DRV_TUNE_ISDBT_T *)pv_set_info)->ui4_freq);
           ui2_video_pid = (((DRV_TUNE_ISDBT_T *)pv_set_info)->ui2_video_pid);
           ui1_video_codec = (((DRV_TUNE_ISDBT_T *)pv_set_info)->ui1_video_codec);
           ui2_audio_pid = (((DRV_TUNE_ISDBT_T *)pv_set_info)->ui2_audio_pid);
           ui1_audio_codec = (((DRV_TUNE_ISDBT_T *)pv_set_info)->ui1_audio_codec);
           ui1_framerate = (((DRV_TUNE_ISDBT_T *)pv_set_info)->ui1_framerate);
           
           //tuner   
           CLI_Parser("n.mute.on 0");	// mute Vdp main path
           CLI_Parser("aud.stop 0");	// stop audio main decoder
           x_thread_delay(50);
           CLI_Parser("aud.stop 1");	// stop audio sub decoder
           x_thread_delay(50);
           CLI_Parser("vdec.s 0");	// stop video decoder main path
           x_thread_delay(50);
           CLI_Parser("d.fp 0");	// free id ???
           x_thread_delay(50);           
           CLI_Parser("vdp.d 0");    // disable Vdp main     
           x_thread_delay(50);
           bApiVideoSetVideoSrc(0,255);		// set video source ???
           x_thread_delay(50);
           CLI_Parser("nim.id 1");  	// set tuner to DTV
           CLI_Parser("nim.go isdbt");   //switch tuner scan rule to ISDB-T
           CLI_Parser_Arg("nim.freq %d",ui4_freq);	// set channel frequency
           //vdp
           CLI_Parser("vdp.e 0");  		// enable vdp main path ? 
           CLI_Parser("vdp.s.outr 0 1");    // set vdp ouput region (ucVdpId; X; Y; W; H)  ?
           CLI_Parser("vdp.s.i 0 0 0");		// set vdp input region (ucVdpId; ucEsId; ucPort) ?
           CLI_Parser("vdp.s.srcr 0 1");	// set vdp source region (ucVdpId; X; Y; W; H) ?
           //vdec
           switch(ui1_video_codec)
           {
             case FCTRY_VIDEO_CODEC_MPEG2://MPEG2
                eVideoDecFmt = VDEC_FMT_MPV;
                break;
             case FCTRY_VIDEO_CODEC_AVC://AVC
                eVideoDecFmt = VDEC_FMT_H264;
                break;
             case FCTRY_VIDEO_CODEC_AVS://AVS
                eVideoDecFmt = VDEC_FMT_AVS;
                break;
             case FCTRY_VIDEO_CODEC_VC1://VC1
                eVideoDecFmt = VDEC_FMT_WMV;
                break;
             case FCTRY_VIDEO_CODEC_MPEG4VISUAL://MPEG4VISUAL
                eVideoDecFmt = VDEC_FMT_MP4;
                break;
             case FCTRY_VIDEO_CODEC_DIVX://DIVX
                eVideoDecFmt = VDEC_FMT_MP4;
                break;          
             default:
                eVideoDecFmt = VDEC_FMT_MAX;
                break;
           }    
           CLI_Parser_Arg("vdec.p 0 %d",eVideoDecFmt);		// video decoder play (EsId; Format)
		   CLI_Parser_Arg("vdec.ss 0 1 1");		// set sync stc (ucEsId; ucMode; ucStcId) ???
		   
           //dmx
           x_thread_delay(100);
           CLI_Parser("d.sfe 0x11 0");		// set fe_type ???
           if(eVideoDecFmt == VDEC_FMT_H264)
           {
               CLI_Parser("d.svt 1");		// set DMX video type
           }           
           else if(eVideoDecFmt == VDEC_FMT_AVS)
           {
               CLI_Parser("d.svt 2");		// set DMX video type
           }
           else
           {               
               CLI_Parser("d.svt 0");		// set DMX video type
           }
           
           CLI_Parser_Arg("d.sp 0 0x%x video",ui2_video_pid);	// set video PID(pid_index; PID; PID_type; device_id )
           CLI_Parser("n.ms dtv1");		// select main source to DTV
           //AUDIO
           switch(ui1_audio_codec)
           {
             case FCTRY_AUDIO_CODEC_LPCM://LPCM
                eAudDecFmt = AUD_FMT_LPCM;
                break;
             case FCTRY_AUDIO_CODEC_AAC://AAC
                eAudDecFmt = AUD_FMT_AAC;
                break;
             case FCTRY_AUDIO_CODEC_AC3://AC3
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_AC3_PLUS://AC3_PLUS
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_HEAAC://HEAAC
                eAudDecFmt = AUD_FMT_HE_AAC;
                break;
             case FCTRY_AUDIO_CODEC_MPEG_AUDIO://MPEG_AUDIO
                eAudDecFmt = AUD_FMT_MPEG;
                break;
             default:
                eAudDecFmt = AUD_FMT_UNKNOWN;
                break;
           }
           CLI_Parser_Arg("aud.s 1 1 %d",eAudDecFmt);		// set audio decoder (decoder_id; stream_from; stream type)
		   CLI_Parser("aud.sync 0 1");		// set audio main decoder sync mode to SLAVE_MODE
		   CLI_Parser("aud.sync 1 1");		// set audio sub decoder sync mode to SLAVE_MODE
		   x_thread_delay(50);
           CLI_Parser("aud.play 1");		// play audio sub decoder
           CLI_Parser("aud.s 0 1 3");		// set audio decoder (main_decoder; stream_from_digital-tuner; stream_type_is_PCM)
           CLI_Parser("aud.play 0");		// play audio main decoder
           CLI_Parser_Arg("d.sp 1 0x%x audio 1",ui2_audio_pid);		// set audio PID(pid_index; PID; PID_type; device_id )
           x_thread_delay(50);
           CLI_Parser("n.mute.all 0 0");    // mute Vdp(ucVdpId; on/off)        
           CLI_Parser("n.mute.off 0");		// unmute main Vdp
#if 1 // wwj		   
		   ui4_end_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();

		   LOG(0, "TUNE_ISDBT %d ms ~~ \n", (ui4_end_time - ui4_begin_time));
#endif		   
           break;
       }
       
       case DRV_CUSTOM_CUST_SPEC_TYPE_TUNE_DVBC:
       {
           UINT8              ui1_tuner_path = 0;
           UINT32             ui4_freq = 0;
           UINT8              ui1_bandwith = 0;
           UINT8              ui1_modulation = 0;
           UINT16             ui2_video_pid = 0;
           UINT8              ui1_video_codec = 0;
           UINT16             ui2_audio_pid = 0;
           UINT8              ui1_audio_codec = 0;
           UINT8              ui1_framerate = 0;
           AUD_FMT_T          eAudDecFmt = 0;
           ENUM_VDEC_FMT_T    eVideoDecFmt = 0;
#if 1 // wwj		   
		   UINT32		ui4_begin_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();
		   UINT32		ui4_end_time = 0;
#endif			   
           
           if ((pv_set_info == NULL) || (z_size != sizeof(DRV_TUNE_DVBT_T)))
           {
               LOG(2, "Invalid parameter (TUNE_DVBT)\n");
               return RMR_INV_ARG;
           }           
           ui1_tuner_path = (((DRV_TUNE_DVBC_T *)pv_set_info)->ui1_tuner_path);
           ui4_freq = (((DRV_TUNE_DVBC_T *)pv_set_info)->ui4_freq);
           ui1_bandwith = (((DRV_TUNE_DVBC_T *)pv_set_info)->ui1_bandwith);
           ui1_modulation = (((DRV_TUNE_DVBC_T *)pv_set_info)->ui1_modulation);
           ui2_video_pid = (((DRV_TUNE_DVBC_T *)pv_set_info)->ui2_video_pid);
           ui1_video_codec = (((DRV_TUNE_DVBC_T *)pv_set_info)->ui1_video_codec);
           ui2_audio_pid = (((DRV_TUNE_DVBC_T *)pv_set_info)->ui2_audio_pid);
           ui1_audio_codec = (((DRV_TUNE_DVBC_T *)pv_set_info)->ui1_audio_codec);
           ui1_framerate = (((DRV_TUNE_DVBC_T *)pv_set_info)->ui1_framerate);
           
           //tuner 
           CLI_Parser("n.mute.on 0");	// mute Vdp main path
           CLI_Parser("aud.stop 0");	// stop audio main decoder
           x_thread_delay(50);
           CLI_Parser("aud.stop 1");	// stop audio sub decoder
           x_thread_delay(50);
           CLI_Parser("vdec.s 0");  // stop video decoder main path        
           CLI_Parser("d.fp 0");	// free id ???
           x_thread_delay(50);           
           CLI_Parser("vdp.d 0");     // disable Vdp main    
           x_thread_delay(50);
           bApiVideoSetVideoSrc(0,255);		// set video source ???
           x_thread_delay(50);
           CLI_Parser("nim.id 1");  	//switch tuner to DTV
           if(ui1_modulation == 16)
           {
               CLI_Parser("nim.go dvbc16");   // switch tuner to DVB-C 16 QAM
           }
           else if(ui1_modulation == 32)
           {
               CLI_Parser("nim.go dvbc32");   // switch tuner to DVB-C 32 QAM
           }           
           else if(ui1_modulation == 64)
           {
               CLI_Parser("nim.go dvbc64");   // switch tuner to DVB-C 64 QAM
           }                   
           else if(ui1_modulation == 128)
           {
               CLI_Parser("nim.go dvbc128");   // switch tuner to DVB-C 128 QAM
           }          
           else
           {
               CLI_Parser("nim.go dvbc64");   // switch tuner to DVB-C 16 QAM
           }
           CLI_Parser_Arg("nim.freq %d",ui4_freq);	// set current tuner frequency
           //vdp
           CLI_Parser("n.ms dtv1");		// select main source to DTV
           CLI_Parser("vdp.e 0");   	// enable vdp main path ?
           CLI_Parser("vdp.s.outr 0 1");	// set vdp ouput region (ucVdpId; X; Y; W; H)  ?
           CLI_Parser("vdp.s.i 0 0 0");		// set vdp input region (ucVdpId; ucEsId; ucPort) ?
           CLI_Parser("vdp.s.srcr 0 1");	// set vdp source region (ucVdpId; X; Y; W; H) ?
           //vdec
           switch(ui1_video_codec)
           {
             case FCTRY_VIDEO_CODEC_MPEG2://MPEG2
                eVideoDecFmt = VDEC_FMT_MPV;
                break;
             case FCTRY_VIDEO_CODEC_AVC://AVC
                eVideoDecFmt = VDEC_FMT_H264;
                break;
             case FCTRY_VIDEO_CODEC_AVS://AVS
                eVideoDecFmt = VDEC_FMT_AVS;
                break;
             case FCTRY_VIDEO_CODEC_VC1://VC1
                eVideoDecFmt = VDEC_FMT_WMV;
                break;
             case FCTRY_VIDEO_CODEC_MPEG4VISUAL://MPEG4VISUAL
                eVideoDecFmt = VDEC_FMT_MP4;
                break;
             case FCTRY_VIDEO_CODEC_DIVX://DIVX
                eVideoDecFmt = VDEC_FMT_MP4;
                break;          
             default:
                eVideoDecFmt = VDEC_FMT_MAX;
                break;
           }    
           CLI_Parser_Arg("vdec.p 0 %d",eVideoDecFmt);		// video decoder play (EsId; Format)
           //dmx
           if(eVideoDecFmt == VDEC_FMT_H264)
           {
               CLI_Parser("d.svt 1");		// set DMX video type
           }           
           else if(eVideoDecFmt == VDEC_FMT_AVS)
           {
               CLI_Parser("d.svt 2");		// set DMX video type
           }
           else
           {               
               CLI_Parser("d.svt 0");		// set DMX video type
           }
           CLI_Parser("d.fp 0");	// free id ???
           CLI_Parser_Arg("d.sp 0 0x%x video",ui2_video_pid);		// set video PID(pid_index; PID; PID_type; device_id )
           //AUDIO
           switch(ui1_audio_codec)
           {
             case FCTRY_AUDIO_CODEC_LPCM://LPCM
                eAudDecFmt = AUD_FMT_LPCM;
                break;
             case FCTRY_AUDIO_CODEC_AAC://AAC
                eAudDecFmt = AUD_FMT_AAC;
                break;
             case FCTRY_AUDIO_CODEC_AC3://AC3
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_AC3_PLUS://AC3_PLUS
                eAudDecFmt = AUD_FMT_AC3;
                break;
             case FCTRY_AUDIO_CODEC_HEAAC://HEAAC
                eAudDecFmt = AUD_FMT_HE_AAC;
                break;
             case FCTRY_AUDIO_CODEC_MPEG_AUDIO://MPEG_AUDIO
                eAudDecFmt = AUD_FMT_MPEG;
                break;
             default:
                eAudDecFmt = AUD_FMT_MPEG;
                break;
           }    
           CLI_Parser("aud.stop 0");	// stop audio main decoder
           CLI_Parser("aud.stop 1");	// stop audio sub decoder
           CLI_Parser_Arg("aud.s 1 1 %d",eAudDecFmt);		// set audio decoder (decoder_id; stream_from; stream type)
           CLI_Parser("aud.play 1");		// play audio sub decoder
           CLI_Parser("aud.s 0 1 3");		// set audio decoder (main_decoder; stream_from_digital-tuner; stream_type_is_PCM)
           CLI_Parser("aud.play 0");		// play audio main decoder
           CLI_Parser_Arg("d.sp 1 0x%x audio 1",ui2_audio_pid);     // set audio PID(pid_index; PID; PID_type; device_id )
           CLI_Parser("n.mute.all 0 0");  	// mute Vdp(ucVdpId; on/off)           
           CLI_Parser("n.mute.off 0");		// unmute main Vdp
#if 1 // wwj		   
		   ui4_end_time = x_os_get_sys_tick() * x_os_get_sys_tick_period();
           
		   LOG(0, "TUNE_DVBC %d ms ~~ \n", (ui4_end_time - ui4_begin_time));
#endif		   
           break;
       }

		case DRV_CUSTOM_CUST_SPEC_TYPE_FACTORY_SCART_OUT_CONTROL:
		{
			UINT16 tv_type = 0;
			if ((pv_set_info == NULL) || (z_size != sizeof(UINT16)))
			{
				LOG(2, "Invalid parameter (scart out control)\n");
				return RMR_INV_ARG;
			}
			
			tv_type	= *(UINT16 *)pv_set_info;

			Printf("tv_type is :%d\n",tv_type);

			switch(tv_type)
			{
				case 0: 	//dtv
					CLI_Parser("b.scm 0");
					CLI_Parser("tve.cs 0 dtv1");
				break;
				case 1: 	//atv
					CLI_Parser("b.scm 0");
					CLI_Parser("tve.cs 0 atd");
				break;
				default:
					Printf("wrong input value,please send again\n");   
				break;
			}

			x_thread_delay(50);
			CLI_Parser("aud.io.interdac.ch 1 3");

			break;
		}
		
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_CLR_TEMP_IDX_SET:
		{
		    UINT16 ui2_idx;
			ui2_idx = *((UINT16 *)(pv_set_info));
			WB_PBM_ColorTemp_Idx_Set(ui2_idx);
			break;
		}
#endif 
       case DRV_CUSTOM_CUST_SPEC_TYPE_LED_MODE:
        {
            D_LED_DISPLAY *prLEDInfo = (D_LED_DISPLAY *)pv_set_info;

            if ((pv_set_info == NULL) || (z_size != sizeof(D_LED_DISPLAY)))
            {
                LOG(2, "Invalid parameter\n");
                return RMR_INV_ARG;
            }
            
           Printf("[d_Soem_cust_spec_set] Set led %d as %d\n", prLEDInfo->eLedType, prLEDInfo->eLedState);

            CustomLEDCtrlFunc(prLEDInfo->eLedType, prLEDInfo->eLedState);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_BRIGHTNESS_PLUS:
        {
            if ((pv_set_info == NULL) || (z_size != sizeof(UINT8)))
            {
                LOG(2, "Invalid parameter\n");
                return RMR_INV_ARG;
            }
            
            DRVCUST_Enable_BrightnessPlus((*(UINT8 *)pv_set_info)); 
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_STANDBY_LED_DISABLE_MODE:
        {
            if ((pv_set_info == NULL) || (z_size != sizeof(UINT8)))
            {
                LOG(2, "Invalid parameter\n");
                return RMR_INV_ARG;
            }
            
            CustomDisableStandbyLEDCtrl((*(UINT8 *)pv_set_info));
            break;
        }
       
        case DRV_CUSTOM_CUST_SPEC_SET_AUDIO_INTERDAC_MUTE:
        {
//            ADAC_GpioInterDecMute((*(UINT8 *)pv_set_info));
            break;
        }        
        
        case DRV_CUSTOM_CUST_SPEC_TYPE_LOGO_STATE:
        {

            DTVCFG_T rDtvCfg;
            UINT8 u1LogoMusic = 0;
            UINT8 u1ActiveFlag = 0;
            
            if ((pv_set_info == NULL) || (z_size != sizeof(UINT8)))
            {
                LOG(2, "Invalid parameter\n");
                return RMR_INV_ARG;
            }

            u1ActiveFlag = (*(UINT8 *)pv_set_info);
            if (EEPDTV_GetCfg(&rDtvCfg) == 0)
            {
                if (u1ActiveFlag & DRV_CUSTOM_LOGO_ACTIVE)
                {
                    rDtvCfg.u1Flags2 &= ~DTVCFG_FLAG2_DISABLE_LOGO;
                 //   Printf("[DRV_CUSTOM_CUST_SPEC_TYPE_LOGO_STATE]Enable LOGO (%d)\n", u1ActiveFlag);
                }
                else
                {
                    rDtvCfg.u1Flags2 |= DTVCFG_FLAG2_DISABLE_LOGO;
                 //   Printf("[DRV_CUSTOM_CUST_SPEC_TYPE_LOGO_STATE]Disable LOGO (%d)\n", u1ActiveFlag);
                }
                
                UNUSED(EEPDTV_SetCfg(&rDtvCfg));
            }
#ifdef CC_AUD_SETUP_MELODY             
            u1LogoMusic = bApiEepromReadByte(EEP_BOOT_MUSIC_ONOFF);
            if (u1ActiveFlag & DRV_CUSTOM_LOGO_MUSIC_ACTIVE)
            {
                u1LogoMusic |= AUD_POWER_ON_MUSIC_MASK;
            }
            else
            {
                u1LogoMusic &= ~AUD_POWER_ON_MUSIC_MASK;
            }
            UNUSED(fgApiEepromWriteByte(EEP_BOOT_MUSIC_ONOFF, u1LogoMusic));
#else
            u1LogoMusic &= ~AUD_POWER_ON_MUSIC_MASK;
            UNUSED(fgApiEepromWriteByte(EEP_BOOT_MUSIC_ONOFF, u1LogoMusic));
#endif            
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_LOGO_DISPLAY:
        {
#ifdef CC_AUD_SETUP_MELODY 
            UINT32 i = 0;
#endif
            
            CustomDisplayLogo();
            x_thread_delay(1000);
#ifdef CC_AUD_SETUP_MELODY 
            while (!AUD_IsSetupMelodyFinish()) 
            { 
                x_thread_delay(500); 
                i++;
                if(i==6)
                {
                    i=0;
                    Printf("Start Up Aud timeout!\n");
                    break;          
                }
            } 
            AUD_StopSetupMelody(AUD_DEC_MAIN);    
#endif
            break;
        }

#ifdef CUSTOM_SELF_DIAG_ENABLE        
        case DRV_CUSTOM_CUST_SPEC_TYPE_SELF_DIAG_MODE:
        {
            UNUSED(SelfDiagResetCounter());
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_BOOT_COUNT_MODE:
        {
            UNUSED(SelfDiagResetBootCount());
            break;
        }
#endif /* CUSTOM_SELF_DIAG_ENABLE */

        case DRV_CUSTOM_CUST_SPEC_TYPE_LOADER_UPGRADE_MODE:
        {
            BOOL bEnable = TRUE;
            if ((pv_set_info == NULL) || (z_size != sizeof(UINT8)))
            {
                LOG(2, "Invalid parameter\n");
                return RMR_INV_ARG;
            }

            bEnable = ((*(UINT8 *)pv_set_info) == 1) ? TRUE : FALSE;
            CustomSetLoaderUsbUpgrade(bEnable);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_MONITOR_OUT:
        {
#ifndef DEMO_BOARD
            /* default Value is CVBS In */
            INT32 i4GPIOValue = DRV_CUSTOM_CVBS_IN_POLARITY;
            
            if ((pv_set_info == NULL) || (z_size != sizeof(BOOL)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_TYPE_MONITOR_OUT] Invalid parameter\n");
                return RMR_INV_ARG;
            }            
            
            i4GPIOValue = ((*(BOOL *)pv_set_info) == TRUE) ? DRV_CUSTOM_MONITOR_OUT_POLARITY : DRV_CUSTOM_CVBS_IN_POLARITY;
            GPIO_Output(DRV_CUSTOM_MONITOR_OUT_GPIO, &i4GPIOValue);
#endif /* DEMO_BOARD */
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_SET_HTL_IR_PASS_THROUGH:
        {
#ifndef DEMO_BOARD            
            INT32 i4GPIOValue;
            if ((pv_set_info == NULL) || (z_size != sizeof(BOOL)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_SET_HTL_IR_PASS_THROUGH] Invalid parameter\n");
                return RMR_INV_ARG;
            }
#if 1            
            i4GPIOValue = ((*(BOOL *)pv_set_info) == TRUE) ? DRV_CUSTOM_IR_PASS_THROUGH_GPIO_ON : DRV_CUSTOM_IR_PASS_THROUGH_GPIO_OFF;
            GPIO_Output(DRV_CUSTOM_IR_PASS_THROUGH_GPIO, &i4GPIOValue);
#else
            if((*(BOOL *)pv_set_info) == TRUE)
            {
                i4GPIOValue = 0;
                GPIO_Output(202, &i4GPIOValue);
            }
            else
            {
                i4GPIOValue = 1;
                GPIO_Output(202, &i4GPIOValue);
            }
#endif        
            
#endif /* DEMO_BOARD */
            break;
        }
#ifdef CC_Factory2K12
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_CLK_MODE:
        {
            HTLCLK_SetMode(*((UINT8*)pv_set_info));
            break;			
        }
        /* Liew: Hotel Clock */       
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_CLK_TIME:
        {
            DRV_CUSTOM_HTL_CLK_TIME_T *pHtlClkTime = (DRV_CUSTOM_HTL_CLK_TIME_T *)pv_set_info;
            BOOL bRet;

            bRet = HTLCLK_SetTime(pHtlClkTime->ui1_hour, pHtlClkTime->ui1_minute,
                                  pHtlClkTime->ui1_second, pHtlClkTime->ui1_day_of_week);
            if(FALSE == bRet)
            {
                LOG(5, "HTL CLK SetTime ERROR!\n");
                i4_ret = -1;
            }
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_CLK_CFG:
        {
            DRV_CUSTOM_HTL_CLK_CFG_T *pHtlClkCfg = (DRV_CUSTOM_HTL_CLK_CFG_T *)pv_set_info;
            BOOL bRet;
            
            bRet = HTLCLK_Config(pHtlClkCfg->ui1_display, pHtlClkCfg->ui1_intensity,
                                 pHtlClkCfg->ui1_reset);
            if(FALSE == bRet)
            {
                LOG(5, "HTL CLK Config ERROR!\n");
                i4_ret = -1;
            }
            break;
        }
        /* Liew: Hotel Clock End */
		#if 0	
		    /* Ooi START - IP TH */
        case DRV_CUSTOM_CUST_SPEC_SET_IP_NOISE_TH:
        {       	
			      sony_IpSetTh ((CUST_IP_NOISE_TH_INFO_T*)pv_set_info);
			      break;
        }
        /* Ooi END */
   		#endif
        /* Aizul: START Hotel Volume */       
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_VOL_MODE:      /* Aizul: Set Hotel Volume module's mode */
        { 
            HTLVOL_SetMode((UINT8 *)pv_set_info);
            break;
        }
        
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_VOL_INITVOL:   /* Aizul: Set Hotel Volume module's intial volume */
        {
            HTLVOL_SetInitVol((UINT8 *)pv_set_info);
            break;
        }
        
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_VOL_STEPTIMER: /* Aizul: Set Hotel Volume module's step timer */
        {
            HTLVOL_SetStepTimer((UINT8 *)pv_set_info);
            break;
        }
        
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_VOL_VOLLVL: /* Aizul: Set Hotel Volume module's volume level */
        {
            HTLVOL_SetVolLvl((UINT8 *)pv_set_info);
            break;
        }
        /* Aizul: END Hotel Volume End */
        
        /* Aizul: START Hotel SI */       
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTLSI_ONLINEMODE:      /* Aizul: Set Hotel SI module's online mode */
        { 
            HTLSI_SetOnlineMode((UINT8 *)pv_set_info);
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_TEST_PTN_RAMP:
        {
            if(*((UINT16*)pv_set_info))
            {
                Sony_PreSetup(TRUE);
                DRVCUST_TurnOnRamp(*((UINT16 *)pv_set_info));
            }
            else
            {
                Sony_PreSetup(FALSE);
                DRVCUST_TurnOnRamp(*((UINT16 *)pv_set_info));
            }
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_MOVE_OS_OPTION_POS:
        {
            if (*(UINT16*)pv_set_info)
            {
                //shift to position 0
                vDrvSetOstgOptPos(0x2);
                OSD_Base_SetHStart();
            }
            else
            {
                //restore
                vDrvSetOstgOptPos(DRVCUST_OptGet(eOSOptionPos));
                OSD_Base_SetHStart();
            }
			break;
        }	
        case DRV_CUSTOM_CUST_SPEC_OSD_PLANE_3:
        {
            SIZE_CHK(z_size, BOOL); 

            OSD_PLA_Enable(OSD_PLANE_3, (*(BOOL *)pv_set_info));
            break;
        }
#endif //#ifdef CC_Factory2K12    
		case DRV_CUSTOM_CUST_SPEC_TYPE_TUNER_LNA:
		{
			Printf("[D-Interface] DRV_CUSTOM_CUST_SPEC_TYPE_TUNER_LNA is %s\n",((UINT8) ((UINT32) pv_set_info))?"ON":"OFF");
		
#if 0//STELLAR_MODEL==STELLAR_CND
			RC232_SetLNA((UINT8) ((UINT32) pv_set_info));
#endif
			break;
		}
        case DRV_CUSTOM_VID_TYPE_LED_MOTION:
        {
         //Printf("Set DRV_CUSTOM_VID_TYPE_LED_MOTION (%d)\n", (UINT8) ((UINT32) pv_set_info));
#ifdef CUST_SOEM_DRV           
/* 
            BOOL bEnable = TRUE;
            if ((pv_set_info == NULL) || (z_size != sizeof(UINT8)))
            {
                LOG(2, "Invalid parameter\n");
                Printf("Invalid parameter\n");
                return RMR_INV_ARG;
            }

            bEnable = ((*(UINT8 *)pv_set_info) == 1) ? TRUE : FALSE;
            vHalVideoLEDMotion(bEnable);
*/            
             #if ENABLE_SOEM_PQ
             vHalVideoLEDMotion((UINT8) ((UINT32) pv_set_info));
             #endif
             Printf("Set DRV_CUSTOM_VID_TYPE_LED_MOTION ok (%d)\n", (UINT8) ((UINT32) pv_set_info));
#endif            
            break;
        }
		case DRV_CUSTOM_CUST_SPEC_TYPE_LED_BLINK_CONTROL:
		{
            #if 0
            /* FIXME !!!! */
            IRRC_LedBlinkConfig((BOOL) ((UINT32) pv_set_info));
            #endif


			Printf("Set DRV_CUSTOM_CUST_SPEC_TYPE_LED_BLINK_CONTROL (%d)\n", (BOOL) ((UINT32) pv_set_info));
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_POP_CVBS_COMP_NOTIFY:
		{
            #if 0
            /* FIXME !!!! */
			vDrvPOPModeYPBPRAV();
            #endif


			Printf("Set DRV_CUSTOM_CUST_SPEC_TYPE_POP_CVBS_COMP_NOTIFY \n");
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_EPG_FLAG:  //When EPG on then turn off dynamic backlight
		{
			if (z_size != sizeof(BOOL))
        	{
            	return (-1);
        	}
      #if ENABLE_SOEM_PQ 
			DRVCUST_EPG_FLAG((UINT8)((UINT32)pv_set_info));
			#endif
        	return 0;  
		}
		case DRV_CUSTOM_CUST_SPEC_DBC_DEBUG:
		{
			if (z_size != sizeof(DRV_CUSTOM_DBC_DEBUG_T))
        	{
            	return (-1);
        	}
        	#if ENABLE_SOEM_PQ
			    DRVCUST_DBC_DEBUG_MODE(((DRV_CUSTOM_DBC_DEBUG_T *)pv_set_info)->ui1DBC_MAGIC,
            ((DRV_CUSTOM_DBC_DEBUG_T *)pv_set_info)->ui1BrightLevel);
          #endif        
        	return 0;
		}
		case DRV_CUSTOM_CUST_SPEC_GAMMA_BUF:
		{
			if (z_size != sizeof(DRV_GAMMA_BUF_T))
        	{
            	return (-1);
        	}

				vDrvWriteGammaBuf(((DRV_GAMMA_BUF_T *)pv_set_info)->ui1_Index,
										   ((DRV_GAMMA_BUF_T *)pv_set_info)->ui2_rx,
								  ((DRV_GAMMA_BUF_T *)pv_set_info)->ui2_gx,
								  ((DRV_GAMMA_BUF_T *)pv_set_info)->ui2_bx);
         
					return 0;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_GPIO_OUTPUT_STATUS:
		{
			if (z_size != sizeof(DRV_CUSTOM_GPIO_OUTPUT_TYPE_T))
			{
				return (-1);
			}
			GPIO_Output((INT32)(((DRV_CUSTOM_GPIO_OUTPUT_TYPE_T *)pv_set_info)->ui1_gpio_output_id),
						(INT32 *)(((DRV_CUSTOM_GPIO_OUTPUT_TYPE_T *)pv_set_info)->ui1_gpio_output_status));
					return 0;
		}
			
#if 1 
        case DRV_CUSTOM_CUST_SPEC_DISP_PANEL_SELECT:
        {
#if 1 
            Printf("!!!!%s : DRV_CUSTOM_DISP_TYPE_PANEL_SELECT\n", __func__);  //ke_test
            Printf("!!!!%s : select ID : %d\n", __func__, (UINT32)pv_set_info);  //ke_test
            
			LOAD_PANEL_FROM_FLASH_CUSTOM(LOAD_PANEL_FROM_FLASH_BY_ID, &pv_set_info);
            if(b_store)
            {
                Printf("!!!!%s : b_store : TRUE\n", __func__);	//ke_test
                WritePanelIndexToEeprom((UINT32)pv_set_info);
				SetCurrentPanelIndex((UINT32)pv_set_info);  
            }	
#else
            Printf("!!!!%s : DRV_CUSTOM_DISP_TYPE_PANEL_SELECT\n", __func__);  //ke_test
            Printf("!!!!%s : select ID : %d\n", __func__, (UINT32)pv_set_info);  //ke_test
            SelectPanel((UINT32) pv_set_info);
            if(b_store)
            {
                Printf("!!!!%s : b_store : TRUE\n", __func__);  //ke_test
                WritePanelIndexToEeprom((UINT32)pv_set_info);
            }
#endif			
            return 0;
        }
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_R_GAIN:
            vDrvSetRGain1(SV_VP_MAIN, ((UINT16)((UINT32)pv_set_info)));
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_G_GAIN:
            vDrvSetGGain1(SV_VP_MAIN, ((UINT16)((UINT32)pv_set_info)));
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_B_GAIN:
            vDrvSetBGain1(SV_VP_MAIN, ((UINT16)((UINT32)pv_set_info)));
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_R_OFFSET:
            vDrvSetROffset11(SV_VP_MAIN, ((UINT16)((UINT32)pv_set_info)));
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_G_OFFSET:
            vDrvSetGOffset11(SV_VP_MAIN, ((UINT16)((UINT32)pv_set_info)));
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_B_OFFSET:
            vDrvSetBOffset11(SV_VP_MAIN, ((UINT16)((UINT32)pv_set_info)));
            break;
#if 0
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_MAGIC:
            {
                UINT8   ui1_m0, ui1_m1;

                ui1_m0 = (((WB_T *) pv_set_info)->ui1_magic[0]);
                ui1_m1 = (((WB_T *) pv_set_info)->ui1_magic[1]);
                fgApiEepromWriteByte( EEP_DISP_WB_MAGIC00,    ui1_m0);
                fgApiEepromWriteByte( EEP_DISP_WB_MAGIC00+1,  ui1_m1);
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_R_GAIN:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_set_info)->ui1_color_temp);
                ui2_tmp = (((WB_T *) pv_set_info)->ui2_val);
                ui1_hi = (ui2_tmp & 0xFF00) >> 8;
                ui1_lo =  ui2_tmp & 0x00FF;
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+(ui1_clr_temp*6),   ui1_lo);
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+(ui1_clr_temp*6)+1, ui1_hi);
            }
            break;

        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_G_GAIN:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_set_info)->ui1_color_temp);
                ui2_tmp = (((WB_T *) pv_set_info)->ui2_val);
                ui1_hi = (ui2_tmp & 0xFF00) >> 8;
                ui1_lo =  ui2_tmp & 0x00FF;
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+2+(ui1_clr_temp*6),   ui1_lo);
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+2+(ui1_clr_temp*6)+1, ui1_hi);
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_B_GAIN:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_set_info)->ui1_color_temp);
                ui2_tmp = (((WB_T *) pv_set_info)->ui2_val);
                ui1_hi = (ui2_tmp & 0xFF00) >> 8;
                ui1_lo =  ui2_tmp & 0x00FF;
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+4+(ui1_clr_temp*6),   ui1_lo);
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+4+(ui1_clr_temp*6)+1, ui1_hi);
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_R_OFFSET:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_set_info)->ui1_color_temp);
                ui2_tmp = (((WB_T *) pv_set_info)->ui2_val);
                ui1_hi = (ui2_tmp & 0xFF00) >> 8;
                ui1_lo =  ui2_tmp & 0x00FF;
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+24+(ui1_clr_temp*6),   ui1_lo);
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+24+(ui1_clr_temp*6)+1, ui1_hi);
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_G_OFFSET:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_set_info)->ui1_color_temp);
                ui2_tmp = (((WB_T *) pv_set_info)->ui2_val);
                ui1_hi = (ui2_tmp & 0xFF00) >> 8;
                ui1_lo =  ui2_tmp & 0x00FF;
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+26+(ui1_clr_temp*6),   ui1_lo);
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+26+(ui1_clr_temp*6)+1, ui1_hi);
            }
            break;
         case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_B_OFFSET:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_set_info)->ui1_color_temp);
                ui2_tmp = (((WB_T *) pv_set_info)->ui2_val);
                ui1_hi = (ui2_tmp & 0xFF00) >> 8;
                ui1_lo =  ui2_tmp & 0x00FF;
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+28+(ui1_clr_temp*6),   ui1_lo);
                fgApiEepromWriteByte( EEP_DISP_WB_COOL_R_GAIN_LO+28+(ui1_clr_temp*6)+1, ui1_hi);
            }
            break;
#endif
       case DRV_CUSTOM_CUST_SPEC_DISP_DYN_GAMMA_MAGIC_NUM:
            {
                UINT8   ui1_i, ui1_tmp;
                for(ui1_i=0; ui1_i<8; ui1_i++)
                {
                    ui1_tmp = (((DYN_GAMMA_T *) pv_set_info)->ui1_magic_num[ui1_i]);
                    fgApiEepromWriteByte( (EEP_DYN_GAMMA_MAGIC00 + ui1_i), ui1_tmp );
                }
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_DYN_GAMMA:
            {
                UINT8   ui1_point = (((DYN_GAMMA_T *) pv_set_info)->ui1_gamma_point),
                        ui1_hi, ui1_lo, ui1_i;
                UINT16  ui2_offset, ui2_val[3];

                ui2_val[0] = (((DYN_GAMMA_T *) pv_set_info)->ui2_r);
                ui2_val[1] = (((DYN_GAMMA_T *) pv_set_info)->ui2_g);
                ui2_val[2] = (((DYN_GAMMA_T *) pv_set_info)->ui2_b);
                for(ui1_i=0; ui1_i<3; ui1_i++)
                {
                    ui2_offset = (EEP_DYN_GAMMA_MAGIC07+1) + (UINT16)ui1_i*22 + (UINT16)ui1_point*2;
                    ui1_lo = ( ui2_val[ui1_i] & 0x00FF );
                    ui1_hi = ( ui2_val[ui1_i] & 0xFF00 ) >> 8;
                    fgApiEepromWriteByte( ui2_offset,   ui1_lo);
                    fgApiEepromWriteByte( ui2_offset+1, ui1_hi);
                }
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_DYN_GAMMA_RELOAD:
            DRVCUST_SET_GAMMA();
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_DYN_GAMMA_REMAP:
            vDrvGammaProc();
            #if ENABLE_SOEM_PQ
            vDrvSetGammaRemap(SV_ON);
            #endif
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_DYN_GAMMA_LINEAR:
            vIO32WriteFldAlign(ADAPTIVE_RGB_GAMMA_REG, 0x30, ADAPTIVE_RGB_GAMMA_SEL);
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_BLUE_STRETCH:
            vDrvSetBlueStretchOnOff( SV_VP_MAIN, ((UINT8)(*(UINT32*)pv_set_info)) );
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_SCE_ON_OFF:
            #if ENABLE_SOEM_PQ 
            if((UINT32)pv_set_info)
            {
                vDrvSCEAllOnOff(TRUE);
            }
            else
            {
                vDrvSCEAllOnOff(FALSE);
            }
            #endif
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_DCR_ON_OFF:
            #if ENABLE_SOEM_PQ
            if(((FAC_DCR_T *) pv_set_info)->b_onoff)
            /* On */
                DRVCUST_DBC_DEBUG_MODE( 0xFF, PANEL_GetBacklightHigh());
            else
            /* Off */
            {
                if(((FAC_DCR_T *) pv_set_info)->b_get_bl_max)
                    DRVCUST_DBC_DEBUG_MODE( 0x30, PANEL_GetBacklightHigh());
                else
                {
                    DRVCUST_DBC_DEBUG_MODE( 0x30, (((FAC_DCR_T *) pv_set_info)->ui1_bl_level));
                }
            }
            #endif
            break;
#if 0
        case DRV_CUSTOM_CUST_SPEC_DISP_WR_VGA_EDID: //Soar add 20101007 for VGA EDID
            Printf("DRV_CUSTOM_CUST_SPEC_DISP_WR_VGA_EDID\n");
            if(PANEL_GetPanelHeight() == 1080)
            {
                if(EEPROM_Write((UINT64)SONY_VGA_EDID_OFFSET,  
                    (UINT32) SONY_FHD_VGA_EDID_TABLE, SONY_VGA_EDID_LENGTH ))
                {
                    Printf("write eeprom edid fail\n");
                }
            }
            else
            {
                if(EEPROM_Write((UINT64)SONY_VGA_EDID_OFFSET,  
                    (UINT32) SONY_WXGA_VGA_EDID_TABLE, SONY_VGA_EDID_LENGTH ))
                {
                    Printf("write eeprom edid fail\n");
                }
            }
            break;
#endif
        case DRV_CUSTOM_CUST_SPEC_DISP_CVBS_AUTO_COLOR:
            fgApiVideoCVBSAutoColor();
            break;

        case DRV_CUSTOM_CUST_SPEC_COLOR_MATRIX_DEF:
        {
            INT32 COLOR_TRANSFORM_Y2R[15] = {0}, i4_index = 2;

            i4_index = (INT32)((UINT8) ((UINT32) pv_set_info));
            x_memcpy(COLOR_TRANSFORM_Y2R, YCBCR2RGBOS[i4_index], sizeof(COLOR_TRANSFORM_Y2R));
            vLoadOSColorMatrix(SV_VP_MAIN, COLOR_TRANSFORM_Y2R);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_COLOR_MATRIX_PQ:
        {
            //vLoadOSColorMatrix(SV_VP_MAIN, COLOR_TRANSFORM_ADJ);
            vDrvVideoColorMatrix(SV_VP_MAIN);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_EEP_RW:
        {
            UINT32 u4Offset = (((FAC_EEP_T *) pv_set_info)->u4Offset);
            UINT32 u4Len = (((FAC_EEP_T *) pv_set_info)->u4Len);

            i4_ret = EEPROM_Write((UINT64)u4Offset, (UINT32)(((FAC_EEP_T *) pv_set_info)->pu1Data), u4Len);
            break;
        }

#endif
        #if 1 //aging ptn related
        case DRV_CUSTOM_CUST_SPEC_TYPE_AGING_PTN:
		{
		    AgingShowPattern(*(UINT16 *)pv_set_info);
			break;
        }
		#endif
#ifdef CUST_SOEM_DRV //lcct_2H
        case DRV_CUSTOM_CUST_SPEC_V_COM_DRV:
        {
            DRV_CUSTOM_VCOM_ST *pVcomParam = (DRV_CUSTOM_VCOM_ST *)pv_set_info;
			
			SelfDiagRequirePanelIDRead();
            GPIO_SetOut(PANEL_BINT_PIN,PIN_HIGH);
			x_thread_delay(10);

            /* SDC and BOE panels use the same read/write protocol */
            if(pVcomParam->vcom_type == SDCVCOM)
            {
                  UINT8	u1DataSet,u1DataSave;

                  u1DataSet = (UINT8)*((UINT16*)pVcomParam->vcom_value) << 1;  // shift 1 bit for v-com spec
                  SIF_X_Write(BUS_ID, CLK_DIV, 0x9e, 0, 0, &u1DataSet, 1);
                  u1DataSave = u1DataSet + 1; //(UINT8) *((UINT16*)pv_set_info);  // shift 1 bit for v-com spec
                  SIF_X_Write(BUS_ID,CLK_DIV, 0x9e, 0, 0, &u1DataSave, 1);
                  x_thread_delay(100);
            }
            else if(pVcomParam->vcom_type == LGDVCOM)
            {
                UINT8 u1Data;

                u1Data = (UINT8) *((UINT16*)pVcomParam->vcom_value) >> 8;  // shift 1 bit for v-com spec
                SIF_X_Write(BUS_ID, CLK_DIV,0x40, 1, 0x15, &u1Data, 1);
                u1Data = (UINT8) *((UINT16*)pVcomParam->vcom_value) & 0xff;  // shift 1 bit for v-com spec
                SIF_X_Write(BUS_ID, CLK_DIV,0x40, 1, 0x16, &u1Data, 1);
                u1Data = 0x40;
                SIF_X_Write(BUS_ID, CLK_DIV,0x40, 1, 0xff, &u1Data, 1);
                x_thread_delay(100);
            }
            else if(pVcomParam->vcom_type == SDPVCOM)
            {
                UINT8 u1Data[] = {0,0};

                u1Data[1] = (UINT8) *((UINT16*)pVcomParam->vcom_value);  // shift 1 bit for v-com spec
                u1Data[0] =  0x40;
                SIF_X_Write(BUS_ID,CLK_DIV,0xE8, 1, 0x00, &u1Data[0], 2);
                x_thread_delay(100);
            }
            else if(pVcomParam->vcom_type == AUOVCOM)
            {
                UINT8 u1DataAdjust, u1DataWrite;

                u1DataAdjust =((UINT8) (*((UINT16*)pVcomParam->vcom_value))) << 1;
                SIF_X_Write(BUS_ID, CLK_DIV, 0xE8, 1, 0x01, &u1DataAdjust, 1);
                x_thread_delay(100);
                u1DataWrite = 0x0A;
                SIF_X_Write(BUS_ID, CLK_DIV, 0xE8, 1, 0x00, &u1DataWrite, 1);
                x_thread_delay(100);
            }

            GPIO_SetOut(PANEL_BINT_PIN,PIN_LOW);
			SelfDiagReleasePanelIDRead();
            //Factory2K12Debug(c_sprintf(fact_dbg_buf,"-- DRV_CUSTOM_CUST_SPEC_V_COM_DRV, set(%x) --\n",(*((UINT16*)pv_set_info))));          
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_WB_EDID_WRITE:
        {
            u4_WB_EDID_Write_return = 0;
            if (0 != Sony_PQ_GAMMA_EDID_Write(*(UINT16*)pv_set_info) ||
                0 != Sony_PBM_EDID_Write(*(UINT16*)pv_set_info))
            {
            u4_WB_EDID_Write_return = 1;
            }
            Factory2K12Debug(c_sprintf(fact_dbg_buf,"dint(%d)\n", u4_WB_EDID_Write_return));
            break;
        }

		case DRV_CUSTOM_CUST_SPEC_SCART_DRV:
		{
			//status_ret = bDrvGetScartInputMode();
			//#define SCART_COLOR_CVBS  1
			//#define SCART_COLOR_SV  2
			//#define SCART_COLOR_RGB 3
			//#define SCART_COLOR_MIX 4
			DRV_CUSTOM_SCART_ST *pscartParam = (DRV_CUSTOM_SCART_ST *)pv_set_info;
			UINT16 set_value = 0;
			set_value = *((UINT16*)pscartParam->scart_value);
			

			if(set_value==0)
				{
					UINT8 SU = 0;
					vScartUIChangeInputMode(SU);	
					
				}
			else if(set_value==1)
				{
					vScartUIChangeInputMode(SCART_COLOR_MIX);
					
				}
			else if(set_value==2)
				{
					vScartUIChangeInputMode(SCART_COLOR_CVBS);
					
				}
			else if(set_value==3)
				{
					vScartUIChangeInputMode(SCART_COLOR_RGB);
					
				}
			else if(set_value==4)
				{
					vScartUIChangeInputMode(SCART_COLOR_SV);
					
				}
			
			break;
		}

		case DRV_CUSTOM_CUST_SPEC_EEP_UPDATE:
		{
			UINT16 Aging_EEP = (*(UINT16*)pv_set_info);
			EEPROM_Write((UINT64) 0x1e80,(UINT32)&Aging_EEP,1);
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_VID_PRESET:
		{
			Sony_Video_PreSetup(*(UINT16 *)pv_set_info);
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_PTN_PRESET_BEFORE_GET_LVL:
		{
			UINT16 ui2RGBLVL;
			UINT8 ui1GRgb;
			UINT8 ui1GLvl;

            ui2RGBLVL= *(UINT16 *)pv_set_info;

            ui1GRgb = (UINT8)((ui2RGBLVL&0xFF00)>>8);
            ui1GLvl = (UINT8)(ui2RGBLVL&0x00FF);
			
			switch(ui1GRgb)
			{
			   case 0x00:
			   	Current_Gamma_RGB = GAMMA_R;
			   	break;
			   case 0x01:
			   	Current_Gamma_RGB = GAMMA_G;
				break;
			   case 0x02:
			   	Current_Gamma_RGB = GAMMA_B;
				break;
			   default:
			   	break;
			}            

			switch(ui1GLvl)
			{
			   case 0x00:
			   	Current_Luma_Lvl = LUMA_LVL_0;
			   	break;
			   case 0x01:
			   	Current_Luma_Lvl = LUMA_LVL_1;
				break;
			   case 0x02:
			   	Current_Luma_Lvl = LUMA_LVL_2;
				break;
			   case 0x03:
			   	Current_Luma_Lvl = LUMA_LVL_3;
			   	break;
			   case 0x04:
			   	Current_Luma_Lvl = LUMA_LVL_4;
				break;
			   case 0x05:
			   	Current_Luma_Lvl = LUMA_LVL_5;
				break;
			   case 0x06:
			   	Current_Luma_Lvl = LUMA_LVL_6;
			   	break;
			   case 0x07:
			   	Current_Luma_Lvl = LUMA_LVL_7;
				break;
			   case 0x08:
			   	Current_Luma_Lvl = LUMA_LVL_8;
				break;
			   case 0x09:
			   	Current_Luma_Lvl = LUMA_LVL_9;
			   	break;
			   case 0x0a:
			   	Current_Luma_Lvl = LUMA_LVL_10;
				break;
			   default:
			   	break;
			} 			
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_PTN_SET_LVL:
		{
			UINT16 Val;

			Val = (*(UINT16 *)pv_set_info);		
			Sony_GammaSetLvl(Current_Gamma_RGB,Current_Luma_Lvl,Val);
			
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_SET_SELECT_LVL:
		{
			UINT16 ui2GLvl;

			ui2GLvl = (*(UINT16 *)pv_set_info);
			Sony_GammaSelectLvl(ui2GLvl);
			
			break;
		}		
		//WBS TO NVM
		case DRV_CUSTOM_CUST_SPEC_TYPE_WBS_TO_NVM_PRESET:
		{
			UINT16 ui2WbsNvmEnv;
			UINT8 ui1ColorIdx;
			UINT8 ui1WbLevel;
			UINT8 ui1Gamma;

            ui2WbsNvmEnv= *(UINT16 *)pv_set_info;

            ui1ColorIdx = (UINT8)((ui2WbsNvmEnv & 0xFF00)>>8);
            ui1WbLevel = (UINT8)((ui2WbsNvmEnv&0x00F0)>>4);
            ui1Gamma = (UINT8)(ui2WbsNvmEnv&0x000F);
			
			switch(ui1ColorIdx)
			{
			   case 0x00:
			   	Current_Wbs_Nvm_Env.CLRIDX = WB_COOL;
			   	break;
			   case 0x01:
			   	Current_Wbs_Nvm_Env.CLRIDX = WB_NEUTRAL;
				break;
			   case 0x02:
			   	Current_Wbs_Nvm_Env.CLRIDX = WB_WARM1;
				break;
			   case 0x03:
			   	Current_Wbs_Nvm_Env.CLRIDX = WB_WARM2;
				break;			   
			   case 0x04:
			   	Current_Wbs_Nvm_Env.CLRIDX = WB_PHOTO;
				break;
			   default:
			   	break;
			} 
			switch(ui1WbLevel)
			{
			   case 0x00:
				Current_Wbs_Nvm_Env.WBLVL = WB_HIGHLIGHT;
				break;
			   case 0x01:
			   	Current_Wbs_Nvm_Env.WBLVL = WB_CUTOFF;
				break;
			   default:
			   	break;
			}
			switch(ui1Gamma)
			{
			   case 0x00:
				Current_Wbs_Nvm_Env.GAMMA = GAMMA_R;
				break;
			   case 0x01:
			   	Current_Wbs_Nvm_Env.GAMMA = GAMMA_G;
				break;
			   case 0x02:
			   	Current_Wbs_Nvm_Env.GAMMA = GAMMA_B;
				break;
			   default:
			   	break;
			} 			
			break;
		}		
		case DRV_CUSTOM_CUST_SPEC_TYPE_WBS_TO_NVM_SET:
		{
			UINT16 Val;

			Val = (*(UINT16 *)pv_set_info);
			Sony_WBSetData(Current_Wbs_Nvm_Env.CLRIDX, Current_Wbs_Nvm_Env.WBLVL, Current_Wbs_Nvm_Env.GAMMA, Val);
			break;
		}		
		case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_PTN_REFRESH:
		{
			Luma_RGB_T LUMA_RGB;
			UINT8 uiFgRgb;
			
            LUMA_RGB = Sony_GammaPatternRGB_Read();
            uiFgRgb = (((GAMMA_SET_PTN_RGB_T *)pv_set_info)->ui1Rgb);

            if(fgGammaRefreshFirstcall)
            {
			   	LUMA_RGB.Luma_R = 0;
				LUMA_RGB.Luma_G = 0;
				LUMA_RGB.Luma_B = 0;
				fgGammaRefreshFirstcall = FALSE;
            }
			
			switch(uiFgRgb)
			{
			   case 0x00:
			   	LUMA_RGB.Luma_R = (((GAMMA_SET_PTN_RGB_T *)pv_set_info)->ui4Val);
			   	break;
			   case 0x01:
			   	LUMA_RGB.Luma_G = (((GAMMA_SET_PTN_RGB_T *)pv_set_info)->ui4Val);
				break;
			   case 0x02:
			   	LUMA_RGB.Luma_B = (((GAMMA_SET_PTN_RGB_T *)pv_set_info)->ui4Val);
				break;
			   default:
			   	break;
			}
			
			Sony_GammaPatternRefresh(&LUMA_RGB);
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_PBM_PQP_PGRAM_LUT_SET:
		{
            UINT16 * ptrpqp_lut;
			UINT16 ui2Idx;

			ptrpqp_lut = (((WB_PBM_PQP_LUT_SET_T *)pv_set_info)->aui2PqpLut);
			ui2Idx = (((WB_PBM_PQP_LUT_SET_T *)pv_set_info)->ui2WbIndex);
			WB_PBM_PQP_PGAM_LUT_Set(ptrpqp_lut, ui2Idx);
			break;
		}
	    case DRV_CUSTOM_CUST_SPEC_TYPE_WB_PBM_PQP_PGRAM_LUT_GET_PRESET:
		{
			Current_Pqp_Lut_setting.ui1RgbIdx   = (((WB_PBM_PQP_LUT_PRESET_T *)pv_set_info)->ui1RgbIdx);
			Current_Pqp_Lut_setting.ui1WbIndex  = (((WB_PBM_PQP_LUT_PRESET_T *)pv_set_info)->ui1WbIndex);
			Current_Pqp_Lut_setting.ui1WblvlIdx = (((WB_PBM_PQP_LUT_PRESET_T *)pv_set_info)->ui1WblvlIdx);
			
			break;
		}
        case DRV_CUSTOM_CUST_SPEC_TYPE_FLASHLIGHT_MODE:
        {
            UINT8 u1FlashLightOnOff,u1Mode;
            
            u1FlashLightOnOff = ((FLASHLIGHT_MODE *)pv_set_info)->u1FlashLightOnOff;
            u1Mode = ((FLASHLIGHT_MODE *)pv_set_info)->u1Mode;

            if(u1FlashLightOnOff == 1)
            {   
            	_bTorchLightOnOff = 1;
                vDrvGammaMute(4095, 4095, 4095);                
                
                if(u1Mode == FLASHLIGHT_MODE_LOW)
                {
                    vIO32WriteFldAlign(BL_CONTROL_MAIN_00, SV_FALSE, BL_UPDATE_EN); //BL_MANU
                    _ui1_pwm = 110; //BL_GAIN

                    vDRVCUST_BLSet_IP_REF(FLASH_LIGHT_IPREF);
                    DRVCUST_SetBacklightDuty(VDP_ARG_BACKLT_DBL, 110);
                }
                else if(u1Mode == FLASHLIGHT_MODE_HIGH)
                {
                    vIO32WriteFldAlign(BL_CONTROL_MAIN_00, SV_FALSE, BL_UPDATE_EN); //BL_MANU
                    _ui1_pwm = 235; //BL_GAIN

                    vDRVCUST_BLSet_IP_REF(FLASH_LIGHT_IPREF);
                    DRVCUST_SetBacklightDuty(VDP_ARG_BACKLT_DBL, 235);
                }
                else
                {
                    LOG(1,"<<<ERROR choose>>>\n");
                }
                
                fgPWMFixed = TRUE;
            }
            else 
            {   
            	_bTorchLightOnOff = 0;
                vDrvGammaUnmute();
                vIO32WriteFldAlign(BL_CONTROL_MAIN_00, SV_TRUE, BL_UPDATE_EN); //BL_MANU                
                fgPWMFixed = FALSE;
            }
			break;
        }
		case DRV_CUSTOM_CUST_SPEC_TYPE_BACKLIGHT_CONTROL:
		{
            UINT8 OperationMode,ui1Set;
			UINT16 OperationParameter;

			OperationMode = (((BL_CTRL_OPERATION_T *)pv_set_info)->uiOpMode);
			OperationParameter = (((BL_CTRL_OPERATION_T *)pv_set_info)->ui2OpParameter);
			
			switch(OperationMode)
			{
			   case 0x01:
                if(OperationParameter == 0x0000) {
			        ui1Set = 1;
                } else {
                    ui1Set = 0;
                }
              #if ENABLE_SOEM_PQ			   	
			   	DRVCUST_WriteDynamicBacklight(ui1Set);
			   	#endif
			   	break;
			   case 0x03:
			   	ui1Set = (UINT8)OperationParameter;
			   	#if ENABLE_SOEM_PQ
			   	DRVCUST_WritePMX(ui1Set);
			   	#endif
				break;
			   default:
			   	break;
			}
			break;
		}

		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_ACFG_UPDATE_SET:
		{
			UINT16 Val;

			Val = (*(UINT16 *)pv_set_info);			
			Sony_WB_Acfg_Update_Set(Val);
 			break;
		}		
#endif
#ifdef ENABLE_USB2UART_FUNC
		case DRV_CUSTOM_CUST_SPEC_USBUART_STATUS:
		{
			UINT16 u2_usb_status = (*(UINT16*)pv_set_info);
			
 
			if ((u2_usb_status == 6)||(u2_usb_status == 7))//uart status
			{
				//CLI_Parser("b.jtag 2");
				BSP_PinSet(PIN_USB_DM_P0, PINMUX_FUNCTION5);
				BSP_PinSet(PIN_USB_DP_P0, PINMUX_FUNCTION5);
				
				IO_WRITE32MSK(IO_VIRT, 0x5981c, 0xc02000, 0xffffffff);
				//IO_WRITE32MSK(IO_VIRT, 0x5991c, 0xc02000, 0xffffffff);port 1
				IO_WRITE32MSK(IO_VIRT, 0x59820, 0x31a, 0xffffffff);
				//IO_WRITE32MSK(IO_VIRT, 0x59920, 0x31a, 0xffffffff);port 1
				//CLI_Parser("w 0xf000d610 0xc0000169");
				//IO_WRITE32(IO_VIRT,0xd610,0xc0000169);
				//BSP_PinSet(PIN_USB_DM_P1, PINMUX_FUNCTION5);
				//BSP_PinSet(PIN_USB_DP_P1, PINMUX_FUNCTION5);
				Printf("@@@@@[Menu]@@@@ set USB pinmux to UART function\n");
			}
			else if ((u2_usb_status == 0)||(u2_usb_status == 1))
			{
				BSP_PinSet(PIN_USB_DM_P0, PINMUX_FUNCTION0);
				BSP_PinSet(PIN_USB_DP_P0, PINMUX_FUNCTION0);
				Printf("@@@@@[Menu]@@@@ set USB pinmux to USB function\n");
			}
			else if (u2_usb_status == 5)
			{
				SerTransparent();
			}
		}
		break;
#endif

#if 1//def CC_UART_ON_OFF_SUPPORT
        case DRV_CUSTOM_CUST_SPEC_TYPE_SET_UART_ON_OFF:
        {
			UINT32 u4Val=0;

            if(*(UINT8*)pv_set_info)
            {
				EEPROM_Read(CUSTOM_UART_SELECTION_ADDR, (UINT32)&u4Val, 1);
				if(((UINT8)u4Val == UART_SELECTION_HOTEL_SONY_VDA)||
				((UINT8)u4Val == UART_SELECTION_HOTEL_SONY_LOCATEL))
				{
	                // Enable UART Rx.
					BSP_PinSet(PIN_U0TX, 0);
					BSP_PinSet(PIN_U0RX, 0);
				}
            }
            else
            {
                // Disable UART Rx.
				BSP_PinSet(PIN_U0TX, 2);
				BSP_PinSet(PIN_U0RX, 2);
            }
            break;
        }
#endif
#ifndef CC_MTK_LOADER
		case DRV_CUSTOM_CUST_SPEC_TYPE_KEY_HEADER:
		{
			DRV_CUST_KEY_HDR_T* pt_header;
			if(pv_set_info == NULL)
			{
				return -1;
			}
			pt_header = (DRV_CUST_KEY_HDR_T*)pv_set_info;
			if (pt_header->t_size != 64)
			{
				Printf("[D-Interface] key header size fail %d !=64\n",pt_header->t_size);
				return -1;
			}
			ui4SetKeyHeader(pt_header->i1_key_hdr, pt_header->ui1_buf ,pt_header->t_size);
			break;
		}

		case DRV_CUSTOM_CUST_SPEC_TYPE_KEYS:
		{
			DRV_CUST_KEY_HDR_T* pt_header;
			if(pv_set_info == NULL)
			{
				return -1;
			}
			pt_header = (DRV_CUST_KEY_HDR_T*)pv_set_info;
			/*if (pt_header->t_size != 64)
			{
				Printf("[D-Interface] key header size fail %d !=64\n",pt_header->t_size);
				return -1;
			}*/
			ui4SetNANDKey(pt_header->i1_key_hdr, pt_header->ui1_buf ,pt_header->t_size);
			break;
		}		
#endif


#ifndef CC_MTK_LOADER    
#if 1//def STELLAR_LED_SPEC
		case DRV_CUSTOM_CUST_SPEC_LED_MODE:
		{
			UINT16 u2LedMode = (*(UINT16*)pv_set_info);
			DTVCFG_T rDtvCfg;
			EEPDTV_GetCfg(&rDtvCfg);
			if(((rDtvCfg.u1Flags & DTVCFG_FLAG_POWER_LEDOFF) && (0==u2LedMode)) || \
			   ((!(rDtvCfg.u1Flags & DTVCFG_FLAG_POWER_LEDOFF)) && (1==u2LedMode)))
			{
				Printf("[D-Interface] LED Mode unchanged");
				break;
			}
			Printf("[%s]Set LED Mode as %s\n",__FUNCTION__,u2LedMode?"ON":"OFF");
			if(u2LedMode == 0)//LED OFF
			{
			   rDtvCfg.u1Flags |= DTVCFG_FLAG_POWER_LEDOFF;
			}
			else
			{
				rDtvCfg.u1Flags &= (~DTVCFG_FLAG_POWER_LEDOFF);//LED on
			}
			EEPDTV_SetCfg(&rDtvCfg);
			vSonyLedModeChg(u2LedMode);
			break;
		}
#endif/* STELLAR_LED_SPEC */
#endif
#ifndef CC_MTK_LOADER    
         case DRV_CUSTOM_CUST_SPEC_UPDATE_LED_FIX_PATTERN:
		 {
		    UINT8 ui1FixPattern = (*(UINT8*)pv_set_info);  
			vUpdateLedFixPattern(ui1FixPattern);
			Printf("[%s]Update FixPattern %s\n",__FUNCTION__,ui1FixPattern?"TRUE":"FALSE");
		 }
		 break;
#endif		 
		case DRV_CUSTOM_CUST_SPEC_AGING_EEP_UPDATE://DRV_CUSTOM_CUST_SPEC_AGING_MODE:
		{
			UINT16 ui2AgingMode = (*(UINT16*)pv_set_info);
			EEPROM_Write((UINT64)0x7d0,(UINT32)&ui2AgingMode,1);
		}
			break;
		case DRV_CUSTOM_CUST_SPEC_TYPE_TUNER_LNA_CTRL:
	    {
		    UINT8 u1LNASts = (*(UINT8*)pv_set_info);
			ITuner_OP(ITunerGetCtx(),itSetLNAUI,u1LNASts,NULL);
			Printf("Set LNA as %s\n",u1LNASts?"ON":"OFF");
	    }
	    break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_TCON_NVM_WRITE:
        {
            UINT16 i = 0;
            UINT16 shift_addr = 0;
            UINT16 ret = 0;
            UINT16 loop_count = 0;
            UINT16 last_data = 0;
            
            WB_TCON_NVM_T* tcon_data = (WB_TCON_NVM_T*)pv_set_info;
            loop_count = (tcon_data->length) / 16;
            last_data = (tcon_data->length) % 16;
			SelfDiagRequirePanelIDRead();
            GPIO_SetOut(PANEL_BINT_PIN, PIN_HIGH);
            //Assume starting address is always start from 0xXX0
            
            if ((loop_count == 0) && (last_data < 16)) {
                ret = SIF_X_Write(BUS_ID, CLK_DIV, TCON_NVM_SLVADDR, ADDR_LENGTH, (tcon_data->subAddr), tcon_data->data_buffer, tcon_data->length);
                if ( ret == SIF_ERROR_RETURN ){ 
                    i4_ret = RMR_DRV_ERROR;
                }
                x_thread_delay(100);
            } else {
                for(i = 0; i < loop_count; i ++ ){
                    shift_addr = i * 0x10;
                    ret = SIF_X_Write(BUS_ID, CLK_DIV, TCON_NVM_SLVADDR, ADDR_LENGTH, (tcon_data->subAddr + shift_addr), &(tcon_data->data_buffer[shift_addr]), 0x10);
                    if ( ret == SIF_ERROR_RETURN ){ 
                        i4_ret = RMR_DRV_ERROR;
                    }
                    x_thread_delay(100);
                }
                if (last_data != 0) {
                    ret = SIF_X_Write(BUS_ID, CLK_DIV, TCON_NVM_SLVADDR, ADDR_LENGTH, (tcon_data->subAddr + shift_addr + 0x10), &(tcon_data->data_buffer[shift_addr + 0x10]), (UINT16)last_data);
                    if ( ret == SIF_ERROR_RETURN ){ 
                        i4_ret = RMR_DRV_ERROR;
                    }
                    x_thread_delay(100);
                }
            }
            GPIO_SetOut(PANEL_BINT_PIN, PIN_LOW);
			SelfDiagReleasePanelIDRead();
            break;
        }
		case DRV_CUSTOM_CUST_SPEC_TYPE_SCART_OUT:
		{
			gbScartOut = (*(BOOL *)pv_set_info);
			//AUD_DspDtvScartFlag(gbScartOut); //mark for build pass by wangle
			#if 1//def CC_SUPPORT_TVE  joe_0924
			vApiTVESetDacMuteMask(0, 1, (gbScartOut?FALSE:TRUE));//UI on, mute false, ui off, mute true
			#endif
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_DVBS_LNB_VOL_CTRL:
		{
		    #if  defined(SYS_DVBS_SUPPORT) && defined(CC_Factory2K12)
			if(pv_set_info)TunerDVBSFac_SetLnbVol(1,(*(UINT8 *)pv_set_info)); 
			#endif
		}
		break;
		case DRV_CUSTOM_CUST_SPEC_TYPE_DVBS_LNB_TONE_CTRL:
		{
		    #if  defined(SYS_DVBS_SUPPORT) && defined(CC_Factory2K12)
			if(pv_set_info)TunerDVBSFac_Set22K(1,(*(UINT8 *)pv_set_info));  
			#endif
		}
		break;
		case DRV_CUSTOM_CUST_SPEC_TYPE_DVBS_DEMOD_CLK_CTRL:
		{
		    #if  defined(SYS_DVBS_SUPPORT) && defined(CC_Factory2K12)
			if(pv_set_info)TunerDVBSFac_SetDemodClock(1,(*(UINT8 *)pv_set_info)); 
			#endif
		}
		break;
		case DRV_CUSTOM_CUST_SPEC_TYPE_UPDATE_REC_STATUS:
		{
		#ifndef CC_MTK_LAODER
		   if(pv_set_info)vUpdateRecStatus((*(UINT8 *)pv_set_info));
		#endif
		   break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_START_LED_BLINK:
		{
		    if(pv_set_info)
			{
			   D_LED_DISPLAY * led_disp=(D_LED_DISPLAY *)pv_set_info;
			   vStartLedBlink(led_disp->eLedState);
			   Printf("Start LED blink %d\n",led_disp->eLedState);
			}
		}
		break;
		case DRV_CUSTOM_CUST_SPEC_TYPE_STOP_LED_BLINK:
		{
		    if(pv_set_info)
			{
			   D_LED_DISPLAY * led_disp=(D_LED_DISPLAY *)pv_set_info;
			   vStopLedBlink(led_disp->eLedState);
			   Printf("Stop LED blink %d\n",led_disp->eLedState);
			}
		}
		break;
		
		case DRV_CUSTOM_CUST_SPEC_TYPE_SET_DI_DATAMODE:
            //vDrvSetDIDataMode(0,(*(UINT8*)pv_set_info)); //marked ; to lower the bandwidth of DI module to improve performance, no need on salvia
        break;	

		case DRV_CUSTOM_CUST_SPEC_TYPE_PGAM_EN:
		{
		    //Param: UINT8 bOnOff
			//1: Set PGAM_EN enable; 0: Set PGAM_EN disable.
			DRVCUST_SetPGAM_EN(*(UINT8 *)pv_set_info);
			break;
		}
		
		case DRV_CUSTOM_CUST_SPEC_TYPE_U_WB_FLAT:
		{
		    //Param: UINT8 bOnOff
			//1: Set U_WB_FLAT enable; 0: Set U_WB_FLAT disable.
			DRVCUST_SetUWBFLAT(*(UINT8 *)pv_set_info);
			break;
		}

        case DRV_CUSTOM_CUST_SPEC_TYPE_HEAAC_LVL:
        {
            //Set HEAAC level
            #ifdef CC_HEAAC_LEVEL_ADJ
            UINT8 u1HEAACLevel;
            u1HEAACLevel = 256 - (*(UINT8 *)pv_set_info);
            AUD_HEAACLevelAdjust(u1HEAACLevel);
            #endif
            break;
        }
		case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_MUTE_LVL:
		{
			vDRVCUST_SetGamma_mute_lvl(*(INT16 *)pv_set_info);//DRVCUST_SetGamma_mute_lvl(*(INT16 *)pv_set_info);
			break;
		}

        case DRV_CUSTOM_AUDIO_FILTER_COUNTRY_TYPE:
		{
			au4Country = (*(INT32 *)pv_set_info);
            
#ifdef CC_AUD_SONY_SALVIA_OVM_GAIN
            APSetCountryValue(au4Country);
#endif
			break;
		}

        case DRV_CUSTOM_AUDIO_SPEAKERS_UI_TYPE:
		{
            /// 0 is TV Speakers, 1 is audio System
            _AUD_DspSetSpeakerMode((*(UINT8 *)pv_set_info));
			break;
		}

        case DRV_CUSTOM_CUST_SPEC_TYPE_SET_AUD_MM_MODE:
        {
            AUD_SetMultimediaMode(0 ,(AUD_MM_MODE_T)(*(UINT8*)pv_set_info));
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_SET_BGM_POWER_ON:
		{
		   #if defined(CC_BGM_SUPPORT_WOW) || defined(CC_BGM_SUPPORT_WOL)
			vWoNET_Exit();
			#endif
		}
		    break;
		case DRV_CUSTOM_CUST_SPEC_TYPE_SET_BGM_FROM_NORMAL:
		{
		   #if defined(CC_BGM_SUPPORT_WOW) || defined(CC_BGM_SUPPORT_WOL)
			vWoNET_Setup_BG();
			#endif
		}
		    break;		
        case DRV_CUSTOM_AUDIO_PLAY_TEST_TONE:
        {
            // 200Hz 0dB Test tone
            AUD_PlayTestTone(AUD_DEC_MAIN,TEST_TONE_200_0dB);
            break;
        }
        
        case DRV_CUSTOM_AUDIO_STOP_TEST_TONE:
        {
            // Stop Test Tone
            AUD_StopTestTone(AUD_DEC_MAIN);
            break;
        }
		case DRV_CUSTOM_CUST_SPEC_TYPE_MHEG_ACTIVE:
		{
			   #if ENABLE_SOEM_PQ
               DRVCUST_MHEG_FLAG(*(UINT8 *)pv_set_info);
			   #endif			

		}
		    break ;	 
			
		case DRV_CUSTOM_CUST_SPEC_TYPE_TELTEXT_ACTIVE://joe_0127_ttx
		{
			   #if ENABLE_SOEM_PQ
               DRVCUST_TeleText_FLAG(*(UINT8 *)pv_set_info);
			   #endif
		}
		break;
		
		case DRV_CUSTOM_CUST_SPEC_TYPE_GINGA_ACTIVE:
		{
		   if(pv_set_info)
			{
                #if ENABLE_SOEM_PQ
                DRVCUST_GINGA_FLAG(*(UINT8 *)pv_set_info);
                #endif
			}
			else
			{
                i4_ret = RMR_INV_ARG;
			}
		}
		break;

		case DRV_CUSTOM_CUST_SPEC_TYPE_SET_DEMO_MODE:
		{
               _bDemoMode = (*(BOOL *)pv_set_info);
		}
		break;
        default:
            #ifdef DRV_3RD_PARTY_CUSTOM_CUST_SPEC_SET
            return DRV_3RD_PARTY_CUSTOM_CUST_SPEC_SET(e_cust_spec_type,
                                                      pv_set_info,
                                                      z_size,
                                                      b_store);
            #else
            i4_ret = RMR_INV_ARG;
            break;
            #endif
            
    }

    return i4_ret;
}

UINT8 BKSV[5];
UINT8 data_buf[340];
#ifdef ENABLE_CA_SUPPORT///FAC_CMD_FOR_CI
extern void MPV_QuerySignal(UINT32* pu4Status);
extern INT32 PCMCIA_DetectCard(void);

#endif
extern UINT8 aLocatelSetting;

INT32 d_Soem_cust_spec_get (
    DRV_CUSTOM_CUST_SPEC_TYPE_T    e_cust_spec_type,
    VOID*                          pv_get_info,
    SIZE_T*                        pz_size
)
{
	INT32 i4_val;
	UINT16 i4_ret = 0;
	UINT8 buff=0;
	
    switch (e_cust_spec_type)
    {
#if 0    
   	case DRV_CUSTOM_CUST_SPEC_TYPE_HDMI_HDCP:
		 {
	#ifdef CC_Support_Sil9285
		#if 0
            i4_val = vSiI9287HDCPKSVread(((MISC_TYPE_HDMI_EDID_T *)pv_get_info)->aui1_hdmi_ksv);                
            if (! i4_val )
            {
                return -1;
            }
	#else
		i4_val = vSiI9287HDCPKSVread(BKSV);	
		x_memset(data_buf,0,sizeof(data_buf));
		data_buf[1]=BKSV[0];
		data_buf[2]=BKSV[1];
		data_buf[3]=BKSV[2];
		data_buf[4]=BKSV[3];
		data_buf[5]=BKSV[4];
		x_memcpy(((MISC_TYPE_HDMI_EDID_T *)pv_get_info)->aui1_hdcp_buf,data_buf,340);
		if (! i4_val )
            	{
                return -1;
           	 }
		#endif
	#else
		return RMR_OK;
	#endif
		    break;			
		 }
#endif

#ifdef CC_Factory2K12
				case DRV_CUSTOM_CUST_SPEC_TYPE_HDMI_EDID:
				{
					i4_val=0;
					//Factory2K12Debug(c_sprintf(fact_dbg_buf,"ui1_hdmi_comp_id (%x)\n",(((MISC_TYPE_HDMI_EDID_T *)pv_get_info)->ui1_hdmi_comp_id)));
					#if ENABLE_SOEM_HDMI 
					
					#if defined(CC_SOEM_BOARD)
					i4_val = SifEDIDRead((((MISC_TYPE_HDMI_EDID_T *)pv_get_info)->ui1_hdmi_comp_id), 256, 0xA0, 0, (((MISC_TYPE_HDMI_EDID_T *)pv_get_info)->aui1_edid_buf));
					#endif
					#endif
                    if ( i4_val < RMR_OK )			  
					{				 
						return -1;			  
					}			
					break;					 
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_HDMI_HDCP:
				{
				  #if ENABLE_SOEM_HDMI
					MISC_TYPE_HDMI_HDCP_T *p_hdmi_hdcp = (MISC_TYPE_HDMI_HDCP_T*)pv_get_info;
					
					if(SifHDCPRead(p_hdmi_hdcp->u2_offset, p_hdmi_hdcp->aui1_hdcp_buf, p_hdmi_hdcp->u2_length))  /* Read 320+20 bytes of HDCP key*/
					{
						return RMR_DRV_ERROR;
					}
					#endif
					break;
				}
		       case DRV_CUSTOM_CUST_SPEC_TYPE_HDCP2X_RW:
	         {
	       MISC_TYPE_HDCP2x_T *param = (MISC_TYPE_HDCP2x_T *)pv_get_info;
		   UINT16 Off_s = 0; 
	       i4_ret = 0;
           if(param->u2_offset + param->u2_length > 885)
           {
               i4_ret = -1;
           }
		   else
		   {
				if(EEPHDCP2x_Read(0,(UINT32)buf_HDCP2x,880))	
			      {
			          i4_ret = -1;
			      } 
			  if(i4_ret ==0)
			  	{
			      if(param->u2_offset < 256)
			  	  {
						x_memcpy(param->aui1_hdcp2x_buf+5, &buf_HDCP2x[param->u2_offset], param->u2_length-5);
			  	  }else
			  	  {
			  	  		Off_s = param->u2_offset - 5;
						x_memcpy(param->aui1_hdcp2x_buf, &buf_HDCP2x[Off_s], param->u2_length);
			  	  }
			  	}
              
		   }
	       }
	   break;
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_WBT_IDX:
				{
					UINT16 ui2_result = WB_PBM_ColorTempIdxGet();
					Factory2K12Debug(c_sprintf(fact_dbg_buf,"-- sony_d_custom, get(%x) --\n",0));
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_ADJ_METHOD:
				{
					UINT16 ui2_result = WB_PBM_WBAdjustMethodGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_EASY_SET_LVL:
				{
					UINT16 ui2_result = WB_PBM_EasySetPatternLevelGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_EASY_SET_EN:
				{
					UINT16 ui2_result = WB_PBM_EasySetPatternEnableGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_Y_SUM_POS:
				{
					UINT16 ui2_result = WB_PBM_YSumPosGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_Y_SUM_MEAS:
				{
					UINT16 ui2_result = WB_PBM_YSumMeasGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_PIXEL_POS:
				{
					UINT16 ui2_result = WB_PBM_YSumPixelPosGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_PIXEL_MEAS_Y:
				{
					UINT16 ui2_result = WB_PBM_PixelMeasYGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_PIXEL_MEAS_CB:
				{
					UINT16 ui2_result = WB_PBM_PixelMeasCBGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_PIXEL_MEAS_CR:
				{
					UINT16 ui2_result = WB_PBM_PixelMeasCRGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_ON:
				{
					UINT16 ui2_result = WB_PBM_LutAdjOnGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_WBT_IDX_CHANGE_STS:
				{
					UINT16 ui2_result = WB_PBM_WBTIdxChangeStsGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INP_EASY_SET_R:
				{
					UINT16 ui2_result = WB_PBM_InpEasySetRGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INP_EASY_SET_G:
				{
					UINT16 ui2_result = WB_PBM_InpEasySetGGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INP_EASY_SET_B:
				{
					UINT16 ui2_result = WB_PBM_InpEasySetBGet();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R00:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 0);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R01:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 1);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R02:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 2);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R03:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 3);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R04:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 4);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R05:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 5);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R06:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 6);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R07:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 7);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R08:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 8);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R09:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 9);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R10:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 10);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R11:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 11);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R12:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 12);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R13:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 13);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R14:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 14);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R15:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 15);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R16:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 16);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R17:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 17);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R18:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 18);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R19:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 19);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R20:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 20);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R21:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 21);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R22:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 22);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R23:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 23);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R24:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 24);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R25:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 25);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R26:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 26);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R27:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 27);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R28:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 28);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R29:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 29);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R30:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 30);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R31:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 31);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R32:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 32);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R33:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 33);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R34:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 34);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R35:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 35);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R36:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 36);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R37:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 37);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R38:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 38);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R39:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 39);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R40:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 40);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R41:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 41);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R42:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 42);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R43:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 43);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R44:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 44);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R45:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 45);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R46:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 46);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R47:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 47);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R48:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 48);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R49:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 49);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R50:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 50);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R51:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 51);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R52:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 52);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R53:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 53);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R54:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 54);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R55:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 55);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_R56:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(0, 56);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}						
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G00:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 0);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G01:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 1);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G02:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 2);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G03:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 3);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G04:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 4);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G05:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 5);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G06:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 6);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G07:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 7);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G08:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 8);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G09:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 9);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G10:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 10);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G11:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 11);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G12:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 12);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G13:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 13);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G14:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 14);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G15:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 15);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G16:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 16);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G17:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 17);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G18:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 18);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G19:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 19);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G20:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 20);
					*((UINT32 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G21:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 21);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G22:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 22);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G23:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 23);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G24:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 24);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G25:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 25);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G26:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 26);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G27:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 27);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G28:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 28);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G29:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 29);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G30:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 30);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G31:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 31);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G32:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(1, 32);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G33:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 33);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G34:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 34);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G35:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 35);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G36:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 36);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G37:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 37);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G38:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 38);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G39:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 39);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G40:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 40);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G41:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 41);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G42:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 42);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G43:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 43);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G44:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 44);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G45:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 45);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G46:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 46);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G47:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 47);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G48:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 48);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G49:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 49);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G50:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 50);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G51:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 51);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G52:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 52);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G53:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 53);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G54:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 54);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G55:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 55);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_G56:
				{
				  UINT16 ui2_result = WB_PBM_CoefGet(1, 56);
				  *((UINT16 *)(pv_get_info)) = ui2_result;
				  break;
				}

				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B00:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 0);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B01:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 1);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B02:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 2);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B03:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 3);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B04:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 4);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B05:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 5);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B06:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 6);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B07:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 7);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B08:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 8);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B09:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 9);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B10:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 10);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B11:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 11);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B12:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 12);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B13:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 13);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B14:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 14);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B15:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 15);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B16:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 16);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B17:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 17);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B18:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 18);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B19:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 19);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B20:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 20);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B21:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 21);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B22:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 22);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B23:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 23);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B24:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 24);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B25:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 25);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B26:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 26);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B27:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 27);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B28:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 28);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B29:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 29);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B30:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 30);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B31:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 31);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B32:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 32);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B33:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 33);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B34:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 34);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B35:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 35);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B36:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 36);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B37:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 37);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B38:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 38);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B39:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 39);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B40:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 40);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B41:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 41);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B42:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 42);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B43:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 43);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B44:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 44);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B45:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 45);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B46:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 46);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B47:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 47);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B48:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 48);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B49:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 49);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B50:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 50);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B51:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 51);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B52:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 52);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B53:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 53);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B54:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 54);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B55:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 55);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_LUT_ADJ_B56:
				{
					UINT16 ui2_result = WB_PBM_CoefGet(2, 56);
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}	

				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_00:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(0, 0);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_01:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(0, 1);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_02:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(0, 2);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_03:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(0, 3);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_04:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(0, 4);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_05:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(0, 5);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_06:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(0, 6);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_07:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(0, 7);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_08:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(0, 8);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_09:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(0, 9);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_R_10:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(0, 10);
                    break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_00:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(1, 0);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_01:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(1, 1);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_02:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(1, 2);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_03:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(1, 3);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_04:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(1, 4);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_05:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(1, 5);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_06:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(1, 6);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_07:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(1, 7);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_08:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(1, 8);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_09:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(1, 9);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_G_10:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(1, 10);
                    break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_00:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(2, 0);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_01:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(2, 1);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_02:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(2, 2);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_03:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(2, 3);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_04:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(2, 4);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_05:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(2, 5);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_06:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(2, 6);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_07:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(2, 7);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_08:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(2, 8);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_09:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(2, 9);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM0_B_10:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM0_RGB_GET(2, 10);
                    break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_00:
                {
                    *(UINT16*)(pv_get_info) = WB_TRACK_INP_LVL_GET(0);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_01:
                {
                    *(UINT16*)(pv_get_info) = WB_TRACK_INP_LVL_GET(1);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_02:
                {
                    *(UINT16*)(pv_get_info) = WB_TRACK_INP_LVL_GET(2);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_03:
                {
                    *(UINT16*)(pv_get_info) = WB_TRACK_INP_LVL_GET(3);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_04:
                {
                    *(UINT16*)(pv_get_info) = WB_TRACK_INP_LVL_GET(4);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_05:
                {
                    *(UINT16*)(pv_get_info) = WB_TRACK_INP_LVL_GET(5);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_06:
                {
                    *(UINT16*)(pv_get_info) = WB_TRACK_INP_LVL_GET(6);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_07:
                {
                    *(UINT16*)(pv_get_info) = WB_TRACK_INP_LVL_GET(7);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_08:
                {
                    *(UINT16*)(pv_get_info) = WB_TRACK_INP_LVL_GET(8);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_09:
                {
                    *(UINT16*)(pv_get_info) = WB_TRACK_INP_LVL_GET(9);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_INP_LVL_WB_10:
                {
                    *(UINT16*)(pv_get_info) = WB_TRACK_INP_LVL_GET(10);
                    break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_00:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM_GAIN_GET(0);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_01:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM_GAIN_GET(1);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_02:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM_GAIN_GET(2);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_03:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM_GAIN_GET(3);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_04:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM_GAIN_GET(4);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_05:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM_GAIN_GET(5);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_06:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM_GAIN_GET(6);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_07:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM_GAIN_GET(7);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_08:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM_GAIN_GET(8);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_09:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM_GAIN_GET(9);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_GAIN_10:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_GAM_GAIN_GET(10);
                    break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAM_SEL:
                {
                   
                   break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_BASE_GAIN_R:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_BASE_GAIN_RGB_GET(0);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_BASE_GAIN_G:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_BASE_GAIN_RGB_GET(1);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_BASE_GAIN_B:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_BASE_GAIN_RGB_GET(2);
                    break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R00:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(0, 0);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R01:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(0, 1);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R02:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(0, 2);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R03:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(0, 3);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R04:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(0, 4);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R05:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(0, 5);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R06:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(0, 6);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R07:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(0, 7);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R08:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(0, 8);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R09:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(0, 9);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_R10:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(0, 10);
                    break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G00:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(1, 0);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G01:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(1, 1);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G02:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(1, 2);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G03:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(1, 3);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G04:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(1, 4);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G05:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(1, 5);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G06:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(1, 6);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G07:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(1, 7);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G08:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(1, 8);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G09:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(1, 9);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_G10:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(1, 10);
                    break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B00:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(2, 0);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B01:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(2, 1);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B02:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(2, 2);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B03:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(2, 3);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B04:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(2, 4);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B05:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(2, 5);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B06:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(2, 6);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B07:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(2, 7);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B08:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(2, 8);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B09:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(2, 9);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_OFST_B10:
                {
                    *(UINT8*)(pv_get_info) = WB_TRACK_OFST_RGB_GET(2, 10);
                    break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_EEP_WB_GAM0_RGB:
                {
                   //*(UINT8*)(pv_get_info)= DRVCUST_GET_WB_GAM(((DRV_EEP_WB_GAM0_RGB*)pv_get_info)->u1Channel,
                                                                                    //((DRV_EEP_WB_GAM0_RGB*)pv_get_info)->u1Levle);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_EEP_INP_LVL_WB:
                {
                    //((DRV_EEP_INP_LVL_WB*)pv_get_info)->u2Value = DRVCUST_GET_INP_LVL_WB(((DRV_EEP_INP_LVL_WB*)pv_get_info)->u1Levle);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_EEP_WB_GAM_GAIN:
                {
                    //((DRV_EEP_WB_GAM_GAIN*)pv_get_info)->u1Value = DRVCUST_GET_INP_LVL_WB(((DRV_EEP_WB_GAM_GAIN*)pv_get_info)->u1Levle);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_EEP_WB_BASE_GAIN_RGB:
                {
                    //((DRV_EEP_WB_BASE_GAIN_RGB*)pv_get_info)->u1Value = DRVCUST_GET_WB_BASE_GAIN(((DRV_EEP_WB_BASE_GAIN_RGB*)pv_get_info)->u1ColorTemp,
                                                                                                //((DRV_EEP_WB_BASE_GAIN_RGB*)pv_get_info)->u1Channel);
                    break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_EEP_WB_OFST_RGB:
                {
                    //((DRV_EEP_WB_OFST_RGB*)pv_get_info)->u1Value = DRVCUST_GET_WB_OFST(((DRV_EEP_WB_OFST_RGB*)pv_get_info)->u1ColorTemp,
                                                                                        //((DRV_EEP_WB_OFST_RGB*)pv_get_info)->u1Channel,
                                                                                        //((DRV_EEP_WB_OFST_RGB*)pv_get_info)->u1Levle);
                    break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_GODID:
                {
                   *(UINT8*)(pv_get_info) = DRVCUST_GET_WBADJ_GODID_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_PON_TIME:
                {
                   *(UINT8*)(pv_get_info) = DRVCUST_GET_WBADJ_PON_TIME_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_JIG_VER:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WBADJ_JIG_VER_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_DS_DATE:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WBADJ_DS_DATE_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_ADJ_DATE:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WBADJ_ADJ_DATE_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_AGING1:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WBADJ_AGING1_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_AGING2:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WBADJ_AGING2_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_JIG_INFO1:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WBADJ_JJG_INFO1_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WBADJ_JIG_INFO2:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WBADJ_JJG_INFO2_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INFO0:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WB_INFO0_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INFO1:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WB_INFO1_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INFO2:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WB_INFO2_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INFO3:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WB_INFO3_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_WB_INFO4:
                {
                   *(UINT16*)(pv_get_info) = DRVCUST_GET_WB_INFO4_EEP();
                   break;
                }
                case DRV_CUSTOM_CUST_SPEC_TYPE_PGAM_EN:
                {
                	*(UINT8*)(pv_get_info) = DRVCUST_GetPGAM_EN();
                	break;
                }

                case DRV_CUSTOM_CUST_SPEC_TYPE_U_WB_FLAT:
                {
                	*(UINT8*)(pv_get_info) = DRVCUST_GetUWBFLAT();
                	break;
                }	
				case DRV_CUSTOM_CUST_SPEC_TYPE_AGING_LAST_POWER_CONTROL:
				{
					UINT16 ui2_result = AgingLastPowerControlState_Get();
					*((UINT16 *)(pv_get_info)) = ui2_result;
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_ACFG_UPDATE_GET:
				{
					UINT16 ui2_acfg_update = Sony_WB_Acfg_Update_Get();
					*((UINT16 *)(pv_get_info)) = ui2_acfg_update;
					//Sony_WB_Acfg_Update_Set(0);
					break;
				}
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_UPDATE_ADJ_CLR_IDX_GET:
				{
					UINT16 ui2_clr_temp_update_idx = Sony_WB_Update_ADJ_CLR_IDX_Get();
					*((UINT16 *)(pv_get_info)) = ui2_clr_temp_update_idx;
					break;
				}				
				case DRV_CUSTOM_CUST_SPEC_TYPE_WB_UPDATE_PARM_GET:
				{
					UINT16 ui2_clr_temp_idx=0;
					WB_CLR_TEMP_DATA_T wb_data;

					ui2_clr_temp_idx = ((WB_CLR_TEMP_DATA_GET_T *)pv_get_info)->ui2ClrTempIdx;
                    					
					wb_data = Sony_WB_Update_PARM_Get(ui2_clr_temp_idx);

                    ((WB_CLR_TEMP_DATA_GET_T *)pv_get_info)->wClrTempData.wRGain = wb_data.wRGain;
					((WB_CLR_TEMP_DATA_GET_T *)pv_get_info)->wClrTempData.wGGain = wb_data.wGGain;
					((WB_CLR_TEMP_DATA_GET_T *)pv_get_info)->wClrTempData.wBGain = wb_data.wBGain;
					((WB_CLR_TEMP_DATA_GET_T *)pv_get_info)->wClrTempData.wROfst = wb_data.wROfst;
					((WB_CLR_TEMP_DATA_GET_T *)pv_get_info)->wClrTempData.wGOfst = wb_data.wGOfst;
					((WB_CLR_TEMP_DATA_GET_T *)pv_get_info)->wClrTempData.wBOfst = wb_data.wBOfst;
					//*((WB_CLR_TEMP_DATA_T *)(pv_get_info)) = ui2_acfg_update;
					//Sony_WB_Acfg_Update_Set(0);
					break;
				}
#endif   


		case DRV_CUSTOM_CUST_SPEC_GET_DEEPCOLOR:
			*((UINT8*)pv_get_info) =  bHDMIDeepColorStatus();
			break;
		case DRV_CUSTOM_CUST_SPEC_GET_ADC_RGB_GAIN_OFFSET:
				((_DRV_CUSTOM_ADC_RGB_GAIN_OFFSET__T *) pv_get_info)->ui1_r_gain = (UINT16) vCust_R_Gain_Read();
				((_DRV_CUSTOM_ADC_RGB_GAIN_OFFSET__T *) pv_get_info)->ui1_g_gain= (UINT16) vCust_G_Gain_Read();
				((_DRV_CUSTOM_ADC_RGB_GAIN_OFFSET__T *) pv_get_info)->ui1_b_gain = (UINT16) vCust_B_Gain_Read();
				((_DRV_CUSTOM_ADC_RGB_GAIN_OFFSET__T *) pv_get_info)->ui1_r_offset = (UINT16) vCust_R_Offset_Read();
				((_DRV_CUSTOM_ADC_RGB_GAIN_OFFSET__T *) pv_get_info)->ui1_g_offset = (UINT16) vCust_G_Offset_Read();
				((_DRV_CUSTOM_ADC_RGB_GAIN_OFFSET__T *) pv_get_info)->ui1_b_offset = (UINT16) vCust_B_Offset_Read();
			break;
		case DRV_CUSTOM_CUST_SPEC_GET_LIGHT_SENSOR_STATS:
		if ((pv_get_info == NULL) || (*(pz_size) != sizeof(DRV_CUSTOM_LIGHT_SENSOR_TYPE_T)))
		{
			LOG(2, "[DRV_CUSTOM_CUST_SPEC_GET_LIGHT_SENSOR_STATS] Invalid parameter\n");
			return RMR_INV_ARG;
		}
		
		buff = 0x2E;
		i4_ret = SIF_X_Write(0x2, 0x120,0x20,0, 0,&buff,1); //0x100 
		if(i4_ret)
			Printf("[GPIO_IbizaPowerOnFunc] Light sensor enter normal mode - successful!!\n");
		else
			Printf("[GPIO_IbizaPowerOnFunc] Light sensor enter normal mode - failed!!\n");
		
		buff = 0x60;
		i4_ret = SIF_X_Write(0x2, 0x120,0x22,0, 0,&buff,1); //0x100 
		if(i4_ret)
			Printf("[GPIO_IbizaPowerOnFunc] Light sensor write 0x22 successful!!\n");
		else
			Printf("[GPIO_IbizaPowerOnFunc] Light sensor write 0x22 error!!\n");

			i4_ret = SIF_X_Read((((DRV_CUSTOM_LIGHT_SENSOR_TYPE_T *)pv_get_info)->u1CHannelID)
								,(((DRV_CUSTOM_LIGHT_SENSOR_TYPE_T *)pv_get_info)->u2ClkDiv)
								,(((DRV_CUSTOM_LIGHT_SENSOR_TYPE_T *)pv_get_info)->u1DevAddr)
								,(((DRV_CUSTOM_LIGHT_SENSOR_TYPE_T *)pv_get_info)->u1WordAddrNum)
								,(((DRV_CUSTOM_LIGHT_SENSOR_TYPE_T *)pv_get_info)->u4WordAddr)
								,(((DRV_CUSTOM_LIGHT_SENSOR_TYPE_T *)pv_get_info)->pu1Buf)
								,(((DRV_CUSTOM_LIGHT_SENSOR_TYPE_T *)pv_get_info)->u2ByteCnt));
			
			break;
		case DRV_CUSTOM_CUST_SPEC_GET_IRRX:
			(((DRV_CUSTOM_IRRX_TYPE_T *)pv_get_info)->ui4_irrx_read) =  
				IRRX_ReadSvadc(((DRV_CUSTOM_IRRX_TYPE_T *)pv_get_info)->ui1_channel);
			break;
		case DRV_CUSTOM_SPEC_TYPE_YAPL:
		{
			*((UINT8*)pv_get_info) =  bDrvGetAPL();
			break;	
		}

#ifdef CUST_SOEM_DRV //lcct_2H

				case DRV_CUSTOM_CUST_SPEC_V_COM_DRV:
				{
            DRV_CUSTOM_VCOM_ST *pVcomParam = (DRV_CUSTOM_VCOM_ST *)pv_get_info;
            UINT8 u1Data;
            UINT8 u2Data[] = {0, 0}; //Dummy to receive data from V-COM SDP 48 inch
            UINT16 ui2_result = 0;
			
			SelfDiagRequirePanelIDRead();
			
            GPIO_SetOut(PANEL_BINT_PIN,PIN_HIGH);
			x_thread_delay(10);

            /* SDC and BOE panels use the same read/write protocol */
            if(pVcomParam->vcom_type == SDCVCOM)
            {
                SIF_X_Read(BUS_ID,CLK_DIV, 0x9e, 0, 0, &u1Data, 1);
                ui2_result = (UINT16)u1Data >> 1; //(u1Data & 0xFE) >> 1;
            }
            else if(pVcomParam->vcom_type == LGDVCOM)
            {
                SIF_X_Read(BUS_ID, CLK_DIV, 0x40, 1, 0x15, &u1Data, 1);
                ui2_result = u1Data << 8;
                SIF_X_Read(BUS_ID, CLK_DIV, 0x40, 1, 0x16, &u1Data, 1);
                ui2_result |= u1Data;
            }
            else if(pVcomParam->vcom_type == SDPVCOM)
            {
                SIF_X_Read(BUS_ID, CLK_DIV, 0xE8, 1, 0x00, &u2Data[0], 2);
                ui2_result = u2Data[1];
            }
            else if (pVcomParam->vcom_type == AUOVCOM)
            {
                SIF_X_Read(BUS_ID, CLK_DIV, 0xE8, 1, 0x01,&u1Data, 1);
                ui2_result = u1Data >> 1;
            }
			else if(pVcomParam->vcom_type == SDCHACK1)
			{ 
            
                UINT8	u4Data[] = {0,0,0,0}; //Dummy to receive data from V-COM SDP 48 inch
                SIF_X_Read(BUS_ID, CLK_DIV, 0xa0, ADDR_LENGTH, 0x0055, &u4Data[0], 1);
                SIF_X_Read(BUS_ID, CLK_DIV, 0xa0, ADDR_LENGTH, 0x0134, &u4Data[1], 1);
                SIF_X_Read(BUS_ID, CLK_DIV, 0xa0, ADDR_LENGTH, 0x015a, &u4Data[2], 1);
                i4_ret = SIF_X_Read(BUS_ID, CLK_DIV, 0xa0, ADDR_LENGTH, 0x1ff9, &u2Data[1], 1);                    
                if ( i4_ret == SIF_ERROR_RETURN ){
                    u2Data[0] = 0xff;
                }
                else if((u4Data[0] == 0x98) && (u4Data[1] == 0x9a) && (u4Data[2] == 0x19))
                {
                    u2Data[0] = 0x01;                            
                }
                else if((u4Data[0] == 0x3e) && (u4Data[1] == 0xf5) && (u4Data[2] == 0x18))
                {
                    u2Data[0] = 0x02;                            
                }
                else
                {
                    u2Data[0] = 0xf0;                            
                }
				ui2_result = u2Data[0]<<8 | u2Data[1];     
            }


            *((UINT16 *)(pVcomParam->vcom_value)) = ui2_result;
            GPIO_SetOut(PANEL_BINT_PIN,PIN_LOW);
			SelfDiagReleasePanelIDRead();
            break;
        }

				case DRV_CUSTOM_CUST_SPEC_WB_EDID_WRITE:
				{
					UINT16 ui2_result = 123;
					Factory2K12Debug(c_sprintf(fact_dbg_buf,"-- DRV_CUSTOM_CUST_SPEC_TYPE_TEST_PTN_RAMP, set(%x) --\n",(*((UINT16*)pv_set_info))));
					
					ui2_result = 123;
					*((UINT32 *)(pv_get_info)) = ui2_result;
					break;
				}		
		case DRV_CUSTOM_CUST_SPEC_MICRO_OPTION_RMVB:
		{
			UINT16 ui2_result = 0;
			ui2_result = (UINT16)IS_SupportRM();
			*((UINT32 *)(pv_get_info)) = ui2_result;
			break;
		}

		case DRV_CUSTOM_CUST_SPEC_GET_GAMMA_SETUP:
		{
			UINT16 Val;
		
            Val = (UINT16)Sony_GammaSetup_Read();
			*((UINT16 *)(pv_get_info)) = Val;
			break;			
		}
				
		case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_PTN_GET_LVL:
		{
			UINT16 Val;
		
            Val = Sony_GammaReadLvl(Current_Gamma_RGB,Current_Luma_Lvl);
			*((UINT16 *)(pv_get_info)) = Val;
			break;
		}		
		case DRV_CUSTOM_CUST_SPEC_TYPE_WBS_TO_NVM_GET:
		{
			UINT16 Val;

			Val= Sony_WBReadData(Current_Wbs_Nvm_Env.CLRIDX, Current_Wbs_Nvm_Env.WBLVL, Current_Wbs_Nvm_Env.GAMMA);
			*((UINT16 *)(pv_get_info)) = Val;
			break;
		}		
		case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_SETUP_STATUS_GET:
		{
			UINT16 Val;
		
            Val = (UINT16)Sony_GammaSetup_Read();
			*((UINT16 *)(pv_get_info)) = Val;
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_GET_SELECT_LVL:
		{
			UINT16 Val;
		
            Val = (UINT16)Sony_GammaSelectLvl_Read();
			*((UINT16 *)(pv_get_info)) = Val;
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_CLRIDX_GET:
		{
			UINT16 Val;

            Val = (UINT16)Sony_WBReadColor();
			*((UINT16 *)(pv_get_info)) = Val;
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_WBLVL_GET:
		{
			UINT16 Val;

            Val = (UINT16)Sony_WBReadLvl();
			*((UINT16 *)(pv_get_info)) = Val;
			break;
		}
        case DRV_CUSTOM_CUST_SPEC_TYPE_WB_GAIN_GET:
		{
            D_AUTOWB_GAIN_MODE GainMode;
			D_AUTOWB_RGB       RgbType;
			UINT16 Val=0;

			GainMode = (((WB_AUTO_GAIN_T *)pv_get_info)->AutoWbMode);
			RgbType  = (((WB_AUTO_GAIN_T *)pv_get_info)->AutoWbRgb);

            switch(RgbType)
            {
                case AUTOWB_R:
                    if(GainMode == DELTA_MODE) {
						Val = Sony_AutoWB_GetGain(DELTA_GAIN,GAMMA_R);
                    } else {
                        Val = Sony_AutoWB_GetGain(FINAL_GAIN,GAMMA_R);
                    }
					break;                
				case AUTOWB_G:
                    if(GainMode == DELTA_MODE) {
						Val = Sony_AutoWB_GetGain(DELTA_GAIN,GAMMA_G);
                    } else {
                        Val = Sony_AutoWB_GetGain(FINAL_GAIN,GAMMA_G);
                    }
					break;                
				case AUTOWB_B:
                    if(GainMode == DELTA_MODE) {
						Val = Sony_AutoWB_GetGain(DELTA_GAIN,GAMMA_B);
                    } else {
                        Val = Sony_AutoWB_GetGain(FINAL_GAIN,GAMMA_B);
                    }
					break;
				default:
					break;
            }
			(((WB_AUTO_GAIN_T *)pv_get_info)->ui2Gain) = Val;
			break;
        }
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_SETUP_STATUS_GET:
		{
			UINT16 Val;

            Val = (UINT16)Sony_WBSetup_Read();
			*((UINT16 *)(pv_get_info)) = Val;
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_WB_PBM_PQP_PGRAM_LUT_GET_BY_ELEMENT:
		{
			UINT16 Val;

            Val = WB_PBM_PQP_PGAM_LUT_Get(Current_Pqp_Lut_setting.ui1RgbIdx,
				                          Current_Pqp_Lut_setting.ui1WblvlIdx,
				                          Current_Pqp_Lut_setting.ui1WbIndex);
			*((UINT16 *)(pv_get_info)) = Val;
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_BACKLIGHT_CONTROL:
		{
            UINT8 OperationMode,ui1Set=0;

			OperationMode = (((BL_CTRL_OPERATION_T *)pv_get_info)->uiOpMode);

			switch(OperationMode)
			{
			   case 0x00:
			    #if ENABLE_SOEM_PQ	
			   	ui1Set = DRVCUST_ReadDynamicBacklight();
			   	#endif
			   	break;
			   case 0x02:
			    #if ENABLE_SOEM_PQ	
			   	ui1Set = DRVCUST_ReadPMX();
			   	#endif
				break;
			   default:
			   	break;
			}
			(((BL_CTRL_OPERATION_T *)pv_get_info)->ui2OpParameter) = (UINT16)ui1Set;
			break;
		}		
#endif

        case DRV_CUSTOM_CUST_SPEC_TYPE_PCB_MODE:
        {
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(UINT32)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_TYPE_PCB_MODE] Invalid parameter\n");
                return RMR_INV_ARG;
            }
            *((UINT32 *)(pv_get_info)) = _u4gModelType;
            break;
        }
		#if 1//cox 110829  
        case DRV_CUSTOM_CUST_SPEC_TYPE_HDMI_POWER5V_STATUS:
        {
         ((DRV_CUSTOM_HDMI_5V_TYPE_T *)pv_get_info)->ui1_5V_status=bHDMIPort5VStatus((E_HDMI_SWITCH_NUM)((DRV_CUSTOM_HDMI_5V_TYPE_T *)pv_get_info)->ui1_hdmi_comp_id);//modified 20110915
		 //((DRV_CUSTOM_HDMI_5V_TYPE_T *)test)->ui1_5V_status=bHDMIPort5VStatus(test->ui1_hdmi_comp_id);
			break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_GPIO_INPUT_STATUS:
        {
         ((DRV_CUSTOM_GPIO_INPUT_TYPE_T *)pv_get_info)->ui1_gpio_input_status=GPIO_Input((INT32)((DRV_CUSTOM_GPIO_INPUT_TYPE_T *)pv_get_info)->ui1_gpio_input_id);
			break;
        }

		#endif
        case DRV_CUSTOM_CUST_SPEC_GET_TAG_VERSION:
        {
        	DRV_CUSTOM_TAG_VERSION_TYPE_T *prTageVer=NULL;
			//MISC_VERSION_ID_T *prTageVer=NULL;

            if (pv_get_info == NULL)
            {
                LOG(0, "[DRV_CUSTOM_CUST_SPEC_GET_TAG_VERSION] Invalid parameter\n");
                return RMR_INV_ARG;
            }
        	prTageVer = (DRV_CUSTOM_TAG_VERSION_TYPE_T *)pv_get_info; 
        	//prTageVer = (MISC_VERSION_ID_T *)pv_get_info;     
            if(prTageVer->ui1_tag_type >= DRV_CUSTOM_TAG_TYPE_MAX)
            {
            	 return RMR_DRV_INV_GET_INFO;
            }
            vGetTagVersion(szTagStr[prTageVer->ui1_tag_type], prTageVer->szVerStr);
			break;
        }   
            
        case DRV_CUSTOM_CUST_SPEC_TYPE_BACKLIGHT_STATUS:
        {
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(UINT32)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_TYPE_BACKLIGHT_STATUS] Invalid parameter\n");
                return RMR_INV_ARG;
            }
            *((UINT32 *)(pv_get_info)) = CustomGetBackltStatus();
           break;
        }
        
#ifdef CUSTOM_SELF_DIAG_ENABLE        
        case DRV_CUSTOM_CUST_SPEC_TYPE_SELF_DIAG_MODE:
        {
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(D_SELF_DIAG_STATE)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_TYPE_SELF_DIAG_MODE] Invalid parameter\n");
                return RMR_INV_ARG;
            }
            UNUSED(SelfDiagGetCounter((D_SELF_DIAG_STATE *)pv_get_info));
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_BOOT_COUNT_MODE:
        {
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(UINT32)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_TYPE_BOOT_COUNT_MODE] Invalid parameter\n");
                return RMR_DRV_ERROR;
            }
            
            if (SelfDiagGetBootCounter((UINT32 *)pv_get_info) != 0)
            {
                return RMR_DRV_ERROR;
            }
            break;
        }
#endif /* CUSTOM_SELF_DIAG_ENABLE */        
#ifdef CUSTOM_SELF_DIAG_ENABLE 
		case DRV_CUSTOM_CUST_SPEC_BATTERY_MODE://d130722_Haibo:[DTV00544479][DGTVi][Task other] System will hang with no keys response sometimes.
		{
			if ((pv_get_info == NULL))
			{
				LOG(2, "[DRV_CUSTOM_CUST_SPEC_BATTERY_MODE] Invalid parameter\n");
				return RMR_INV_ARG;
			}
			 *((UINT32 *)pv_get_info) = SelfDiagGetBatteryMode();
			 //Printf("[%s]Battery mode=%d\n",__FUNCTION__,SelfDiagGetBatteryMode());
			break;
		}				
#endif
        case DRV_CUSTOM_CUST_SPEC_GET_DIMMING_FREQ_48:
        case DRV_CUSTOM_CUST_SPEC_GET_DIMMING_FREQ_50:
        case DRV_CUSTOM_CUST_SPEC_GET_DIMMING_FREQ_60:
        {
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(UINT32)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_GET_DIMMING_FREQ] Invalid parameter\n");
                return RMR_INV_ARG;
            }

            if (e_cust_spec_type == DRV_CUSTOM_CUST_SPEC_GET_DIMMING_FREQ_60)
            {
                *((UINT32 *)pv_get_info) = PANEL_GetDimmingFrequency60Hz();
            }
            else if (e_cust_spec_type == DRV_CUSTOM_CUST_SPEC_GET_DIMMING_FREQ_50)
            {
                *((UINT32 *)pv_get_info) = PANEL_GetDimmingFrequency50Hz();
            }
            else    // 48 Hz
            {
                #ifdef SUPPORT_PANEL_48HZ
                *((UINT32 *)pv_get_info) = PANEL_GetDimmingFrequency48Hz();
                #else
                *((UINT32 *)pv_get_info) = PANEL_GetDimmingFrequency60Hz();                
                #endif
            }
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_SS_PERMILLAGE:
        {
            UINT32 u4Freq, u4Permillage;    
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(UINT32)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_GET_DIMMING_FREQ] Invalid parameter\n");
                return RMR_INV_ARG;
            }
            PANEL_GetSpreadSpectrum(&u4Freq, &u4Permillage);
            *((UINT32 *)pv_get_info) = u4Permillage;
            break;
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_PANEL_ID:
        {
#ifdef CC_Factory2K12
            #define PANEL_ID_STRING_LEN            16
            //int i;
            CHAR *prPanelName = NULL;
            DRV_CUSTOM_PANEL_ID_T *p_panel_id = (DRV_CUSTOM_PANEL_ID_T*)pv_get_info;
#ifdef CC_PANEL_FROM_FLASH
            prPanelName = FlashPanel_GetIDString(); // allen add for get panel id
            x_memcpy(&p_panel_id->aui1_panel_id_buf[0], (void *)prPanelName, PANEL_ID_STRING_LEN);
//            x_memcpy(pv_get_info, (void *)prPanelName, PANEL_ID_STRING_LEN);           
#endif
            break;
#else
            #define IRIS_PANEL_ID_STRING_LEN            16

            CHAR *prPanelName = NULL;
            if ((pv_get_info == NULL) || (*(pz_size) != IRIS_PANEL_ID_STRING_LEN))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_TYPE_PANEL_ID] Invalid parameter\n");
                return RMR_DRV_ERROR;
            }

            prPanelName = GetCurrentPanelName();
            x_memcpy(pv_get_info, (void *)prPanelName, IRIS_PANEL_ID_STRING_LEN);
            break;

#endif
        }
        case DRV_CUSTOM_CUST_SPEC_GET_PANEL_INCH_SIZE:
        {
#if MT5396_PORTING
            *(UINT32*)pv_get_info = 0;
#else            
            #ifdef LOAD_PANEL_FROM_FLASH_CUSTOM 
            *(UINT32*)pv_get_info = FlashPanel_GetInchSize();
            #else      
            UINT32 u4PanelIndex = GetCurrentPanelIndex();
#ifdef PANEL_LG_32_WXN_SCB1
            if (u4PanelIndex == PANEL_LG_32_WXN_SCB1)
            {
                *(UINT32*)pv_get_info = 32;
            }
            else 
#endif
#ifdef PANEL_LG_37_WUN_SCC1
			if (u4PanelIndex == PANEL_LG_37_WUN_SCC1)
            {
                *(UINT32*)pv_get_info = 37;
            }
            else
#endif			
            {
                *(UINT32*)pv_get_info = 0;
            }
            #endif
#endif// MT5396_PORTING
            break;      
        }
        case DRV_CUSTOM_CUST_SPEC_TYPE_LOGO_STATE:
        {
            DTVCFG_T rDtvCfg;
#ifdef CC_AUD_SETUP_MELODY
            UINT8 u1ActiveFlag = DRV_CUSTOM_LOGO_ACTIVE | DRV_CUSTOM_LOGO_MUSIC_ACTIVE;
#else
            UINT8 u1ActiveFlag = DRV_CUSTOM_LOGO_ACTIVE;            
#endif// MT5396_PORTING
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(UINT8)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_TYPE_LOGO_STATE] Invalid parameter\n");
                return RMR_DRV_ERROR;
            }

            if (EEPDTV_GetCfg(&rDtvCfg) == 0)
            {
                if (rDtvCfg.u1Flags2 & DTVCFG_FLAG2_DISABLE_LOGO)
                {
                    u1ActiveFlag &= ~DRV_CUSTOM_LOGO_ACTIVE;
                }
            }
#ifdef CC_AUD_SETUP_MELODY                
            if (!(bApiEepromReadByte(EEP_BOOT_MUSIC_ONOFF) & AUD_POWER_ON_MUSIC_MASK))
            {
                u1ActiveFlag &= ~DRV_CUSTOM_LOGO_MUSIC_ACTIVE;
            }
#endif// MT5396_PORTING            
            *((UINT8 *)pv_get_info) = u1ActiveFlag;
            
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_LOADER_UPGRADE_MODE:
        {
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(UINT8)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_TYPE_LOADER_UPGRADE_MODE] Invalid parameter\n");
                return RMR_DRV_ERROR;
            }

            *((UINT8 *)pv_get_info) = CustomIsLoaderUsbUpgradeEnable() ? 1 : 0;
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_TYPE_DVD_ENABLE:
        {
            //DRV_MODELID_DVD * p_dvd_info = NULL;
            UINT8 ui_dvd_option = 0;
            
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(BOOL)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_TYPE_DVD_ENABLE] Invalid parameter\n");
                return RMR_INV_ARG;
            }
            
            //p_dvd_info = (DRV_MODELID_DVD *)pv_get_info;
            if (EEPROM_Read((UINT64)DRV_CUSTOM_MODELID_DVD, (UINT32)&(ui_dvd_option), sizeof(UINT8)) != 0)
            {    
                //p_dvd_info->b_dvd_support = FALSE;
                *(BOOL *)pv_get_info = FALSE; /* default value is false */
                return RMR_DRV_ERROR;
            }
            else
            {
                *(BOOL *)pv_get_info = (ui_dvd_option == 1) ? TRUE : FALSE;
            }
            break;
        }
        
        case DRV_CUSTOM_CUST_SPEC_TYPE_PCB_REGION:
        {
            //DRV_MODELID_DEST * p_dest_info = NULL;
            
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(UINT8)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_TYPE_PCB_REGION] Invalid parameter\n");
                return RMR_INV_ARG;
            }
            
            //p_dest_info = (DRV_MODELID_DEST *)pv_get_info;            
            if (EEPROM_Read((UINT64)DRV_CUSTOM_MODELID_REGION, (UINT32)pv_get_info, sizeof(UINT8)) != 0)
            {    
                //p_dest_info->e_region = D_MODELID_PAA; /* default is PAA */
                *(UINT8 *)pv_get_info = 0;/* default is PAA */
                return RMR_DRV_ERROR;
            }
            break;
        }    

        case DRV_CUSTOM_CUST_SPEC_GET_TEMP_SENSOR_VALUE:
        {
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(UINT32)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_GET_TEMP_SENSOR_VALUE] Invalid parameter\n");
                return RMR_INV_ARG;
            }
            
            *(UINT32 *)pv_get_info = CustomQueryTempRawData();
            break;
        }
#ifdef CC_Factory2K12
#ifdef CUST_SOEM_DRV
        case DRV_CUSTOM_CUST_SPEC_WB_EDID_WRITE_STATUS:
        {
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(UINT32)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_GET_TEMP_SENSOR_VALUE] Invalid parameter\n");
                return RMR_INV_ARG;
            }
            
            *(UINT32 *)pv_get_info = u4_WB_EDID_Write_return;
            break;
        }
#endif
        /* Liew : Hotel Clock Related */
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_CLK_MODE:
        {
            HTLCLK_GetMode((UINT8 *)pv_get_info);
            break;
        }
        
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_CLK_TIME:
        {
            DRV_CUSTOM_HTL_CLK_TIME_T *pv_time;
            BOOL bRet;

            pv_time = (DRV_CUSTOM_HTL_CLK_TIME_T*)pv_get_info;
            bRet = HTLCLK_GetTime(&pv_time->ui1_hour, &pv_time->ui1_minute, 
                                  &pv_time->ui1_second, &pv_time->ui1_day_of_week,
                                  &pv_time->ui1_is_valid);

            if(FALSE == bRet)
            {
                LOG(5, "HTL CLK Get Time ERROR!\n");
            }
            break;
        }
#if 0
        /* Liew: END Hotel Clock Related */
		/* Ooi Start - IP GET NOISE TH */
        case DRV_CUSTOM_CUST_SPEC_GET_IP_NOISE_TH:
        {       
            sony_IpGetTh ((CUST_IP_NOISE_TH_INFO_T *)pv_get_info);
            break;
        }
#endif
        /* Aizul: Start Hotel Volume Related */
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_VOL_MODE:      /* Aizul: Query Hotel Volume module's mode */
        {
            HTLVOL_GetMode((UINT8 *)pv_get_info);
            break;
        }
        
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_VOL_INITVOL:   /* Aizul: Query Hotel Volume initial volume */
        {
            HTLVOL_GetInitVol((UINT8 *)pv_get_info);
            break;
        }
        
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_VOL_STEPTIMER:   /* Aizul: Query Hotel Volume step timer */
        {
            HTLVOL_GetStepTimer((UINT8 *)pv_get_info);
            break;
        }
        
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTL_VOL_VOLLVL:    /* Aizul: Query Hotel Volume volume level */
        {
            HTLVOL_GetVolLvl((UINT8 *)pv_get_info);
            break;
        }
        /* Aizul: End Hotel Volume Related */
        
        /* Aizul: START Hotel SI */       
        case DRV_CUSTOM_CUST_SPEC_TYPE_HTLSI_ONLINEMODE:   /* Aizul: Query Hotel SI module's online mode */
        { 
            HTLSI_GetOnlineMode((UINT8 *)pv_get_info);
            break;
        }
        /* Aizul: END Hotel SI */      
#endif //#ifdef CC_Factory2K12   

            
#if 1 
        case DRV_CUSTOM_CUST_SPEC_DISP_PANEL_ID:
            //Printf("!!!!%s : DRV_CUSTOM_DISP_TYPE_PANEL_ID\n", __func__);  //ke_test
            *((UINT32*)pv_get_info) = GetCurrentPanelIndex();
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_PANEL_NAME:
            //Printf("!!!!%s : DRV_CUSTOM_DISP_TYPE_PANEL_NAME\n", __func__);  //ke_test
#if 0 
            x_strcpy((CHAR *)pv_get_info, GetCurrentPanelName());
#else
            x_strncpy((CHAR *)pv_get_info, (CHAR *)FlashPanel_GetIDString(), x_strlen((CHAR *)FlashPanel_GetIDString()));
#endif
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_PANEL_TOTAL_NUM:
            *((UINT32*)pv_get_info) = PANEL_TOTAL_NUMBER;
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_PANEL_BACK_LIGHT_HI:
            *((UINT8 *) pv_get_info) = PANEL_GetBacklightHigh();
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_PANEL_BACK_LIGHT_LOW:
            *((UINT8 *) pv_get_info) = PANEL_GetBacklightLow();
            break;
		case DRV_CUSTOM_CUST_SPEC_DISP_PANEL_PHYSICAL_WIDTH:
            *((UINT16 *) pv_get_info) = FlashPanel_GetWidthInmm(); 
			Printf("[DI]Width:%d mm\n",*((UINT16 *) pv_get_info));
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_PANEL_PHYSICAL_HEIGHT:
            *((UINT16 *) pv_get_info) = FlashPanel_GetHeightInmm(); 
			Printf("[DI]Height:%d mm\n",*((UINT16 *) pv_get_info));
            break;		
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_R_GAIN:
            *((UINT16 *) pv_get_info) = wDrvGetRGain1(SV_VP_MAIN);
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_G_GAIN:
            *((UINT16 *) pv_get_info) = wDrvGetGGain1(SV_VP_MAIN);
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_B_GAIN:
            *((UINT16 *) pv_get_info) = wDrvGetBGain1(SV_VP_MAIN);
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_R_OFFSET:
            *((UINT16 *) pv_get_info) = (UINT16)dwDrvGetROffset11(SV_VP_MAIN);
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_G_OFFSET:
            *((UINT16 *) pv_get_info) = (UINT16)dwDrvGetGOffset11(SV_VP_MAIN);
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_REG_WB_B_OFFSET:
            *((UINT16 *) pv_get_info) = (UINT16)dwDrvGetBOffset11(SV_VP_MAIN);
            break;
#if 0
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_MAGIC:
            {
                (((WB_T *) pv_get_info)->ui1_magic[0]) = bApiEepromReadByte( EEP_DISP_WB_MAGIC00);
                (((WB_T *) pv_get_info)->ui1_magic[1]) = bApiEepromReadByte( EEP_DISP_WB_MAGIC00+1);
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_R_GAIN:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_offset, ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_get_info)->ui1_color_temp);
                ui2_offset = EEP_DISP_WB_COOL_R_GAIN_LO+(ui1_clr_temp*6);
                ui1_lo = bApiEepromReadByte( ui2_offset);
                ui1_hi = bApiEepromReadByte( ui2_offset+1);
                ui2_tmp = ((UINT16)ui1_hi<<8) + ((UINT16)ui1_lo);
                (((WB_T *) pv_get_info)->ui2_val) = ui2_tmp;
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_G_GAIN:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_offset, ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_get_info)->ui1_color_temp);
                ui2_offset = EEP_DISP_WB_COOL_R_GAIN_LO+2+(ui1_clr_temp*6);
                ui1_lo = bApiEepromReadByte( ui2_offset);
                ui1_hi = bApiEepromReadByte( ui2_offset+1);
                ui2_tmp = ((UINT16)ui1_hi<<8) + ((UINT16)ui1_lo);
                (((WB_T *) pv_get_info)->ui2_val) = ui2_tmp;
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_B_GAIN:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_offset, ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_get_info)->ui1_color_temp);
                ui2_offset = EEP_DISP_WB_COOL_R_GAIN_LO+4+(ui1_clr_temp*6);
                ui1_lo = bApiEepromReadByte( ui2_offset);
                ui1_hi = bApiEepromReadByte( ui2_offset+1);
                ui2_tmp = ((UINT16)ui1_hi<<8) + ((UINT16)ui1_lo);
                (((WB_T *) pv_get_info)->ui2_val) = ui2_tmp;
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_R_OFFSET:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_offset, ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_get_info)->ui1_color_temp);
                ui2_offset = EEP_DISP_WB_COOL_R_GAIN_LO+24+(ui1_clr_temp*6);
                ui1_lo = bApiEepromReadByte( ui2_offset);
                ui1_hi = bApiEepromReadByte( ui2_offset+1);
                ui2_tmp = ((UINT16)ui1_hi<<8) + ((UINT16)ui1_lo);
                (((WB_T *) pv_get_info)->ui2_val) = ui2_tmp;
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_G_OFFSET:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_offset, ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_get_info)->ui1_color_temp);
                ui2_offset = EEP_DISP_WB_COOL_R_GAIN_LO+26+(ui1_clr_temp*6);
                ui1_lo = bApiEepromReadByte( ui2_offset);
                ui1_hi = bApiEepromReadByte( ui2_offset+1);
                ui2_tmp = ((UINT16)ui1_hi<<8) + ((UINT16)ui1_lo);
                (((WB_T *) pv_get_info)->ui2_val) = ui2_tmp;
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_EEP_WB_B_OFFSET:
            {
                UINT8   ui1_hi, ui1_lo, ui1_clr_temp;
                UINT16  ui2_offset, ui2_tmp;

                ui1_clr_temp = (((WB_T *) pv_get_info)->ui1_color_temp);
                ui2_offset = EEP_DISP_WB_COOL_R_GAIN_LO+28+(ui1_clr_temp*6);
                ui1_lo = bApiEepromReadByte( ui2_offset);
                ui1_hi = bApiEepromReadByte( ui2_offset+1);
                ui2_tmp = ((UINT16)ui1_hi<<8) + ((UINT16)ui1_lo);
                (((WB_T *) pv_get_info)->ui2_val) = ui2_tmp;
            }
            break;
#endif
        case DRV_CUSTOM_CUST_SPEC_DISP_HDCP_KSV0:
            *((UINT8 *) pv_get_info) = u1RegRead1B(SHD_BKSV0_2 + 0xC00);
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_HDCP_KSV1:
            *((UINT8 *) pv_get_info) = u1RegRead1B(SHD_BKSV0_3 + 0xC00);
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_HDCP_KSV2:
            *((UINT8 *) pv_get_info) = u1RegRead1B(SHD_BKSV1_0 + 0xC00);
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_HDCP_KSV3:
            *((UINT8 *) pv_get_info) = u1RegRead1B(SHD_BKSV1_1 + 0xC00);
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_HDCP_KSV4:
            *((UINT8 *) pv_get_info) = u1RegRead1B(SHD_BKSV1_2 + 0xC00);
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_DYN_GAMMA_MAGIC_NUM:
            {
                UINT8   ui1_i, ui1_tmp;
                for(ui1_i=0; ui1_i<8; ui1_i++)
                {
                    ui1_tmp = bApiEepromReadByte( EEP_DYN_GAMMA_MAGIC00 + ui1_i );
                    (((DYN_GAMMA_T *) pv_get_info)->ui1_magic_num[ui1_i]) = ui1_tmp;
                }
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_DYN_GAMMA:
            {
                UINT8   ui1_point = (((DYN_GAMMA_T *) pv_get_info)->ui1_gamma_point),
                        ui1_lo=0, ui1_hi=0, ui1_i;
                UINT16  ui2_offset, ui2_val[3];

                for(ui1_i=0; ui1_i<3; ui1_i++)
                {
                    ui2_offset = (EEP_DYN_GAMMA_MAGIC07+1) + (UINT16)ui1_i*22 + (UINT16)ui1_point*2;
                    ui1_lo = bApiEepromReadByte( ui2_offset);
                    ui1_hi = bApiEepromReadByte( ui2_offset+1);
                    ui2_val[ui1_i] = ((UINT16)ui1_hi<<8) + ((UINT16)ui1_lo);
                }
                (((DYN_GAMMA_T *) pv_get_info)->ui2_r) = ui2_val[0];
                (((DYN_GAMMA_T *) pv_get_info)->ui2_g) = ui2_val[1];
                (((DYN_GAMMA_T *) pv_get_info)->ui2_b) = ui2_val[2];
            }
            break;

        case DRV_CUSTOM_CUST_SPEC_DISP_BLUE_STRETCH:
            *((UINT8 *) pv_get_info) = bDrvGetBlueStretchOnOff();
            break;

        case DRV_CUSTOM_CUST_SPEC_DISP_CVBS_AUTO_COLOR:
            *((UINT8 *) pv_get_info) = fgApiVideoIsEvtFlgSet(VDO_FLG_TVDAUTO_DOING);
			break;
        case DRV_CUSTOM_CUST_SPEC_DISP_CVBS_D_GAIN:
            #if ENABLE_SOEM_PQ
            *((UINT16 *) pv_get_info) = bDrvGetTVDADCDGain();
            #endif            
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_CVBS_A_GAIN:
            #if ENABLE_SOEM_PQ
            *((UINT8 *) pv_get_info) = bDrvGetTVDADCGain();
            #endif            
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_Y_LEVEL:
            {
                UINT16 aui2_YCbCr_buf[3];
                vDrvSceDbgInfo( (PANEL_GetPanelWidth()/2), (PANEL_GetPanelHeight()/2), aui2_YCbCr_buf, NULL);
                *((UINT16 *) pv_get_info) = aui2_YCbCr_buf[0];
            }
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_PQ_VERSION:
            x_strncpy((CHAR *)pv_get_info, (CHAR *)bApiFlashPqGetVersion(0, FLASHPQ_XML_VER), strlen((CHAR *)bApiFlashPqGetVersion(0, FLASHPQ_XML_VER)));
            break;
        case DRV_CUSTOM_CUST_SPEC_DISP_PQ_GAMMA_VER:
            x_strncpy((CHAR *)pv_get_info, (CHAR *)bApiFlashPqGetVersion(0, FLASHPQ_GAMMA_VER), strlen((CHAR *)bApiFlashPqGetVersion(0, FLASHPQ_GAMMA_VER)));
		   break;
        case DRV_CUSTOM_CUST_SPEC_DISP_PQ_SCE_VER:
            x_strncpy((CHAR *)pv_get_info, (CHAR *)bApiFlashPqGetVersion(0, FLASHPQ_SCE_VER), strlen((CHAR *)bApiFlashPqGetVersion(0, FLASHPQ_SCE_VER)));
			break;
        case DRV_CUSTOM_CUST_SPEC_DISP_PQ_QTY_VER:
            x_strncpy((CHAR *)pv_get_info, (CHAR *)bApiFlashPqGetVersion(0, FLASHPQ_QTY_VER), strlen((CHAR *)bApiFlashPqGetVersion(0, FLASHPQ_QTY_VER)));
			break;

        case DRV_CUSTOM_CUST_SPEC_DISP_PANEL_FLASH_VERSION:
            x_strncpy((CHAR *)pv_get_info, (CHAR *)FlashPanel_GetVersion(), strlen((CHAR *)FlashPanel_GetVersion()));
		   break;
        case DRV_CUSTOM_CUST_SPEC_DISP_PANEL_FLASH_NUMBER:
            *((UINT32 *) pv_get_info) = FlashPanel_GetPanelNumber();
            break;

        case DRV_CUSTOM_CUST_SPEC_DISP_PANEL_FLASH_ID_LIST:
            FlashPanel_ListAllPanelID( (UINT8 *) pv_get_info );
            break;

        case DRV_CUSTOM_CUST_SPEC_SERVO_ADC:
            {
                UINT32  u4Val = 0, u4Channel = (UINT32)(((FAC_SERVO_ADC_T *) pv_get_info)->ui1_servo_pin);
                if(u4Channel > TOTAL_SERVOADC_NUMBER)
                    return RMR_INV_ARG;
                u4Channel += SERVO0;
                do {
                    u4Val = PDWNC_ReadServoADCChannelValue(u4Channel);
                } while (u4Val != PDWNC_ReadServoADCChannelValue(u4Channel));

                (((FAC_SERVO_ADC_T *) pv_get_info)->i4_val) = (INT32)u4Val;
            }
            break;

        case DRV_CUSTOM_CUST_SPEC_HDMI_EDID_DATA:
        {
            static UINT8    *aui1_edid;
            UINT8           ui1_port = 1;

            aui1_edid = ((UINT8 *) pv_get_info);

            switch(aui1_edid[0])
            {
            case 0: //HDMI1
                ui1_port = 1;
                //ui1_port = 2; //Port 1 & 2 are with same EDID
                break;
            case 1: //HDMI2
                ui1_port = 3;
                break;
            case 2: //HDMI3
                ui1_port = 4;
                break;
            default:
                return RMR_INV_ARG;
                break;
            }

            u1HDMI_GetEdidData(ui1_port, aui1_edid, 256);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_VGA_EDID_DATA:
        {
            static UINT8    *aui1_edid;

            aui1_edid = ((UINT8 *) pv_get_info);

            u1VGA_GetEdidData(aui1_edid, 128);
            break;
        }

        case DRV_CUSTOM_CUST_SPEC_TUNER_REG:
        /* For Sony tuner:rb211, whose I2C is connected with I2C gateway of Sony Demod:cxd2828 */
        {
            UINT8   aui1_addr[2] = {0}, aui1_buffer[256] = {0};
            //UCHAR   ucI2cAddr = 0xD8;
            UINT8   GatewaySlaveAddr = 0xD8; /* Demod Slave Address */
            INT32   GatewaySubAddr = 9, wordAddr = 0;
            UINT16  ui2_ret = 0, ui2_cnt = 0;
            UINT32  u4DemodBusId = 0;

            DRVCUST_OptQuery(eDemodI2cBusID,&u4DemodBusId);

            /* Write I2C Gateway */
            aui1_addr[0] = 0xC0; // Tuner Slave address
            aui1_addr[1] = (((FAC_TUNER_REG_T *) pv_get_info)->ui1_sub_addr); // Tuner sub address
            ui2_cnt = 2;
            ui2_ret = SIF_X_Write(u4DemodBusId, 0x200, GatewaySlaveAddr, 1, GatewaySubAddr, aui1_addr, ui2_cnt);
            if(ui2_ret != ui2_cnt)
            {
                (((FAC_TUNER_REG_T *) pv_get_info)->ui2_ret) = ui2_ret;
                Printf("SIF_X_Write failed: %02X-%02X at line %d : d_Soem_cust_spec_get()\n", GatewaySlaveAddr, GatewaySubAddr, __LINE__);
                break;
            }

            // I2C address in MTK function should be in 8bit form
            ui2_cnt = (((FAC_TUNER_REG_T *) pv_get_info)->ui2_cnt);
            wordAddr = (GatewaySubAddr << 8) | (aui1_addr[0] | 0x01); // I2C Read
            ui2_ret = SIF_X_Read( u4DemodBusId, 0x200, GatewaySlaveAddr, 2, wordAddr, aui1_buffer, ui2_cnt);
            (((FAC_TUNER_REG_T *) pv_get_info)->ui2_ret) = ui2_ret;

            if(ui2_ret == 0)
            {
                Printf("SIF_X_Read failed: %02X-%02X at line : d_Soem_cust_spec_get()\n", GatewaySlaveAddr, wordAddr, __LINE__);
            }
            else
            {
                x_memcpy((((FAC_TUNER_REG_T *) pv_get_info)->aui1_val), aui1_buffer, ui2_cnt);
            }
            break;
        }

#endif

#ifndef CC_MTK_LOADER
		case DRV_CUSTOM_CUST_SPEC_TYPE_KEY_HEADER:
		{
			DRV_CUST_KEY_HDR_T* pt_header;
			if(pv_get_info == NULL)
			{
				return -1;
			}
			pt_header = (DRV_CUST_KEY_HDR_T*)pv_get_info;
			if (pt_header->t_size != 64)
			{
				Printf("[D-Interface] key header size fail %d !=64\n",pt_header->t_size);
				return -1;
			}
			ui4GetKeyHeader(pt_header->i1_key_hdr, pt_header->ui1_buf);
			break;
		}

		case DRV_CUSTOM_CUST_SPEC_TYPE_KEYS:
		{
			DRV_CUST_KEY_HDR_T* pt_header;
			if(pv_get_info == NULL)
			{
				return -1;
			}
			pt_header = (DRV_CUST_KEY_HDR_T*)pv_get_info;
			/*if (pt_header->t_size != 64)
			{
				Printf("[D-Interface] key header size fail %d !=64\n",pt_header->t_size);
				return -1;
			}*/
			
			ui4GetNANDKey(pt_header->i1_key_hdr, pt_header->ui1_buf, pt_header->t_size);
			break;
		}			
#endif

#ifndef CC_MTK_LOADER    
#if 1//def STELLAR_LED_SPEC
		case DRV_CUSTOM_CUST_SPEC_LED_MODE:
		{
			UINT16 u2LedMode = 0;
			DTVCFG_T rDtvCfg;
			EEPDTV_GetCfg(&rDtvCfg);
			if(rDtvCfg.u1Flags & DTVCFG_FLAG_POWER_LEDOFF)
			{
				u2LedMode = 0;
			}
			else
			{
				u2LedMode = 1;
			}
			*((UINT16*)pv_get_info) = u2LedMode;
			Printf("[D-Interface] LED mode is %s\n",u2LedMode?"ON":"OFF");
			break;
		}
#endif/* STELLAR_LED_SPEC */
#endif

		case DRV_CUSTOM_CUST_SPEC_TYPE_GET_LOCATEL_SETTING:
		{
			Printf("@@@@@@@@@@@@@@%s  %d\n",__FUNCTION__,__LINE__);
			if(pv_get_info != NULL)
			{
				//UINT8 ui1Size=0;
				/*for(ui1Size=0; ui1Size< *pz_size; ui1Size++)
				{
					*((UINT8*)pv_get_info+ui1Size) = aLocatelSetting[ui1Size];
					Printf("@@@@@@@@@@@%s %d\n",__FUNCTION__,*((UINT8*)pv_get_info+ui1Size));
				}*/
				//x_memcpy(pv_get_info, aLocatelSetting,*pz_size);
				*(UINT8 *)pv_get_info = aLocatelSetting;
			}
			//x_memcpy(pv_get_info, aLocatelSetting,*pz_size);
			break;
		}
				
#ifdef ENABLE_CA_SUPPORT//FAC_CMD_FOR_CI
			//DRV_CUSTOM_CUST_SPEC_CI_PLUG_IN,
			case DRV_CUSTOM_CUST_SPEC_CI_PLUG_IN:
			{
				*((UINT16*)pv_get_info) = PCMCIA_DetectCard();
				break;
			}
			//DRV_CUSTOM_CUST_SPEC_CI_DESCRAMBLE,
			case DRV_CUSTOM_CUST_SPEC_CI_DESCRAMBLE:
			{
				UINT32 au4Status[2];
				MPV_QuerySignal(au4Status);
				*((UINT16*)pv_get_info) = (au4Status[1]<<8 | au4Status[0]);
				break;
			}
#endif
        case DRV_CUSTOM_CUST_SPEC_TYPE_DTV_PACKET_RX_STATUS:
		{
		    UINT32 u4RecvPackets,u4RDropPackets;
			UINT8 u1TsLockStatus=0;
            DMX_GetPacketStatus(0,100,&u4RecvPackets,&u4RDropPackets);
			if(u4RecvPackets>0)
			{
			    u1TsLockStatus=1;
			}
			*((UINT8*)pv_get_info) =u1TsLockStatus;
			Printf("DMX Status=%d(%d,%d)\n",u1TsLockStatus,u4RecvPackets,u4RDropPackets);
		}
		break;
		
		case DRV_CUSTOM_CUST_SPEC_READ_ECC_UNCRRCT:
		{
			UINT32 u4EccError=0;	
			UINT32 u4BadBlock;
			
			NAND_CheckEcc(&u4EccError,&u4BadBlock);
			*(UINT32 *)pv_get_info =u4EccError;
			break;
		}
        case DRV_CUSTOM_CUST_SPEC_TYPE_TCON_NVM_READ:
        {
            UINT16 ret;
            WB_TCON_NVM_T* d_tcon_nvm = (WB_TCON_NVM_T*)pv_get_info;
			SelfDiagRequirePanelIDRead();
            GPIO_SetOut(PANEL_BINT_PIN, PIN_HIGH);
            ret = SIF_X_Read(BUS_ID, CLK_DIV, TCON_NVM_SLVADDR, ADDR_LENGTH, d_tcon_nvm->subAddr, d_tcon_nvm->data_buffer, d_tcon_nvm->length);
            if ( ret == SIF_ERROR_RETURN ){
                return RMR_DRV_ERROR;
            }
            x_thread_delay(100);
            GPIO_SetOut(PANEL_BINT_PIN, PIN_LOW);
			SelfDiagReleasePanelIDRead();
            break;

        }
		case DRV_CUSTOM_CUST_SPEC_TYPE_V_COM_DRV:
		{
			*(UINT32 *)pv_get_info = FlashPanel_GetVCOMDRV();
            Printf("[D-Interface] V-COM Type is %s\n",FlashPanel_GetVCOMDRV());
			break;
		}

		case DRV_CUSTOM_CUST_SPEC_TYPE_SCART_OUT:
		{
			*(BOOL *)pv_get_info = gbScartOut;
			break;
		}
		case DRV_CUSTOM_CUST_SPEC_TYPE_DVBS_LNB_VOL_CTRL:
		{
		   #if  defined(SYS_DVBS_SUPPORT) && defined(CC_Factory2K12)
			if(pv_get_info)TunerDVBSFac_GetLnbVol(1,(UINT8 *)pv_get_info);
			#endif
		}
		break;
		case DRV_CUSTOM_CUST_SPEC_TYPE_DVBS_LNB_TONE_CTRL:
		{
		   #if  defined(SYS_DVBS_SUPPORT) && defined(CC_Factory2K12)
			if(pv_get_info)TunerDVBSFac_GetLnb22KStatus(1,(UINT8 *)pv_get_info);
			#endif
		}
		break;
		case DRV_CUSTOM_CUST_SPEC_TYPE_DVBS_LNB_SHORT_STATUS:
		{
		   #if  defined(SYS_DVBS_SUPPORT) && defined(CC_Factory2K12)
			if(pv_get_info)TunerDVBSFac_GetLnbShortStatus(1,(UINT8 *)pv_get_info);
			#endif
		}
		break;
		case DRV_CUSTOM_CUST_SPEC_TYPE_DEMOD_MOUNT_STATUS:
		{
		   #if  defined(SYS_DVBS_SUPPORT) && defined(CC_Factory2K12)
			if(pv_get_info)
			{
			*(UINT8 *)pv_get_info=TunerDVBSFac_GetDemodMountStatus(0);
			}
			#endif
		}
		break;
		case DRV_CUSTOM_CUST_SPEC_TYPE_LNB_MOUNT_STATUS:
		{
		   #if  defined(SYS_DVBS_SUPPORT) && defined(CC_Factory2K12)
			if(pv_get_info)
			{
			*(UINT8 *)pv_get_info=TunerDVBSFac_GetLNBMountStatus(0);
			}
			#endif
		}
		break;	
       case DRV_CUSTOM_CUST_SPEC_TYPE_IS_SIGNAL_LOSS:
	   		{
			if(pv_get_info)
			{
			#if 0//def CC_Factory2K12
		    *(UINT8 *)pv_get_info= Tuner_IsSignalLoss(); 
			#else
			*(UINT8 *)pv_get_info= 1;
			#endif
			}
		}
		break;
		case DRV_CUSTOM_CUST_SPEC_TYPE_GAMMA_MUTE_LVL:
		{
			if(pv_get_info)
			{
    		    *(UINT16 *)pv_get_info = u1DRVCUST_GetGamma_mute_lvl();
			}
		}
        break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_GET_TVD_LOCK:
        {
            UINT8   tv_lock = FALSE;
            if ((pv_get_info == NULL) || (*(pz_size) != sizeof(BOOL)))
            {
                LOG(2, "[DRV_CUSTOM_CUST_SPEC_TYPE_GET_TVD_LOCK] Invalid parameter\n");
                return RMR_DRV_ERROR;
            }
            tv_lock = bTvd3dSignalStatus();
            Printf("tvd_lock is :%d\n",tv_lock);
            if(tv_lock == 3)
            {
               *((UINT8 *)pv_get_info) = 0;
            }
            else
            {
                *((UINT8 *)pv_get_info) = 1;
            }
            Printf("pv_get_info is :%d\n",*((UINT8 *)pv_get_info));
        }
        break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_GET_TV_UP_TIME:
        {
            HAL_TIME_T halTime;
            HAL_GetTime( &halTime );
            *((UINT32 *)pv_get_info) = halTime.u4Seconds;
        }
        break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_SOUND_SYSTEM:
	    {
             *(UINT16*)(pv_get_info) = (UINT16)AUD_DspGetTvSrcMode();
        }	        
        break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_SOUND_DET_MODE:
	    {
             *(UINT16*)(pv_get_info) = (UINT16)DSP_GetAudChlInfo(AUD_DEC_AUX);
        }	        
		break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_SOUND_SET_MODE:
        {
             *(UINT16*)(pv_get_info) = (UINT16)AUD_DspGetSoundMode(AUD_DEC_AUX);
        }	        
		break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_SOUND_MAIN_CARR_LVL:
	    {
		    *(INT16*)(pv_get_info) = AudAtvMainCarrierLvlQuery();
        }	
		break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_SOUND_SUB_CARR_LVL:
	    {
		  *(INT16*)(pv_get_info) = AudAtvSubCarrierLvlQuery();
        }		        
		break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_SOUND_CUE_LVL:
        {
		    *(INT16*)(pv_get_info) = AudAtvPilotLvlQuery();
        }
		break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_SOUND_MAIN_NOISE_LVL:
	    {
		    *(INT16*)(pv_get_info) = AudAtvMainNoiseLvlQuery();
        }	        
		break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_SOUND_SUB_NOISE_LVL:
	    {
		    *(INT16*)(pv_get_info) = AudAtvSubNoiseLvlQuery();
        }        
		break;
        case DRV_CUSTOM_CUST_SPEC_TYPE_SOUND_NICAM_ERROR:
	    {
	        *(UINT32*)(pv_get_info) = AudAtvNicamErrorQuery();	  	
        }        
        break;
        default:
            #ifdef DRV_3RD_PARTY_CUSTOM_CUST_SPEC_GET
            return DRV_3RD_PARTY_CUSTOM_CUST_SPEC_GET(e_cust_spec_type,
                                                      pv_get_info,
                                                      pz_size);
            #else
            return RMR_INV_ARG;            
            #endif
    }

    return RMR_OK;
}
#ifndef CC_MTK_LOADER
#ifdef CC_Factory2K12
extern void sonyDrv_RegisterCallback(void); /* BEGIN SONY, ramesh, 07/08/09 */
//2.Customer initial function add by Hua 20090609
void d_sony_2k12_cust_drv_init(void)
{
    sonyDrv_RegisterCallback();  /* END SONY, ramesh, 07/08/09 */
    /*regist your ir event callback*/
    /* EEP Map Check */
    EEP_map_check();
    /* RGB Init */
    RGB_Init();
    /* Temp Sensor Init */
    //TEMP_SENSOR_Init();

	/* your device initial function here*/
    //Am_ligtht_sensor_dev_init();
    //Dyn_BacklightCtrl_Init();

    //SIG_BSTR_Init();
    //SONY_TUNER_Init(); /* 20090903 Sony Chow: Tuner Init function*/

	/* Hotel Clock Init */
    //HTLCLK_Init();
                                                                                                                                /* Hotel Volume Init */
    HTLVOL_Init(); 
    //HTLSI_Init();

}
#else
void d_sony_2k12_cust_drv_init(void)
{
}
#endif
#endif



