/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
#include "general.h"
#include "hw_vdoin.h"
#include "util.h"
#include "pe_if.h"
#include "drv_nr.h"
#include "video_def.h"
#include "drv_video.h"
#include "api_backlt.h"
#include "drv_contrast.h"
#include "api_eep.h"
#include "eeprom_if.h"
#include "eepdef.h"
#include "drv_tvd.h"
#include "vdo_misc.h"
#include "vdp_drvif.h"
#include "drv_scpos.h"
#include "eeprom_if.h"
#include "u_drv_cust.h"
#include "drvcust_if.h"
#include "drv_hdtv.h"
#include "drv_mpeg.h"
#include "x_debug.h"
#include "x_hal_5381.h"
#include "drv_vdoclk.h"
#include "drv_adcset.h"
#include "drv_autocolor.h"
#include "source_select.h"
#include "drv_ycproc.h"
#include "drv_contrast.h"
#include "drv_pq_cust.h"
#include "drv_dvi.h"
#include "srm_drvif.h"
#include "drv_meter.h"
#include "drv_od.h"
#include "hw_ospe.h"
#include "hw_ycproc.h"
#include "nptv_debug.h"
#include "panel.h"
#include "drv_lcdim.h"
#include "drv_default.h"
#include "drv_upscaler.h"
#include "drv_tdtv_drvif.h"
#include "hw_nr.h"
#include "vdo_rm.h"
#include "drv_di.h"
#include "hw_sw.h"
#include "hw_di_int.h"
#ifdef CC_Factory2K12
#include "mute_if.h"
#include "osd_drvif.h"
#include "pd_atd_if.h"
#include "ATV/priv_drv/sony_drv_inc/pq_gamma_if.h"
#include "ATV/priv_drv/sony_drv_inc/Sony_drv_cb.h"
#include "ATV/priv_drv/sony_drv_inc/wb_pbm.h"


static SONY_DRV_CB_ST  callback_funcs; /* SONY, ramesh 21/08/09, memory wrapper function */
static BOOL _fgOSDStatusOn = FALSE;
#endif
#ifdef CC_PowerCons_Ctrl
#include "sony_PowerConsumptionCtrl.h"
#include "pcmcia_if.h"
#include "adac_if.h"
#include "mute_if.h"
#include "sv_const.h"
#ifdef SYS_DVBS_SUPPORT
#include TARGET_SPEC_DRV_CUST_CUSTOMIZED_HDR_FILE
#endif
#ifdef SYS_MHL_SUPPORT
#include "mhl_if.h"
#endif
#endif
static UINT8 gbSmartPicIndex = 0;
static UINT8 gbSceUi = 0;
static UINT8 gbOdUi = 0;
static UINT8 gbGammaUi = 0;
static UINT16 gu2RawDataTblIndex = 0;
static UINT16 gu2RawDataCaseIndex = 0;
static UINT8 IsInPhotoFrameMode = 0x0;
static UINT8 bPhotoFrameDisplayMode = 0xFF;

static UINT8 u1GammamuteLvl = 0xFF;    //For Zero-d dimming measure luminance table
// for NR auto R2C interval
//static UINT32 u4PreWidth = 0;
//static UINT8 bR2CInterval_1 = 5;
//static UINT8 bR2CInterval_2 = 6;
//static UINT8 bR2RSTFlag = SV_FALSE;
#ifdef CC_Factory2K12
static BOOL b_fginit = FALSE;    /* SONY, cheah 24/07/09, to ensure init before call ISR func */
extern void DRVCUST_Gamma_ISR(void);
extern UINT8 u1IsForceWBEepReload(void);
extern INT32 _iUsedCtlValue_R[33], _iUsedCtlValue_G[33], _iUsedCtlValue_B[33];
extern INT32 _iUsedColorTemp;
#endif
UINT16 wGammaMute[11][3];

#define SIPADAN_BZ 1
UINT8 fgpicturemodechange = SV_FALSE;
UINT8 fgpicturemodechange_done = SV_FALSE;

#define GAMMA_MAGIC00 0x10
#define GAMMA_MAGIC01 0x20

#define TCON_EEPROM_GAMMA_SIZE 257
#define TCON_EEPROM_GAMMA_TBL_ADDR_1 512
#define TCON_EEPROM_GAMMA_TBL_ADDR_2 898
#define TCON_EEPROM_GAMMA_TBL_ADDR_3 1284
#define TCON_EEPROM_OD_SIZE 289
#define TCON_EEPROM_OD_TBL_ADDR_1 3072
#define TCON_EEPROM_OD_TBL_ADDR_2 3434
#define TCON_EEPROM_OD_TBL_ADDR_3 3796
#define TCON_EEPROM_OD_TBL_ADDR_4 4158

#define BP_MAGIC1 0x3FF0
#define BP_MAGIC2 0x3FF1
#define BPBASE_G1 0x3FF2
#define BPBASE_G2 0x3FF3

#define SHP_MAGIC1 0x3FE8
#define SHP_MAGIC2 0x3FE9
#define SHPGAIN_HD 0x3FEA
#define SHPGAIN_SD 0x3FEB

#define CUSTOM_GAMMA_BASE 0x3C00
#define EN_PEDASTAL_IN_SUB_PATH 0

#define GAMMA_CTRL_POINT_NUM_PBM 57
#define GAMMA_CTRL_POINT_NUM2_PBM 33		//For salvia
#define GAMMA_CTRL_POINT_NUM_TRACK 11
#define GAMMA_10P_OFST_CTRL_POINT_NUM 11

#define NUM_OF_TEMP_GAMMA 0x80

typedef enum
{
    E_CT_COOL = 0,
    E_CT_NEUTRAL,
    E_CT_WARM1,
    E_CT_WARM2,
    E_CT_PHOTO,
    E_CT_MAX,
} E_CUST_COLOR_TEMP_MODE;

typedef enum
{
    E_SMPM_Vivid        = 0,
    E_SMPM_Vivid_Ind    = 1,
    E_SMPM_Standard     = 2,
    E_SMPM_Customer     = 3,
    E_SMPM_Cinema       = 4,
    E_SMPM_Sports       = 5,
    E_SMPM_Photo_Vivid  = 6,
    E_SMPM_Photo_Std    = 7,
    E_SMPM_Game         = 8,
    E_SMPM_Graphic      = 9,
    E_SMPM_MIN          = 10,
    E_SMPM_MAX          = 11,
} E_CUST_Smart_Picture_MODE;

static UINT8 bGammaInit = SV_FALSE;

extern UINT16 pPedestalMatrixISR[15];
UINT16 DRVCUST_pMecbethMatrix[15]={0};
UINT16 u2WBGain[SV_RGB_RGB] = {0x200, 0x200, 0x200};
UINT16 u2WBOfst[SV_RGB_RGB] = {0x00, 0x00, 0x00};
UINT8 bWBFlatPreOnoff = SV_FALSE;

extern UINT16 u2GammaDecodedTable[3][GAMMA_INDEX];

UINT8 bColorIndex=0xFF;
UINT8 bPreGammaSel=0xFF;
static UINT8 bAingFlag = FALSE;
UINT16 wHwGammaCurve[SV_RGB_RGB][GAMMA_INDEX];
static UINT8 bGammaLinear = SV_FALSE;

static UINT8 u1WB_GAM_RGB[SV_RGB_RGB][GAMMA_CTRL_POINT_NUM_TRACK];
static UINT8 u1WB_OFST_RGB[E_CT_MAX][SV_RGB_RGB][GAMMA_CTRL_POINT_NUM_TRACK];
static UINT8 u1WB_GAM_GAIN[GAMMA_CTRL_POINT_NUM_TRACK];
static UINT16 u2WB_INP_LVL[GAMMA_CTRL_POINT_NUM_TRACK];
static UINT16 u2WB_INP_LVL_Fac[GAMMA_CTRL_POINT_NUM_TRACK];
static UINT8 u1WB_BASE_GAIN_RGB_EEP[E_CT_MAX][SV_RGB_RGB];
#ifdef CC_MAPLE_CUST_DRV
static UINT8 u110POfst[E_CT_MAX][SV_RGB_RGB][GAMMA_10P_OFST_CTRL_POINT_NUM];
static UINT8 u1Gam10PGain[GAMMA_10P_OFST_CTRL_POINT_NUM];
static UINT16 u2Inplvl10P[GAMMA_10P_OFST_CTRL_POINT_NUM];
static INT32 i4Ctrl10POfst[SV_RGB_RGB][GAMMA_10P_OFST_CTRL_POINT_NUM];
static INT32 i4Gam10POfst[SV_RGB_RGB][GAMMA_INDEX];
#endif

#ifdef CC_MAPLE_CUST_DRV
//For Sakura
static UINT16 u2CtlPos_PBM[GAMMA_CTRL_POINT_NUM_PBM] = {0x00, 0x02, 0x04, 0x06, 0x08, 0x0A, 0x0C, 0x0E,
												     	0x10, 0x12, 0x14, 0x16, 0x18, 0x1A, 0x1C, 0x1E,
												  	 	0x20, 0x22, 0x24, 0x26, 0x28, 0x2A, 0x2C, 0x2E,
												  	 	0x30, 0x32, 0x34, 0x36, 0x38, 0x3A, 0x3C, 0x3E,
												   	 	0x40, 0x48, 0x50, 0x58, 0x60, 0x68, 0x70, 0x78,
												   	 	0x80, 0x88, 0x90, 0x98, 0xA0, 0xA8, 0xB0, 0xB8,
												   	 	0xC0, 0xC8, 0xD0, 0xD8, 0xE0, 0xE8, 0xF0, 0xF8, 0x100}; 
#else
//For Salvia
static UINT16 u2CtlPos_PBM[GAMMA_CTRL_POINT_NUM2_PBM] = {0x00, 0x04, 0x08, 0x0B, 0x10, 0x14, 0x18, 0x1C,
														  0x20, 0x24, 0x28, 0x2C, 0x30, 0x34, 0x38, 0x3C,
														  0x40, 0x4C, 0x58, 0x64, 0x70, 0x7C, 0x88, 0x94,
														  0xA0, 0xAC, 0xB8, 0xC4, 0xD0, 0xDC, 0xE8, 0xF4, 0x100};
#endif

//257 base value for tracking mode
/*
static INT32 u4WB_BASE_VALUE[GAMMA_INDEX] = {0,   16,   32,   48,   64,   80,   96,  112,  128,  144,  160,  176,  192,  208,  224,  240,
										   256,  272,  288,  304,  320,  336,  352,  368,  384,  400,  416,  432,  448,  464,  480,  496,
										   512,  528,  544,  560,  576,  592,  608,  624,  640,  656,  672,  688,  704,  720,  736,  752,
										   768,  784,  800,  816,  832,  848,  864,  880,  896,  912,  928,  944,  960,  976,  992, 1008,
										  1024, 1040, 1056, 1072, 1088, 1104, 1120, 1136, 1152, 1168, 1184, 1200, 1216, 1232, 1248, 1264,
										  1280, 1296, 1312, 1328, 1344, 1360, 1376, 1392, 1408, 1424, 1440, 1456, 1472, 1488, 1504, 1520,
										  1536, 1552, 1568, 1584, 1600, 1616, 1632, 1648, 1664, 1680, 1696, 1712, 1728, 1744, 1760, 1776,
										  1792, 1808, 1824, 1840, 1856, 1872, 1888, 1904, 1920, 1936, 1952, 1968, 1984, 2000, 2016, 2032,
										  2048, 2064, 2080, 2096, 2112, 2128, 2144, 2160, 2176, 2192, 2208, 2224, 2240, 2256, 2272, 2288,
										  2304, 2320, 2336, 2352, 2368, 2384, 2400, 2416, 2432, 2448, 2464, 2480, 2496, 2512, 2528, 2544,
										  2560, 2576, 2592, 2608, 2624, 2640, 2656, 2672, 2688, 2704, 2720, 2736, 2752, 2768, 2784, 2800,
										  2816, 2832, 2848, 2864, 2880, 2896, 2912, 2928, 2944, 2960, 2976, 2992, 3008, 3024, 3040, 3056,
										  3072, 3088, 3104, 3120, 3136, 3152, 3168, 3184, 3200, 3216, 3232, 3248, 3264, 3280, 3296, 3312,
										  3328, 3344, 3360, 3376, 3392, 3408, 3424, 3440, 3456, 3472, 3488, 3504, 3520, 3536, 3552, 3568,
										  3584, 3600, 3616, 3632, 3648, 3664, 3680, 3696, 3712, 3728, 3744, 3760, 3776, 3792, 3808, 3824,
										  3840, 3856, 3872, 3888, 3904, 3920, 3936, 3952, 3968, 3984, 4000, 4016, 4032, 4048, 4064, 4080, 4096};

*/
extern MMAppInfo sMMAppInfo;
extern UINT32 u4SCHCCoeff[][SCPQ_COEF_TBLSIZE];
extern UINT32 u4SCHYCoeff[][SCPQ_COEF_TBLSIZE];
extern UINT32 u4SCVYCCoeff[][SCPQ_COEF_TBLSIZE];

//extern PE_UI_RANGE_TBL rPEUITable;
#ifdef CC_FLIP_MIRROR_SUPPORT
//EXTERN UINT32 u4QueryFlipModule(UINT32 u4VdpId);
EXTERN UINT8 u1GetFlipMirrorConfig(void);
#endif

#ifdef CC_SUPPORT_PRE_UNMUTE
#include TARGET_SPEC_DRV_CUST_CUSTOMIZED_HDR_FILE
BOOL vCustom_UnmuteEnable(void)
{
    BOOL fgLogoFinish=FALSE;
	SIZE_T arg_sz=sizeof(fgLogoFinish);
    d_custom_cust_spec_get(DRV_CUSTOM_CUST_SPEC_TYPE_STARTUP_LOGO_STATUS,&fgLogoFinish,&arg_sz);
	return fgLogoFinish;
}
#endif

void sonyDrv_RegisterCallback(void);

UINT16 vApiFlashPqGetSceId()
{
    //This is sample code : SCE ID can be decided 
    //by panel id , ui setting, picture mode .....
    //UINT8 bPanelIdx = GetCurrentPanelIndex();

#ifdef LOAD_PANEL_FROM_FLASH_CUSTOM
			printf("\n\nPanel index = %d\n\n", (UINT32)FlashPanel_GetPQIndex(0));
			return ((UINT32)FlashPanel_GetPQIndex(0) * 16 + gbSceUi);
#else
		switch (gbSceUi)
		{
			case 0:
			default:
				return 0;
		}
#endif

}

UINT16 vApiFlashPqGetMinSceId()
{
    //This is sample code : SCE ID can be decided 
    //by panel id , ui setting, picture mode .....
    //UINT8 bPanelIdx = GetCurrentPanelIndex();

    return (1);
}

void vApiFlashPqSetSceId(UINT8 bIndex)
{
    gbSceUi = 5;

    //RF ATV source uses different SCE table.
    if(bGetSignalType(SV_VP_MAIN)==(UINT8)SV_ST_TV)
    {
        switch(bIndex)
        {
            case 1: // Live color Off
                gbSceUi = 5;//RF_Custom
                break;
            case 2: // Live color Low
                gbSceUi = (gbSmartPicIndex==5) ? 6 : 4;//Sport mode ? Sport curve ; RF_Standard
                break;
            case 3: // Live color Mid
                gbSceUi = 1;//1:RF_Vivid or 2:RF_Vivid_Ind or 3:RF_Vivid_Other
                break;
            case 4: // Live color High
                gbSceUi = 0;//RF_MAX
                break;
            default:
                break;
        }
    }
    else // Non RF
    {
        switch(bIndex)
        {
            case 1: // Live color Off
                gbSceUi = 11;//NonRF_Custom 
                break;
            case 2: // Live color Low
                switch(gbSmartPicIndex)
                {
                    case 5: gbSceUi = 12; break; // Sport  mode
                    case 7: gbSceUi = 15; break; //Photo_std pic mode
                    default: gbSceUi = 10; break; //Others: NonRF_Standard
                }
                break;
            case 3: // Live color Mid
                gbSceUi = 8;//8:NonRF_Vivid or 9:NonRF_Vivid_Ind or 10:NonRF_Vivid_Other
                break;
            case 4: // Live color High
                gbSceUi = 7;//NonRF_MAX
                break;
            default:
                break;                
        }
    }

    //Sport , Photo, Game mode  use specific SCE regardless of live color setting
    switch(gbSmartPicIndex)
    {
		case 8:// Game mode 
			gbSceUi = 13;
			break;
        case 6: // Photo  Vivid mode
            gbSceUi = 14;
            break;
    }

}

UINT16 vApiFlashPqGetOdId(void)
{
    //UINT8 bPanelIdx = GetCurrentPanelIndex();   
    
    return gbOdUi;
}

void vApiFlashPqSetOdId(UINT8 bIndex)
{
    gbOdUi = bIndex;
}

UINT16 vApiFlashPqGetGammaId()
{
    //This is sample code : GAMMA ID can be deside 
    //by panel id , ui setting, picture mode .....
    //UINT8 bPanelIdx = GetCurrentPanelIndex();

    switch (gbGammaUi)
    {
        case 1:
            return 0;
        case 2:
            return 1;
        case 3:
            return 2;
        default:
    		return 0;
	}

#if 0 // This is sample code for different gamma table under 3D PR Panel
    switch (gbGammaUi)
    {
        case 1:
            // 3D Using Shutter Glass : IS_LVDS_DISP_3D_SHUTTER
            // 3D Using Polarized Panel : IS_LVDS_DISP_3D_POLARIZED
            // 
            // u4DrvTDTV3DModeQuery() : Query 3D Mode
            
            if((u4DrvTDTV3DModeQuery() != E_TDTV_UI_3D_MODE_OFF) && (IS_LVDS_DISP_3D_POLARIZED))
            {               
                return 0;       // gamma table for PR panel
            }
            else
			{
                return 1;       // gamma table for normal state
            }
        default:
    		return 0;
	}
#endif    
}

void vApiFlashPqSetGammaId(UINT8 bIndex)
{
    gbGammaUi = bIndex;
}

UINT16 vApiFlashPqGetQtyId(UINT8 bIndex)
{
	UNUSED(bIndex);
#ifdef LOAD_PANEL_FROM_FLASH_CUSTOM
    printf("\n\nQty id No. by FlashPQ Panel %d\n\n", ((UINT16)FlashPanel_GetPQIndex(0)));
        return ((UINT16)FlashPanel_GetPQIndex(0));
#else	
    if (PANEL_GetPanelWidth() <= 1440)
    {
        return (1);
    }
    else
    {
        return (0);
    }
#endif	
}

EXTERN BOOL PWOn_Sequence;	
void vApiFlashPqSetSmartPicId(UINT8 bIndex)
{
#if 0    
#ifndef CC_DRIVER_PROGRAM    
	static UINT8 bPreNoDropMode=0xFF;  
	UINT8 bCurNoDropMode;
	UINT8 i4UiIndex, j;
	PE_UI_RANGE_T rUiVqMinMaxDft;

	Printf("Smart Pic XXXXX %d\n", bIndex);
#endif
#endif
    
    //if((PWOn_Sequence != SV_TRUE)&&(IO32ReadFldAlign(PIC_RGB_GAIN, PIC_GAIN_EN30)==1))
    #if 0
    if((PWOn_Sequence != SV_TRUE)&&(bIndex != gbSmartPicIndex)
        &&(IO32ReadFldAlign(PIC_RGB_GAIN, PIC_GAIN_EN30)==0))    //temp test
    {
        fgpicturemodechange = SV_TRUE;
        fgpicturemodechange_done = SV_FALSE;
    }
	#endif
    UINT16 u2CaseId=0;
    gbSmartPicIndex = bIndex;
	printf("\nSmart Pic Id =[ %d ]\n",gbSmartPicIndex);


    //update DBC parameter
    switch ((E_CUST_Smart_Picture_MODE)gbSmartPicIndex)
    {
        case E_SMPM_Vivid:
            u2CaseId = 1;
            //if(wReadQualityTable(QUALITY_AL_ON_1_OFF_0) == SV_OFF)
            //{u2CaseId = 0;}
            break;
        case E_SMPM_Standard:
            u2CaseId = 2;
            break;
        case E_SMPM_Customer:
        case E_SMPM_Sports:
            u2CaseId = 3;
            break;
        case E_SMPM_Cinema:
            u2CaseId = 4;
            break;
        case E_SMPM_Game:
            u2CaseId = 5;
            break;
        case E_SMPM_Graphic:
            u2CaseId = 6;
            break;
        case E_SMPM_Photo_Vivid:
        case E_SMPM_Photo_Std:
            u2CaseId = 7;
            break;
        default:
            u2CaseId = 0;
            break;
	}
    bApiFlashPqUpdateRawDataEx(0, u2CaseId);
#if 0
#ifndef CC_DRIVER_PROGRAM
#ifdef __KERNEL__   
	ASSERT(rPEUITable.ptUiPicMinMaxDftTbl!=NULL && gbSmartPicIndex<rPEUITable.bSmartPicNum);   
	// update all source UI default table, since the table is same
	for (i4UiIndex = 0; i4UiIndex < (UINT8)EVDP_VIS_MAX; i4UiIndex++)
	{
		for(j=0; j< rPEUITable.bUIPQItemNum; j++)
		{
			if(rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemType >=PE_ARG_BRIGHTNESS &&
				rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemType < PE_ARG_NS)
			{
/*				printf("rPEUITable.ptUiPicMinMaxDftTbl[%d][%d].rPQItemType| %x, Min %x, Max %x, Dft %x \n", gbSmartPicIndex,j,rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemType,
					rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemRange.i4Min, rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemRange.i4Max,
					rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemRange.i4Dft);
*/
				PE_SetUiRange(i4UiIndex, rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemType, 
														 &(rPEUITable.ptUiPicMinMaxDftTbl[gbSmartPicIndex][j].rPQItemRange));
			}
		}
}
#endif
#endif
#endif
}

UINT8 vApiFlashPqGetSmartPicId(void)
{
    return (gbSmartPicIndex);
}

UINT16 u2ApiFlashPqGetRawDataTblId(void)
{
    return gu2RawDataTblIndex;
}

UINT16 u2ApiFlashPqGetRawDataCaseId(void)
{
    return gu2RawDataCaseIndex;
}

void vApiFlashPqSetRawDataTblId(UINT16 u2Index)
{
    gu2RawDataTblIndex = u2Index;
}

void vApiFlashPqSetRawDataCaseId(UINT16 u2Index)
{
    gu2RawDataCaseIndex = u2Index;
}

UINT8 bApiFlashPqUpdateRawDataEx(UINT16 u2TblId, UINT16 u2CaseId)
{
    RAWDATA_INFO stRawInfo;

    vApiFlashPqSetRawDataTblId(u2TblId);
    vApiFlashPqSetRawDataCaseId(u2CaseId);

    bApiFlashPqUpdateRawData();
    bApiFlashPqGetRawDataInfo(&stRawInfo);
    bApiFlashPqSetRawData(stRawInfo.u2RegNum, stRawInfo.pRegTbl, stRawInfo.pDataTbl);

    return SV_TRUE;
}

// set photo frame mode flag, 
// 1: in photo frame mode
// 0. out of photo frame mode.
void DRVCUST_SetPhotoFrameMode(UINT8 bmode)
{
	IsInPhotoFrameMode = bmode;
	printf("\n\n--IsInPhotoFrameMode = %d---\n\n", IsInPhotoFrameMode);
}

UINT8 DRVCUST_GetPhotoFrameMode(void)
{
	return IsInPhotoFrameMode;
}

// Set 'Display Mode' under photo frame mode 
// 0: Image and Clock
// 1. Full Screen Image
// 2. Full Screen Clock
void DRVCUST_SetPhotoDisplayMode(UINT8 bmode)
{
	bPhotoFrameDisplayMode = bmode;
	LOG(1,"\nXXX-bPhotoFrameDisplayMode=[%d]--\n", bPhotoFrameDisplayMode);
}

UINT8 DRVCUST_GetPhotoDisplayMode(void)
{
	return bPhotoFrameDisplayMode;
}

void DRVCUST_HwInit(void)
{
#ifdef CC_Factory2K12
    //if (bApiEepromReadByte(EEP_PBM_GAMMA_ONOFF)==0xff)
    //{
    //    fgApiEepromWriteByte(EEP_PBM_GAMMA_ONOFF, 0x01);   //if EEPROM is initialized as FF, set to 1 as default
    //}
    //WB_Tracking_WriteDefaultToNVMIfNecessary();
    //WB_PBM_WriteDefaultToNVMIfNecessary(); 
#endif
    WB_EEP_Data_Init_To_Default();
    WB_Data_BootUp_Check();
    return;
}
void CheckToEnablePBM(void)
{
    vIO32WriteFldAlign(CUST_GAMMA_01, (DRVCUST_EepromReadByte(EEP_WB_LUT_ADJ_ON)==0x01), CUST_GAMMA_PBM_ON);
}

void DRVCUST_SetBrightnessPlusGain(void)
{
#if 0
	UINT8 bMagic1 = 0;
	UINT8 bMagic2 = 0;
	UINT8 bG1 = 0;
	UINT8 bG2 = 0;
    EEPROM_Read(BP_MAGIC1,(UINT32)&bMagic1, 1);
    EEPROM_Read(BP_MAGIC2,(UINT32)&bMagic2, 1);
	EEPROM_Read(BPBASE_G1,(UINT32)&bG1, 1);
    EEPROM_Read(BPBASE_G2,(UINT32)&bG2, 1);

	if((bMagic1 == 0x10) && (bMagic2 == 0x20))
	{
		vIO32WriteFldAlign(BRIGHT_PLUS_01, bG1, BRIGHT_PLUS_G1);
		vIO32WriteFldAlign(BRIGHT_PLUS_01, bG2, BRIGHT_PLUS_G2);
	}
#endif
	vIO32WriteFldAlign(ADAPTIVE_RGB_GAMMA_REG_01, 30, ADAPTIVE_RGB_GAMMA_DECAY_UPTH);
	vIO32WriteFldAlign(ADAPTIVE_RGB_GAMMA_REG_01, 0, ADAPTIVE_RGB_GAMMA_DECAY_LOWTH);
	vIO32WriteFldAlign(ADAPTIVE_RGB_GAMMA_REG_01, 1, ADAPTIVE_RGB_GAMMA_BLENING_EN);

	

}

void DRVCUST_SetSHPGain(void)
{
	UINT8 bMagic1 = 0;
	UINT8 bMagic2 = 0;
	UINT8 bGHD = 0;
	UINT8 bGSD = 0;
    EEPROM_Read(SHP_MAGIC1,(UINT32)&bMagic1, 1);
    EEPROM_Read(SHP_MAGIC2,(UINT32)&bMagic2, 1);
	EEPROM_Read(SHPGAIN_HD,(UINT32)&bGHD, 1);
    EEPROM_Read(SHPGAIN_SD,(UINT32)&bGSD, 1);

	if((bMagic1 == 0x10) && (bMagic2 == 0x20))
	{
		vIO32WriteFldAlign(TDSHPALL_ADAP_GAIN_00, bGHD, TDSHARPALL_GAIN_HD);
		vIO32WriteFldAlign(TDSHPALL_ADAP_GAIN_00, bGSD, TDSHARPALL_GAIN_SD);
	}
	else
	{
		vIO32WriteFldAlign(TDSHPALL_ADAP_GAIN_00, 75, TDSHARPALL_GAIN_HD);
		vIO32WriteFldAlign(TDSHPALL_ADAP_GAIN_00, 50, TDSHARPALL_GAIN_SD);
	}

}

void DRVCUST_DynamicCBoostInit(void)
{
	vIO32WriteFldAlign(DYN_CHROMA_BOOST, 0x85, CBOOST_GAIN_HIGH);
	//Following 3 register from sony adjusted
	vIO32WriteFldAlign(DYN_CHROMA_BOOST, 0x78, CBOOST_GAIN_LOW);
	vIO32WriteFldAlign(DYN_CHROMA_BOOST, 0x46, CBOOST_APL_HIGH_TH);
	vIO32WriteFldAlign(DYN_CHROMA_BOOST, 0x28, CBOOST_APL_LOW_TH);
}

void DRVCUST_DynamicCBoost(void)
{
	static UINT8 u1CBoostGain = 0x80;
	static UINT8 u1FirstTime = SV_TRUE;
	UINT8 u1CBoostGainTarget = 0x80;
	UINT8  u1APL = bDrvGetAPL();
	UINT8 u1CBoostGainHigh = IO32ReadFldAlign(DYN_CHROMA_BOOST, CBOOST_GAIN_HIGH);
	UINT8 u1CBoostGainLow = IO32ReadFldAlign(DYN_CHROMA_BOOST, CBOOST_GAIN_LOW);
	UINT8 u1APLHighTh = IO32ReadFldAlign(DYN_CHROMA_BOOST, CBOOST_APL_HIGH_TH);
	UINT8 u1APLLowTh = IO32ReadFldAlign(DYN_CHROMA_BOOST, CBOOST_APL_LOW_TH);

	if(u1APL >= u1APLHighTh)
	{
		u1CBoostGainTarget = u1CBoostGainHigh;
	}
	else if(u1APL >= u1APLLowTh)
	{
		u1CBoostGainTarget = u1CBoostGainLow + (u1CBoostGainHigh - u1CBoostGainLow)*(u1APL - u1APLLowTh)/(u1APLHighTh - u1APLLowTh);
	}
	else if(u1APL < u1APLLowTh)
	{
		u1CBoostGainTarget = u1CBoostGainLow;
	}

	if(u1CBoostGainTarget > u1CBoostGain)
	{
		u1CBoostGain++;
	}
	else if(u1CBoostGainTarget < u1CBoostGain)
	{
		u1CBoostGain--;
	}

	if(u1FirstTime == SV_TRUE)
	{
		u1CBoostGain = u1CBoostGainTarget;
		u1FirstTime = SV_FALSE;
	}
	
	vIO32WriteFldAlign(C_BOOST_MAIN, u1CBoostGain, CBOOST_GAIN);	
}

void DRVCUST_ATVWeakSignalPatch(void)    //for warkmark issue in ATV weak signal
{
    EXTERN BOOL fgDrvAnrAutoOnTNR(void);
    static UINT8 fgWeakSig = 0;
    if((bGetVideoDecType(SV_VP_MAIN)==SV_VD_TVD3D)
         &&(bGetSignalType(SV_VP_MAIN)==SV_ST_TV)
         &&(bTvdSignalStrengthLevel(1)<=43)
         &&(fgDrvAnrAutoOnTNR() == 1)
         &&(IO32ReadFldAlign(NR_PATCH_06, NR_PATCH_06_EN)==0))
     {
         fgWeakSig = 1;
         vIO32WriteFldAlign(MCVP_CS_21, 1, FORCE_ME_OUT_EN);    
         vIO32WriteFldAlign(MCVP_CS_21, 1, FORCE_ME_OUT_VALID);    
         vIO32WriteFldAlign(MCVP_CS_21, 0, FORCE_ME_OUT_MVX);    
         vIO32WriteFldAlign(MCVP_CS_21, 0, FORCE_ME_OUT_MVY);    
     }
     else if(fgWeakSig == 1)
     {
         fgWeakSig = 0;
         vIO32WriteFldAlign(MCVP_CS_21, 0, FORCE_ME_OUT_EN);    
         vIO32WriteFldAlign(MCVP_CS_21, 0, FORCE_ME_OUT_VALID);    
     }
}

void DRVCUST_VideoInit(void)
{
    //sonyDrv_RegisterCallback();
    CheckToEnablePBM();
    DRVCUST_AdaptiveBacklightInit();
    DRVCUST_SetBrightnessPlusGain();
    DRVCUST_SetSHPGain();
    
    //Init Adaptive PBC
    vIO32WriteFldAlign(ADAPTIVE_PBC_00, 1, ADAPTIVE_PBC_EN);
    vIO32WriteFldAlign(ADAPTIVE_PBC_00, 65, ADAPTIVE_PBC_THD);

	DRVCUST_DynamicCBoostInit();

#ifdef CC_Factory2K12    
    b_fginit = TRUE;             /* SONY, cheah 24/07/09, to ensure init before call ISR func */
#endif

#ifdef SUPPORT_AMBI_GLOW
    vIO32WriteFldAlign(AMBILRATIO, 0x140, AMBL_SAT_GAIN);
#endif
    return;
}

void DRVCUST_SetMacbethOnOff(UINT8 bOnoff, UINT16 u2Ylvl, UINT16 u2Ulvl, UINT16 u2Vlvl)
{
	if(bOnoff)
	{
		memset(DRVCUST_pMecbethMatrix, 0x00, sizeof(DRVCUST_pMecbethMatrix));
		DRVCUST_pMecbethMatrix[12] = u2Ylvl;
		DRVCUST_pMecbethMatrix[13] = u2Ulvl;
		DRVCUST_pMecbethMatrix[14] = u2Vlvl;
		
		x_memcpy(pPedestalMatrixISR, DRVCUST_pMecbethMatrix, sizeof(DRVCUST_pMecbethMatrix));
        vApiRegisterVideoEvent(PE_EVENT_COLOR_TRANSFORM, SV_VP_MAIN, SV_ON);
	}
	else
	{
		vVdoSetColorTransform(SV_VP_MAIN);
	}
}

void DRVCUST_SetPGAM_EN(UINT8 bOnoff)
{
    bGammaLinear = (bOnoff==0) ? 1 : 0;
    DRVCUST_SET_GAMMA();
	//vDrvGammaOnOff(bOnoff);
}

UINT8 DRVCUST_GetPGAM_EN(void)
{
	return (!bGammaLinear);
}

void DRVCUST_ReadRGBGainOfst(void)
{
	u2WBGain[SV_RGB_R] = wDrvGetRGain1(SV_VP_MAIN);
	u2WBGain[SV_RGB_G] = wDrvGetGGain1(SV_VP_MAIN);
	u2WBGain[SV_RGB_B] = wDrvGetBGain1(SV_VP_MAIN);
	u2WBOfst[SV_RGB_R] = dwDrvGetROffset11(SV_VP_MAIN);
	u2WBOfst[SV_RGB_G] = dwDrvGetGOffset11(SV_VP_MAIN);
	u2WBOfst[SV_RGB_B] = dwDrvGetBOffset11(SV_VP_MAIN);
}

void DRVCUST_SetUWBFLAT(UINT8 bOnoff)
{
    bOnoff = bOnoff ? SV_TRUE : SV_FALSE;
	if(bOnoff == bWBFlatPreOnoff)
		return;
	
	if(bOnoff)
	{
		DRVCUST_ReadRGBGainOfst();
		
		vHalVideoRGBGain(SV_VP_MAIN, SV_RGB_R, 0x200);
	    vHalVideoRGBGain(SV_VP_MAIN, SV_RGB_G, 0x200);
	    vHalVideoRGBGain(SV_VP_MAIN, SV_RGB_B, 0x200);
	    vHalVideoRGBOffset(SV_VP_MAIN, SV_RGB_R ,0);
	    vHalVideoRGBOffset(SV_VP_MAIN, SV_RGB_G ,0);
	    vHalVideoRGBOffset(SV_VP_MAIN, SV_RGB_B ,0);
	}
	else
	{
		vHalVideoRGBGain(SV_VP_MAIN, SV_RGB_R, u2WBGain[SV_RGB_R]);
	    vHalVideoRGBGain(SV_VP_MAIN, SV_RGB_G, u2WBGain[SV_RGB_G]);
	    vHalVideoRGBGain(SV_VP_MAIN, SV_RGB_B, u2WBGain[SV_RGB_B]);
	    vHalVideoRGBOffset(SV_VP_MAIN, SV_RGB_R, u2WBOfst[SV_RGB_R]);
	    vHalVideoRGBOffset(SV_VP_MAIN, SV_RGB_G, u2WBOfst[SV_RGB_G]);
	    vHalVideoRGBOffset(SV_VP_MAIN, SV_RGB_B, u2WBOfst[SV_RGB_B]);
	}

    bWBFlatPreOnoff = bOnoff;
	DRVCUST_SET_GAMMA();
}

UINT8 DRVCUST_GetUWBFLAT(void)
{
    return (bWBFlatPreOnoff ? SV_TRUE : SV_FALSE);
}

INT32 DRVCUST_Color_Trans_ADJ[15]={0};
static UINT8 bFirstInGammaMute = SV_TRUE;
static UINT8 bPreMainMute = SV_OFF;
static UINT8 bPreDBLOnOff = SV_ON;
void vDRVCUST_SetGamma_mute_lvl(UINT16 u2lvl)
{
    UINT16 u2RGBLvl = MIN(u2lvl*32,1023);
    u1GammamuteLvl = (u2lvl <= 32) ? u2lvl : 0xFF;
    
    printf("\nDDD ==>> DRVCUST_SetGamma_mute_lvl[%d]==\n",u2lvl);
    if (u2lvl <= 32)
    {
        //vDrvGammaMute(u2RGBLvl, u2RGBLvl, u2RGBLvl);
        memset(DRVCUST_Color_Trans_ADJ, 0x00, sizeof(DRVCUST_Color_Trans_ADJ));
        DRVCUST_Color_Trans_ADJ[12] = u2RGBLvl;
		DRVCUST_Color_Trans_ADJ[13] = u2RGBLvl;
		DRVCUST_Color_Trans_ADJ[14] = u2RGBLvl;
        vLoadOSColorMatrix(SV_VP_MAIN, DRVCUST_Color_Trans_ADJ);

        if(bFirstInGammaMute == SV_TRUE)
        {
            bPreMainMute = fgMainMuteOn();
            bPreDBLOnOff = IO32ReadFldAlign(DBL_00, DBL_ENABLE);
            bFirstInGammaMute = SV_FALSE;
        }
        vRegWriteFldAlign(DBL_00, SV_OFF, DBL_ENABLE);
        vDrvMainMute(SV_OFF);
    }
    else
    {
        //vDrvGammaUnmute();
        vDrvVideoColorMatrix(SV_VP_MAIN);
        vDrvMainMute(bPreMainMute);
        vRegWriteFldAlign(DBL_00, bPreDBLOnOff, DBL_ENABLE);
        bFirstInGammaMute = SV_TRUE;
    }
    return;
}

UINT8 u1DRVCUST_GetGamma_mute_lvl(void)
{
    return u1GammamuteLvl;
}

UINT8 DRVCUST_EepromReadByte(UINT16 waddr)
{
	INT32 i4Ret;
	UINT8 u4Data = 0;
	
	i4Ret = EEPROM_Read(waddr, (UINT32)&u4Data, 1);

	if(i4Ret)
	{
		Printf("EEP ReadByte Error\n");
		return (0);
	}
	return (u4Data);
}

BOOL DRVCUST_EepromWriteByte(UINT16 waddr, UINT8 u1Data)
{
	INT32 i4Ret;
	
	i4Ret = EEPROM_Write(waddr, (UINT32)&u1Data, 1);
	
	if(i4Ret)
	{
		return (SV_FALSE);
	}
	else
	{
		return (SV_TRUE);
	}
}

void DRVCUST_SetPBMGammaByte(UINT8 bOnOff)
{
    DRVCUST_EepromWriteByte(EEP_WB_LUT_ADJ_ON, bOnOff);
}
UINT8 DRVCUST_GetPBMGammaByte(void)
{
    return DRVCUST_EepromReadByte(EEP_WB_LUT_ADJ_ON);
}
void DRVCUST_HUPSCaleCoeff(UINT8 bPath)
{

    UINT8 bHCoeffIdx;
	UINT32 dwScHIn = u4IO32Read4B(SCALER_COEF_MAIN_H_IN);
	UINT32 dwScHOut= u4IO32Read4B(SCALER_COEF_MAIN_H_OUT);
		
    static UINT8 bPreHCoeffIdx = 0xFF;
	
    if(bPath!=SV_VP_MAIN)
        return;

	//	bHCoeffIdx
	//		0: up scaling
	//		1: down scaling 1.5
	//		2: down scaling 2
	//		3: down scaling 3
	//		4: down scaling 4
	//		5: down scaling 5
 
	bHCoeffIdx = (dwScHOut>=dwScHIn)?0: // upscaling only 1 hw default tbl
			  (dwScHOut*9<dwScHIn*2)?5: // DS ratio > 4.5 use 5
			  (dwScHOut*7<dwScHIn*2)?4: // DS ratio > 3.5 use 4
			  (dwScHOut*5<dwScHIn*2)?3: // DS ratio > 2.5 use 3
			  (dwScHOut*3<dwScHIn*2)?2: // DS ratio > 1.75 use 2
			  (1);						// DS ratio < 1.75 use 1.5

    if(!bIsScalerInput444(bPath)) // 422 mode Y/C needs different coeff
    {
			if(bPreHCoeffIdx!=bHCoeffIdx)
			{
				bPreHCoeffIdx = bHCoeffIdx;
		        vDrvSCPQSetSramCoeff(COEFTYP_HOR_Y,u4SCHYCoeff[bHCoeffIdx]);
		        vDrvSCPQSetSramCoeff(COEFTYP_HOR_C,u4SCHCCoeff[bHCoeffIdx]);
			}
	}
    else // 444 mode Y/C use same coeff
    {
        // turn off sram coeff, Both HY, HC use Hw SC_H_COEF_TABLE_SEL default coeff tbls 
        // when SC_H_422_MODE_EN_1 is 0
        vIO32WriteFldAlign(SCPIP_SCCTRL1_07, bHCoeffIdx, SCCTRL1_07_SC_H_COEF_TABLE_SEL);
        //vIO32WriteFldAlign(SCPIP_SCCTRL1_33, bHCoeffIdx, SCCTRL2_13_SC_HC_COEF_TABLE_SEL);
        vIO32WriteFldAlign(SCFIR_0C, SV_OFF, H_SRAM_COEFF_EN); 
    }
    return;

}

void DRVCUST_VUPSCaleCoeff(UINT8 bPath)
{

    UINT8 bVCoeffIdx;
    UINT8 bLineInterleave;
	UINT32 dwScVIn = u4IO32Read4B(SCALER_COEF_MAIN_V_IN);
	UINT32 dwScVOut= u4IO32Read4B(SCALER_COEF_MAIN_V_OUT);		
    //static UINT8 bPreVCoeffIdx = 0xFF;
	UINT8 bPingPongMode = IO32ReadFldAlign(SCPIP_SCCTRL1_04, SCCTRL1_04_SC_COEF_PP_ENABLE);
    UINT8 bPingPongWRTVC = IO32ReadFldAlign(SCPIP_SCCTRL1_05, SCCTRL1_05_SC_COEF_PP_RD_A);
    UINT32   u4SCL  = u4DrvTDTVScalerModeQuery();
    E_TD_OUT eSCLOut= TD_SCL_OUT(u4SCL);
    E_TD_IN  eSCLIn = TD_SCL_IN(u4SCL);
	
    if(bPath!=SV_VP_MAIN)
        return;
	
	//scaler out line interleave or not
	bLineInterleave =((E_TD_OUT_3D_LI==eSCLOut)||
					 ((E_TD_IN_LI_P==eSCLIn)&&(E_TD_OUT_NATIVE==eSCLOut))); 

     //  bVCoeffIdx
     //   0: up scaling
     //   1: down scaling 1.5
     //   2: down scaling 2
     //   3: down scaling 3
     //   4: down scaling 4
     //   5: down scaling 5

    bVCoeffIdx = ((dwScVOut>=dwScVIn) && (!bLineInterleave))?0: // upscaling only 1 hw default tbl
    		  	  (dwScVOut>=dwScVIn)?6: // upscaling use 4 taps tbl
	              (dwScVOut*9<dwScVIn*2)?5: // DS ratio > 4.5 use 5
	              (dwScVOut*7<dwScVIn*2)?4: // DS ratio > 3.5 use 4
	              (dwScVOut*5<dwScVIn*2)?3: // DS ratio > 2.5 use 3
	              (dwScVOut*3<dwScVIn*2)?2: // DS ratio > 1.75 use 2
	              (1);                      // DS ratio < 1.75 use 1.5	

        //Use Hw default coeff tbl          
        //vIO32WriteFldAlign(SCFIR_0C, SV_OFF, V_SRAM_COEFF_EN);
        //vIO32WriteFldAlign(SCPIP_SCCTRL1_07, bVCoeffIdx, SCCTRL1_07_SC_V_COEF_TABLE_SEL);
        if(bPingPongMode)
        {
            //Ping-pong R/W VYC same tbl         
            vDrvSCPQSetSramCoeff(((bPingPongWRTVC)?COEFTYP_VER_C:COEFTYP_VER_Y), 
                                                          u4SCVYCCoeff[bVCoeffIdx]);
            vIO32WriteFldAlign(SCPIP_SCCTRL1_05, (!bPingPongWRTVC), SCCTRL1_05_SC_COEF_PP_RD_A);
        }
        else
        {
			vDrvSCPQSetSramCoeff(COEFTYP_VER_C, u4SCVYCCoeff[0]);
		}

    return;
}
void DRVCUST_VdoModeChgDone(UINT8 bPath)
{
    UNUSED(bPath);
#ifdef CC_SMALL_TCON_BOARD
    DRVCUST_SetODTable();
#endif
    return;
}

void DRVCUST_BrightPlusProc(void)
{
#if 0
    static UINT8 bCtrl = 0,
                 bMaxTh = 0,
                 bMaxTh_MSB = 0,
                 bP1 = 0,
                 bP2 = 0,
                 bG1 = 0,
                 bG2 = 0;
	
    if((bCtrl!= wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_CTRL))
        ||(bMaxTh!= wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_MAXTH))
        ||(bMaxTh_MSB!= wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_MAXTH_MSB))
        ||(bP1!= wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_P1))
        ||(bP2!= wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_P2))
        ||(bG1!= wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_G1))
        ||(bG2!= wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_G2)))
    {
        bCtrl      = wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_CTRL);
        bMaxTh     = wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_MAXTH);
        bMaxTh_MSB = wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_MAXTH_MSB);
        bP1        = wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_P1);
        bP2        = wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_P2);
        bG1        = wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_G1);
        bG2        = wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_G2);
        vIO32WriteFldAlign(BRIGHT_PLUS_00,bCtrl,BRIGHT_PLUS_CTRL);
        vIO32WriteFldAlign(OPC_0A,(bMaxTh | bMaxTh_MSB<<8),OPC_MAX_CONTENT_TH);
        vIO32WriteFldAlign(BRIGHT_PLUS_01,bP1,BRIGHT_PLUS_P1);
        vIO32WriteFldAlign(BRIGHT_PLUS_01,bP2,BRIGHT_PLUS_P2);
        vIO32WriteFldAlign(BRIGHT_PLUS_01,bG1,BRIGHT_PLUS_G1);
        vIO32WriteFldAlign(BRIGHT_PLUS_01,bG2,BRIGHT_PLUS_G2);
    }
#endif
        vIO32WriteFldAlign(BRIGHT_PLUS_00,wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_CTRL),BRIGHT_PLUS_CTRL);
        vIO32WriteFldAlign(OPC_0A,
            (wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_MAXTH) | wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_MAXTH_MSB)<<8),OPC_MAX_CONTENT_TH);
        vIO32WriteFldAlign(BRIGHT_PLUS_01,wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_P1),BRIGHT_PLUS_P1);
        vIO32WriteFldAlign(BRIGHT_PLUS_01,wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_P2),BRIGHT_PLUS_P2);
        vIO32WriteFldAlign(BRIGHT_PLUS_01,wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_G1),BRIGHT_PLUS_G1);
        vIO32WriteFldAlign(BRIGHT_PLUS_01,wReadQualityTable(QUALITY_MISC_BRIGHTPLUS_G2),BRIGHT_PLUS_G2);

}

/*add for sony after change input source under aging show gamma mute it will go to mute black*/
void DRVCUST_SetAgingFlag(UINT8 bOnOff)
{
	switch(bOnOff)
	{
		case 0:
			bAingFlag = FALSE;
			break;
		case 1:
			bAingFlag = TRUE;
			break;
		default:
			bAingFlag = FALSE;
			break;
	}
}

UINT8 DRVCUST_IsEnablePedastal(UINT8 bPath)
{

    UINT32 u4SrcType = bGetSignalType(bPath);
    
    if (u4SrcType == SV_ST_TV || u4SrcType == SV_ST_AV)
    {
        if((GET_MATRIX_PED) && (bPath == SV_VP_MAIN))   
        {
            return SV_TRUE;
        }
        else if(bPath == SV_VP_PIP && EN_PEDASTAL_IN_SUB_PATH)
        {
            return SV_TRUE;
        }
    }
    
    return SV_FALSE;
}

void DRVCUST_PanelGammaRemapProc(void);
#ifdef CC_PowerCons_Ctrl

#define PowerConsCtrl_ISSUE_DEBUG_MSG 1
static UINT8 volume_setting=0;
static BOOL speaker_unmute=FALSE;
static BOOL mhl_use=FALSE;
static BOOL lnb_use=FALSE;;
static BOOL ci_use=FALSE;
static BOOL _fgPwrConsOn=FALSE;
static UINT8 _u1ModelID=0xFF;
	
UINT8 C_BL_POWER_LIMIT=255;

//HANDLE_T _hIRLedCtrlTimer = NULL_HANDLE;
HANDLE_T _hPowerConsCtrlMsgQue = NULL_HANDLE;
HANDLE_T _hPowerConsCtrlHandle = NULL_HANDLE;
void DRVCUST_PowerConsCtrl(void)
{
    UINT16 POWER_CONS_TOTAL_MAX;
	UINT16 POWER_CONS_TOTAL_TYP;
	UINT16 POWER_CONS_AUDIO_MAX;
	UINT16 POWER_CONS_AUDIO_TYP;
	UINT16 bl_power_limit_max;
	UINT16 bl_power_limit_TYP;

	//Check model ID based on Option bit
	//Get related data from data table

	
	//start
  if(_fgPwrConsOn)
	{
	    
	if(_u1ModelID>=sizeof(power_cons_data_table)/sizeof(power_cons_data_table[0]))
	{
	    Printf("[PCC]ModelId is invalid %d\n",_u1ModelID);
		return;
	}
	
	    //Check argument stability about 500msec
		x_thread_delay(500);
		//Calculate audio power consumption	
		//1.for maximum
		POWER_CONS_AUDIO_MAX=power_cons_data_table[_u1ModelID].AUDIO_PWR_OFFSET_MAX+(((UINT32)((power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_UP_MAX - power_cons_data_table[_u1ModelID].AUDIO_PWR_OFFSET_MAX)*volume_setting*speaker_unmute))/power_cons_data_table[_u1ModelID].AUDIO_VOLUME_TH_MAX);
		if (POWER_CONS_AUDIO_MAX > power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_UP_MAX) 
		{
			POWER_CONS_AUDIO_MAX = power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_UP_MAX;
		}
		if (POWER_CONS_AUDIO_MAX < power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_LOW_MAX) 
		{
			POWER_CONS_AUDIO_MAX = power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_LOW_MAX;
		}
		Printf("[PCC]POWER_CONS_AUDIO_MAX=%d[%d,%d]\n",POWER_CONS_AUDIO_MAX,power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_UP_MAX,power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_LOW_MAX);
		//2.for typical
		POWER_CONS_AUDIO_TYP=power_cons_data_table[_u1ModelID].AUDIO_PWR_OFFSET_TYP+(((UINT32)((power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_UP_TYP - power_cons_data_table[_u1ModelID].AUDIO_PWR_OFFSET_TYP)*volume_setting*speaker_unmute))/power_cons_data_table[_u1ModelID].AUDIO_VOLUME_TH_TYP);

		if (POWER_CONS_AUDIO_TYP > power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_UP_TYP) 
		{
			POWER_CONS_AUDIO_TYP = power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_UP_TYP;
		}
		if (POWER_CONS_AUDIO_TYP < power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_LOW_TYP) 
		{
			POWER_CONS_AUDIO_TYP = power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_LOW_TYP;
		}
		Printf("[PCC]POWER_CONS_AUDIO_TYP=%d[%d,%d]\n",POWER_CONS_AUDIO_TYP,power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_UP_TYP,power_cons_data_table[_u1ModelID].AUDIO_PWR_LIMIT_LOW_TYP);
		
		//Calculate total power consumptio
		//1.for maximum
		POWER_CONS_TOTAL_MAX = power_cons_data_table[_u1ModelID].BL_POWER_WATT_MAX+ POWER_CONS_AUDIO_MAX+ mhl_use*static_power_cons_data_table[_u1ModelID].POWER_CONS_MHL_MAX+ lnb_use * static_power_cons_data_table[_u1ModelID].POWER_CONS_LNB_MAX+ ci_use * static_power_cons_data_table[_u1ModelID].POWER_CONS_CI_MAX+ power_cons_data_table[_u1ModelID].POWER_CONS_BASE_MAX;
		//2.for typical
		POWER_CONS_TOTAL_TYP = power_cons_data_table[_u1ModelID].BL_POWER_WATT_TYP+ POWER_CONS_AUDIO_TYP+ mhl_use*static_power_cons_data_table[_u1ModelID].POWER_CONS_MHL_TYP+ lnb_use * static_power_cons_data_table[_u1ModelID].POWER_CONS_LNB_TYP+ ci_use * static_power_cons_data_table[_u1ModelID].POWER_CONS_CI_TYP+ power_cons_data_table[_u1ModelID].POWER_CONS_BASE_TYP;
       
	    Printf("[PCC]POWER_CONS_TOTAL_MAX=%d,POWER_CONS_TOTAL_TYP=%d\n",POWER_CONS_TOTAL_MAX,POWER_CONS_TOTAL_TYP);
		//Calculate C_BL_POWER_LIMIT
		//1.for maximum
        if (POWER_CONS_TOTAL_MAX > power_cons_data_table[_u1ModelID].POWER_CONS_LIMIT_MAX) 
		{
			bl_power_limit_max = POWER_CONS_TOTAL_MAX - power_cons_data_table[_u1ModelID].POWER_CONS_LIMIT_MAX;
        }
		else
		{
		    bl_power_limit_max = 0;
		}
		//2.for typical
        if (POWER_CONS_TOTAL_TYP > power_cons_data_table[_u1ModelID].POWER_CONS_LIMIT_TYP) 
		{
			bl_power_limit_TYP = POWER_CONS_TOTAL_TYP - power_cons_data_table[_u1ModelID].POWER_CONS_LIMIT_TYP;
        }
		else
		{
		    bl_power_limit_TYP = 0;
		}
		Printf("[PCC]bl_power_limit_max=%d,bl_power_limit_TYP=%d[%d,%d]\n",bl_power_limit_max,bl_power_limit_TYP,power_cons_data_table[_u1ModelID].POWER_CONS_LIMIT_MAX,power_cons_data_table[_u1ModelID].POWER_CONS_LIMIT_TYP);
        //Lower limit of bl_power_limit_typ
        if((power_cons_data_table[_u1ModelID].BL_POWER_WATT_TYP - bl_power_limit_TYP) < ((UINT32)(power_cons_data_table[_u1ModelID].BL_POWER_WATT_TYP * power_cons_data_table[_u1ModelID].BL_POWER_LIMIT_LOWER))/ 255) 
		{
			bl_power_limit_TYP = power_cons_data_table[_u1ModelID].BL_POWER_WATT_TYP - ((UINT32)(power_cons_data_table[_u1ModelID].BL_POWER_WATT_TYP*power_cons_data_table[_u1ModelID].BL_POWER_LIMIT_LOWER))/255;
        }
		//Use bigger value of "bl_power_limit_max" and "bl_power_limit_typ"
		if(bl_power_limit_max > bl_power_limit_TYP) 
		{
			C_BL_POWER_LIMIT = (((UINT32)((power_cons_data_table[_u1ModelID].BL_POWER_WATT_MAX - bl_power_limit_max)*255))/power_cons_data_table[_u1ModelID].BL_POWER_WATT_MAX);
		}
		else
		{
			C_BL_POWER_LIMIT = (((UINT32)((power_cons_data_table[_u1ModelID].BL_POWER_WATT_TYP - bl_power_limit_TYP)*255))/power_cons_data_table[_u1ModelID].BL_POWER_WATT_TYP);
		}
		Printf("[PCC] C_BL_POWER_LIMIT==%d \n",C_BL_POWER_LIMIT);
		
	}
	else
	{
	    Printf("[PCC]PowerConS is OFF!\n");
		C_BL_POWER_LIMIT=255;
	}
	
	//DRVCUST_SendEvent(E_CUST_BL_POWER_LIMIT_CHANGE, 0);
}
void DRVCUST_PowerConsCtrlHandle(void)
{
     //Printf("PowerConsCtrlHandle \n");
	 DRVCUST_PowerConsCtrl();
}

static void DRVCUST_PowerConsCtrlMsgHandle(void *pvArg)
{
    UINT16 u2MsgIdx;
    PowerCons_Change_STATE rPowerConsCtrlMsg;
    
	
	
    while (1)
    {
        SIZE_T zMsgSize = sizeof(PowerCons_Change_STATE);
        INT32  i4MsgRet;
     
        i4MsgRet = x_msg_q_receive(&u2MsgIdx, &rPowerConsCtrlMsg, &zMsgSize,
                                   &_hPowerConsCtrlMsgQue, 1, X_MSGQ_OPTION_WAIT);
        if (i4MsgRet == OSR_OK)
        {
          DRVCUST_PowerConsCtrlHandle();
            //PowerConsCtrlHandle(rPowerConsCtrlMsg.Mute_State,rPowerConsCtrlMsg.MHL_State,rPowerConsCtrlMsg.LNB_State,rPowerConsCtrlMsg.CI_State,rPowerConsCtrlMsg.u1volume_set);
        }
    }
}

void DRVCUST_PowerConsCtrlResourceInit(void)
{
        UINT32 u4PanelInchSize=0;
		 
		u4PanelInchSize=FlashPanel_GetInchSize();
        _fgPwrConsOn=Custom_drv_feature_support(CUST_FEATURE_QUERY_PWR_CONS_CTRL);	
	    if(_fgPwrConsOn)
		{
		    switch(u4PanelInchSize)
			{
			   case 32:
			   #if SALVIA_MODEL==SALVIA_EU
			   if(!Custom_drv_feature_support(CUST_FEATURE_SUPPORT_DVBS))//s2
			   {
			       _u1ModelID=2;
			   }
			   #elif SALVIA_MODEL==SALVIA_PAA || SALVIA_MODEL==SALVIA_PAD
			    if(!Custom_drv_feature_support(CUST_FEATURE_SUPPORT_SUBWOOFER))//sub woofer
				{
				    _u1ModelID=1;
				}
			  #else//other region
     			     _u1ModelID=1;
			  #endif
                break;			  
              case 40:
			     #if SALVIA_MODEL==SALVIA_PAA || SALVIA_MODEL==SALVIA_PAD
				 if(!Custom_drv_feature_support(CUST_FEATURE_SUPPORT_SUBWOOFER))//do not support sub woofer
				 {
				    _u1ModelID=3; 
				 }
				 #elif SALVIA_MODEL!=SALVIA_EU
				  _u1ModelID=3; 
				  #endif
				 break;	
              case 48:
			    #if SALVIA_MODEL==SALVIA_PAA || SALVIA_MODEL==SALVIA_PAD
				if(Custom_drv_feature_support(CUST_FEATURE_SUPPORT_SUBWOOFER))//sub woofer
			     {
                    if(Custom_drv_feature_support(CUST_FEATURE_QUERY_SHIPPING_REGION)!=DRV_CUSTOM_SHIPPING_REGION_OPTION_PAA_INDIA)    				 
			        {
					    _u1ModelID=4;
			        }
				 }	
			    #endif	
              break;					
			}
		}
		if(_u1ModelID==0xFF)_fgPwrConsOn=FALSE;
		else _u1ModelID--;
		Printf("[PCC]Inch Size=%d,Ctrl=%d ModelId=%d\n",u4PanelInchSize,_fgPwrConsOn,_u1ModelID);
		
        VERIFY(x_msg_q_create(&_hPowerConsCtrlMsgQue, "PowerConsCtrlMsgQue", 
                              sizeof(PowerCons_Change_STATE), 8) == OSR_OK);
        
        // Create the Led state handle handle task
        if (x_thread_create(&_hPowerConsCtrlHandle, "PowerConsCtrlHandle",
                            0x800, DRVCUST_OptGet(eReleaseWatchdogPriority),
                            DRVCUST_PowerConsCtrlMsgHandle, 0, NULL) != OSR_OK)
        {
            Printf("\n[PCC]Error: Create Power consumption ctrl handle thread fail\n");
            x_msg_q_delete(_hPowerConsCtrlMsgQue);
            _hPowerConsCtrlMsgQue = NULL_HANDLE;
        }
}

void DRVCUST_PowerConsCtrlTrigger(bool unMute_State,bool MHL_State,bool LNB_State,bool CI_State, UINT8 u1volume_set)
{
    PowerCons_Change_STATE rPowerConsCtrlMsg;
	
#if PowerConsCtrl_ISSUE_DEBUG_MSG
    Printf("[PCC]Power Consumption Ctrl Trigger %d %d %d %d %d\n", unMute_State, MHL_State,LNB_State,CI_State,u1volume_set);
#endif
    if (_hPowerConsCtrlMsgQue == NULL_HANDLE)
    {
	    DRVCUST_PowerConsCtrlResourceInit();
    }
    if (_hPowerConsCtrlMsgQue != NULL_HANDLE)
    {
        rPowerConsCtrlMsg.unMute_State = unMute_State;
		rPowerConsCtrlMsg.MHL_State = MHL_State;
		rPowerConsCtrlMsg.LNB_State = LNB_State;
		rPowerConsCtrlMsg.CI_State = CI_State;
		rPowerConsCtrlMsg.u1volume_set = u1volume_set;

        UNUSED(x_msg_q_send(_hPowerConsCtrlMsgQue, &rPowerConsCtrlMsg,
                            sizeof(PowerCons_Change_STATE), 1));
    }
}

void DRVCUST_PowerConsCtrlStatusCheck(void)
{
     BOOL ci_use_tmp=FALSE;
	 UINT8 volume_set_tmp=0;
	 BOOL MHL_use_tmp=FALSE;
	 BOOL speaker_unmute_tmp=FALSE;
     BOOL fgStatusChanged=FALSE;
	 UINT8 lnb_mount_status=0;
	 BOOL lnb_use_tmp=FALSE;
	 static BOOL fgFirstTime=TRUE;
	 
	 #ifdef SYS_DVBS_SUPPORT
	 SIZE_T paralen=sizeof(UINT8);
	 DRV_CUSTOM_CUST_SPEC_GET(DRV_CUSTOM_CUST_SPEC_TYPE_LNB_MOUNT_STATUS,&lnb_mount_status,&paralen);
	 #endif
	 
	 if(lnb_mount_status)
	 {
	    lnb_use_tmp=TRUE;
	 }
	 
     if(lnb_use_tmp!=lnb_use)
	 {
	    lnb_use=lnb_use_tmp;
		fgStatusChanged=TRUE;
	 }
	 
     if(1==PCMCIA_DetectCard())//0,disconnected,1,connected,2,abnormal status
    	ci_use_tmp=TRUE;
    else
		ci_use_tmp=FALSE;
	if(ci_use_tmp!=ci_use)
	{
    	ci_use=ci_use_tmp;
		//DRVCUST_PowerConsCtrlTrigger(speaker_unmute,mhl_use,lnb_use,ci_use,volume_setting);
		fgStatusChanged=TRUE;
    }
	//check MHL status change
	#ifdef SYS_MHL_SUPPORT
	if(_IsMhlDevice())
    	MHL_use_tmp=TRUE;
    else
		MHL_use_tmp=FALSE;
	#endif 
	if(mhl_use!=MHL_use_tmp)
	{
	   mhl_use=MHL_use_tmp;
	   fgStatusChanged=TRUE;
	}
	//check AMP mute
	if(ADAC_AmpEnableFlag()==1)
    	speaker_unmute_tmp=1;
    else
		speaker_unmute_tmp=0;

	if(speaker_unmute_tmp!=speaker_unmute)
	{
    	speaker_unmute=speaker_unmute_tmp;
		fgStatusChanged=TRUE;
		//DRVCUST_PowerConsCtrlTrigger(speaker_unmute,mhl_use,lnb_use,ci_use,volume_setting);
    }
    //check volume change
	volume_set_tmp=AUD_DspGetMasterVolume(AUD_DEC_MAIN);
    if(volume_set_tmp!=volume_setting)
    {
    	volume_setting=volume_set_tmp;
		//DRVCUST_PowerConsCtrlTrigger(speaker_unmute,mhl_use,lnb_use,ci_use,volume_setting);
		fgStatusChanged=TRUE;
    }
	if(fgStatusChanged || fgFirstTime)
	{
	    DRVCUST_PowerConsCtrlTrigger(speaker_unmute,mhl_use,lnb_use,ci_use,volume_setting);
	}
	fgFirstTime=FALSE;
}
#endif

void DRVCUST_VideoMainloop()
{
	#ifdef CC_PowerCons_Ctrl
    static BOOL fgFirstUnmute=FALSE;
	#endif
	//EXTERN UINT8 bGammaInit;
    //EXTERN BOOL gbScartOut;
    //static BOOL bpre_gbScartOut = SV_FALSE;

	/*
    if(bpre_gbScartOut != gbScartOut)
    {
        bpre_gbScartOut = gbScartOut;
        vHalVideoScartOut_PQOnOff(!bpre_gbScartOut);
    }
    */
    DRVCUST_ATVWeakSignalPatch();
    DRVCUST_AdaptiveBacklightProc();
	//DRVCUST_BrightPlusProc();
	#ifdef CC_PowerCons_Ctrl
	if(!fgFirstUnmute && (_u4DrvVideoGetMute(SV_VP_MAIN)==SV_OFF))
    {
		 fgFirstUnmute=TRUE;
	     Printf("[PCC]Start BL adjustment\n");
		 DRVCUST_PowerConsCtrlStatusCheck();
    }
	if(fgFirstUnmute)
	{
	    DRVCUST_PowerConsCtrlStatusCheck();
	}
	#endif
    DRVCUST_PanelGammaRemapProc();
    
	#ifdef CC_SONY_GAMMA
	DRVCUST_AutoWB_Proc();	/* SONY, cheah 14/07/09 */
	#endif
	DRVCUST_DynamicCBoost();
}

/*
void DRVCUST_PictureMode_Change(void)
{
    LOG(2,"\nPictureMode_Change Enter 1---\n");
    //---Update AL parameter
    vHalVideoAdaptiveLumaParam();
    
    //---Update Contrast/Brightness/Saturation/Hue
    vDrvGlobalPQAdj();  

    //---Update Gamma
    bPreGammaSel = IO32ReadFldAlign(ADAPTIVE_RGB_GAMMA_REG, ADAPTIVE_RGB_GAMMA_SEL);
    DRVCUST_PANEL_GAMMA_REMAP(bPreGammaSel);
    vHalVideoGammaLoadTable();
    
    LOG(2,"\nPictureMode_Change Exit 1---\n");
}
*/

void DRVCUST_OutVSyncISR()
{
#if 0
    //---Workaroud for Flicker issue when switch Picture mode
    static UINT8 bcnt = 0x0;
    extern void vDrvBrightPlusSetOPCCurve(void);
    extern void vDrvClearTPF(void);
    extern void vDrvBrightPlusSetDefault(void);
    
    bcnt = (bcnt > 0) ? (bcnt-1) :0;

    if((fgpicturemodechange)&&(fgpicturemodechange_done))
    {
        fgpicturemodechange_done = SV_FALSE;
        DRVCUST_PictureMode_Change();
        bcnt = 2;
    }

    if(bcnt == 1)    //Next vsync
    {
        LOG(2,"\nPictureMode_Change Enter 2---\n");
        fgpicturemodechange = SV_FALSE;
       
    	vDrvClearTPF();
        vDrvBrightPlusSetDefault();

        if(IO32ReadFldAlign(PIC_RGB_GAIN, PIC_GAIN_EN)==0)
        {
            vIO32WriteFldAlign(GAINOSET_00,IO32ReadFldAlign(PIC_RGB_GAIN, PIC_GAIN_R), R_GAIN_MAIN);
            vIO32WriteFldAlign(GAINOSET_00,IO32ReadFldAlign(PIC_RGB_GAIN, PIC_GAIN_G), G_GAIN_MAIN);
            vIO32WriteFldAlign(GAINOSET_00,IO32ReadFldAlign(PIC_RGB_GAIN, PIC_GAIN_B), B_GAIN_MAIN);
            //vIO32WriteFldAlign(GAINOSET_02,IO32ReadFldAlign(PIC_RGB_OFFSET, PIC_OFFSET_R), R_OFST1_MAIN);
            //vIO32WriteFldAlign(GAINOSET_02,IO32ReadFldAlign(PIC_RGB_OFFSET, PIC_OFFSET_G), G_OFST1_MAIN);
            //vIO32WriteFldAlign(GAINOSET_02,IO32ReadFldAlign(PIC_RGB_OFFSET, PIC_OFFSET_B), B_OFST1_MAIN);
        }
        LOG(2,"\nPictureMode_Change Exit 2---\n");
    }
    //--- End of Workaround
    
    if(fgpicturemodechange == SV_FALSE)
    {
        vDrvBrightPlusSetOPCCurve();
    }
#endif

	//DRVCUST_AdaptivePBC();    //Adaptive PBC for sony 

#ifdef SUPPORT_AMBI_GLOW
    vDrvAmbiGlowProc();
#endif
#ifdef CC_Factory2K12
	if (b_fginit == TRUE)		 /* SONY, cheah 24/07/09, to ensure init before call ISR func */
	{
#ifdef CC_SONY_GAMMA
	  DRVCUST_AutoWB_ISR();	/* SONY, cheah 14/07/09 */
	  DRVCUST_Gamma_ISR();	 /* SONY, cheah 28/07/09 */
#endif
	}
#endif


    return;
}

void DRVCUST_VdoInISR()
{
    return;
}

#if 0
void DRVCUST_AdaptivePBC(void)
{
    static UINT8 u1count = 0,u1Region_index = 0xFF;
    UINT16 u2Ration = 0;
    UINT16 wWidth = 0;
    UINT16 wHeight = 0;
    UINT32 u4Pixelcnt = 0;
    //UINT8 u1region_flag = 0;
    //UINT32 u4PxlCnt = 0;
    
    //extern functions
    extern void vDrvSetPBCRegion(UINT8 bRegionId);    //for sony
    extern UINT16 u2ScpipGetDispWidth(UINT8 bPath);
    extern UINT16 u2ScpipGetDispHeight(UINT8 bPath);

    if (IO32ReadFldAlign(ADAPTIVE_PBC_00, ADAPTIVE_PBC_EN))
    {
        wWidth = u2ScpipGetDispWidth(SV_VP_MAIN);
        wHeight = u2ScpipGetDispHeight(SV_VP_MAIN);
        u4Pixelcnt = IO32ReadFldAlign(TWO_D_W1_RESULT,W1_RESULT);
        u2Ration =  (u4Pixelcnt>>3)/MAX(10,((wWidth*wHeight>>3)/1000));
        //vDrvGetHueHistHW();
        //u1DrvGetHueHist(u4HueHist, &u4PxlCnt, 0);   

        if(u2Ration <= IO32ReadFldAlign(ADAPTIVE_PBC_00, ADAPTIVE_PBC_THD))
        {
            u1count = (u1count<5) ? u1count+1 : 5;
            if((u1Region_index != 1)&&(u1count >= 4))
            {
                u1Region_index = 1;
                vDrvSetPBCRegion(u1Region_index);    //Set to Blue Region
            }
        }
        else
        {
            u1count = (u1count>0) ? u1count-1 : 0;
            if((u1Region_index != 0)&&(u1count <= 1))
            {
                u1Region_index = 0;
                vDrvSetPBCRegion(u1Region_index);    //return to skin Region
            }
        }
    }
    else
    {
        if(u1Region_index != 0)
        {
            u1Region_index = 0;
            vDrvSetPBCRegion(u1Region_index);    //return to skin Region
        }
    }
    //---debug information
    if (IO32ReadFldAlign(ADAPTIVE_PBC_00, ADAPTIVE_PBC_LOG))
    {
        Printf("\n[Stellar_video_drv.c][AdP_PBC]{u2Ration[%d],u1Region_index[-%d-]}---[Skin:0,Blue:1]\n",
              u2Ration,u1Region_index);
    }
}
#endif

void vDRVCUST_ColorShift_Patch(UINT8 bPath)
{
    if(bPath != SV_VP_MAIN) 
        return;
    
    if((bGetSignalType(SV_VP_MAIN) == SV_ST_DVI)
        &&(bDrvVideoGetTiming(SV_VP_MAIN) == 17))    //HDMI 480P, Color shift issue
    {
        UINT8 bFlipMirror = u1GetFlipMirrorConfig();
        vIO32WriteFldAlign(CH_DLY_MAIN, ((bFlipMirror == 0x3) ? 0 : 1), CB_DEL);
        vIO32WriteFldAlign(CH_DLY_MAIN, ((bFlipMirror == 0x3) ? 1 : 0), CR_DEL);
    }
    else
    {
        vIO32WriteFldAlign(CH_DLY_MAIN, 0, CB_DEL);
        vIO32WriteFldAlign(CH_DLY_MAIN, 0, CR_DEL);
    }
}

UINT32 DRVCUST_RGBOfstRemap(UINT32 u4Value)
{
    return u4Value;
}

UINT16 DRVCUST_Y2RMap(void)
{
    //HSI SPEC change , Always -16 For video mode / Special Mode , 
    //because of DEMO Mode Support
    return  0;
}

/* @ Auto NR default Initial setting
 *      1: low
 *      2: Middle
 */
UINT8 DRVCUST_AutoNRDefSet(void)
{
    return 2;
}

/* @ Auto NR noise level implement
 * @ return noise level
 */
UINT8 DRVCUST_NoiseLevel(void)
{
#if 0
    UINT8 bNoiseLevel = NM_INVALIDLEVEL;
    UINT8 bRFNMLevel;

    if((bGetVideoDecType(bDrvNRGetCurrentPath())==SV_VD_TVD3D)&&
        	 (bGetSignalType(bDrvNRGetCurrentPath())==SV_ST_TV))// TVD RF source
    {

        bRFNMLevel = bTvdSignalStrengthLevel(1);   //RF level 0 ~ 80

        if(bRFNMLevel > 75)
        {
            bNoiseLevel = NM_LEVEL1_3;
        }
        else if(bRFNMLevel > 69)
        {
            bNoiseLevel = NM_LEVEL2;
        }
        else if(bRFNMLevel > 59)
        {
            bNoiseLevel = NM_LEVEL3;
        }
        else if(bRFNMLevel > 55)
        {
            bNoiseLevel = NM_LEVEL4;
        }
        else
        {
            bNoiseLevel = NM_LEVEL5;
        }
    }
    else
    {
        bNoiseLevel = vDrvNMLevel();   //content NR, Noise level 0 ~ 4
    }
    
    return bNoiseLevel;
#endif
    return 0;
}

/* @ Motion Sharpness Quailty Table
 *      
 *      
 */
void DRVCUST_MoSharpSetQtyTbl(void)
{
#if 0     //TODO:fix me
    UINT8 UI_LEVEL, XLEVEL,YLEVEL,DLEVEL;

// Set Total Level
    UI_LEVEL =IO32ReadFldAlign(MOADAP_SHARP_00, MO_SHP_LEVEL);  
    // Get SW UI Level	
    if (UI_LEVEL>8)			// Protect UI_LEVEL <=8
    {
       vIO32WriteFldAlign(MOADAP_SHARP_00, 0x08, MO_SHP_LEVEL);   
    	UI_LEVEL=8;    	
    } 
// Get Mo Level                
    if (IO32ReadFldAlign(MOADAP_SHARP_00, MO_SHP_EN))
    {      
	XLEVEL = (vDrvGetMoSharpXLevel()*UI_LEVEL)>>3;    
	YLEVEL = (vDrvGetMoSharpYLevel()*UI_LEVEL)>>3;
    }
    else
    {
    	XLEVEL = 0;
    	YLEVEL = 0;
    }
    DLEVEL = (XLEVEL<YLEVEL)?XLEVEL:YLEVEL;  
	
    // Edge Clear : TDSHARP ACLPF
	vRegWriteFldAlign(TDSHP_29, 
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_TDSHARPALL_AC_LPF_COE), 0x00, XLEVEL), TDS_AC_LPF_COE);  	

    // Detail Reveal : HSAHRP Coring
	vRegWriteFldAlign(HSHARP_MAIN_02, 
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_HSHARP_HIGH_CORING), 0x00, XLEVEL), HSP_SHARP_HIGH_CORING);      
	vRegWriteFldAlign(HSHARP_MAIN_02, 
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_HSHARP_HIGH_CORING), 0x00, XLEVEL), HSP_SHARP_MID_CORING);      
	vRegWriteFldAlign(HSHARP_MAIN_02, 
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_HSHARP_HIGH_CORING), 0x00, XLEVEL), HSP_SHARP_LOW_CORING);      
	vRegWriteFldAlign(HSHARP_MAIN_09, 
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_HSHARP_HIGH_CORING), 0x00, XLEVEL), HSP_LC_SHARP_HIGH_CORING);      
	vRegWriteFldAlign(HSHARP_MAIN_09, 
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_HSHARP_HIGH_CORING), 0x00, XLEVEL), HSP_LC_SHARP_MID_CORING);      
	vRegWriteFldAlign(HSHARP_MAIN_09, 
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_HSHARP_HIGH_CORING), 0x00, XLEVEL), HSP_LC_SHARP_LOW_CORING);     
    // Clarity Keeping : TDSAHRP Clip Soft Gain
	vRegWriteFldAlign(TDSHP_10,                                                                                                    
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_TDSHARP_GAIN_H1), 0x80, XLEVEL), TDS_GAIN_H1);
	vRegWriteFldAlign(TDSHP_10,                                                                                                    
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_TDSHARP_GAIN_H2), 0x80, XLEVEL), TDS_GAIN_H2);
	vRegWriteFldAlign(TDSHP_12,                                                                                                    
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_LTI_GAIN_LTI_H1), 0x80, XLEVEL), TDS_GAIN_LTI_H1);
	vRegWriteFldAlign(TDSHP_12,                                                                                                    
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_LTI_GAIN_LTI_H2), 0x80, XLEVEL), TDS_GAIN_LTI_H2);


	vRegWriteFldAlign(TDSHP_10,                                                                                                    
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_TDSHARP_GAIN_D1), 0xFF, DLEVEL), TDS_GAIN_D1);
	vRegWriteFldAlign(TDSHP_11,                                                                                                    
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_TDSHARP_GAIN_D2), 0xFF, DLEVEL), TDS_GAIN_D2);

	vRegWriteFldAlign(TDSHP_11,                                                                                                    
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_TDSHARP_GAIN_V1), 0x80, YLEVEL), TDS_GAIN_V1);
	vRegWriteFldAlign(TDSHP_11,                                                                                                    
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_TDSHARP_GAIN_V2), 0x80, YLEVEL), TDS_GAIN_V2);
	vRegWriteFldAlign(TDSHP_12,                                                                                                    
	    vDrvGetMoSharpValue(wReadQualityTable(QUALITY_LTI_GAIN_LTI_V), 0x80, YLEVEL), TDS_GAIN_LTI_V);
	

    return;
#endif    
}


void DRVCUST_SetPedestalCtrl(UINT8 bLevel)
{    
#if 0 // Below is SAMPLE CODE for function customization.
    if(fgIsMainVga()||fgIsMainDVI())
    {
        SET_MATRIX_PED(SV_OFF);
        
        switch (bLevel)
        {
            case SV_OFF:
                vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_FULL);
                break;
            case SV_ON:
                vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_LIMIT);
                break;
            default:
                vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_AUTO);
                break;                
        }
    }
    else if (fgIsMainTvd3d()||fgIsMainYPbPr())
    {
        vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_AUTO);

        switch (bLevel)
        {
            case SV_ON:
                SET_MATRIX_PED(SV_ON);
                break;
            case SV_OFF:
            default:
                SET_MATRIX_PED(SV_OFF);
                break;   
        }
    }
    else
    {
        SET_MATRIX_PED(SV_OFF);
        vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_AUTO);
    }
#endif
}

UINT8 DRVCUST_ColorTransform(UINT8 bPath, UINT8 bColorSys, UINT8 bHdtv)
{
    UINT8 bMonColorTransform;
    UINT8 bIsVideoTiming;

    bIsVideoTiming = (bGetSignalType(bPath) == SV_ST_DVI) ? bDviIsVideoTiming() : SV_TRUE;
    
    switch (bColorSys)
    {
        case SV_COLOR_YCBCR:
		#if 0//fix me
        case SV_COLOR_YCBCR_RGB:
        case SV_COLOR_YPBPR_ANALOG:
        case SV_COLOR_YPBPR_DIGITAL:
		#endif
        case SV_COLOR_HDMI_422_601:
        case SV_COLOR_HDMI_444_601:
        case SV_COLOR_HDMI_422_709:
        case SV_COLOR_HDMI_444_709:
            if (bIsScalerInput444(bPath))
            {
                if (bHdtv == SV_FALSE)
                {   // SDTV
                    bMonColorTransform = bIsVideoTiming ? 
                        SV_COLORTRANS_YCBCR601L_2_RGBF : SV_COLORTRANS_YCBCR601F_2_RGBF;
                }
                else    //HDTV
                {
                    bMonColorTransform = bIsVideoTiming ? 
                        SV_COLORTRANS_YCBCR709L_2_RGBF : SV_COLORTRANS_YCBCR709F_2_RGBF;
                }
            }
            else
            {
                if (bHdtv == SV_FALSE)
                {   // SDTV
                    bMonColorTransform = bIsVideoTiming ? 
                        SV_COLORTRANS_YCBCR601L_2_YCBCR601L : SV_COLORTRANS_YCBCR601F_2_YCBCR601L;
                }
                else    //HDTV
                {
                    bMonColorTransform = bIsVideoTiming ? 
                        SV_COLORTRANS_YCBCR709L_2_YCBCR601L : SV_COLORTRANS_YCBCR709L_2_YCBCR601L;
                }
            }
            break;
        case SV_COLOR_HDMI_RGB:
            if (bIsScalerInput444(bPath))
            {
                bMonColorTransform = bIsVideoTiming ? 
                    SV_COLORTRANS_RGBL_2_RGBF : SV_COLORTRANS_RGBF_2_RGBF;
            }
            else
            {
                bMonColorTransform = bIsVideoTiming ? 
                    SV_COLORTRANS_RGBL_2_YCBCR601L : SV_COLORTRANS_RGBF_2_YCBCR601L;
            }
            break;
        case SV_COLOR_RGB:
        default:
            bMonColorTransform = bIsVideoTiming ? 
                SV_COLORTRANS_RGBL_2_RGBF : SV_COLORTRANS_RGBF_2_RGBF;
            break;
    }
    return bMonColorTransform;
}


void DRVCUST_SetBlackLvlCtrl(UINT8 bPath)
{    
#if 0 // Below is SAMPLE CODE for function customization.
    UINT8 bLevel = GET_BLK_LVL(bPath);
    if (bPath == SV_VP_MAIN)
    {
        if(fgIsMainDVI())
    {
        SET_MATRIX_PED(SV_OFF);
            switch (bLevel)
            {
                case SV_OFF:
                    vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_FULL);
                    break;
                case SV_ON:
                    vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_LIMIT);
                    break;
                default:
                    vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_AUTO);
                    break;                
            }
        }
        else if (fgIsMainTvd3d() || fgIsMainYPbPr())
        {
            SET_MATRIX_PED(bLevel);
            vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_AUTO);
        }
        else
        {
            SET_MATRIX_PED(SV_OFF);
            vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_AUTO);
        }
    }
    else
    {
        SET_MATRIX_PED(SV_OFF);
        vSetHDMIRangeMode(SV_HDMI_RANGE_FORCE_AUTO);
    }
#endif
}

UINT32 DRVCUST_HDMIRange(UINT8 bPath)
{
    return (bDviIsVideoTiming() ? SV_HDMI_RANGE_LIMIT : SV_HDMI_RANGE_FULL);
}

UINT32 DRVCUST_GetOSMatrix709(UINT8 bPath)
{
    UINT32 u4Matrix709;

#if 1
    u4Matrix709 = GET_MATRIX_HD_709 && (wDrvVideoInputHeight(bPath) >= 720);
#else
    UINT32 u4ScrTiming = bDrvVideoGetSourceTypeTiming(bPath);
    u4Matrix709 = ((u4ScrTiming >= SOURCE_TYPE_TIMING_MM_SD_I) && (u4ScrTiming <= SOURCE_TYPE_TIMING_MM_1080IP_HD)) ? 
                    SV_FALSE : (GET_MATRIX_HD_709 && (wDrvVideoInputHeight(bPath) >= 720));
#endif
    return u4Matrix709;

}

UINT8 DRVCUST_MMAPPGetTiming(UINT8 bOutputTiming)
{
    switch(bOutputTiming)
	{
        case SOURCE_TYPE_TIMING_MM_1080IP_HD:
		case SOURCE_TYPE_TIMING_MM_1080IP_SD:
            return SOURCE_TYPE_TIMING_NET_1080IP;

       	case SOURCE_TYPE_TIMING_MM_720P_SD:
		case SOURCE_TYPE_TIMING_MM_720P_HD:
            return SOURCE_TYPE_TIMING_NET_720P;

		case SOURCE_TYPE_TIMING_MM_SD_P:
			return SOURCE_TYPE_TIMING_NET_SD_P;
			
		case SOURCE_TYPE_TIMING_MM_SD_I:
            return SOURCE_TYPE_TIMING_NET_SD_I;
        default:
            return (bOutputTiming);
    }
}

extern void u4TconCustEepromRead(UINT32 u4offset, UINT8 *pu1Buf,  UINT16 u2Count);
UINT8 GAMMA_Table_R0[TCON_EEPROM_GAMMA_SIZE];
UINT8 GAMMA_Table_G0[TCON_EEPROM_GAMMA_SIZE];
UINT8 GAMMA_Table_B0[TCON_EEPROM_GAMMA_SIZE];
UINT8 GAMMA_Table_R1[TCON_EEPROM_GAMMA_SIZE];
UINT8 GAMMA_Table_G1[TCON_EEPROM_GAMMA_SIZE];
UINT8 GAMMA_Table_B1[TCON_EEPROM_GAMMA_SIZE];
extern UINT8 GAMMA_256[3][GAMMA_INDEX];

void DRVCUST_EepromLoadGammaTable(void)
{

    #ifdef CC_SMALL_TCON_BOARD
    if(GetCurrentPanelIndex()== PANEL_MLVDS_SS_MB7)
    {
    	UINT8 *u1tmp;
        u1tmp = (UINT8 *)x_mem_alloc(TCON_EEPROM_GAMMA_SIZE);

        u4TconCustEepromRead(TCON_EEPROM_GAMMA_TBL_ADDR_1,u1tmp,TCON_EEPROM_GAMMA_SIZE);
        x_memcpy(&GAMMA_256[0], u1tmp, TCON_EEPROM_GAMMA_SIZE);
        u4TconCustEepromRead(TCON_EEPROM_GAMMA_TBL_ADDR_2, u1tmp, TCON_EEPROM_GAMMA_SIZE);
        x_memcpy(&GAMMA_256[1], u1tmp, TCON_EEPROM_GAMMA_SIZE);
        u4TconCustEepromRead(TCON_EEPROM_GAMMA_TBL_ADDR_3, u1tmp, TCON_EEPROM_GAMMA_SIZE);
        x_memcpy(&GAMMA_256[2], u1tmp, TCON_EEPROM_GAMMA_SIZE);
        x_mem_free( (VOID *)u1tmp ); 
    }
    #endif
}

extern UINT8 OD_Table_17_50Hz_LTemp[TCON_EEPROM_OD_SIZE];
extern UINT8 OD_Table_17_50Hz_HTemp[TCON_EEPROM_OD_SIZE];
extern UINT8 OD_Table_17_60Hz_LTemp[TCON_EEPROM_OD_SIZE];
extern UINT8 OD_Table_17_60Hz_HTemp[TCON_EEPROM_OD_SIZE];
extern UINT8 OD_Table[];

void DRVCUST_EepromLoadODTable(void)
{
    #ifdef CC_SMALL_TCON_BOARD
	UINT8 *u1tmp1;
	UINT8 *u1tmp2;    
    if(GetCurrentPanelIndex()== PANEL_MLVDS_SS_MB7)
    {
        u1tmp1 = (UINT8 *)x_mem_alloc(TCON_EEPROM_OD_SIZE/2+1);
        u1tmp2 = (UINT8 *)x_mem_alloc(TCON_EEPROM_OD_SIZE/2);
        
        u4TconCustEepromRead(TCON_EEPROM_OD_TBL_ADDR_1,u1tmp1,(TCON_EEPROM_OD_SIZE/2+1));
        x_memcpy(&OD_Table_17_50Hz_LTemp[0], u1tmp1, TCON_EEPROM_OD_SIZE/2+1);

        u4TconCustEepromRead((TCON_EEPROM_OD_TBL_ADDR_1+TCON_EEPROM_OD_SIZE/2+1),u1tmp2,(TCON_EEPROM_OD_SIZE/2));
        x_memcpy(&OD_Table_17_50Hz_LTemp[TCON_EEPROM_OD_SIZE/2+1], u1tmp2, TCON_EEPROM_OD_SIZE/2);

        u4TconCustEepromRead(TCON_EEPROM_OD_TBL_ADDR_2,u1tmp1,(TCON_EEPROM_OD_SIZE/2+1));
        x_memcpy(&OD_Table_17_50Hz_HTemp[0], u1tmp1, TCON_EEPROM_OD_SIZE/2+1);

        u4TconCustEepromRead((TCON_EEPROM_OD_TBL_ADDR_2+TCON_EEPROM_OD_SIZE/2+1),u1tmp2,(TCON_EEPROM_OD_SIZE/2));
        x_memcpy(&OD_Table_17_50Hz_HTemp[TCON_EEPROM_OD_SIZE/2+1], u1tmp2, TCON_EEPROM_OD_SIZE/2);

        u4TconCustEepromRead(TCON_EEPROM_OD_TBL_ADDR_3,u1tmp1,(TCON_EEPROM_OD_SIZE/2+1));
        x_memcpy(&OD_Table_17_60Hz_LTemp[0], u1tmp1, TCON_EEPROM_OD_SIZE/2+1);

        u4TconCustEepromRead((TCON_EEPROM_OD_TBL_ADDR_3+TCON_EEPROM_OD_SIZE/2+1),u1tmp2,(TCON_EEPROM_OD_SIZE/2));
        x_memcpy(&OD_Table_17_60Hz_LTemp[TCON_EEPROM_OD_SIZE/2+1], u1tmp2, TCON_EEPROM_OD_SIZE/2);

        u4TconCustEepromRead(TCON_EEPROM_OD_TBL_ADDR_4,u1tmp1,(TCON_EEPROM_OD_SIZE/2+1));
        x_memcpy(&OD_Table_17_60Hz_HTemp[0], u1tmp1, TCON_EEPROM_OD_SIZE/2+1);

        u4TconCustEepromRead((TCON_EEPROM_OD_TBL_ADDR_4+TCON_EEPROM_OD_SIZE/2+1),u1tmp2,(TCON_EEPROM_OD_SIZE/2));
        x_memcpy(&OD_Table_17_60Hz_HTemp[TCON_EEPROM_OD_SIZE/2+1], u1tmp2, TCON_EEPROM_OD_SIZE/2);        

        x_mem_free( (VOID *)u1tmp1 );    
        x_mem_free( (VOID *)u1tmp2 );        
    }
#endif
}

extern UINT8 bSI_DISPLAY_DCLK_TYPE;
void DRVCUST_SetODTable(void)
{
    //get OD table from flashPQ
#ifdef CC_SMALL_TCON_BOARD
	if(GetCurrentPanelIndex()== PANEL_MLVDS_SS_MB7)
	{
	    if(bSI_DISPLAY_DCLK_TYPE == SV_DCLK_60HZ)
	    {
	        x_memcpy(OD_Table, OD_Table_17_60Hz_LTemp, TCON_EEPROM_OD_SIZE);     
	    }
	    else
	    {
	        x_memcpy(OD_Table, OD_Table_17_50Hz_LTemp, TCON_EEPROM_OD_SIZE);                
	    }        
	}
	else
#endif        
	{
    bApiFlashPqUpdateOD();
	}
    vApiRegisterVideoEvent(PE_EVENT_OD, SV_VP_MAIN, SV_ON);
}

///////////////////////////////////////////////////////
//  Gamma Processing                                                            //
///////////////////////////////////////////////////////
int check_num;
//extern UINT16 u2GammaDecodedTable[3][257];
UINT16 u2GammaExtDecodedTable[3][4097];
//extern void vDrvGammaInterpolation(UINT32 u4Count, INT32* iCtlPos, INT32* iCtlValue, INT32* OutputLut);

void vDrvWriteGammaBuf(UINT8 bIndex, UINT16 wRal, UINT16 wGal, UINT16 wBal)
{
	wGammaMute[bIndex][0] = wRal;
	wGammaMute[bIndex][1] = wGal;
	wGammaMute[bIndex][2] = wBal;
}

UINT16 DRVCUST_GetGammaBuf(UINT8 bIndex, UINT8 bMode)
{
	if ((bIndex < 11) && (bMode<3))
	{
		return wGammaMute[bIndex][bMode];	
	}
	else
	{
		return 0;
	}
}

UINT16 DRVCUST_GetGammaDefault(UINT8 bMode, UINT8 bIndex)
{
	if (bIndex < 256)
	{
		return u2GammaDecodedTable[bMode][bIndex];	
	}
	else
	{
		return 0;
	}
}

//Interpolate from 11 or 57 ctrl point to 257 point gamma curve
void DRVCUST_PBM_GAMLinearInterpolation(UINT32 u4CtrlCount, UINT16* u4CtrlPos, UINT16* u4TarCtrPos, INT32* iCtrlValue, INT32* OutputLut)
{
	int i, j;
	INT32 u4Temp;
	
	OutputLut[0] = iCtrlValue[0];
	OutputLut[256] = iCtrlValue[u4CtrlCount - 1];
	
	for(i=0; i<GAMMA_INDEX; i++)
	{
		for(j=0; j<u4CtrlCount-1; j++)
		{
			if((u4TarCtrPos[i] > u4CtrlPos[j]) && (u4TarCtrPos[i] <= u4CtrlPos[j+1]))
			{
				//Need do rounding
				u4Temp = (u4TarCtrPos[i] - u4CtrlPos[j]) * (iCtrlValue[j+1] - iCtrlValue[j]) * 10 / (u4CtrlPos[j+1] - u4CtrlPos[j]);
				OutputLut[i] = iCtrlValue[j] + ((u4Temp > 0) ? (u4Temp + 5)/10 : (u4Temp - 5)/10);
				break;
			}
		}
	}
	
	return;
}

#ifdef CC_MAPLE_CUST_DRV
//Only for Sakura, Salvia NO need
BOOL DRVCUST_GAMMA_Ofst_ADJ_UI(UINT8 u1Channel, UINT8 u1Index, UINT8 u1Value)
{
    LOG(2, "DRVCUST_GAMMA_Ofst_ADJ_UI: Channel: %d, Index: %d, Value: %d\n", u1Channel, u1Index, u1Value);
	//u1Channel: 0:R; 1:G; 2:B
	if(u1Channel>2 || u1Index>(GAMMA_10P_OFST_CTRL_POINT_NUM-1) || u1Value>40 || u1Value<0)
	{
		LOG(0, "Gamma Adjust UI error! Channel: %d, Index: %d, Value:%d\n",  u1Channel, u1Index, u1Value);
		return SV_FALSE;
	}

	//AP set gamma!!!
	//DRVCUST_SET_GAMMA();
	//DRVCUST_SendEvent(E_CUST_PIC_SETTING_CHANGE, 0);

	u110POfst[bColorIndex][u1Channel][u1Index] = (UINT8)((INT32)u1Value - 20 + 128);
	if(SV_FALSE == DRVCUST_EepromWriteByte(EEP_WB_10P_OFST_G0_START + 
		(bColorIndex*3*GAMMA_10P_OFST_CTRL_POINT_NUM + u1Channel*GAMMA_10P_OFST_CTRL_POINT_NUM + u1Index), u110POfst[bColorIndex][u1Channel][u1Index]))
	{
		Printf("Write Gamma to EEPROM Fail!!\n");
		return SV_FALSE;
	}

	return SV_TRUE;
}
#endif

BOOL DRVCUST_SET_WB_GAM(UINT8 u1Channel, UINT8 u1Index, UINT8 u1Value)
{
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Channel>2 || u1Index>(GAMMA_CTRL_POINT_NUM_TRACK-1) || u1Value<0)
	{
		LOG(0, "Tracking mode: Set WB_GAM_XX error! Channel: %d, Index: %d, Value:%d\n", u1Channel, u1Index, u1Value);
		return SV_FALSE;
	}

    if(SV_FALSE == DRVCUST_EepromWriteByte(EEP_WB_GAM0_START + (GAMMA_CTRL_POINT_NUM_TRACK*u1Channel + u1Index), u1Value))
	{
		LOG(0, "Tracking mode: Write WB_GAM_XX to EEPROM Fail!!\n");
		return SV_FALSE;
	}
	
    return SV_TRUE;
}

BOOL DRVCUST_SET_INP_LVL_WB(UINT8 u1Index, UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Index>(GAMMA_CTRL_POINT_NUM_TRACK-1) || u2Value>8192 || u2Value<0)
	{
		LOG(0, "Tracking mode: Set INP_LVL_WB_XX error! Index: %d, Value:%d\n", u1Index, u2Value);
		return SV_FALSE;
	}

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_INP_LVL_START, (UINT32)u1Temp, 2))//DRVCUST_EepromWriteByte(EEP_WB_INP_LVL_START + u1Index*2, u1Value))
	{
		LOG(0, "Tracking mode: Write INP_LVL_WB_XX to EEPROM Fail!!\n");
		return SV_FALSE;
	}
	
    return SV_TRUE;
}


BOOL DRVCUST_SET_WB_GAM_GAIN(UINT8 u1Index, UINT8 u1Value)
{
	if(u1Index>(GAMMA_CTRL_POINT_NUM_TRACK-1) || u1Value<0)
	{
		LOG(0, "Tracking mode: Set WB_GAM_GAIN_XX error! Index: %d, Value:%d\n", u1Index, u1Value);
		return SV_FALSE;
	}

    if(SV_FALSE == DRVCUST_EepromWriteByte(EEP_WB_GAM_GAIN_START + u1Index, u1Value))
	{
		LOG(0, "Tracking mode: Write WB_GAM_GAIN_XX to EEPROM Fail!!\n");
		return SV_FALSE;
	}
	
    return SV_TRUE;
}

BOOL DRVCUST_SET_WB_BASE_GAIN(UINT8 u1ColorTemp, UINT8 u1Channel, UINT8 u1Value)
{
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Channel>2)
	{
		LOG(0, "Tracking mode: Set WB_GAM_XX error! Channel: %d, Index: %d, Value:%d\n", u1Channel, u1Value);
		return SV_FALSE;
	}

    if(SV_FALSE == DRVCUST_EepromWriteByte(EEP_WB_BASE_GAIN_START + (u1ColorTemp*3 + u1Channel), u1Value))
	{
		LOG(0, "Tracking mode: Write WB_BASE_GAIN_XX to EEPROM Fail!!\n");
		return SV_FALSE;
	}
	
    return SV_TRUE;
}


BOOL DRVCUST_SET_WB_GAM_SEL(UINT8 u1Value)
{
	if(SV_FALSE == DRVCUST_EepromWriteByte(EEP_WB_GAM_SEL, u1Value))
	{
		LOG(0, "Tracking mode: Write WB_GAIN_SEL to EEPROM Fail!!\n");
		return SV_FALSE;
	}
	
    return SV_TRUE;
}

BOOL DRVCUST_SET_WB_OFST(UINT8 u1ColorTemp, UINT8 u1Channel, UINT8 u1Index, UINT8 u1Value)
{
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Channel>2 || u1Index>(GAMMA_CTRL_POINT_NUM_TRACK-1) || u1Value<0)
	{
		LOG(0, "Tracking mode: Set WB_OFST_XX error! Channel: %d, Index: %d, Value:%d\n", u1Channel, u1Index, u1Value);
		return SV_FALSE;
	}

    if(SV_FALSE == DRVCUST_EepromWriteByte(EEP_WB_OFST_START + 
        (GAMMA_CTRL_POINT_NUM_TRACK*u1ColorTemp*3 + GAMMA_CTRL_POINT_NUM_TRACK*u1Channel + u1Index), u1Value))
	{
		LOG(0, "Tracking mode: Write WB_OFST_XX to EEPROM Fail!!\n");
		return SV_FALSE;
	}
	
    return SV_TRUE;
}

BOOL DRVCUST_SET_WBADJ_GODID_EEP(UINT8 u1Value)
{
    if(SV_FALSE == DRVCUST_EepromWriteByte(EEP_WB_WBADJ_GODID, u1Value))
    {
        LOG(0, "Write WBADJ_GODID to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WBADJ_PON_TIME_EEP(UINT8 u1Value)
{
    if(SV_FALSE == DRVCUST_EepromWriteByte(EEP_WB_WBADJ_PON_TIME, u1Value))
    {
        LOG(0, "Write WBADJ_PON_TIME to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WBADJ_JIG_VER_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_WBADJ_JJG_VER, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_JIG_VER to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WBADJ_DS_DATE_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_WBADJ_DS_DATE, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_DS_DATE to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WBADJ_ADJ_DATE_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_WBADJ_ADJ_DATE, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_ADJ_DATE to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WBADJ_AGING1_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_WBADJ_AGING1, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_AGING1 to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WBADJ_AGING2_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_WBADJ_AGING2, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_AGING2 to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WBADJ_JJG_INFO1_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_WBADJ_JJG_INFO_1, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_JJG_INFO_1 to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WBADJ_JJG_INFO2_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_WBADJ_JJG_INFO_2, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_JJG_INFO_2 to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WB_INFO0_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_INFO_0, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_INFO_0 to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WB_INFO1_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_INFO_1, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_INFO_1 to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WB_INFO2_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_INFO_2, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_INFO_2 to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WB_INFO3_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_INFO_3, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_INFO_3 to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}

BOOL DRVCUST_SET_WB_INFO4_EEP(UINT16 u2Value)
{
    UINT8 u1Temp[2] = {0};

    u1Temp[0] = u2Value & 0xFF;
    u1Temp[0] = (u2Value>>8) & 0xFF;
    
    if(SV_FALSE == EEPROM_Write(EEP_WB_INFO_4, (UINT32)u1Temp, 2))
    {
        LOG(0, "Write WBADJ_INFO_4 to EEPROM Fail!!\n");
        return SV_FALSE;
    }
    return SV_TRUE;
}


UINT8 DRVCUST_GET_WB_GAM(UINT8 u1Channel, UINT8 u1Index)
{
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Channel>2 || u1Index>GAMMA_CTRL_POINT_NUM_TRACK-1)
	{
		LOG(0, "Tracking mode: Get WB_GAM_XX error! Channel: %d, Index: %d, Value:%d\n", u1Channel, u1Index);
		return SV_FALSE;
	}
	
    return DRVCUST_EepromReadByte(EEP_WB_GAM0_START + (GAMMA_CTRL_POINT_NUM_TRACK*u1Channel + u1Index));
}

UINT16 DRVCUST_GET_INP_LVL_WB(UINT8 u1Index)
{
    UINT8 u2Value[2] = {0};
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Index>GAMMA_CTRL_POINT_NUM_TRACK-1)
	{
		LOG(0, "Tracking mode: Get INP_LVL_WB_XX error! Index: %d, Value:%d\n", u1Index);
		return SV_FALSE;
	}

    EEPROM_Read(EEP_WB_INP_LVL_START, (UINT32)u2Value, 2);
	
    return (u2Value[1]<<8 | u2Value[0]);
}

UINT8 DRVCUST_GET_WB_GAM_GAIN(UINT8 u1Index)
{
	if(u1Index>GAMMA_CTRL_POINT_NUM_TRACK-1)
	{
		LOG(0, "Tracking mode: Get WB_GAM_GAIN_XX error! Index: %d, Value:%d\n", u1Index);
		return SV_FALSE;
	}
	
    return DRVCUST_EepromReadByte(EEP_WB_GAM_GAIN_START + u1Index);
}

UINT8 DRVCUST_GET_WB_BASE_GAIN(UINT8 u1ColorTemp, UINT8 u1Channel)
{
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Channel>2)
	{
		LOG(0, "Tracking mode: Get WB_GAM_XX error! Channel: %d, Index: %d, Value:%d\n", u1Channel);
		return SV_FALSE;
	}
	
    return DRVCUST_EepromReadByte(EEP_WB_BASE_GAIN_START + (u1ColorTemp*3 + u1Channel));
}

UINT8 DRVCUST_GET_WB_GAM_SEL(void)
{	
    return DRVCUST_EepromReadByte(EEP_WB_GAM_SEL);
}

UINT8 DRVCUST_GET_WB_OFST(UINT8 u1ColorTemp, UINT8 u1Channel, UINT8 u1Index)
{
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Channel>2 || u1Index>GAMMA_CTRL_POINT_NUM_TRACK-1)
	{
		LOG(0, "Tracking mode: Get WB_OFST_XX error! Channel: %d, Index: %d, Value:%d\n", u1Channel, u1Index);
		return SV_FALSE;
	}
	
    return DRVCUST_EepromReadByte(EEP_WB_OFST_START + 
        (GAMMA_CTRL_POINT_NUM_TRACK*u1ColorTemp*3 + GAMMA_CTRL_POINT_NUM_TRACK*u1Channel + u1Index));
}

UINT8 DRVCUST_GET_WBADJ_GODID_EEP(void)
{
    return DRVCUST_EepromReadByte(EEP_WB_WBADJ_GODID);
}

UINT8 DRVCUST_GET_WBADJ_PON_TIME_EEP(void)
{
    return DRVCUST_EepromReadByte(EEP_WB_WBADJ_PON_TIME);
}

UINT16 DRVCUST_GET_WBADJ_JIG_VER_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_WBADJ_JJG_VER, (UINT32)u1Temp, 2);
	
    return (u1Temp[1]<<8 | u1Temp[0]);
}

UINT16 DRVCUST_GET_WBADJ_DS_DATE_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_WBADJ_DS_DATE, (UINT32)u1Temp, 2);
    
    return (u1Temp[1]<<8 | u1Temp[0]);
}



UINT16 DRVCUST_GET_WBADJ_ADJ_DATE_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_WBADJ_ADJ_DATE, (UINT32)u1Temp, 2);
    
    return (u1Temp[1]<<8 | u1Temp[0]);
}


UINT16 DRVCUST_GET_WBADJ_AGING1_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_WBADJ_AGING1, (UINT32)u1Temp, 2);
    
    return (u1Temp[1]<<8 | u1Temp[0]);
}


UINT16 DRVCUST_GET_WBADJ_AGING2_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_WBADJ_AGING2, (UINT32)u1Temp, 2);
    
    return (u1Temp[1]<<8 | u1Temp[0]);
}


UINT16 DRVCUST_GET_WBADJ_JJG_INFO1_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_WBADJ_JJG_INFO_1, (UINT32)u1Temp, 2);
    
    return (u1Temp[1]<<8 | u1Temp[0]);
}


UINT16 DRVCUST_GET_WBADJ_JJG_INFO2_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_WBADJ_JJG_INFO_2, (UINT32)u1Temp, 2);
    
    return (u1Temp[1]<<8 | u1Temp[0]);
}


UINT16 DRVCUST_GET_WB_INFO0_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_INFO_0, (UINT32)u1Temp, 2);
    
    return (u1Temp[1]<<8 | u1Temp[0]);
}


UINT16 DRVCUST_GET_WB_INFO1_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_INFO_1, (UINT32)u1Temp, 2);
    
    return (u1Temp[1]<<8 | u1Temp[0]);
}


UINT16 DRVCUST_GET_WB_INFO2_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_INFO_2, (UINT32)u1Temp, 2);
    
    return (u1Temp[1]<<8 | u1Temp[0]);
}


UINT16 DRVCUST_GET_WB_INFO3_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_INFO_3, (UINT32)u1Temp, 2);
    
    return (u1Temp[1]<<8 | u1Temp[0]);
}


UINT16 DRVCUST_GET_WB_INFO4_EEP(void)
{
    UINT8 u1Temp[2] = {0};

    EEPROM_Read(EEP_WB_INFO_4, (UINT32)u1Temp, 2);
    
    return (u1Temp[1]<<8 | u1Temp[0]);
}


UINT8 DRVCUST_GET_WB_GAM_ForFac(UINT8 u1Channel, UINT8 u1Index)
{
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Channel>2 || u1Index>GAMMA_CTRL_POINT_NUM_TRACK-1)
	{
		LOG(0, "Tracking mode: DRVCUST_GET_WB_GAM_ForFac error! Channel: %d, Index: %d\n", u1Channel, u1Index);
		return SV_FALSE;
	}
	
    return u1WB_GAM_RGB[u1Channel][u1Index];
}

UINT16 DRVCUST_GET_INP_LVL_WB_ForFac(UINT8 u1Index)
{
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Index>GAMMA_CTRL_POINT_NUM_TRACK-1)
	{
		LOG(0, "Tracking mode: DRVCUST_GET_INP_LVL_WB_ForFac error! Index: %d\n", u1Index);
		return SV_FALSE;
	}
	
    return u2WB_INP_LVL_Fac[u1Index];
}

UINT8 DRVCUST_GET_WB_GAM_GAIN_ForFac(UINT8 u1Index)
{
	if(u1Index>GAMMA_CTRL_POINT_NUM_TRACK-1)
	{
		LOG(0, "Tracking mode: DRVCUST_GET_WB_GAM_GAIN_ForFac error! Index: %d\n", u1Index);
		return SV_FALSE;
	}
	
    return u1WB_GAM_GAIN[u1Index];
}

UINT8 DRVCUST_GET_WB_BASE_GAIN_ForFac(UINT8 u1Channel)
{
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Channel>2)
	{
		LOG(0, "Tracking mode: DRVCUST_GET_WB_BASE_GAIN_ForFac error! Channel: %d\n", u1Channel);
		return SV_FALSE;
	}
	
    return u1WB_BASE_GAIN_RGB_EEP[bColorIndex][u1Channel];
}

UINT8 DRVCUST_GET_WB_OFST_ForFac(UINT8 u1Channel, UINT8 u1Index)
{
    //u1Channel: 0:R; 1:G; 2:B
	if(u1Channel>2 || u1Index>GAMMA_CTRL_POINT_NUM_TRACK-1)
	{
		LOG(0, "Tracking mode: DRVCUST_GET_WB_OFST_ForFac error! Channel: %d, Index: %d\n", u1Channel, u1Index);
		return SV_FALSE;
	}
	
    return u1WB_OFST_RGB[bColorIndex][u1Channel][u1Index];
}
void DRVCUST_SetGammaRemapForceLoad(UINT8 bForceLoadGamma);

void DRVCUST_SET_GAMMA(void)
{
    UINT32 i, j;        
    UINT8 u1CttlPointNum;
    static UINT8 bBootUp=SV_TRUE;           
    static INT32 i4GamCurveRGB[SV_RGB_RGB][GAMMA_INDEX];
    static UINT8 u1GammaPBMMode;

    UINT16 *u2TarCtlPos; 
    #ifdef CC_MAPLE_CUST_DRV
    UINT8 u1EepInplvl10PBuf[GAMMA_10P_OFST_CTRL_POINT_NUM*sizeof(UINT16)];
	#endif
    
    if((u2TarCtlPos= (UINT16*)x_mem_alloc(GAMMA_INDEX*sizeof(UINT16))) == NULL)
    {
        LOG(0, "DRVCUST_SET_GAMMA memory request fail !\n");
        return;
    }
    
    bGammaInit = SV_FALSE;      
        
    //PBM and Tracking use different gamma points.
    u1GammaPBMMode = DRVCUST_EepromReadByte(EEP_WB_LUT_ADJ_ON); 
    Printf("WB Method  %d, ColorIndex: %d\n", u1GammaPBMMode, bColorIndex);
    bColorIndex = MIN(E_CT_MAX-3, bColorIndex);     //Salvia only have 3 Color Temperature, Cool, Nature, Warm

    //This for temporary check, because the EEPROM have NOT ready!!
    /*
    if((DRVCUST_EepromReadByte(EEP_WB_TRAK_MAGIC_NUM_START) != GAMMA_MAGIC00) &&
        (DRVCUST_EepromReadByte(EEP_WB_TRAK_MAGIC_NUM_START + 1) != GAMMA_MAGIC01) &&
        (DRVCUST_EepromReadByte(EEP_WB_PBM_MAGIC_NUM00) != GAMMA_MAGIC01) &&
        (DRVCUST_EepromReadByte(EEP_WB_PBM_MAGIC_NUM01) != GAMMA_MAGIC01))
    {
        vApiFlashPqSetGammaId(bColorIndex);    
        bApiFlashPqUpdateGamma();
        vDrvGammaDecodeTable();
        vDrvSetGammaWritePingPongFlag(SV_TRUE); 
        return;
    }
    */

    if(!u1GammaPBMMode)//Tracking   
    {
        UINT8 u1WB_INP_LVL_EEP_BUF[GAMMA_CTRL_POINT_NUM_TRACK*2]={0};
        /*
        static UINT8 u1WB_GAM_RGB[SV_RGB_RGB][GAMMA_CTRL_POINT_NUM_TRACK];
        static UINT8 u1WB_OFST_RGB[E_CT_MAX][SV_RGB_RGB][GAMMA_CTRL_POINT_NUM_TRACK];
        static UINT8 u1WB_GAM_GAIN[GAMMA_CTRL_POINT_NUM_TRACK];
        static UINT16 u2WB_INP_LVL[GAMMA_CTRL_POINT_NUM_TRACK];
        static UINT8 u1WB_BASE_GAIN_RGB_EEP[E_CT_MAX][SV_RGB_RGB];
        */

        INT32 u4Determination_OFST[SV_RGB_RGB][GAMMA_CTRL_POINT_NUM_TRACK];
        //INT32 i4New_OFST[SV_RGB_RGB][GAMMA_CTRL_POINT_NUM_TRACK];
        INT32 iWB_BASE_GAIN_RGB[E_CT_MAX][SV_RGB_RGB];
        Printf("Tracking \n\n");
        
#ifdef CC_SONY_GAMMA
        /* init all gamma related parameters */
        //DRVCUST_Gamma_Init();
        //x_thread_delay(100);
#endif /* CC_SONY_GAMMA */

        if((DRVCUST_EepromReadByte(EEP_WB_TRAK_MAGIC_NUM_START) != GAMMA_MAGIC00) || 
            (DRVCUST_EepromReadByte(EEP_WB_TRAK_MAGIC_NUM_START + 1) != GAMMA_MAGIC01) || (bGammaLinear == SV_TRUE))
        {
            // Apply linear gamma           
            
            for (i=0; i<GAMMA_INDEX; i++)                                                                                                                         
            {                                                                                                                                                 
                i4GamCurveRGB[SV_RGB_R][i] = i<<4;                                                                                                        
                i4GamCurveRGB[SV_RGB_G][i] = i<<4;                                                                                                        
                i4GamCurveRGB[SV_RGB_B][i] = i<<4;                                                                                                        
            }
        }                                                                                                                                                         
        else// Gamma was enabled                                                                                                                                  
        {
            // Get EEPROM Gamma
            if(bBootUp || u1IsForceWBEepReload())     //Read PBM data from EEPROM 1st time to initialize gamma
            {
                if(EEPROM_Read(EEP_WB_GAM0_START, (UINT32)&u1WB_GAM_RGB, GAMMA_CTRL_POINT_NUM_TRACK*SV_RGB_RGB))
                {
                    Printf("Read Gamma from EEPROM Fail!!\n");
                }
                if(EEPROM_Read(EEP_WB_OFST_START, (UINT32)&u1WB_OFST_RGB, E_CT_MAX*SV_RGB_RGB*GAMMA_CTRL_POINT_NUM_TRACK))
                {
                    Printf("Read Gamma from EEPROM Fail!!\n");
                }
                if(EEPROM_Read(EEP_WB_GAM_GAIN_START, (UINT32)&u1WB_GAM_GAIN, GAMMA_CTRL_POINT_NUM_TRACK))
                {
                    Printf("Read Gamma from EEPROM Fail!!\n");
                }
                if(EEPROM_Read(EEP_WB_INP_LVL_START, (UINT32)&u1WB_INP_LVL_EEP_BUF, GAMMA_CTRL_POINT_NUM_TRACK*2))
                {
                    Printf("Read Gamma from EEPROM Fail!!\n");
                }
                u2WB_INP_LVL[0] = (u1WB_INP_LVL_EEP_BUF[0*2+1] << 8 | u1WB_INP_LVL_EEP_BUF[0*2]) >> 4;
    			for(i=1; i<GAMMA_CTRL_POINT_NUM_TRACK; i++)
    			{
    			    u2WB_INP_LVL[i] = u1WB_INP_LVL_EEP_BUF[i*2+1] << 8 | u1WB_INP_LVL_EEP_BUF[i*2];
    			    
    				if(u2WB_INP_LVL[i] < u2WB_INP_LVL[i-1])
    				{
    					u2WB_INP_LVL[i] = (u2WB_INP_LVL[i-1]<=4096) ? u2WB_INP_LVL[i-1] : 4096;
    				}
    				u2WB_INP_LVL_Fac[i] = u2WB_INP_LVL[i];
    				u2WB_INP_LVL[i] = u2WB_INP_LVL[i] >> 4;
    			}
    			
                if(EEPROM_Read(EEP_WB_BASE_GAIN_START, (UINT32)&u1WB_BASE_GAIN_RGB_EEP, SV_RGB_RGB*E_CT_MAX))
                {
                    Printf("Read Gamma from EEPROM Fail!!\n");
                }
            }

            for(i=0; i<GAMMA_CTRL_POINT_NUM_TRACK; i++)
            {
				u4Determination_OFST[SV_RGB_R][i] = ((INT32)((u1WB_GAM_RGB[SV_RGB_R][i] - 128) + (u1WB_OFST_RGB[bColorIndex][SV_RGB_R][i] -128))) * u1WB_GAM_GAIN[i];
				u4Determination_OFST[SV_RGB_G][i] = ((INT32)((u1WB_GAM_RGB[SV_RGB_G][i] - 128) + (u1WB_OFST_RGB[bColorIndex][SV_RGB_G][i] -128))) * u1WB_GAM_GAIN[i];
				u4Determination_OFST[SV_RGB_B][i] = ((INT32)((u1WB_GAM_RGB[SV_RGB_B][i] - 128) + (u1WB_OFST_RGB[bColorIndex][SV_RGB_B][i] -128))) * u1WB_GAM_GAIN[i];
			}
    
            for(i=0; i<GAMMA_INDEX; i++)
			{
				u2TarCtlPos[i] = i;
			}

			//Only for debug log
			LOG(4, "***********Track GAMMA Parameter ***********\nCtrlIdx    WB_GAM_R    WB_GAM_G    WB_GAM_B    WB_OFST_R    WB_OFST_G    WB_OFST_B\n");
			for(i=0; i<GAMMA_CTRL_POINT_NUM_TRACK; i++)
			{
			    LOG(4, "  %04d	  %04d	  %04d	  %04d	  %04d	  %04d	  %04d\n", i, u1WB_GAM_RGB[SV_RGB_R][i], u1WB_GAM_RGB[SV_RGB_G][i], u1WB_GAM_RGB[SV_RGB_B][i],
			        u1WB_OFST_RGB[bColorIndex][SV_RGB_R][i], u1WB_OFST_RGB[bColorIndex][SV_RGB_G][i], u1WB_OFST_RGB[bColorIndex][SV_RGB_B][i]);
			}

			for(i=0; i<GAMMA_CTRL_POINT_NUM_TRACK; i++)
			{
			    if(i==0)
			    {
                    LOG(4, "WB_GAM_GAIN:\n");
			    }
			    LOG(4, "    %04d\n",  u1WB_GAM_GAIN[i]);
			}

			for(i=0; i<GAMMA_CTRL_POINT_NUM_TRACK; i++)
			{
			    if(i==0)
			    {
                    LOG(4, "WB_INP_LVL:\n");
			    }
			    LOG(4, "  %04d\n", u2WB_INP_LVL[i]);
			}

			LOG(4, "WB_BASE_GAIN_RGB:   %04d	  %04d	  %04d\n", u1WB_BASE_GAIN_RGB_EEP[bColorIndex][SV_RGB_R], u1WB_BASE_GAIN_RGB_EEP[bColorIndex][SV_RGB_G], u1WB_BASE_GAIN_RGB_EEP[bColorIndex][SV_RGB_B]);
			
			LOG(4, "***********Track GAMMA Parameter END***********\n\n");

			LOG(3, "***********Track GAMMA u4Determination_OFST ***********\nCtrlIdx    R    G    B\n");
			for(i=0; i<GAMMA_CTRL_POINT_NUM_TRACK; i++)
			{
			    for(j=0; j<SV_RGB_RGB; j++)
			    {
				    LOG(3, "  %04d	  %04d	  %04d	  %04d\n", i, u4Determination_OFST[SV_RGB_R][i], u4Determination_OFST[SV_RGB_G][i], u4Determination_OFST[SV_RGB_B][i]);
                }
			}
			LOG(3, "***********Track GAMMA u4Determination_OFST END***********\n\n");

            //New OFST, ofst interpolate from 11 ctrl point to 257 point.
            DRVCUST_PBM_GAMLinearInterpolation(GAMMA_CTRL_POINT_NUM_TRACK, u2WB_INP_LVL, u2TarCtlPos, u4Determination_OFST[0], i4GamCurveRGB[0]);
            DRVCUST_PBM_GAMLinearInterpolation(GAMMA_CTRL_POINT_NUM_TRACK, u2WB_INP_LVL, u2TarCtlPos, u4Determination_OFST[1], i4GamCurveRGB[1]);
            DRVCUST_PBM_GAMLinearInterpolation(GAMMA_CTRL_POINT_NUM_TRACK, u2WB_INP_LVL, u2TarCtlPos, u4Determination_OFST[2], i4GamCurveRGB[2]);

            //Only for debug log
            LOG(3, "***********Track GAMMA New Offset***********\nCtrlIdx  CtrlPos  R_OFST  G_OFST  B_OFST\n");
            for(i=0; i<GAMMA_INDEX; i++)
            {
                LOG(3, "  %04d    %04d    %04d    %04d    %04d\n", i, u2TarCtlPos[i], i4GamCurveRGB[0][i], i4GamCurveRGB[1][i], i4GamCurveRGB[2][i]);
            }
            LOG(3, "***********Track GAMMA New Offset END***********\n\n");
                
            for(i=0; i<E_CT_MAX; i++)
            {
                for(j=0; j<SV_RGB_RGB; j++)
                {
                    iWB_BASE_GAIN_RGB[i][j] = u1WB_BASE_GAIN_RGB_EEP[i][j];     //convert from UINT8 to INT32, because the max the 0xff, if NOT convert,  (u1WB_BASE_GAIN_RGB_EEP + 1 >> 8) will error.

                }
            }

            for(i=0; i<GAMMA_INDEX; i++)
            {
                i4GamCurveRGB[SV_RGB_R][i] = ((u4WB_BASE_VALUE[i] * (iWB_BASE_GAIN_RGB[bColorIndex][SV_RGB_R] + 1))>>8) + i4GamCurveRGB[SV_RGB_R][i];
                i4GamCurveRGB[SV_RGB_G][i] = ((u4WB_BASE_VALUE[i] * (iWB_BASE_GAIN_RGB[bColorIndex][SV_RGB_G] + 1))>>8) + i4GamCurveRGB[SV_RGB_G][i];
                i4GamCurveRGB[SV_RGB_B][i] = ((u4WB_BASE_VALUE[i] * (iWB_BASE_GAIN_RGB[bColorIndex][SV_RGB_B] + 1))>>8) + i4GamCurveRGB[SV_RGB_B][i];
            }
        }
    }   
    else // PBM                                                                                                                                                   
    {      
        if((DRVCUST_EepromReadByte(EEP_WB_PBM_MAGIC_NUM00) != GAMMA_MAGIC00) || 
            (DRVCUST_EepromReadByte(EEP_WB_PBM_MAGIC_NUM01) != GAMMA_MAGIC01) || (bGammaLinear == SV_TRUE))
        {  
            // Apply linear gamma           
            
            for (i=0; i<GAMMA_INDEX; i++)                                                                                                                         
            {                                                                                                                                                 
                i4GamCurveRGB[SV_RGB_R][i] = i<<4;                                                                                                        
                i4GamCurveRGB[SV_RGB_G][i] = i<<4;                                                                                                        
                i4GamCurveRGB[SV_RGB_B][i] = i<<4;                                                                                                        
            }
        }       
        else
        {
        // 5 Gamma for color temp
        // 3 channel R, G, B for each Gamma
        // 33 points for each channel
        // 2 bytes for each points 
        static UINT8 u1EEPGammaBuf[E_CT_MAX][SV_RGB_RGB][GAMMA_CTRL_POINT_NUM_PBM * 2];
        UINT16 u2CtlPos[GAMMA_CTRL_POINT_NUM_PBM] = {0};
        
        INT32 iCtlValue_RGB[SV_RGB_RGB][GAMMA_CTRL_POINT_NUM_PBM];
            
        LOG(0, "PBM GAMMA\n\n");

#ifdef CC_MAPLE_CUST_DRV
        //For Sakura
        u1CttlPointNum = GAMMA_CTRL_POINT_NUM_PBM;
#else
        //For Salvia
        u1CttlPointNum = GAMMA_CTRL_POINT_NUM2_PBM;
#endif
        for(i=0; i< u1CttlPointNum; i++)
        {
            u2CtlPos[i] = u2CtlPos_PBM[i];
        }

        if(bBootUp || u1IsForceWBEepReload())//Read PBM data from EEPROM 1st time to initialize gamma
        {
            if(EEPROM_Read(EEP_WB_LUT_ADJ_G0_START,(UINT32)&u1EEPGammaBuf, E_CT_MAX*GAMMA_CTRL_POINT_NUM_PBM*2*SV_RGB_RGB))
            {
                Printf("Read Gamma from EEPROM Fail!!\n");
            }
        }

        LOG(3, "***********PBM GAMMA CONTROL POINT***********\n  CtrlIdx    CtrlPos    R    G    B\n");
        
        // Get EEPROM Gamma  from buffer (EEPROM already meet magic No.)
        for (i=0; i<u1CttlPointNum; i++)                                                                                                                          
        {                                                                                                                                                 
            iCtlValue_RGB[SV_RGB_R][i] = (INT32)(u1EEPGammaBuf[bColorIndex][SV_RGB_R][i*2+1])<<8 | u1EEPGammaBuf[bColorIndex][SV_RGB_R][i*2];
                                                                                                                                                              
            iCtlValue_RGB[SV_RGB_G][i] = (INT32)(u1EEPGammaBuf[bColorIndex][SV_RGB_G][i*2+1])<<8 | u1EEPGammaBuf[bColorIndex][SV_RGB_G][i*2];  
                                                                                                                                                              
            iCtlValue_RGB[SV_RGB_B][i] = (INT32)(u1EEPGammaBuf[bColorIndex][SV_RGB_B][i*2+1])<<8 | u1EEPGammaBuf[bColorIndex][SV_RGB_B][i*2];  

            LOG(3, "  %d,  %d,  %04d, %04d, %04d\n", i, u2CtlPos[i], iCtlValue_RGB[SV_RGB_R][i], iCtlValue_RGB[SV_RGB_G][i], iCtlValue_RGB[SV_RGB_B][i]);
        }
        LOG(3, "***********PBM GAMMA CONTROL POINT END***********\n");
        
#ifdef CC_Factory2K12
        for (i=0; i<u1CttlPointNum; ++i)
        {
            _iUsedCtlValue_R[i] = iCtlValue_RGB[SV_RGB_R][i];
            _iUsedCtlValue_G[i] = iCtlValue_RGB[SV_RGB_G][i];
            _iUsedCtlValue_B[i] = iCtlValue_RGB[SV_RGB_B][i];
        }
#endif

        for(i=0; i<GAMMA_INDEX; i++)
        {
            u2TarCtlPos[i] = i;
        }
        // GAMMA INTERPOLATION                                                                                                                                      
        DRVCUST_PBM_GAMLinearInterpolation(u1CttlPointNum, u2CtlPos, u2TarCtlPos, iCtlValue_RGB[SV_RGB_R], i4GamCurveRGB[SV_RGB_R]);  
        DRVCUST_PBM_GAMLinearInterpolation(u1CttlPointNum, u2CtlPos, u2TarCtlPos, iCtlValue_RGB[SV_RGB_G], i4GamCurveRGB[SV_RGB_G]); 
        DRVCUST_PBM_GAMLinearInterpolation(u1CttlPointNum, u2CtlPos, u2TarCtlPos, iCtlValue_RGB[SV_RGB_B], i4GamCurveRGB[SV_RGB_B]);                                                                                                                                                                        
        }
    }       

    _iUsedColorTemp = bColorIndex;
#ifdef CC_MAPLE_CUST_DRV
	//Only for Sakura, Salvia NO need
	if(bBootUp || u1IsForceWBEepReload())
	{
		if(EEPROM_Read(EEP_WB_10P_OFST_G0_START,(UINT32)&u110POfst, E_CT_MAX*GAMMA_10P_OFST_CTRL_POINT_NUM*SV_RGB_RGB))
		{
			Printf("Read Gamma from EEPROM Fail!!\n");
		}
		if(EEPROM_Read(EEP_WB_GAM_10P_GAIN_START,(UINT32)&u1Gam10PGain, GAMMA_10P_OFST_CTRL_POINT_NUM))
		{
			Printf("Read Gamma from EEPROM Fail!!\n");
		}
		if(EEPROM_Read(EEP_INP_LVL_10P_START,(UINT32)&u1EepInplvl10PBuf, GAMMA_10P_OFST_CTRL_POINT_NUM*2))
		{
			Printf("Read Gamma from EEPROM Fail!!\n");
		}
		for(i=0; i<GAMMA_10P_OFST_CTRL_POINT_NUM; i++)
		{
            u2Inplvl10P[i] = u1EepInplvl10PBuf[i*2+1]<<8 | u1EepInplvl10PBuf[i*2];
            u2Inplvl10P[i] = u2Inplvl10P[i] >> 4;
		}
	}

	if(bWBFlatPreOnoff == SV_FALSE)
	{
		i4Ctrl10POfst[SV_RGB_R][0] = 0;
		i4Ctrl10POfst[SV_RGB_G][0] = 0;
		i4Ctrl10POfst[SV_RGB_B][0] = 0;

		for(i=1; i<GAMMA_10P_OFST_CTRL_POINT_NUM; i++)
		{
			i4Ctrl10POfst[SV_RGB_R][i] = ((INT32)u110POfst[bColorIndex][SV_RGB_R][i] - 128) * u1Gam10PGain[i];
			i4Ctrl10POfst[SV_RGB_G][i] = ((INT32)u110POfst[bColorIndex][SV_RGB_G][i] - 128) * u1Gam10PGain[i];
			i4Ctrl10POfst[SV_RGB_B][i] = ((INT32)u110POfst[bColorIndex][SV_RGB_B][i] - 128) * u1Gam10PGain[i];
		}

		//Only for debug log
		LOG(4, "***********User 10P GAMMA Parameters***********\n  CtrlIdx    INP_LVL    GAM_GAIN	 1OFST_R	  OFST_G    OFST_B\n");
		for (i=0; i<GAMMA_10P_OFST_CTRL_POINT_NUM; i++) 																													  
		{																																				  
			LOG(4, "  %d,  %04d,  %04d,  %04d,    %04d,    %04d\n", i, u1Gam10PGain[i], u2Inplvl10P[i], u110POfst[bColorIndex][SV_RGB_R][i], 
			    u110POfst[bColorIndex][SV_RGB_G][i], u110POfst[bColorIndex][SV_RGB_B][i]);
		}
		LOG(4, "***********User 10P GAMMA Parameters END***********\n");
		
		LOG(3, "***********User 10P GAMMA CONTROL POINT***********\n  CtrlIdx	 R	  G    B\n");
		for (i=0; i<GAMMA_10P_OFST_CTRL_POINT_NUM; i++) 																													  
		{																																				  
			LOG(3, "  %d,  %04d,  %04d,    %04d,    %04d\n", i, u2Inplvl10P[i], i4Ctrl10POfst[0][i], i4Ctrl10POfst[1][i], i4Ctrl10POfst[2][i]);
		}
		LOG(3, "***********User 10P GAMMA CONTROL POINT END***********\n");

		for(i=0; i<GAMMA_INDEX; i++)
		{
			u2TarCtlPos[i] = i;
		}

		DRVCUST_PBM_GAMLinearInterpolation(GAMMA_10P_OFST_CTRL_POINT_NUM, u2Inplvl10P, u2TarCtlPos, i4Ctrl10POfst[SV_RGB_R], i4Gam10POfst[SV_RGB_R]); 
		DRVCUST_PBM_GAMLinearInterpolation(GAMMA_10P_OFST_CTRL_POINT_NUM, u2Inplvl10P, u2TarCtlPos, i4Ctrl10POfst[SV_RGB_G], i4Gam10POfst[SV_RGB_G]); 
		DRVCUST_PBM_GAMLinearInterpolation(GAMMA_10P_OFST_CTRL_POINT_NUM, u2Inplvl10P, u2TarCtlPos, i4Ctrl10POfst[SV_RGB_B], i4Gam10POfst[SV_RGB_B]);

		for(i=0; i<SV_RGB_RGB; i++)
		{
			for(j=0; j<GAMMA_INDEX; j++)
			{
				i4GamCurveRGB[i][j] += i4Gam10POfst[i][j] ;
			}
		}
	}		
#endif

    //Only for debug log
    LOG(5, "***********HW GAMMA CURVE AFTER INTP***********\n  Idx    R     G     B\n");
    for(i=0; i<GAMMA_INDEX; i++)
    {
        LOG(5, " %d  %d  %d  %d\n", i, i4GamCurveRGB[0][i], i4GamCurveRGB[1][i], i4GamCurveRGB[2][i]);
    }
    LOG(5, "***********HW GAMMA CURVE AFTER INTP END***********\n");  

    for(i=0; i<GAMMA_INDEX; i++)
    {
        for(j=0; j<SV_RGB_RGB; j++)
        {
            if(i4GamCurveRGB[j][i] < 0)
            {
                i4GamCurveRGB[j][i] = 0;
            }
            if(i4GamCurveRGB[j][i] > ((i==GAMMA_INDEX-1) ? 4096 : 4095))
            {
                i4GamCurveRGB[j][i] = ((i==GAMMA_INDEX-1) ? 4096 : 4095);
            }
        }
    }
    
    u2GammaDecodedTable[SV_RGB_R][0] = (UINT16)(i4GamCurveRGB[SV_RGB_R][0]);                                                                                                      
    u2GammaDecodedTable[SV_RGB_G][0] = (UINT16)(i4GamCurveRGB[SV_RGB_G][0]);                                                                                                      
    u2GammaDecodedTable[SV_RGB_B][0] = (UINT16)(i4GamCurveRGB[SV_RGB_B][0]);                                                                                                          
    wHwGammaCurve[SV_RGB_R][0] = (UINT16)(i4GamCurveRGB[SV_RGB_R][0]);                                                                                                            
    wHwGammaCurve[SV_RGB_G][0] = (UINT16)(i4GamCurveRGB[SV_RGB_G][0]);                                                                                                            
    wHwGammaCurve[SV_RGB_B][0] = (UINT16)(i4GamCurveRGB[SV_RGB_B][0]);  

    //limter before to decoder table.                                                                                                                                                             
    for (i=1; i<GAMMA_INDEX; i++)                                                                                                                                       
    {                                                                                                                                                         
        if ((i4GamCurveRGB[SV_RGB_R][i] < i4GamCurveRGB[SV_RGB_R][i-1]) || (i4GamCurveRGB[SV_RGB_R][i]==0))                                                                                   
        {                                                                                                                                                 
            i4GamCurveRGB[SV_RGB_R][i] = i4GamCurveRGB[SV_RGB_R][i-1];                                                                                                        
        }                                                                                                                                                 
        if ((i4GamCurveRGB[SV_RGB_G][i] < i4GamCurveRGB[SV_RGB_G][i-1]) || (i4GamCurveRGB[SV_RGB_G][i]==0))                                                                                   
        {                                                                                                                                                 
            i4GamCurveRGB[SV_RGB_G][i] = i4GamCurveRGB[SV_RGB_G][i-1];                                                                                                        
        }                                                                                                                                                 
        if ((i4GamCurveRGB[SV_RGB_B][i] < i4GamCurveRGB[SV_RGB_B][i-1]) || (i4GamCurveRGB[SV_RGB_B][i]==0))                                                                                   
        {                                                                                                                                                 
            i4GamCurveRGB[SV_RGB_B][i] = i4GamCurveRGB[SV_RGB_B][i-1];                                                                                                        
        }                                                                                                                                                 
                                                                                                                                                          
        u2GammaDecodedTable[SV_RGB_R][i] = (UINT16)(i4GamCurveRGB[SV_RGB_R][i]);                                                                                                      
        u2GammaDecodedTable[SV_RGB_G][i] = (UINT16)(i4GamCurveRGB[SV_RGB_G][i]);                                                                                                      
        u2GammaDecodedTable[SV_RGB_B][i] = (UINT16)(i4GamCurveRGB[SV_RGB_B][i]);                                                                                                      
        wHwGammaCurve[SV_RGB_R][i] = (UINT16)(i4GamCurveRGB[SV_RGB_R][i]);                                                                                                        
        wHwGammaCurve[SV_RGB_G][i] = (UINT16)(i4GamCurveRGB[SV_RGB_G][i]);                                                                                                        
        wHwGammaCurve[SV_RGB_B][i] = (UINT16)(i4GamCurveRGB[SV_RGB_B][i]);  
    }           

    x_mem_free(u2TarCtlPos);

    vDrvSetGammaWritePingPongFlag(SV_TRUE);
    
    bBootUp = SV_FALSE;
    bGammaInit = SV_TRUE;
    //DRVCUST_SetGammaRemapForceLoad(SV_ON); //ForceGammaRemmap
    vDrvSetGammaRemap(SV_ON);
}


///////////////////////////////////////////////////////
//Gamma REMAP
///////////////////////////////////////////////////////

#define NUM_OF_TEMP_GAMMA 0x80

const  UINT16 PANEL_GAMMA_REMAP_TBL[]=
{
    #include "GammaRemapTbl.h"
};

//Flag for Notice Gamma writing later
//volatile UINT8 bUpdatingGamma=SV_FALSE;
//Flag for Not Updating Gamma Because Gamma is waiting to be write
//EXTERN volatile UINT8 bWaitingWriteGamma;

static INT32 i4DynGammaIndex=0x40;

void DRVCUST_SET_DEFAULT_GAMMA_REMAP(void)
{
    vIO32WriteFldAlign(ADAPTIVE_RGB_GAMMA_REG, 0x30, ADAPTIVE_RGB_GAMMA_SEL);
}

void DRVCUST_SetGammaRemapForceLoad(UINT8 bForceLoadGamma)
{
	//if have remap spec, need to modify... Currently, set to default, means no remap
	DRVCUST_SET_DEFAULT_GAMMA_REMAP();
	vIO32WriteFldAlign(ADAPTIVE_RGB_GAMMA_REG, bForceLoadGamma, ADAPTIVE_RGB_GAMMA_FORCE_LOAD);
}

void DRVCUST_GAMMA_REMAP_CALC(UINT32 u4GammaSel)
{

	UINT32 i;
	EXTERN UINT16 u2GammaDecodedTable[3][257];

	//UINT16 wTmpGammaCurve[3][257];

	UINT16 *wTmpGammaCurve;	
	UINT16 GammaLength = 2*3*257;
	const UINT16 *pwRemapTable=NULL;
	//UINT16 pwTempTable[256];
	UINT32 u4Index,u4IndexNxt;
	UINT32 u4CurrentCh;
	UINT8  bDecayUpTh,bDecayLowTh;
	UINT16 bAlpha;
	UINT8  bGammaBlendingEn;

	bDecayUpTh= IO32ReadFldAlign(ADAPTIVE_RGB_GAMMA_REG_01, ADAPTIVE_RGB_GAMMA_DECAY_UPTH);
	bDecayLowTh= IO32ReadFldAlign(ADAPTIVE_RGB_GAMMA_REG_01, ADAPTIVE_RGB_GAMMA_DECAY_LOWTH);
	bGammaBlendingEn= IO32ReadFldAlign(ADAPTIVE_RGB_GAMMA_REG_01, ADAPTIVE_RGB_GAMMA_BLENING_EN);
	if((wTmpGammaCurve = x_mem_alloc(GammaLength)) == NULL)
		return;
	
	if(u4GammaSel > 50)
	{
		bGammaBlendingEn = 0;
	}
	
	if(u4GammaSel <= NUM_OF_TEMP_GAMMA)
	{
		pwRemapTable=PANEL_GAMMA_REMAP_TBL+u4GammaSel*0x100;		
	}

	bDecayUpTh = MAX(bDecayLowTh+1,bDecayUpTh);



	if(pwRemapTable!=NULL)
	{ 

		for(u4CurrentCh=0; u4CurrentCh<3; ++u4CurrentCh)
		{
			for(i=0;i<256;++i)
			{
				if(i >= bDecayUpTh)
				{
					bAlpha = 100;
				}
				else if(i <= bDecayLowTh) 
				{
					bAlpha = 15;
				}
				else
				{
					bAlpha = (85 * (i - bDecayLowTh) / (bDecayUpTh - bDecayLowTh)) + 15;
				}
				
				if(!bGammaBlendingEn)
				{
					u4Index = (pwRemapTable[i] >> 2)&0xFF;
					u4IndexNxt = MIN(u4Index + 1,0xFF);
				}
				else
				{
					u4Index = ((i*4 + (((pwRemapTable[i] - i*4) * bAlpha )/100)) >> 2)&0xFF;
					u4IndexNxt = MIN(u4Index + 1,0xFF);
				}

				/*wTmpGammaCurve[u4CurrentCh][i]=
					((wHwGammaCurve[u4CurrentCh][u4Index] * (4-(pwRemapTable[i]&3)) +
						wHwGammaCurve[u4CurrentCh][u4IndexNxt]*(pwRemapTable[i]&3) + 2)>>2);*/ //modify to fix warning "Frame size bigger than 1024Byte"
				wTmpGammaCurve[u4CurrentCh*257 + i] = 
					((wHwGammaCurve[u4CurrentCh][u4Index] * (4-(pwRemapTable[i]&3)) +
						wHwGammaCurve[u4CurrentCh][u4IndexNxt]*(pwRemapTable[i]&3) + 2)>>2);
			}
		}
		/*wTmpGammaCurve[0][256] = wHwGammaCurve[0][256];
		wTmpGammaCurve[1][256] = wHwGammaCurve[1][256];
		wTmpGammaCurve[2][256] = wHwGammaCurve[2][256];*/ // modify to fix warning "Frame size bigger than 1024Byte"
		wTmpGammaCurve[256] = wHwGammaCurve[0][256];
		wTmpGammaCurve[1*257+256] = wHwGammaCurve[1][256];
		wTmpGammaCurve[2*257+256] = wHwGammaCurve[2][256];
		
	}
	else
	{
		for(i=0;i<257;++i)
		{
			/*wTmpGammaCurve[0][i]=wHwGammaCurve[0][i];
			wTmpGammaCurve[1][i]=wHwGammaCurve[1][i];
			wTmpGammaCurve[2][i]=wHwGammaCurve[2][i];*/  // modify to fix warning "Frame size bigger than 1024Byte"
			wTmpGammaCurve[i]=wHwGammaCurve[0][i];
			wTmpGammaCurve[1*257+i]=wHwGammaCurve[1][i];
			wTmpGammaCurve[2*257+i]=wHwGammaCurve[2][i];
		}	
	}

	LOG(5, "***********HW GAMMA CURVE AFTER REMAP***********\n  Idx	  R 	G	  B\n");
	for(i=0; i<257; i++)
    {
		LOG(5, " %d  %d  %d  %d\n", i, wTmpGammaCurve[i], wTmpGammaCurve[1*257+i], wTmpGammaCurve[2*257+i]);
    }
	LOG(5, "***********HW GAMMA CURVE AFTER REMAP END***********\n");
	//x_memcpy(u2GammaDecodedTable, wTmpGammaCurve, sizeof(wTmpGammaCurve));		
	x_memcpy(u2GammaDecodedTable, wTmpGammaCurve, GammaLength);		
	x_mem_free(wTmpGammaCurve);
	wTmpGammaCurve = NULL;
}

void DRVCUST_PANEL_GAMMA_REMAP(UINT32 u4GammaSel)
{
	i4DynGammaIndex=u4GammaSel+0x10;
	DRVCUST_GAMMA_REMAP_CALC(i4DynGammaIndex);	

}

void DRVCUST_PanelGammaRemapProc(void)
{
	//Gamma Proc for Gamma Remap.
    if ((bGammaInit && ((bPreGammaSel!= IO32ReadFldAlign(ADAPTIVE_RGB_GAMMA_REG, ADAPTIVE_RGB_GAMMA_SEL)) || 
		IO32ReadFldAlign(ADAPTIVE_RGB_GAMMA_REG, ADAPTIVE_RGB_GAMMA_FORCE_LOAD)))
        /*&&(bAingFlag == FALSE)&&(fgpicturemodechange == SV_FALSE)*/)
    {
        bPreGammaSel= IO32ReadFldAlign(ADAPTIVE_RGB_GAMMA_REG, ADAPTIVE_RGB_GAMMA_SEL);
        DRVCUST_PANEL_GAMMA_REMAP(bPreGammaSel);
        vDrvSetGammaWritePingPongFlag(SV_TRUE);
        vIO32WriteFldAlign(ADAPTIVE_RGB_GAMMA_REG, SV_FALSE, ADAPTIVE_RGB_GAMMA_FORCE_LOAD);
    }
}

void DRVCUST_SET_YGAMMA(UINT32 i1Mode)
{
    EXTERN void vDrvADLSetYGamma(UINT8 bIndex);
    
    switch((INT8)i1Mode)
    {
        case -3:
            vDrvADLSetYGamma(9);
            break;
        case -2:
            vDrvADLSetYGamma(8);
            break;

        case -1:
            vDrvADLSetYGamma(7);

            break;
        case 1:
            vDrvADLSetYGamma(1);
            break;

        case 2:
            vDrvADLSetYGamma(3);
            break;
        case 3:
            vDrvADLSetYGamma(5);
            break;

        default:
            vDrvADLSetYGamma(0);
            break;
    }

    return;
}

void DRVCUST_AutoColorTempUpdate(AUTO_COLORTEMP_SETS_INFO_T *aCTInfo)
{
    //because of factory command, I need a flag to force update gamma curve
    //I use the 1st bit of ui1CTIndex as that flag
    UINT8 u1_force_update = 0;
    
	printf("Update Color Temp %d, \n", aCTInfo->ui1CTIndex);
    if(aCTInfo->ui1CTIndex & 0x80)
    {
        u1_force_update = 1;
        aCTInfo->ui1CTIndex &= 0x7F;
    }
    
    //Set color temp index;
    if(u1_force_update || bColorIndex!=aCTInfo->ui1CTIndex)
    {
        bColorIndex = aCTInfo->ui1CTIndex;
        DRVCUST_SET_GAMMA();
    }
}

void DRVCUST_ClarityUpdate(INT8 u1Value)
{
    
    //printf("User change clarity setting %d \n", u1Value);
    vIO32WriteFldAlign(NR_AUTO_CONTROL, (INT8)u1Value, NR_AUTO_STRENGTH);
    return;
}

void DRVCUST_MMAPProc(void)
{
    if (sMMAppInfo.u1AppType == 0xFF) /*Pretend for Netflix App */
    {
        //Update new QtyTbl
        bApiVideoProc(SV_VP_MAIN, PE_ARG_3D_NR);
        bApiVideoProc(SV_VP_MAIN, PE_ARG_NR);
        bApiVideoProc(SV_VP_MAIN, PE_ARG_MPEG_NR);
        bApiVideoProc(SV_VP_MAIN, PE_ARG_SHARPNESS);
    }
}

void DRVCUST_AdaptiveBacklightMode(UINT8 bMode)
{
     UNUSED(bMode);
     return;
}
void DRVCUST_AutoBacklightDisable(void)
{    
    return;
}
UINT32 DRVCUST_DemoRegion(void)
{
     
    return VDP_PQ_DEMO_ON_LEFT;
}
void DRVCUST_TurnOnInkMark(UINT8 ui1_onOff)
{
    if(ui1_onOff)
    {
        vRegWriteFldAlign(DBG_CFG_MAIN, 1, INK_EN);
        vRegWriteFldAlign(DBG_CFG_MAIN, 0, Y_INK_MODE);
        vRegWriteFldAlign(DBG_CFG_MAIN, 0, CB_INK_MODE);
        vRegWriteFldAlign(DBG_CFG_MAIN, 0, CR_INK_MODE);

        // ink color
        vRegWriteFldMulti(INK_DATA_MAIN,
            P_Fld(0x100, INK_DATA_Y) |
            P_Fld(0, INK_DATA_CB));
        vRegWriteFldAlign(INK_DATA_MAIN_CR, 0, INK_DATA_CR);
    }
    else
    {
        vRegWriteFldAlign(DBG_CFG_MAIN, 0, INK_EN);
    }
}
void DRVCUST_SetInkMark(UINT16 ui2_x, UINT16 ui2_y)
{
    vRegWriteFldMulti(POS_MAIN, P_Fld(ui2_x, POS_X)|P_Fld(ui2_y, POS_Y));
}
void DRVCUST_TurnOnRamp(UINT8 ui1_onOff)
{
    if(ui1_onOff)
    {
        vRegWriteFldAlign(DBG_CFG_MAIN, 1, INK_EN);
        if (ui1_onOff == 2)
        {
            vRegWriteFldAlign(DBG_CFG_MAIN, 2, Y_INK_MODE);
        }
        else if (ui1_onOff == 3)
        {
            vRegWriteFldAlign(DBG_CFG_MAIN, 4, Y_INK_MODE);
        }
        else
        {
            vRegWriteFldAlign(DBG_CFG_MAIN, 3, Y_INK_MODE);
        }
        // ink color
        vRegWriteFldMulti(INK_DATA_MAIN,
            P_Fld(0x3FF, INK_DATA_Y) |
            P_Fld(0x200, INK_DATA_CB));
        vRegWriteFldAlign(INK_DATA_MAIN_CR, 0x200, INK_DATA_CR);
			
        vRegWriteFldAlign(DBG_CFG_MAIN, 1, CB_INK_MODE);
        vRegWriteFldAlign(DBG_CFG_MAIN, 1, CR_INK_MODE);
    }
    else
    {
        vRegWriteFldAlign(DBG_CFG_MAIN, 0, INK_EN);
    }
}
#define MAUNAL_GAMMA_STEP 4
#define MAUNAL_GAMMA_UI_OFFSET 0
UINT32 iCtlValue[3][11];
#define INT32_CLIP(val, min, max) (((val>=max) ? max : ((val<=min) ? min : val)))  

void DRVCUST_SET_MAUNAL_GAMMA(INT32 i4GammaCtrlPts[3][11])
{
    UINT32 i;
    const UINT8 GAMMA_NUM = 11;
    const INT32 i4LinearGamma[11] = {0, 416, 816, 1232, 1632, 2048, 2464, 2864, 3280, 3680, 4096};//allencyhsu 20131225

    for (i = 0; i < GAMMA_NUM; i++)
    {
        iCtlValue[0][i] = INT32_CLIP(i4LinearGamma[i] + ((i4GammaCtrlPts[0][i] - MAUNAL_GAMMA_UI_OFFSET) * MAUNAL_GAMMA_STEP), 0, 4095);
        iCtlValue[1][i] = INT32_CLIP(i4LinearGamma[i] + ((i4GammaCtrlPts[1][i] - MAUNAL_GAMMA_UI_OFFSET) * MAUNAL_GAMMA_STEP), 0, 4095);
        iCtlValue[2][i] = INT32_CLIP(i4LinearGamma[i] + ((i4GammaCtrlPts[2][i] - MAUNAL_GAMMA_UI_OFFSET) * MAUNAL_GAMMA_STEP), 0, 4095);
    }

    for (i = 0; i < GAMMA_NUM; i++)
    {
        vIO32Write2B(GAMMA_MAUNAL_REMAP_R_00 + i * 2, iCtlValue[0][i]);
        vIO32Write2B(GAMMA_MAUNAL_REMAP_G_00 + i * 2, iCtlValue[1][i]);
        vIO32Write2B(GAMMA_MAUNAL_REMAP_B_00 + i * 2, iCtlValue[2][i]);
    }
}

void DRVCUST_GetLcdimPanelDelay(UINT8 *u1PanelDelay, UINT8 u1BlockNum)
{
    UINT8 bIndex;
    UINT16 i;
    bIndex = GetCurrentPanelIndex();

    if(bIndex == PANEL_LG_47_EUH_PR)
    {

        UINT8 u1PanelDelayCust[16] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15};
        x_memcpy(u1PanelDelay, u1PanelDelayCust, sizeof(u1PanelDelayCust));
    }   
    else
    {
        for(i = 0; i < u1BlockNum; i++)
        {
            u1PanelDelay[i] = 0;
        }
    }        
}

#ifdef CC_Factory2K12
/* BEGIN SONY, ramesh, 21/07/09 */

///////////////BEGIN SONY DRV CALLBACK/////////////////

#define NULL_CHK(ptr)  \
          do {                                              \
            if (ptr == NULL)\
            {\
                    return;\
            } } while (0)


void cbSony_AutoBacklightGetDbcParam(void* pvArg)
{
    printf("[][]cbSony_AutoBacklightGetDbcParam is not implement\n");
#if 0
    NULL_CHK(pvArg);
    ST_PARAM_DBC_MAIN* param = (ST_PARAM_DBC_MAIN*)pvArg;
    
    param->aplm = bDrvGetAPL();
    param->scene_change_det = bSceneChange;
    bDrvGetNormHist32(param->wHist32);
    param->luma_max = bDrvGetLumaMax();
		vDrvGetChromaHist((UINT16*)(param->cHist8), SV_FALSE, 0xFF);
#endif		
}

void cbSony_AutoBacklightGetDbc4psEnable(void* pvArg)
{
    printf("[][]cbSony_AutoBacklightGetDbc4psEnable is not implement\n");
#if 0
    NULL_CHK(pvArg);
    BOOL _fgNotNoSignal;
    BOOL _fgNotPipPap;
    BOOL _fgNotFullScreenOsd;
    BOOL _fgNotUsbPhotoMusic;
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */
    BOOL _fgNotFmRadio;
#endif
    BOOL* dbc4psEnable = (BOOL*)pvArg;


    if ((d_app_bl_stat.u1MmpMode == D_MMP_PHOTO) &&
        (d_app_bl_stat.u1MmpMode == D_MMP_MUSIC))
    {
      _fgNotUsbPhotoMusic = FALSE;    
    }
    else
    {
      _fgNotUsbPhotoMusic = TRUE;    
    }
    
    if ((d_app_bl_stat.u1MmpMode == D_MMP_NONE)           ||
        ((d_app_bl_stat.u1MmpOsdState == D_MMP_OSD_NONE)  &&
         (d_app_bl_stat.u1OsdType == D_MMP_OSD_NOT_FULL)))
    {
      _fgNotFullScreenOsd = TRUE;    
    }
    else
    {
      _fgNotFullScreenOsd = FALSE;    
    }
    
    if ((SRM_GetTvMode() == SRM_TV_MODE_TYPE_PIP) ||
        (SRM_GetTvMode() == SRM_TV_MODE_TYPE_POP))
    {
      _fgNotPipPap = FALSE;    
    }    
    else
    {
      _fgNotPipPap = TRUE;
    }
    
    if ((_fgNotPipPap == TRUE) &&
        (bDrvVideoSignalStatus_DBL(SV_VP_MAIN) != (UINT8)SV_VDO_STABLE))
    {
      _fgNotNoSignal = FALSE;
    }
    else
    {
      _fgNotNoSignal = TRUE;
    }
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */    
    if (d_app_bl_stat.u1FmRadioState == D_FM_RADIO_ON)
    {
      _fgNotFmRadio = FALSE;    
    }
    else
    {
      _fgNotFmRadio = TRUE;    
    }
#endif    

#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */
    if(_fgNotUsbPhotoMusic && _fgNotPipPap && _fgNotNoSignal && _fgNotFullScreenOsd & _fgNotFmRadio)
#else
    if(_fgNotUsbPhotoMusic && _fgNotPipPap && _fgNotNoSignal && _fgNotFullScreenOsd)
#endif
    {
      *dbc4psEnable = TRUE;
    }
    else
    {
      *dbc4psEnable = FALSE;
    }
#endif    
}

void cbSony_AutoBacklightGetDbcEnable(void* pvArg)
{
    printf("[][]cbSony_AutoBacklightGetDbcEnable is not implement\n");
#if 0
    NULL_CHK(pvArg);
    BOOL _fgNoSignal;
    BOOL _fgMute;
    BOOL _fgPap;
    BOOL _fgFullOsd;
    BOOL _fgUsbPhotoMusic;
    BOOL _fgScanning;
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */
    BOOL _fgTeletext;
    BOOL _fgFmRadio;
#endif
    BOOL _fgSceneX;
    BOOL* dbcEnable = (BOOL*)pvArg;
    
   if((bGetSignalType(SV_VP_MAIN) == SV_ST_TV)                          &&
      (bDrvVideoSignalStatus_DBL(SV_VP_MAIN) != (UINT8)SV_VDO_STABLE))
    {
      _fgNoSignal = TRUE;
    }
    else
    {
      _fgNoSignal = FALSE;
    }    

    if((SRM_GetTvMode() == SRM_TV_MODE_TYPE_NORMAL) &&
       (_u4DrvVideoGetMute(SV_VP_MAIN)))  
    {
      _fgMute = TRUE;
    }
    else
    {
      _fgMute = FALSE;
    }  
    
    if(SRM_GetTvMode() == SRM_TV_MODE_TYPE_POP)
    {
      _fgPap = TRUE;
    }
    else
    {
      _fgPap = FALSE;
    } 
    
    if ((d_app_bl_stat.u1MmpMode == D_MMP_NONE)           ||
        ((d_app_bl_stat.u1MmpOsdState == D_MMP_OSD_NONE)  &&
         (d_app_bl_stat.u1OsdType == D_MMP_OSD_NOT_FULL)))
    {
      _fgFullOsd = FALSE;    
    }
    else
    { 
      _fgFullOsd = TRUE;    
    } 

    if ((d_app_bl_stat.u1MmpMode == D_MMP_PHOTO) &&
        (d_app_bl_stat.u1MmpMode == D_MMP_MUSIC))
    {
      _fgUsbPhotoMusic = TRUE;    
    }
    else
    {
      _fgUsbPhotoMusic = FALSE;    
    }  

    if(d_app_bl_stat.u1AutoManScanState == D_IS_SCANNING)
    {
      _fgScanning = TRUE;    
    }
    else
    {
      _fgScanning = FALSE;    
    }  
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */    
    if(d_app_bl_stat.u1TeletextMode == D_TELETEXT_ON)
    {
      _fgTeletext = TRUE;    
    }
    else
    {
      _fgTeletext = FALSE;    
    }
    
    if (d_app_bl_stat.u1FmRadioState == D_FM_RADIO_ON)
    {
      _fgFmRadio = TRUE;    
    }
    else
    {
      _fgFmRadio = FALSE;    
    }    
#endif    
    if ((d_app_bl_stat.u1SceneMode == D_SCENE_GRAPHICS) &&
        (d_app_bl_stat.u1SceneMode == D_SCENE_GAME))
    {
      _fgSceneX = TRUE;    
    }
    else
    {
      _fgSceneX = FALSE;    
    }
    
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */
    if(_fgNoSignal || _fgMute || _fgPap || _fgFullOsd ||
       _fgUsbPhotoMusic || _fgScanning || _fgTeletext || _fgSceneX || _fgFmRadio)
#else
    if(_fgNoSignal || _fgMute || _fgPap || _fgFullOsd ||
       _fgUsbPhotoMusic || _fgScanning || _fgSceneX)
#endif
    {
      *dbcEnable = FALSE;
    }
    else
    {
    *dbcEnable = TRUE;
    }
#endif    
}

void cbSony_AutoBacklightGetNoSigGain(void* pvArg)
{
    printf("[][]cbSony_AutoBacklightGetNoSigGain is not implement\n");
#if 0
    NULL_CHK(pvArg);
    BOOL _fgNoMmp;
    BOOL _fgNoPipPapState;
    BOOL _fgNormalState;
    BOOL _fgNoAutoScan;
    BOOL _fgNotDemoUsb;
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */
    BOOL _fgNotFmRadio;
#endif
    BOOL* noSigGain = (BOOL*)pvArg;
    
    
    if(d_app_bl_stat.u1MmpMode == D_MMP_NONE)
    {
      _fgNoMmp = TRUE;
    }
    else
    {
      _fgNoMmp = FALSE;
    }
    
    if ((SRM_GetTvMode() == SRM_TV_MODE_TYPE_PIP)                         ||
        (SRM_GetTvMode() == SRM_TV_MODE_TYPE_POP))     
    {
      _fgNoPipPapState = FALSE;
    }
    else
    {
      _fgNoPipPapState = TRUE;
    }    

    if((SRM_GetTvMode() == SRM_TV_MODE_TYPE_NORMAL)                            &&
        ((_u4DrvVideoGetMute(SV_VP_MAIN))                                       ||
         ((bGetSignalType(SV_VP_MAIN)!= SV_ST_TV)                               &&
         (bDrvVideoSignalStatus_DBL(SV_VP_MAIN) == (UINT8)SV_VDO_NOSIGNAL))))
    {
      _fgNormalState = TRUE;
    }
    else
    {
      _fgNormalState = FALSE;
    }
    
    if(d_app_bl_stat.u1AutoManScanState == D_NOT_SCANNING)
    {
      _fgNoAutoScan = TRUE;    
    }
    else
    {
      _fgNoAutoScan = FALSE;    
    }

    if(d_app_bl_stat.u1DemoUsb == D_DEMO_MODE_USB_OFF)
    {
      _fgNotDemoUsb = TRUE;    
    }
    else
    {
      _fgNotDemoUsb = FALSE;    
    }

#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */    
    if (d_app_bl_stat.u1FmRadioState == D_FM_RADIO_OFF)
    {
      _fgNotFmRadio = TRUE;    
    }
    else
    {
      _fgNotFmRadio = FALSE;    
    }  
#endif

#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */          
    if(_fgNoMmp && _fgNoPipPapState && _fgNormalState && _fgNoAutoScan && _fgNotFmRadio && _fgNotDemoUsb)
#else
    if(_fgNoMmp && _fgNoPipPapState && _fgNormalState && _fgNoAutoScan && _fgNotDemoUsb)
#endif
    {     
      *noSigGain = TRUE;    
    }
    else
    {  
    *noSigGain = FALSE;
    }
#endif    
}

void cbSony_AutoBacklightSetDimming(void* pvArg)
{
    printf("[][]cbSony_AutoBacklightSetDimming is not implement\n");
#if 0
    NULL_CHK(pvArg);
    ST_PARAM_DIMMER* param = (ST_PARAM_DIMMER*)pvArg;
    
    vApiSetDimming(param->u2_pwm_Freq, param->u2_pwm_Duty);
#endif    
}    
    
extern INT32 OSD_PLA_Enable(UINT32 u4Plane, BOOL fgEnable);

/* >>> START, cheah 31-Jul-09, callback for Sony GammaWB adj + AutoWB */
void cbSony_GammaOSDControl(void* pvArg)
{
    BOOL* bOnOff = (BOOL*)pvArg;
    NULL_CHK(pvArg);

    /* disable/enable OSD */
    if (*bOnOff)
    {
        //OSD_PLA_Force_Off(TRUE);    //OSD_PLA_Force_Off
        OSD_PLA_Enable(OSD_PLANE_1, FALSE);
        OSD_PLA_Enable(OSD_PLANE_2, FALSE);
        OSD_PLA_Enable(OSD_PLANE_3, FALSE);
		//OSD_PLA_Enable_Ex(OSD_PLANE_2, 0);
    }
    else
    {
        //OSD_PLA_Force_Off(FALSE);   //OSD_PLA_Force_Off
        OSD_PLA_Enable(OSD_PLANE_1, TRUE);
        OSD_PLA_Enable(OSD_PLANE_2, TRUE);
        OSD_PLA_Enable(OSD_PLANE_3, TRUE);
        //OSD_PLA_Enable_Ex(OSD_PLANE_2, 1);
    }
}

void cbSony_GammaSetPat(void* pvArg)
{
	ST_PARAM_GAM_PTG* gam_param = (ST_PARAM_GAM_PTG*)pvArg;
	NULL_CHK(pvArg);
	
	if (gam_param->onOff == SV_TRUE)
	{
		/* toggle off first to avoid gamma curve corruption */
		vDrvGammaUnmute(); 
		/* turn ON gamma pattern */
		vDrvGammaMute(gam_param->wGammaR, \
                      gam_param->wGammaG, \
                      gam_param->wGammaB);
	}
	else
	{
		/* turn OFF gamma pattern */
		vDrvGammaUnmute(); 
	}
}

void cbSony_GammaSetSCEPat(void* pvArg)
{
	extern INT32 const YCBCR2RGBOS[3][15];	
	extern INT32 COLOR_TRANSFORM_ADJ[15];
    INT32 COLOR_TRANSFORM_Y2R[15];
    static UINT8 fgOnOff = SV_OFF;
    ST_PARAM_SCE_PTG* sce_param = (ST_PARAM_SCE_PTG*)pvArg;
    NULL_CHK(pvArg);

    vDrvSCEPatGen(sce_param->onOff, sce_param->data);
    vDrvSCEAllOnOff(sce_param->sceProc);       
    if (sce_param->onOff) 
    { 
        fgOnOff = bDrvGetBlueStretchOnOff(); /* store latest setting */
        if (fgOnOff)
        {
            vDrvSetBlueStretchOnOff(SV_VP_MAIN, SV_OFF); /* bypass blue stretch */
        }
        
		x_memcpy(COLOR_TRANSFORM_Y2R, YCBCR2RGBOS[0], sizeof(COLOR_TRANSFORM_Y2R));
        vLoadOSColorMatrix(SV_VP_MAIN, COLOR_TRANSFORM_Y2R);
        vOSTGVideoPlaneHWMute(SV_VP_MAIN,0); //Disable HDMI mute during pattern on
        _vDrvVideoForceUnMute(0, 1);
    }
    else
    { 
        if (fgOnOff != bDrvGetBlueStretchOnOff())
        {
            vDrvSetBlueStretchOnOff(SV_VP_MAIN, fgOnOff); /* restore user blue stretch setting */
        }
        
        vOSTGVideoPlaneHWMute(SV_VP_MAIN,1); //Enable HDMI mute
        _vDrvVideoForceUnMute(0, 0);		
        vLoadOSColorMatrix(SV_VP_MAIN, COLOR_TRANSFORM_ADJ);
    }	
}

void cbSony_GammaLoad(void* pvArg)
{
    UNUSED(pvArg);
#if 0
    UNUSED(pvArg);
	/* load sony gamma table */
	vDrvGammaLoadTable(E_GAMMA_MIDDLE);
    vIO32WriteFldAlign(ADAPTIVE_RGB_GAMMA_REG,SV_ON,ADAPTIVE_RGB_GAMMA_FORCE_LOAD);
#else
	/* load sony gamma table */
    vDrvSetGammaWritePingPongFlag(SV_TRUE);                                                                                                                                 
#endif    
}

void cbSony_WBSetGainOfst(void* pvArg)
{
	ST_PARAM_WB_T* wb_param = (ST_PARAM_WB_T*)pvArg;
	NULL_CHK(pvArg);
	
	/* Color Gain */
	vHalVideoRGBGain(SV_VP_MAIN, SV_RGB_R, wb_param->wGainR);
	vHalVideoRGBGain(SV_VP_MAIN, SV_RGB_G, wb_param->wGainG);
	vHalVideoRGBGain(SV_VP_MAIN, SV_RGB_B, wb_param->wGainB);
	
	/* Color offset */
	vHalVideoRGBOffset(SV_VP_MAIN, SV_RGB_R, wb_param->wOfstR);
	vHalVideoRGBOffset(SV_VP_MAIN, SV_RGB_G, wb_param->wOfstG);
	vHalVideoRGBOffset(SV_VP_MAIN, SV_RGB_B, wb_param->wOfstB);
}

/* <<< END, cheah 31-Jul-09, callback for Sony GammaWB adj + AutoWB */

/* >>> START cheah, fetch WB data from Sony (08-Sep-09) */
UINT16 DRVCUST_GetRGB(UINT8 bCTIndex, UINT8 bmode, UINT8 bRGB)
{
	return (DRVCUST_GetSonyRGB(bCTIndex, bmode, bRGB));
}
/* <<< END cheah, fetch WB data from Sony (08-Sep-09) */

/* Ooi START: callback func for get noise level (31 July 09) */
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */
void cbSony_IPGetNRLvl (void* pvArg)
{
  NULL_CHK(pvArg);
	*((UINT8*)pvArg) = bTvdSignalStrengthLevel(1);
}

void cbSony_IPGetSignalStatus (void* pvArg)
{
  NULL_CHK(pvArg);
	BOOL* status = (BOOL*)pvArg;
	
	if (bDrvVideoSignalStatus_DBL(SV_VP_MAIN) == SV_VDO_STABLE)
	{
		*status = TRUE;	
	}
	else
	{
		*status = FALSE;
	}
}

void cbSony_IPIsCVBS (void* pvArg)
{
  NULL_CHK(pvArg);
	BOOL* ret = (BOOL*) pvArg;

	if((bGetVideoDecType(bDrvNRGetCurrentPath())==SV_VD_TVD3D)&&
    	(bGetSignalType(bDrvNRGetCurrentPath())==SV_ST_AV))
  	{
		*ret = TRUE;
  	}
  	else
  	{
  		*ret = FALSE;
  	}
}

void cbSony_IPIsChannelChange (void* pvArg)
{
  NULL_CHK(pvArg);
	BOOL* param = NULL;
	
	if (pvArg == NULL)
	{
		return;
	}
	param = (BOOL*)pvArg;
	
	*param = FALSE;
	
	if (fgTvdCannelChangeStatus())
	{
		*param = TRUE;	
	}
}
#endif
/*Ooi END */

void cbSony_IsRgbSensor (void* pvArg)
{
    UINT32 *pu4Data ;
    NULL_CHK(pvArg);

    //VERIFY(DRVCUST_InitQuery(eCustomerRGBSensorSupport,(UINT32 *)pvArg) == 0);
    pu4Data = pvArg;
    *pu4Data = (UINT32)0;
}

void cbSony_SIFWrite (void* pvArg)
{
  ST_PARAM_SIF_T* param = (ST_PARAM_SIF_T*)pvArg;
  NULL_CHK(pvArg);

  param->u2Ret = SIF_Write(param->u2ClkDiv, param->u1DevAddr, param->u1WordAddr,
                                       param->pu1Buf, param->u2ByteCnt);
}

void cbSony_SIFRead (void* pvArg)
{
  ST_PARAM_SIF_T* param = (ST_PARAM_SIF_T*)pvArg;  
  NULL_CHK(pvArg);
  
  param->u2Ret = SIF_Read(param->u2ClkDiv, param->u1DevAddr, param->u1WordAddr,
                                      param->pu1Buf, param->u2ByteCnt);
}

#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY
#define DEEP_DIMMER_GPIO      GPIO(13)
#endif
void cbSony_AutoBacklightPwmSwitch(void* pvArg)
{
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY
    NULL_CHK(pvArg);
    GPIO_Output(DEEP_DIMMER_GPIO, (INT32*)pvArg);  
#endif
}

void cbSony_AutoBacklightGet24P(void* pvArg)
{
  BOOL* param = (BOOL*)pvArg;
  NULL_CHK(pvArg);
  
  if(bDrvVideoGetSourceTypeTiming(SV_VP_MAIN) == SOURCE_TYPE_TIMING_DIGI_1080P_24)
  {
    *param = TRUE;
  }
  else
  {
    *param = FALSE;
  }
}

/* BEGIN SONY, zahrul 25/08/09 */
void cbSony_AutoBacklightGetDblParam(void* pvArg)
{
    ST_PARAM_DBL_CTRL* param = (ST_PARAM_DBL_CTRL*)pvArg;
    NULL_CHK(pvArg);

    if(param == NULL)
    {
        return;
    }
#ifdef LOAD_PANEL_FROM_FLASH_CUSTOM   
    param->bl_mid_knee      = 0; //FlashPanel_GetBacklightData(BL_MID_KNEE);
    param->bl_setuden       = 0; //FlashPanel_GetBacklightData(BL_SETUDEN);
    param->bl_psh           = 0; //FlashPanel_GetBacklightData(BL_PSH);
    param->bl_cri_onoff     = 0; //FlashPanel_GetBacklightData(BL_CRI_ONOFF);
    param->bl_cri_pwm_frq   = 0; //FlashPanel_GetBacklightData(BL_CRI_PWM_FRQ);
    param->bl_cri_duty      = 0; //FlashPanel_GetBacklightData(BL_CRI_DUTY);
    param->bl_max_duty      = 0; //FlashPanel_GetBacklightData(BL_MAX_DUTY);
    param->bl_min_duty      = 0; //FlashPanel_GetBacklightData(BL_MIN_DUTY);
    param->d_dimmer_th_en   = 0; //FlashPanel_GetDimData(D_DIMMER_TH_EN);
    param->d_dimmer_th_h    = 0; //FlashPanel_GetDimData(D_DIMMER_TH_H);
    param->d_dimmer_th_l    = 0; //FlashPanel_GetDimData(D_DIMMER_TH_L);    
    param->bl_top           = 0; //PANEL_GetBacklightHigh();
    param->bl_mid           = 0; //PANEL_GetBacklightMiddle();
    param->bl_bottom        = 0; //PANEL_GetBacklightLow();
    param->bl_pwm_frq       = 0; //PANEL_GetDimmingFrequency50Hz();
    param->bl_24p_pwm_frq   = 0; //PANEL_GetDimmingFrequency48Hz();
    param->panel_type       = 0; //FlashPanel_GetPanelType();
#else
    param->bl_mid_knee      = 0x05; 
    param->bl_setuden       = 0x32; 
    param->bl_psh           = 0x00; 
    param->bl_cri_onoff     = 0x01; 
    param->bl_cri_pwm_frq   = 0x4b; 
    param->bl_cri_duty      = 0x0a; 
    param->bl_max_duty      = 0xff; 
    param->bl_min_duty      = 0x33; 
    param->d_dimmer_th_en   = 0x01; 
    param->d_dimmer_th_h    = 0x5a; 
    param->d_dimmer_th_l    = 0x55;     
    param->bl_top           = 0xff;
    param->bl_mid           = 0x96;
    param->bl_bottom        = 0x32;
    param->bl_pwm_frq       = 0x96;  
    param->bl_24p_pwm_frq   = 0x90;  
    param->panel_type       = 0x01;
#endif /* LOAD_PANEL_FROM_FLASH_CUSTOM */
    /* Load from AQ flash */
    param->bl_temp_th_low   = 0; //AUD_Get_BackLight(TEMP_TH_LOW);
    param->bl_temp_th_high  = 0; //AUD_Get_BackLight(TEMP_TH_HIGH);
    param->temp_bl_limit    = 0; //AUD_Get_BackLight(TEMP_TH_LIMIT);
    param->bl_temp_cntth    = 0; //AUD_Get_BackLight(BL_TEMP_CNTTH);
    param->bl_temp_inc      = 0; //AUD_Get_BackLight(BL_TEMP_INC);
    param->temp_bl_bottom   = 0; //AUD_Get_BackLight(TEMP_BL_BOTTOM);
    param->opt_bl_deadb     = 0; //AUD_Get_BackLight(OPT_BL_DEADB); 
    param->opt_bl_deadb_cin = 0; //AUD_Get_BackLight(OPT_BL_DEADB_CIN);
    param->bl_cri_temp_l    = 0; //AUD_Get_BackLight(BL_CRI_TEMP_L);
    param->bl_cri_temp_h    = 0; //AUD_Get_BackLight(BL_CRI_TEMP_H);
}

void cbSony_SetBacklightGpioOffOn(void* pvArg)
{
    INT32* blSet = (INT32*)pvArg;
    NULL_CHK(pvArg);
    
    if((*blSet) == BACKLIGHT_ON)
    {
        vApiBackltONOFF(PANEL_ON);
    }
    else
    {
        vApiBackltONOFF(PANEL_OFF);
    }  
}

void cbSony_GetBacklightGpioStatus(void* pvArg)
{
    BOOL* bChkBLiteON = (BOOL*)pvArg; 
    UINT32 u4Check = 0;
    NULL_CHK(pvArg);
    
    u4Check = GPIO_Output(BACKLIGHT_GPIO,NULL);
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY
    if(u4Check == 1)
    {
        *bChkBLiteON = BACKLIGHT_ON;
    }
    else if(u4Check == 0)
    {
        *bChkBLiteON = BACKLIGHT_OFF;
    }
#else
    if(u4Check == 0)
    {
        *bChkBLiteON = BACKLIGHT_ON;
    }
    else if(u4Check == 1)
    {
        *bChkBLiteON = BACKLIGHT_OFF;
    }
#endif
}

void cbSony_GetOSDStatus(void* pvArg)
{
    BOOL* ret = (BOOL*)pvArg;
    NULL_CHK(pvArg);

    *ret = (BOOL)_fgOSDStatusOn;    
}
/* END SONY, Zahrul */

/* BEGIN SONY, ramesh 21/08/09, memory alloc wrapper function */
VOID cbSony_x_mem_alloc (void* pvArg)
{
  PARAM_X_MEM_MGMT* param = (PARAM_X_MEM_MGMT*)pvArg;
  NULL_CHK(pvArg);

  UNUSED(param->pv_mem_block);
  UNUSED(param->ui4_num_element);
  
  param->pv_mem_addr = x_mem_alloc(param->z_size);
}

VOID cbSony_x_mem_calloc (void* pvArg)
{
  PARAM_X_MEM_MGMT* param = (PARAM_X_MEM_MGMT*)pvArg;
  NULL_CHK(pvArg);

  UNUSED(param->pv_mem_block);
  
  param->pv_mem_addr = x_mem_calloc(param->ui4_num_element, param->z_size);
}

VOID cbSony_x_mem_realloc (void* pvArg)
{
  PARAM_X_MEM_MGMT* param = (PARAM_X_MEM_MGMT*)pvArg;
  NULL_CHK(pvArg);

  UNUSED(param->ui4_num_element);
  
  param->pv_mem_addr = x_mem_realloc(param->pv_mem_block, param->z_size);
}

VOID cbSony_x_mem_free (void* pvArg)
{
  PARAM_X_MEM_MGMT* param = (PARAM_X_MEM_MGMT*)pvArg;
  NULL_CHK(pvArg);

  UNUSED(param->pv_mem_addr);
  UNUSED(param->z_size);
  UNUSED(param->ui4_num_element);
  
  x_mem_free(param->pv_mem_block);
}

/* END SONY, ramesh 21/08/09, memory wrapper function */

void cbSony_ATD_GetNoiseLevel(void* pvArg)
{
    NULL_CHK(pvArg);
    //*((UINT32*)pvArg) = ATD_GetNoiseLevel();     //temp mark for fix build error.
}
    
void cbSony_ATD_GetIFAGC(void* pvArg)
{
    NULL_CHK(pvArg);
    *((UINT16*)pvArg) = ATD_GetIFAGC();
}

void cbSony_ATD_SetLNA(void* pvArg)
{
    ST_PARAM_SetLNA* param = (ST_PARAM_SetLNA*)pvArg;
    NULL_CHK(pvArg);

    param->SetSuccess = ATD_SetLNA(param->fgLNA);
}

#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */
/* Start 20090903 Sony Chow: Get and set tuner register function*/
void cbSony_ATD_GetRegister(void* pvArg)
{
    NULL_CHK(pvArg);
    ST_PARAM_ATD_GETSETREG* param = (ST_PARAM_ATD_GETSETREG*)pvArg;

    (param->Success) = ATD_GetRegister(param->RegAddr,param->pData,param->ByteCnt);
}
void cbSony_ATD_SetAGCPara(void* pvArg)
{
    NULL_CHK(pvArg);
    ST_PARAM_ATD_GETSETREG* param = (ST_PARAM_ATD_GETSETREG*)pvArg;

    (param->Success) = ATD_SetAGCPara(param->RegAddr,param->pData,param->ByteCnt);
}

void cbSony_Tuner_GetDevData(void* pvArg)
{
    NULL_CHK(pvArg);
    ST_SONY_TUNER_DATA* param = (ST_SONY_TUNER_DATA*)pvArg;
    param->value = 0;
    switch(param->TU_DATA){
        case TU_FreqData:
            param->value = Tuner_GetFreqData();
            break;
        case TU_StepData:
            param->value = (UINT16)Tuner_GetStepData();
            break;
        case TU_BandData:
            param->value = (UINT16)Tuner_GetBandData();
            break;
        default:
            break;
    }
}
void cbSony_Tuner_SetDevData(void* pvArg)
{
    NULL_CHK(pvArg);
    ST_SONY_TUNER_DATA* param = (ST_SONY_TUNER_DATA*)pvArg;
    param->success = FALSE;
    switch(param->TU_DATA){
        case TU_FreqData:
            param->success = Tuner_SetFreqData(param->value);
            break;
        case TU_StepData:
            param->success = Tuner_SetStepData((UINT8)(param->value));
            break;
        case TU_BandData:
            param->success = Tuner_SetBandData((UINT8)(param->value));
            break;
        default:
            break;
    }
}
/* End 20090903 Sony Chow: Get and set tuner register function*/

void cbSony_SigBstr_GetIPStatus(void* pvArg)
{
    NULL_CHK(pvArg);
    *((BOOL*)pvArg) = fgDrvGetAutoNROnOff();
}
#endif

void cbSony_IsPcHdmiPc(void* pvArg)
{
    NULL_CHK(pvArg);
  
    if(( bDrvVideoSignalStatus_DBL(SV_VP_MAIN) == (UINT8)SV_VDO_STABLE )                                    &&
       (( bGetVideoDecType( SV_VP_MAIN ) == SV_VD_DVI ) || ( bGetVideoDecType( SV_VP_MAIN ) == SV_VD_VGA )) &&
       fgApiVideoIsVgaTiming( SV_VP_MAIN ))
    {
      /* HDMI PC or PC */
      *( (BOOL*)pvArg ) = TRUE;
    }
    else
    {
      *( (BOOL*)pvArg ) = FALSE;
    }

}

void sonyDrv_RegisterCallback(void)
{
  UINT8 i;
  
  for(i=0; i < CB_DRV_FUNC_COUNT; i++)
  {
    callback_funcs.cbDrv[i] = NULL;
  }

  callback_funcs.cbDrv[CB_DRV_DBC_PARAM]         = cbSony_AutoBacklightGetDbcParam;
  callback_funcs.cbDrv[CB_DRV_DBC4PS_ENABLE]     = cbSony_AutoBacklightGetDbc4psEnable;
  callback_funcs.cbDrv[CB_DRV_DBC_ENABLE]        = cbSony_AutoBacklightGetDbcEnable;
  callback_funcs.cbDrv[CB_DRV_NO_SIG_GAIN]       = cbSony_AutoBacklightGetNoSigGain;  
  callback_funcs.cbDrv[CB_DRV_SET_DIMMING]           = cbSony_AutoBacklightSetDimming;
  callback_funcs.cbDrv[CB_DRV_GAM_OSD_CONTROL]       = cbSony_GammaOSDControl; 
  callback_funcs.cbDrv[CB_DRV_GAM_PATGEN_GAM]        = cbSony_GammaSetPat;
  callback_funcs.cbDrv[CB_DRV_GAM_PATGEN_SCE]        = cbSony_GammaSetSCEPat;
  callback_funcs.cbDrv[CB_DRV_GAM_LOADTBL]           = cbSony_GammaLoad;
  callback_funcs.cbDrv[CB_DRV_WB_GAINOFST]           = cbSony_WBSetGainOfst;
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */ 
  callback_funcs.cbDrv[CB_DRV_IP_GET_NOISE]          = cbSony_IPGetNRLvl;
  callback_funcs.cbDrv[CB_DRV_IP_GET_SIGNAL_STATUS]  = cbSony_IPGetSignalStatus;
  callback_funcs.cbDrv[CB_DRV_IP_IS_CVBS]            = cbSony_IPIsCVBS; 
#endif
  callback_funcs.cbDrv[CB_DRV_SIF_READ]              = cbSony_SIFRead;
  callback_funcs.cbDrv[CB_DRV_SIF_WRITE]             = cbSony_SIFWrite;
  callback_funcs.cbDrv[CB_DRV_IS_RGB_SENSOR]         = cbSony_IsRgbSensor;
  callback_funcs.cbDrv[CB_DRV_BL_PWM_SWITCH]         = cbSony_AutoBacklightPwmSwitch;
  callback_funcs.cbDrv[CB_DRV_BL_24P_STATUS]         = cbSony_AutoBacklightGet24P;
/* BEGIN SONY, ramesh 21/08/09, memory wrapper function */
  callback_funcs.cbDrv[CB_DRV_X_MEM_ALLOC]           = cbSony_x_mem_alloc;
  callback_funcs.cbDrv[CB_DRV_X_MEM_CALLOC]          = cbSony_x_mem_calloc;
  callback_funcs.cbDrv[CB_DRV_X_MEM_REALLOC]         = cbSony_x_mem_realloc;
  callback_funcs.cbDrv[CB_DRV_X_MEM_FREE]            = cbSony_x_mem_free;
/* END SONY, ramesh 21/08/09, memory wrapper function */
  callback_funcs.cbDrv[CB_DRV_LNA_GET_NOISE_LVL]     = cbSony_ATD_GetNoiseLevel;
  callback_funcs.cbDrv[CB_DRV_LNA_GET_IFAGC]         = cbSony_ATD_GetIFAGC;
  callback_funcs.cbDrv[CB_DRV_LNA_SET_LNA]           = cbSony_ATD_SetLNA;
  callback_funcs.cbDrv[CB_DRV_DBL_PARAM]             = cbSony_AutoBacklightGetDblParam;
  
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */
  /* Start 20090903 Sony Chow: Get and set tuner register function*/
  callback_funcs.cbDrv[CB_DRV_ATD_GETREG]            = cbSony_ATD_GetRegister;
  callback_funcs.cbDrv[CB_DRV_ATD_SETAGCPARA]        = cbSony_ATD_SetAGCPara;
  callback_funcs.cbDrv[CB_DRV_TUNER_DEVDATA_R]	 = cbSony_Tuner_GetDevData;
  callback_funcs.cbDrv[CB_DRV_TUNER_DEVDATA_W]	 = cbSony_Tuner_SetDevData;
  /* End 20090903 Sony Chow: Get and set tuner register function*/
  callback_funcs.cbDrv[CB_DRV_TUNER_GET_IP_STATUS]	 = cbSony_SigBstr_GetIPStatus;
#endif  
  
  /* Ooi: Callback func for IP if tuning is done (11/9/09) */
#ifdef THIRD_PARTY_LIB_EMCS_ATV_ONLY   /* Not Used in ATSC Project */  
  callback_funcs.cbDrv[CB_DRV_IP_IS_CHANCHG]	 = cbSony_IPIsChannelChange;
  /* Ooi End */
#endif
  callback_funcs.cbDrv[CB_DRV_IS_PC_HDMI_PC]	 = cbSony_IsPcHdmiPc;
  callback_funcs.cbDrv[CB_DRV_BL_GPIO_SWITCH]		= cbSony_SetBacklightGpioOffOn;
  callback_funcs.cbDrv[CB_DRV_BL_ONOFF_STATUS]      = cbSony_GetBacklightGpioStatus;
  callback_funcs.cbDrv[CB_DRV_BL_OSD_STATUS]       	= cbSony_GetOSDStatus;

  sonyDrvRegisterCallback(&callback_funcs);
}

///////////////END SONY DRV CALLBACK///////////////////
VOID DRVCUST_OSD_STATUS_CHANGE(BOOL fgOSDOn)
{
    UNUSED(_fgOSDStatusOn);
    _fgOSDStatusOn = fgOSDOn;
    
    Printf("DRVCUST_OSD_STATUS_CHANGE %d\n", fgOSDOn);
    /*Todo: Customer should add handling code in this function*/
}
#endif

BOOL DRVCUST_THIRDPARTY_FLAG(BOOL OnOff)
{
	return OnOff;
}
void DRVCUST_Enable_BrightnessPlus(BOOL OnOff)
{
	//vIO32WriteFldAlign(BRIGHT_PLUS_00, OnOff, BRIGHT_PLUS_CTRL);
}

BOOL vApiEepromGammaFlag(void)
{
	BOOL EepromGammaFlag=0;
/*	if (GetCurrentPanelIndex()== 30)
	{
		EepromGammaFlag = 1;
	}*/
    return EepromGammaFlag;
}

BOOL vApiEepromODFlag(void)
{
	BOOL EepromODFlag=0;
/*	if (GetCurrentPanelIndex()== 30)
	{
		EepromODFlag = 1;
	}*/
    return EepromODFlag;
}

void DRVCUST_GetLcdimPanelOrder(UINT8 *u1PanelOrder, UINT8 u1BlockNum)
{
	UINT8 bIndex;
	UINT16 i;
    bIndex = GetCurrentPanelIndex();

    if(bIndex == PANEL_EPI_LGDV12GIPFHD120)          // 1 * 12, LGD protocal
    {
        UINT8 u1PanelOrderCust[12] = {0, 2, 4, 6, 8, 10, 11, 9, 7, 5, 3, 1};      // MTK IC HW Sequence            
        x_memcpy(u1PanelOrder, u1PanelOrderCust, sizeof(u1PanelOrderCust));
    }   
    else if(bIndex == PANEL_LG_47_EUH_PR)          // 8 * 2, AMS protocal
    {
        UINT8 u1PanelOrderCust[16] = {0, 15, 1, 14, 2, 13, 3, 12, 4, 11, 5, 10, 6, 9, 7, 8};      // MTK IC HW Sequence
        x_memcpy(u1PanelOrder, u1PanelOrderCust, sizeof(u1PanelOrderCust));
    }       
    else
    {
        for(i = 0; i < u1BlockNum; i++)
        {
            u1PanelOrder[i] = i;
        }
    }        
    
    LOG(0, "Panel Order = ");
    
    for(i = 0; i < u1BlockNum; i++)
    {
        LOG(0, "%d  ", u1PanelOrder[i]);
    }    
}

void DRVCUST_GetLcdimPanelDimGain(UINT8 *u1PanelDimGain, UINT8 u1BlockNum)
{
	UINT8 bIndex;
	UINT16 i;
    bIndex = GetCurrentPanelIndex();

    if(bIndex == PANEL_EPI_LGDV12GIPFHD120)          // 1 * 12, LGD protocal
    {
        UINT8 u1PanelDimGainCust[12] = {0x98, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x98};
        x_memcpy(u1PanelDimGain, u1PanelDimGainCust, sizeof(u1PanelDimGainCust));
    }
    else if(bIndex == PANEL_LG_47_EUH_PR)          // 8 * 2, AMS protocal
    {
        UINT8 u1PanelDimGainCust[16] = {0xFF, 0xFF, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0xFF, 0xFF};
        x_memcpy(u1PanelDimGain, u1PanelDimGainCust, sizeof(u1PanelDimGainCust));
    }       
    else
    {
        for(i = 0; i < u1BlockNum; i++)
        {
            u1PanelDimGain[i] = 0x80;   //0x80 means gain 1
        }
    }        
    
    LOG(0, "Panel Dim Gain = ");
    
    for(i = 0; i < u1BlockNum; i++)
    {
        LOG(0, "%d  ", u1PanelDimGain[i]);
    }    
}

void DRVCUST_PqModeChange(UINT8 bPath)
{
    UINT32 i;
    
    for (i=0; i < (UINT8)PE_ARG_NS; i++)
    {
        switch (i)
        {
            // List all the quality items that do not update after mode change done.
            //  the back light is not relative to video timing, nor main/pip change.
            case PE_ARG_ADAPTIVE_BACK_LIGHT:
            case PE_ARG_BACK_LIGHT_LVL:
            case PE_ARG_R_GAIN:
            case PE_ARG_G_GAIN:
            case PE_ARG_B_GAIN:
            case PE_ARG_R_OFFSET:
            case PE_ARG_G_OFFSET:
            case PE_ARG_B_OFFSET:
                break;
            default:
                UNUSED(bApiVideoProc(bPath, (PE_ARG_TYPE)i));
                break;
        }
    }
    
    //DRVCUST_Reset_DBC_IIRCoef();  //Reset Coef of DBC
}


/***************************************************************************/
/******************************* AMBI-GLOW *********************************/
/***************************************************************************/

#ifdef SUPPORT_AMBI_GLOW

typedef enum
{
	RGB_ITEM_R1,
    RGB_ITEM_G1,
    RGB_ITEM_B1,
    RGB_ITEM_R2,
    RGB_ITEM_G2,
    RGB_ITEM_B2,    
	RGB_ITEM_MAX,
} RGB_QUE_ITEM;

UINT32 RGBDataQue[RGB_ITEM_MAX][256];
UINT32 RGBQueCounter[RGB_ITEM_MAX] = {0, 0, 0, 0, 0, 0};

UINT32 u4ReturnRGBQueAverage(UINT32 dwValue, UINT8 bItem)
{
	UINT32 bi;
	UINT32 PWMAverage=0;
	UINT32 RGBQueSize = IO32ReadFldAlign(OPC_0E, RUN_QUE_SIZE);

    if(RGBQueSize == 0)
    {
        RGBQueSize = 1;
    }

	if (RGBQueCounter[bItem] == 0)
	{
		RGBQueCounter[bItem]++;
		RGBDataQue[bItem][0] = dwValue;
		return dwValue;
	}

	if (RGBQueCounter[bItem] < RGBQueSize)
	{
		RGBQueCounter[bItem]++;

	}
	else
	{
        RGBQueCounter[bItem] = RGBQueSize;
	}

	for (bi = RGBQueCounter[bItem] - 1; bi > 0 ; bi--)
	{
		RGBDataQue[bItem][bi] = RGBDataQue[bItem][bi - 1];
	}

	// Insert New Item
	RGBDataQue[bItem][0] = dwValue;

	// Average Running Que
	for (bi = 0; bi < RGBQueCounter[bItem]; bi++)
	{
		PWMAverage += RGBDataQue[bItem][bi];
	}

	PWMAverage = PWMAverage / RGBQueCounter[bItem];

	return PWMAverage;
}


#ifdef AbsDiff
#undef AbsDiff
#endif
#define AbsDiff(a, b)  (((a)>(b)) ? ((a)-(b)) : ((b)-(a)))

UINT16 u4SatHist[8] = {0,0,0,0,0,30961,0,0};
UINT16 u4SatBound[9] = {0,1,4,9,20,36,54,80,80};

UINT16 u4HueHist[8] = {0,0,0,0,0,0,30961,0};
UINT16 u4HueBound[8] = {32, 64, 96, 128, 160, 192, 224, 0};

//sin(0 deg ~ 90 deg) = 0 ~ (2 ^ 14 = 16384)
INT32 const COLOR_TRANSFORM_HUE[129] =
{
    0,201,402,603,803,1004,1205,1405,               
    1605,1805,2005,2204,2404,2602,2801,2998,        
    3196,3393,3589,3785,3980,4175,4369,4563,        
    4756,4948,5139,5329,5519,5708,5896,6083,        
    6269,6455,6639,6822,7005,7186,7366,7545,        
    7723,7900,8075,8249,8423,8594,8765,8934,        
    9102,9268,9434,9597,9759,9920,10079,10237,      
    10393,10548,10701,10853,11002,11150,11297,11442,
    11585,11726,11866,12003,12139,12273,12406,12536,
    12665,12791,12916,13038,13159,13278,13395,13510,
    13622,13733,13842,13948,14053,14155,14255,14353,
    14449,14543,14634,14723,14810,14895,14978,15058,
    15136,15212,15286,15357,15426,15492,15557,15618,
    15678,15735,15790,15842,15892,15940,15985,16028,
    16069,16107,16142,16175,16206,16234,16260,16284,
    16305,16323,16339,16353,16364,16372,16379,16382,
    16384
};

UINT32 u4GetMainHue(UINT16 *u2Hist, UINT16 *u2Bound)
{
    UINT32 HueResult0_3 = 0, HueResult4_7 = 0, HueResult = 0;
    UINT32 u2HistSumHalf0_3 = u2Hist[0]  +  u2Hist[1]  +  u2Hist[2]  +  u2Hist[3] + u2Hist[7];
    UINT32 u2HistSumHalf4_7 =  u2Hist[4] + u2Hist[5]  +  u2Hist[6];    
    UINT32 u2HistSum = u2Hist[0]  +  u2Hist[1]  +  u2Hist[2]  +  u2Hist[3] + u2Hist[4]  +  u2Hist[5]  +  u2Hist[6]  +  u2Hist[7];
   
    
    if(u2HistSumHalf0_3 != 0)
    {
        HueResult0_3 = (u2Hist[0] * u2Bound[0] +  u2Hist[1] * u2Bound[1] +  u2Hist[2] * u2Bound[2] +  u2Hist[3] * u2Bound[3] +   u2Hist[7] * u2Bound[7]) / u2HistSumHalf0_3;
    }
    
    if(u2HistSumHalf4_7 != 0)
    {
        HueResult4_7 = (u2Hist[4] * u2Bound[4] + u2Hist[5] * u2Bound[5] +  u2Hist[6] * u2Bound[6]) / u2HistSumHalf4_7; 
    }

    if(u2HistSum != 0)
    {
        if((HueResult4_7 - HueResult0_3) > 128)
        {
            HueResult = ((( HueResult0_3 + 256 ) * u2HistSumHalf0_3) + (HueResult4_7 * u2HistSumHalf4_7)) / u2HistSum;            
        }
        else
        {
            HueResult = (( HueResult0_3  * u2HistSumHalf0_3) + (HueResult4_7 * u2HistSumHalf4_7)) / u2HistSum;

        }
    }

   
    HueResult = HueResult % 256;
    

    return (HueResult << 1);
}

UINT32 u4GetAverageHue(UINT16 *u2Hist, UINT16 *u2Bound)
{
	UINT32 i, HueSum = 0, TotalPxlCnt = 0, HueResult = 0;

	for(i = 0; i < 8; i++)
	{
		HueSum += u2Hist[i] * u2Bound[i];
		TotalPxlCnt += u2Hist[i];
	}
	if(TotalPxlCnt != 0)
	{
    	HueResult = (HueSum * 2) / TotalPxlCnt;
	}

	return HueResult;
}

UINT32 u4GetAverageSat(UINT16 *u2Hist, UINT16 *u2Bound)
{
	UINT32 i, SatSum = 0, TotalPxlCnt = 0, SatResult = 0;

	for(i = 0; i < 8; i++)
	{
		SatSum += ((u2Bound[i]+u2Bound[i+1])>>1) * u2Hist[i];
		TotalPxlCnt += u2Hist[i];
	}

	if(TotalPxlCnt != 0)
	{	
    	SatResult = SatSum / TotalPxlCnt;
	}

	return SatResult;
}

UINT8 u1HueHistCenter[8] = {16, 48, 80, 112, 144, 176, 208, 240};

UINT8 u1RemmapedSatGain[256] = {
0	,	0	,	0	,	0	,	0	,	0	,	0	,	0	,
2	,	4	,	6	,	8	,	10	,	12	,	14	,	16	,
19	,	22	,	25	,	28	,	31	,	34	,	37	,	40	,
44	,	48	,	52	,	56	,	60	,	64	,	68	,	72	,
77	,	82	,	87	,	92	,	97	,	102	,	107	,	112	,
118	,	124	,	130	,	136	,	142	,	148	,	154	,	160	,
167	,	174	,	181	,	188	,	195	,	202	,	209	,	216	,
224	,	232	,	240	,	248	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
255	,	255	,	255	,	255	,	255	,	255	,	255	,	255	,
};


UINT8 u1RemmapedSatGainWeighted[256] = {
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
251, 247, 243, 239, 235, 231, 227, 223, 219, 215, 211, 207, 203, 199, 195, 191,
187, 183, 179, 175, 171, 167, 163, 159, 155, 151, 147, 143, 139, 135, 131, 127,
123, 119, 115, 111, 107, 103, 99, 95, 91, 87, 83, 79, 75, 71, 67, 63,
57, 53, 49, 45, 41, 37, 33, 30, 30, 30, 30, 30, 30, 30, 30, 30,
30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
};


UINT32 u4HueProtectOnDistr(UINT32 u4Hue, UINT16 *u2Hist)
{
    UINT8 i;
    UINT32 u4HueDiff;
    UINT32 u4Distribution = 0;
    UINT32 u2HistSum = u2Hist[0]  +  u2Hist[1]  +  u2Hist[2]  +  u2Hist[3] + u2Hist[4]  +  u2Hist[5]  +  u2Hist[6]  +  u2Hist[7];    
    static UINT32 u4LogCnt = 0;

    u4Hue = u4Hue >> 1;


    for(i = 0; i < 8; i++)
    {
        if(AbsDiff(u4Hue, u1HueHistCenter[i]) > 128)
        {
            u4HueDiff = (AbsDiff(MIN(u4Hue, u1HueHistCenter[i]) + 256, MAX(u4Hue, u1HueHistCenter[i]))) % 256;
        }
        else
        {
            u4HueDiff = AbsDiff(u4Hue, u1HueHistCenter[i]);
        }
        u4Distribution += u4HueDiff * u2Hist[i];
    }

    if(u2HistSum == 0)
    {
        return 0;
    }
    
    u4Distribution = (u4Distribution * 0xFF) / ( u2HistSum * 64 );

    if((u4LogCnt ++ % 121) == 0)
    { 
        Printf("u4Distribution = %d, u4Hue = %d\n", u4Distribution, u4Hue);
        Printf("u2Hist[0] = %d, u2Hist[1] = %d, u2Hist[2] = %d, u2Hist[3] = %d, u2Hist[4] = %d, u2Hist[5] = %d, u2Hist[6] = %d, u2Hist[7] = %d\n", 
            u2Hist[0],u2Hist[1],u2Hist[2],u2Hist[3],u2Hist[4],u2Hist[5],u2Hist[6],u2Hist[7]);
    }


    if(u4Distribution > 255){u4Distribution = 255;}

    

    return u1RemmapedSatGainWeighted[u4Distribution];
}

UINT32 u4HueProtect(UINT32 u4Hue, UINT16 *u2Hist)
{
    UINT32 u2HistSum = u2Hist[0]  +  u2Hist[1]  +  u2Hist[2]  +  u2Hist[3] + u2Hist[4]  +  u2Hist[5]  +  u2Hist[6]  +  u2Hist[7];
    UINT32 u4SpecifiedSum;
    UINT32 u4MainVectorRatio;
    
    static UINT32 u4LogCnt = 0;

    UINT8 i;

    u4Hue = (u4Hue >> 1);

    if((u4Hue >= u1HueHistCenter[7]) || (u4Hue < u1HueHistCenter[0]))
    {
        u4SpecifiedSum = u2Hist[7];
    }
    else
    {
        for(i = 0; i < 7; i++)
        {
            if((u4Hue >= u1HueHistCenter[i]) && (u4Hue < u1HueHistCenter[i+1]))
            {
                u4SpecifiedSum = u2Hist[i];            
            }
        }
    }

    if(u2HistSum != 0)
    {
        u4MainVectorRatio = (u4SpecifiedSum * 0xFF) / u2HistSum;
    }
    else
    {
        u4MainVectorRatio = 0;
    }

    if((u4LogCnt ++ % 120) == 0)
    { 
        Printf("u4SpecifiedSum = %d, u2HistSum = %d, u4MainVectorRatio = %d RemappedGain = %d\n", u4SpecifiedSum, u2HistSum, u4MainVectorRatio, u1RemmapedSatGain[u4MainVectorRatio]);
    }

    return u1RemmapedSatGain[u4MainVectorRatio];
}

UINT8 u1MaxLumaofHue[16] = {29/*BLUE*/,51,102,56,46/*RED*/,79,114,173,204/*YELLOW*/,178,163,152,193/*CYAN*/,152,71,38};
UINT8 u1LumaWeightArray[16] =     {0, 32, 64, 96, 128, 160, 192, 208, 208, 208, 208, 208, 208, 208, 208, 208};

UINT32 u4RemmapLuma(UINT8 u1RGBMax, UINT8 u1APL, UINT32 u4Hue, UINT32 u4Sat)
{
    UINT8 u1LumaWeight = u1LumaWeightArray[u4Sat>>4]; ; 
    UINT32 RemmapedY;
	UINT32 YOffset = IO32ReadFldAlign(AMBILRATIO_2, AMBIL_Y_OFST);	    
    static UINT32 u4LogCnt = 0;     
#if 0
    RemmapedY = ((((UINT32)u1APL * (UINT32)u1MaxLumaofHue[u4Hue>>5] * (UINT32)u1LumaWeight)/0xFF)+
                ((UINT32)u1RGBMax * (UINT32)(0xFF-u1LumaWeight)))/0xFF;

    // patch for cyan
    if((u4Hue > CYAN_LOWER_BOUND) &&(u4Hue < CYAN_UPPER_BOUND))
    {
        YOffset = (((CYAN_UPPER_BOUND - CYAN_LOWER_BOUND)/2) - AbsDiff(u4Hue, (CYAN_LOWER_BOUND+CYAN_UPPER_BOUND)/2 ))*2;
    }
    
#else
    UNUSED(u1APL);
    RemmapedY = ((((UINT32)u1RGBMax * (UINT32)u1MaxLumaofHue[u4Hue>>5] * (UINT32)u1LumaWeight)/0xFF)+
                ((UINT32)u1RGBMax * (UINT32)(0xFF-u1LumaWeight)))/0xFF;
#endif


    if((u4LogCnt ++ % 121) == 0)
    { 
        Printf("RemmapedY = %d\n", RemmapedY);
    }    
    
    return MIN((RemmapedY+YOffset), 255);
}

#define HUE_REMAP_START 320
#define HUE_REMAP_END   HUE_REMAP_START+128

UINT32 u4HueRemap[128] = {320, 322, 324, 326, 328, 330, 332, 334, 336, 338, 340, 342, 344, 346, 348, 350, 
                          352, 354, 356, 358, 360, 362, 364, 366, 368, 370, 372, 374, 376, 378, 380, 382, 
                          384, 386, 388, 390, 392, 394, 396, 398, 400, 400, 401, 401, 402, 402, 403, 403, 
                          404, 404, 405, 405, 406, 406, 407, 407, 408, 408, 409, 409, 410, 410, 410, 411, 
                          411, 412, 412, 413, 413, 414, 414, 415, 415, 416, 416, 417, 417, 418, 418, 419, 
                          419, 420, 420, 421, 421, 422, 422, 423, 423, 424, 424, 425, 425, 426, 426, 426, 
                          427, 427, 428, 428, 429, 429, 430, 430, 431, 431, 432, 432, 433, 433, 434, 434, 
                          435, 435, 436, 436, 437, 437, 438, 439, 440, 441, 442, 443, 444, 445, 446, 447};

UINT32 u4HueRemapping(UINT32 u4Hue)
{
    if((u4Hue >= HUE_REMAP_START) && (u4Hue < HUE_REMAP_END))
    {
        u4Hue = u4HueRemap[u4Hue-HUE_REMAP_START];
    }

    return u4Hue;
}

// 1024 as 1.0
void vConvertYSH2RGB(INT32 u4Y, INT32 u4Cb, INT32 u4Cr,
						INT32 *u4R, INT32 *u4G, INT32 *u4B)
{
	*u4R = ((1187 * u4Y + 1638 * u4Cr) >> 10) - 18;
	*u4G = ((1187 * u4Y - 399 * u4Cb - 834*u4Cr) >> 10) - 18;
	*u4B = ((1187 * u4Y + 2068 * u4Cb) >> 10) - 18;
}

UINT16 u2LeftWindow[4] = {0, 0, 319, 1079};
UINT16 u2RightWindow[4] = {1600, 0, 1919, 1079};

void vDrvAmbiGlowProc(void)
{
	INT32 i4Cb, i4Cr;
	UINT32 u4Hue, u4Sat, u4PxlCnt, u4R, u4G, u4B;
	INT32 i4SinTheta, i4CosTheta;
	INT32 i4Y = 128;//IO32ReadFldAlign(TEMP_APL_VAL, TEMP_APL_VAL0);
	UINT8 u1Y[6];
	UINT8 u1APL = bDrvGetAPL();
	UINT8 u1LumaRgbRatio = IO32ReadFldAlign(AMBILRATIO, LUMA_RGB_RATIO);
	UINT8 u1SatControlBypass = IO32ReadFldAlign(AMBILRATIO, SAT_PROT_BYP);
    UINT8 u1LumaControlBypass = IO32ReadFldAlign(AMBILRATIO, LUMA_CTRL_BYP);
    UINT8 u1HueControlBypass = IO32ReadFldAlign(AMBILRATIO, HUE_CTRL_BYP);    
	UINT8 u1SatControlModul = IO32ReadFldAlign(AMBILRATIO, SAT_PROT_MODULE);	
	UINT32 u4SatGain = IO32ReadFldAlign(AMBILRATIO, AMBL_SAT_GAIN);	
	UINT32 HOffset = IO32ReadFldAlign(AMBILRATIO_2, AMBIL_H_OFST);	 
	
	INT32 i4R, i4G, i4B;
	static UINT8 u1CurrentSide = 0; // 0 : Left / 1 : right
	static UINT32 u4LogCnt = 0;

    vDrvGetHueHistHW();
    vDrvGetSatHistHW();
    u1DrvGetSatHist(u4SatHist, 0);
    u1DrvGetHueHist(u4HueHist, &u4PxlCnt, 0);    
    vDrvGetLcDimAverageResult(u1Y);
	// hue range : 0 ~ 511
//	u4Hue = u4GetAverageHue(u4HueHist, u4HueBound);	
	u4Hue = u4GetMainHue(u4HueHist, u4HueBound);	
	
	// sat range : 0 ~ 255
	u4Sat = u4GetAverageSat(u4SatHist, u4SatBound);

    if(u1SatControlBypass==0)
    {
        if(u1SatControlModul == 1)
        {
            u4Sat = (u4Sat * u4HueProtect(u4Hue, u4HueHist))/0xFF;
            u4Sat = ( u4Sat * u4SatGain ) / 0xFF;
        }
        else
        {
            u4Sat = (u4Sat * u4HueProtectOnDistr(u4Hue, u4HueHist))/0xFF;
            u4Sat = ( u4Sat * u4SatGain ) / 0xFF;
        }
    }

    if(u1HueControlBypass==0)
    {   
        u4Hue = u4HueRemapping(u4Hue);
    }
    else
    {
        u4Hue = (u4Hue + HOffset)%512;
    }
	
	// sin / cos range : 0 ~ (+/-)16384
	if(u4Hue <= 0x80)
	{
		i4SinTheta = COLOR_TRANSFORM_HUE[u4Hue];
		i4CosTheta = COLOR_TRANSFORM_HUE[0x80 - u4Hue];
	}
	else if(u4Hue <= 0x100)
	{
		i4SinTheta = COLOR_TRANSFORM_HUE[0x100 - u4Hue];
		i4CosTheta = -COLOR_TRANSFORM_HUE[u4Hue - 0x80];
	}
	else if(u4Hue <= 0x180)
	{
		i4SinTheta = -COLOR_TRANSFORM_HUE[u4Hue - 0x100];
		i4CosTheta = -COLOR_TRANSFORM_HUE[0x180 - u4Hue];
	}
	else // if(u4Hue < 0x200)
	{
		i4SinTheta = -COLOR_TRANSFORM_HUE[0x200 - u4Hue];
		i4CosTheta = COLOR_TRANSFORM_HUE[u4Hue - 0x180];
	}	  

	i4Cb = ((INT32)u4Sat * i4CosTheta) >> 14;
	i4Cr = ((INT32)u4Sat * i4SinTheta) >> 14;

	if(u1CurrentSide == 0)
	{
	    if(u1LumaControlBypass)
	    {
            i4Y = (u1Y[u1CurrentSide] * ( 0xFF - u1LumaRgbRatio ) + (u1APL * u1LumaRgbRatio)) / 0xFF;
	    }
	    else
	    {
            i4Y = u4RemmapLuma(u1Y[u1CurrentSide], u1APL, u4Hue, u4Sat);
	    }
	}
	else
	{
	    if(u1LumaControlBypass)
	    {
            i4Y = (u1Y[5] * ( 0xFF - u1LumaRgbRatio ) + (u1APL * u1LumaRgbRatio)) / 0xFF;
	    }
	    else
	    {
            i4Y = u4RemmapLuma(u1Y[5], u1APL, u4Hue, u4Sat);
	    }
	}

	vConvertYSH2RGB(i4Y, i4Cb, i4Cr, &i4R, &i4G, &i4B);

    i4R = (i4R > 255) ? 255 : i4R;
    i4R = (i4R <=  0) ? 0   : i4R;    
    i4G = (i4G > 255) ? 255 : i4G;
    i4G = (i4G <=  0) ? 0   : i4G;    
    i4B = (i4B > 255) ? 255 : i4B;
    i4B = (i4B <=  0) ? 0   : i4B;        
	
	u4R = (UINT32)i4R << 2;
	u4G = (UINT32)i4G << 2;
	u4B = (UINT32)i4B << 2;

    if((u4LogCnt ++ % 121) == 0)
    { 
        Printf("u4Sat = %d, u4Hue = %d\n", u4Sat, u4Hue);
    }

   
    if(u1CurrentSide == 0)
    {
        u4R = u4ReturnRGBQueAverage(u4R, RGB_ITEM_R1);
        u4G = u4ReturnRGBQueAverage(u4G, RGB_ITEM_G1);
        u4B = u4ReturnRGBQueAverage(u4B, RGB_ITEM_B1); 
        
        vDrvSetSatHueHistWindow(u2RightWindow);       
        vRegWriteFldAlign(WINDOW_00, ((u4R>>1) << 20) | ((u4G>>1) << 10) | (u4B>>1), WINDOW_COLOR1);
        u1CurrentSide = 1;        
    }
    else
    {
        u4R = u4ReturnRGBQueAverage(u4R, RGB_ITEM_R2);
        u4G = u4ReturnRGBQueAverage(u4G, RGB_ITEM_G2);
        u4B = u4ReturnRGBQueAverage(u4B, RGB_ITEM_B2);        

        vDrvSetSatHueHistWindow(u2LeftWindow);
        vRegWriteFldAlign(WINDOW_01, ((u4R>>1) << 20) | ((u4G>>1) << 10) | (u4B>>1), WINDOW_COLOR2);
        u1CurrentSide = 0;
    }	
}

#endif


void vDRVCUST_SetPWR_TYPE(UINT8 u1pwr_type)
	{	
		vIO32WriteFldAlign(DBC_PARAM1_MAIN, u1pwr_type, DBC_POWER_BANK_PWR_TYPE);
		
	}

